<?php

function check_host_status($host_id){
	check_dir(FTEMP.'hosts');
	$f=fopen(FTEMP.'hosts/'.$host_id,'w+');
	fwrite($f,'check');
	fclose($f);
	$timer=host_timer_min($host_id);
	for($i=0;$i<5;$i++){
		usleep($timer*1000);
		if(!file_exists(FTEMP.'hosts/'.$host_id) || file_get_contents(FTEMP.'hosts/'.$host_id)!='check'){
			if(file_exists(FTEMP.'hosts/'.$host_id)) unlink(FTEMP.'hosts/'.$host_id);
			return 1;
		}
	}
	if(file_exists(FTEMP.'hosts/'.$host_id)) unlink(FTEMP.'hosts/'.$host_id);
	return 0;
}

function host_timer_min($host_id){
	global $db;
	getrow($db,"SELECT * FROM main_host WHERE host_id=$host_id");
	$host_timer=$db->Record['host_timer'];
	$host_listener_timer=$db->Record['host_listener_timer'];

	if(empty($host_timer)) $host_timer=20;
	if(empty($host_listener_timer)) $host_listener_timer=20;
	$x=$host_timer;
	$y=$host_listener_timer;
	if($x==$y) $time=$x;
	else {
		while($x!=$y){
			$ty=$y;
			$y=min($x,$y);
			$x=max($x,$ty)-min($x,$ty);
		}
		if($x<20) $x=20;
		$time=$x;
	}	
	return $time;
}

function get_host_url($host_id,$only_sname=0){
	global $db,$zone,$za,$prot;
	getrow($db,"SELECT * FROM main_host WHERE host_id=$host_id");
	$module_id=$db->Record['host_module'];
	$host_sname=$db->Record['host_sname'];
	getrow($db,"SELECT module_sname FROM main_module WHERE module_id=$module_id");
	$module_sname=$db->Record['module_sname'];
	if($only_sname) return $module_sname.'.'.$host_sname;
	$h=$GLOBALS['host'];
	if(empty($h)) $h=$prot.'://'.$_SERVER['HTTP_HOST'];
	return $h.'?cron=1&host='.$module_sname.'.'.$host_sname;
	//if($zone[$za]["zone_module"]==-1){
	//	return $GLOBALS['host'].'ajax?action=start_host&host='.$module_sname.'.'.$host_sname;
	//} else {
	//	return $GLOBALS['host'].'?host='.$module_sname.'.'.$host_sname;
	//}
}

function start_host($host_id, $skip_check=0){	
	global $prot;
	if($skip_check==1 || check_host_status($host_id)==0){
		$tmp=do_get(get_host_url($host_id));
		if(!is_url_enable($prot.'://'.$_SERVER['HTTP_HOST'])){
			header("Refresh:0");
			start_host_event_loop(get_host_url($host_id,1));
		}
		usleep(1000*1000);
	}
}

function stop_host($host_id){
	if(check_host_status($host_id)==1){
		check_dir(FTEMP.'hosts');
		$f=fopen(FTEMP.'hosts/'.$host_id,'w+');
		fwrite($f,'stop');
		fclose($f);
		$timer=host_timer_min($host_id);
		for($i=0;$i<5;$i++){
			usleep($timer*1000);
			if(!file_exists(FTEMP.'hosts/'.$host_id)) break;
		}
		if(file_exists(FTEMP.'hosts/'.$host_id)) unlink(FTEMP.'hosts/'.$host_id);
	}
}

function reset_this_host(){
	global $this_host_id;
	if(!empty($this_host_id)){
		start_host($this_host_id,1);
		exit;
	}
}

function find_client_by_socket($socket,$return_key=false,$remove=false){
	global $host_clients;
	if(!empty($host_clients)) foreach($host_clients AS $key=>$h) if($h->socket==$socket){
		if($return_key) return $key;
		if($remove) unset($host_clients[$key]);
		else return $host_clients[$key];
	}
}

function start_host_event_loop($host_url){
	global $db,$this_host_id;
	$host_url=explode('.',$host_url);
	if(count($host_url)!=2) return false;	
	$module_sname=safe_sql_input($host_url[0]);
	getrow($db,"SELECT module_id FROM main_module WHERE module_sname='$module_sname'");
	if(empty($db->Record['module_id'])) return false;
	$module_id=$db->Record['module_id'];
	$host_sname=safe_sql_input($host_url[1]);
	getrow($db,"SELECT * FROM main_host WHERE host_module=$module_id AND host_sname='$host_sname'");
	if(empty($db->Record['host_id'])) return false;
	foreach($db->Record AS $var=>$value) $$var=$value;
	$this_host_id=$host_id;
	if(check_host_status($host_id)==1) return false;
	
	ignore_user_abort(1);
	set_time_limit(0);
	$size=ob_get_length();
	@header("Content-Length: $size");
	if($size>0) ob_end_flush();
	if(!function_exists('fastcgi_finish_request') || !@fastcgi_finish_request()) flush();
	// в этот момент пользователь отсоединяется от сервера
	// в то время как сервер продолжает обрабатывать запрос
	ob_start();
	
	$host = 'localhost';
	$null = NULL;
	$err = chr(3).chr(233);
	$fix_runtime=true; // вычитать из времени следующего запуска время выполнения операции (может привести к постоянному потоку операций и загрузке процессора)
	$min_sleep=10*1000;// минимальное время простоя между операциями
	$socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
	socket_set_option($socket, SOL_SOCKET, SO_REUSEADDR, 1);
	socket_set_option($socket, SOL_TCP, TCP_NODELAY, 1);
	if(!socket_bind($socket, 0, $host_port)) return false;
	socket_listen($socket);
	global $clients;
	global $host_clients, $connect_id;
	$host_clients=Array();
	$clients = array($socket);
	
	if(empty($host_timer)) $host_timer=20;
	if(empty($host_listener_timer)) $host_listener_timer=20;
	$x=$host_timer;
	$y=$host_listener_timer;
	if($x==$y) $time=$x;
	else {
		while($x!=$y){
			$ty=$y;
			$y=min($x,$y);
			$x=max($x,$ty)-min($x,$ty);
		}
		if($x<20) $x=20;
		$time=$x;
	}
	$timer_max=floor($host_timer/$time);
	if($timer_max==0) $timer_max=1;
	$timer_iter=0;
	
	$listener_max=floor($host_listener_timer/$time);
	if($listener_max==0) $listener_max=1;
	$listener_iter=0;
	$timer_global_iter=0;
	
	$hf=FTEMP.'hosts/'.$host_id;
	if(file_exists($hf)) unlink($hf);
	if(empty($connect_id)) $connect_id=0;
	$stime=0;
	$ctime=0;
	
	while(true){
		if($fix_runtime) $stime=microtime(true);
		if(file_exists($hf)){
			$cmd=file_get_contents($hf);
			if($cmd=='check'){
				unlink($hf);
			} elseif ($cmd=='stop'){
				unlink($hf);
				break;
			} else {
				unlink($hf);
			}
		}
		
		$timer_iter++;
		if($timer_iter>=$timer_max){
			$timer_iter=0;
			if($host_on_timer){
				$GLOBALS['host_action']='on_timer';
				$GLOBALS['host_timer_count']=$timer_global_iter;
				run_part($host_on_timer);
				$GLOBALS['host_action']='';
				$timer_global_iter++;
			}
		}
		
		$listener_iter++;
		if($listener_iter>=$listener_max){
			$listener_iter=0;
			$changed = $clients;
			socket_select($changed, $null, $null, 0, 10);
			if (in_array($socket, $changed)) {
				$connect_id++;
				$socket_new = socket_accept($socket);
				$clients[] = $socket_new;								
				$header = socket_read($socket_new, 1024);								
				$session=host_perform_handshaking($header, $socket_new, $host, $host_port);				
				
				$host_clients[$connect_id]=new stdClass();
				$host_clients[$connect_id]->socket=$socket_new;
				$host_clients[$connect_id]->id=0;
				$host_clients[$connect_id]->session=$connect_id;
				$host_clients[$connect_id]->type='usr';
				$host_clients[$connect_id]->ip=host_get_ip($socket_new);
				if(!empty($session)){
					$hash=safe_sql_input($session);
					$tmp=getrowval("SELECT session_auth FROM auth_session WHERE session_hash='$hash' AND session_active=1 AND session_over=0",'session_auth');//возможно есть смысл добавить сюда проверку IP адреса
					if(!empty($tmp)) $host_clients[$connect_id]->id=$tmp;
				}
				
				if($host_on_connect){
					$GLOBALS['cur_client']=$host_clients[$connect_id];//key(end($clients));
					$GLOBALS['host_action']='on_connect';
					run_part($host_on_connect);
					$GLOBALS['cur_client']=0;
					$GLOBALS['host_action']='';
				}
				
				$found_socket = array_search($socket, $changed);
				unset($changed[$found_socket]);
			}		
			foreach ($changed as $key=>$changed_socket){	
				while(socket_recv($changed_socket, $buf, /*1024*/$host_length, 0) >= 1)
				{
					$received_text = host_unmask($buf);
					if($host_on_message && !empty($received_text)){
						if(strlen($received_text)==2 && $received_text==$err){
							break 2;
						}
						$GLOBALS['cur_client']=find_client_by_socket($changed_socket);
						$GLOBALS['client_message']=$received_text;
						$GLOBALS['host_action']='on_message';
						run_part($host_on_message);
						$GLOBALS['cur_client']=0;
						$GLOBALS['client_message']='';
						$GLOBALS['host_action']='';
					}
					break 2;
				}
				$buf = @socket_read($changed_socket, 1024, PHP_NORMAL_READ);
				if ($buf === false) {
					$found_socket = array_search($changed_socket, $clients);
					if($host_on_disconnect){
						$GLOBALS['cur_client']=find_client_by_socket($changed_socket);
						$GLOBALS['host_action']='on_disconnect';
						run_part($host_on_disconnect);
						$GLOBALS['cur_client']=0;
						$GLOBALS['host_action']='';
					}
					find_client_by_socket($changed_socket,0,1);
					unset($clients[$found_socket]);
				}
			}
		}
		$sleep=$time*1000;
		if($fix_runtime){
			$etime=microtime(true)+$ctime;
			$sleep-=floor(($etime-$stime)*1000000);
			if($sleep<$min_sleep){
				$ctime=($etime-$stime-$min_sleep/1000000);
				$sleep=$min_sleep;
			} else $ctime=0;
		}
		usleep($sleep);
	}
	
	socket_close($socket);
	ob_end_clean();
}

function host_send_message($client,$msg)
{
	global $clients;
	$msg=host_mask($msg);
	@socket_write($client,$msg,strlen($msg));
}

function host_send_message_all($msg, $except_current=0){
	global $clients;
	if(!empty($clients)) foreach($clients as $client)
	{
		if($except_current && !empty($GLOBALS['cur_client']) && $GLOBALS['cur_client']->socket==$client) continue;
		host_send_message($client,$msg);
	}
}

function host_unmask($text) {
	$length = ord($text[1]) & 127;
	if($length == 126) {
		$masks = substr($text, 4, 4);
		$data = substr($text, 8);
	}
	elseif($length == 127) {
		$masks = substr($text, 10, 4);
		$data = substr($text, 14);
	}
	else {
		$masks = substr($text, 2, 4);
		$data = substr($text, 6);
	}
	$text = "";
	for ($i = 0; $i < strlen($data); ++$i) {
		$text .= $data[$i] ^ $masks[$i%4];
	}
	return $text;
}

function host_mask($text)
{
	$b1 = 0x80 | (0x1 & 0x0f);
	$length = strlen($text);
	
	if($length <= 125)
		$header = pack('CC', $b1, $length);
	elseif($length > 125 && $length < 65536)
		$header = pack('CCn', $b1, 126, $length);
	elseif($length >= 65536)
		$header = pack('CCNN', $b1, 127, $length);
	return $header.$text;
}

function host_perform_handshaking($receved_header,$client_conn, $host, $port)
{
	$headers = array();
	$lines = preg_split("/\r\n/", $receved_header);
	foreach($lines as $line)
	{
		$line = chop($line);
		if(preg_match('/\A(\S+): (.*)\z/', $line, $matches))
		{
			$headers[$matches[1]] = $matches[2];
		}
	}

	$secKey = $headers['Sec-WebSocket-Key'];
	
	$secAccept = base64_encode(pack('H*', sha1($secKey . '258EAFA5-E914-47DA-95CA-C5AB0DC85B11')));
	//hand shaking header
	$upgrade  = "HTTP/1.1 101 Web Socket Protocol Handshake\r\n" .
	"Upgrade: websocket\r\n" .
	"Connection: Upgrade\r\n" .
	"WebSocket-Origin: $host\r\n" .
	"WebSocket-Location: ws://$host:$port/demo/shout.php\r\n".
	"Sec-WebSocket-Accept:$secAccept\r\n\r\n";
	socket_write($client_conn,$upgrade,strlen($upgrade));
	if(!empty($headers)){
		$x=get_tag(serialize($headers),'user_hook=',';');
		if(strpos($x,'"')!==false){
			$x=explode('"',$x);
			$x=$x[0];
		}
		return $x;
	}
	else return 0;
}

function host_get_ip($client){
	$ip=0;
	socket_getpeername($client, $ip);
	return $ip;
}

?>