<?php

$MinServers=5; // Количество потоков
$AutoStopServer=5; // Автоматически закрывать сервер по истечении указанного кол-ва секунд простоя, 0 - работать бесконечно
$CheckServerSeconds=3; // Проверять сервера через указанное кол-во секунд
$SystemName='Work'; // Имя подсети серверов
$MaxServerMemory=50; // Максимальный объём сервера (в мб), при превышении объёма сервер завершает работу (после отдачи последнего ответа)
$CreateServerUntilMin=false; // Создавать сервера пока не достигнут лимит (даже при наличии свободных), работает если AutoStopServer=0
$WriteAnswerInFile=true; // Писать ответ в файл
$AnswerFolder='core/cache/';
$RotateServers=true; // Перебирать работающие сервера друг за другом (иначе используется просто первый свободный)
$IsTest=0;
$IsLog=0;

global $mem;
if(empty($mem)){
	$mem=new Memcached();
	$mem->addServer('localhost',11211);
}

// Проверка запроса для сервера
function CheckQuery(){
	global $mem, $ServerId, $SystemName;
	return $mem->get('Query'.$ServerId.$SystemName);
}

// Проверка ответа от сервера
function CheckAnswer(){
	global $mem, $ServerId, $SystemName, $WriteAnswerInFile, $AnswerFolder;
	if(!$WriteAnswerInFile) return $mem->get('Answer'.$ServerId.$SystemName);
	else {
		if(file_exists($AnswerFolder.'Answer'.$ServerId.$SystemName)) return unserialize(file_get_contents($AnswerFolder.'Answer'.$ServerId.$SystemName));
		else return false;
	}
}

// Обработка запроса
function StartRequest($WorkOnlyOnFree=false){
	global $mem, $RunServers, $FreeServers, $MinServers, $ServerDirectEcho, $IsTest, $ServerId, $RunFile, $SystemName, $CreateServerUntilMin, $RotateServers, $WriteAnswerInFile, $AnswerFolder;
	ignore_user_abort(true);
	set_time_limit(0);
	if($IsTest){ $mtime=explode(" ", microtime());$start_time=$mtime[1]+$mtime[0]; }
	$Seconds=time();
	if(!CheckBusy()){
		$R=Pause('CheckBusy', 1);
		if($R===false) $mem->delete('busy'.$SystemName);
	}
	$RunServers=$mem->get('RunServers'.$SystemName);
	if(empty($RunServers)) $RunServers=Array();
	$FreeServers=$mem->get('FreeServers'.$SystemName);
	if(empty($FreeServers)) $FreeServers=Array();
	// Ограничиваем соединение
	if(empty($FreeServers) || $CreateServerUntilMin && count($RunServers)<$MinServers){
		if($WorkOnlyOnFree){
			ReleaseRouter(2);
			return false;
		}
		if(count($RunServers)<$MinServers){
			// Запускаем новый сервер
			header("Connection: close");
			ob_start();
			$ServerId=count($RunServers)+1;
			if($IsTest) echo 'Для Вас запущен сервер №'.$ServerId.'<br>';
			if($IsTest) ServerLog('Запущен новый сервер');		
			$RunServers[$ServerId]=$Seconds;
			ReleaseRouter();
			register_shutdown_function('ErrorServer');
			if(!empty($RunFile)) include_once($RunFile);
			$ServerDirectEcho=1;
			PrependWorker();
			$Result=StartWorker();
			if(is_array($Result)) echo $Result[1]; else echo $Result;
			ReleaseServer($Seconds);
			$ServerDirectEcho=0;
			// Отсоеденяем клиента веб-сервера
			ResetClient();
			// Непосредственный старт сервера
			WaitQuery();
		} else {
			ReleaseRouter(2);
			// Запускаем скрипт без создания сервера
			if(!empty($RunFile)) include_once($RunFile);
			if($IsTest) ServerLog('Воркер запущен в обход серверов (превышен лимит)',1);
			$Result=StartWorker();
			if(is_array($Result)) echo $Result[1]; else echo $Result;
		}
	} else {		
		if(!$RotateServers){
			$ServerId=array_pop($FreeServers);
		} else {	
			$FreeServers=array_reverse($FreeServers,1);
			$ServerId=array_pop($FreeServers);
			$FreeServers=array_reverse($FreeServers,1);
		}
		
		$RunServers[$ServerId]=$Seconds;
		ReleaseRouter();
		if($IsTest) echo 'Вам выделен сервер №'.$ServerId.'<br>';
		if($IsTest) echo 'Остальные сервера: '.count($FreeServers).' из '.count($RunServers).'<br>';
		if($IsTest) ServerLog('Сформирован запрос к серверу (сервер выделен)');

		if(!$WriteAnswerInFile) $mem->delete('Answer'.$ServerId.$SystemName);
		else unlink($AnswerFolder.'Answer'.$ServerId.$SystemName);
		$mem->set('Query'.$ServerId.$SystemName,Array($_SERVER,$_GET,$_POST,$_FILES,$_COOKIE));
		$Answer=Pause('CheckAnswer', 0.1, 'CheckQuery');
		if($Answer===false){
			if($WorkOnlyOnFree){
				if(!CheckBusy()) Pause('CheckBusy');
				$FreeServers=$mem->get('FreeServers');
				$FreeServers[$ServerId]=$ServerId;
				ReleaseRouter(1);
				if($IsTest) echo 'Неудачная попытка подключения к серверу №'.$ServerId.'<br>';
				//ReleaseServer();
				return false;
			}
			header("Connection: close");
			ob_start();
			CheckLost(2);
			if($IsTest) ServerLog('Сервер '.$ServerId.' вовремя не принял запрос. Он будет перезапущен');
			if($IsTest) echo 'Сервер '.$ServerId.' вовремя не принял запрос. Он будет перезапущен<br>';
			if(!CheckBusy()) Pause('CheckBusy');
			$Seconds=time();
			$RunServers=$mem->get('RunServers'.$SystemName);
			$RunServers[$ServerId]=$Seconds;
			ReleaseRouter(3);
			register_shutdown_function('ErrorServer');
			if(!empty($RunFile)) include_once($RunFile);
			$ServerDirectEcho=1;
			PrependWorker();
			$Result=StartWorker();
			ReleaseServer();
			if(is_array($Result)) echo $Result[1]; else echo $Result;
			$ServerDirectEcho=0;
			// Отсоеденяем клиента веб-сервера
			ResetClient();
			// Непосредственный старт сервера
			WaitQuery();
		} else {
			ReleaseServer($Seconds);
			//var_dump($Answer);
			if(is_array($Answer)){
				if(is_array($Answer[0])){
					foreach($Answer[0] AS $h) header($h);
				} else header($Answer[0]);
				echo $Answer[1];
				if(!empty($Answer[2])) foreach($Answer[2] AS $CookieName=>$CookieVal){
					if(!isset($_COOKIE[$CookieName]) || $_COOKIE[$CookieName]!=$CookieVal) SetCookie($CookieName,$CookieVal,0,'/','',false,1);
				}
			} else echo $Answer;
		}
		if($IsTest) ServerLog('Получен ответ от сервера');
		if($IsTest){
			$mtime=explode(" ", microtime());$end_time=$mtime[1]+$mtime[0];
			$total_time = ($end_time - $start_time);
			$ds=substr($total_time,0,5);
			echo 'Время выполнения: '.$ds.'<br>';
		}
	}
	return true;
	//ResetClient();
}

// Работа сервера
function WorkServer($Query,$sid){
	global $mem, $SystemName, $IsTest, $WriteAnswerInFile, $AnswerFolder;
	$mem->delete('Query'.$sid.$SystemName);
	if(isset($Query[5])){
		$c=$Query[5];
		if($c=='die'){
			DieServer();
		}
		if($c=='signal'){
			if(!$WriteAnswerInFile) $mem->set('Answer'.$sid.$SystemName,1);
			else file_put_contents($AnswerFolder.'Answer'.$sid.$SystemName,serialize(1));
		}
	} else {
		$_SERVER=$Query[0];
		$_GET=$Query[1];
		$_POST=$Query[2];
		$_FILES=$Query[3];
		$_COOKIE=$Query[4];
		PrependWorker();
		start_timer();
		$Answer=StartWorker();
		$x=end_timer();
		if(!$WriteAnswerInFile) $mem->set('Answer'.$sid.$SystemName,$Answer);
		else file_put_contents($AnswerFolder.'Answer'.$sid.$SystemName,serialize($Answer));
		if($IsTest) ServerLog('Сервер сформировал ответ');
	}
}

// Ожидание запроса
function WaitQuery(){
	global $ServerId, $IsTest, $CheckServerSeconds, $AutoStopServer, $MaxServerMemory;
	$SleepTime=0;
	while(true){
		$Query=Pause('CheckQuery',$CheckServerSeconds);
		if($Query===false){
			$SleepTime+=$CheckServerSeconds;
			CheckLost(1);
			if($AutoStopServer && $SleepTime>=$AutoStopServer){
				DieServer();
			}
		} else {
			$SleepTime=0;
			if($IsTest) ServerLog('Сервером получен запрос');
			WorkServer($Query, $ServerId);
			if($MaxServerMemory!=0 && memory_get_usage()/1024/1024>$MaxServerMemory) exit;//DieServer(false);
		}
	}
}

// Подготовка перед запуском функции старта в воркере
function PrependWorker(){
	global $mem, $ServerId, $SystemName;
	if($mem->get('Flush'.$ServerId.$SystemName)!==false){
		$mem->delete('Flush'.$ServerId.$SystemName);
		FlushWorker();
	}
}

// Обнуление данных всех воркеров
function FlushWorkers($except=0){
	global $mem, $SystemName;
	$RunServers=$mem->get('RunServers'.$SystemName);
	if(!empty($RunServers)) foreach($RunServers AS $sid=>$tmp) if($sid!=$except) $mem->set('Flush'.$sid.$SystemName,1);
}

// Выключение сервера
function DieServer($Message='Server Over'){
	global $mem, $ServerId, $IsTest, $FreeServers, $RunServers, $ServerDirectEcho, $SystemName, $WriteAnswerInFile, $AnswerFolder;
	if(!CheckBusy()){
		Pause('CheckBusy');
	}
	$FreeServers=$mem->get('FreeServers'.$SystemName);
	if(empty($FreeServers)) $FreeServers=Array();
	$RunServers=$mem->get('RunServers'.$SystemName);
	if(empty($RunServers)) $RunServers=Array();
	unset($RunServers[$ServerId]);
	unset($FreeServers[$ServerId]);
	ReleaseRouter();
	if($ServerDirectEcho) echo $Message;
	else {
		if($Message!=false){
			if($WriteAnswerInFile) file_put_contents($AnswerFolder.'Answer'.$ServerId.$SystemName,$Message);
			else $mem->set('Answer'.$ServerId.$SystemName,$Message);
		}
	}
	if($IsTest) ServerLog('Сервер выключен');
	exit;
}

// Обработка фатальной ошибки сервера
function ErrorServer(){
	global $e5_error_msg;
	if(!is_null($e = error_get_last())){
		if($e['type']==1 || !empty($e5_error_msg)){
			$t='Server Over with error:<br><b>'.$e['message'].'</b> ('.$e['file'].': '.$e['line'].')';
			if(!empty($e5_error_msg)) $t=$e5_error_msg;
			//$x=debug_backtrace();
			//foreach($x AS $xs){
			//	$t.=$xs["file"].' : '.$xs["line"].'<br>';
			//}
			DieServer($t);
		}
	} else DieServer();
}

// Освобождение сервера
function ReleaseServer($Seconds=0){
	global $mem, $FreeServers, $ServerId, $IsTest, $SystemName;
	if(!CheckBusy()){
		Pause('CheckBusy');
	}
	$FreeServers=$mem->get('FreeServers'.$SystemName);
	$RunServers=$mem->get('RunServers'.$SystemName);
	if(isset($RunServers[$ServerId]) && (!$Seconds || $mem->get('StopServerByTime'.$ServerId.$SystemName)!=$Seconds)){
		$FreeServers[$ServerId]=$ServerId;
		ReleaseRouter(1);
	} else ReleaseRouter(2);
	if($IsTest) ServerLog('Сервер освобождён');
}

// Проверка занятости роутера
function CheckBusy(){
	global $mem, $SystemName;
	return $mem->add('busy'.$SystemName,1);
}

// Освобождение роутера
function ReleaseRouter($OnlyFree=0){
	global $RunServers, $FreeServers, $mem, $SystemName;
	//0 - Обновить Run и Free
	//1 - Обновить только Free
	//2 - Только очистить busy
	//3 - Обновить только Run
	if(!$OnlyFree || $OnlyFree==3) $mem->set('RunServers'.$SystemName,$RunServers);
	if($OnlyFree!=2 && $OnlyFree!=3) $mem->set('FreeServers'.$SystemName,$FreeServers);
	$mem->delete('busy'.$SystemName);
}

// Сброс серверов
function ResetServers(){
	global $mem, $SystemName;
	$RunServers=$mem->get('RunServers'.$SystemName);
	if(!empty($RunServers)) foreach($RunServers AS $sid=>$tmp) $mem->set('Query'.$sid.$SystemName,Array(0,0,0,0,0,'die'));
	$mem->delete('busy'.$SystemName);
	$mem->delete('RunServers'.$SystemName);
	$mem->delete('FreeServers'.$SystemName);
}

// Сброс клиента
function ResetClient(){
	global $ClientReset;
	if(empty($ClientReset)){
		$ClientReset=1;
		fastcgi_finish_request();
		$size=ob_get_length();
		header("Content-Length: $size");
		if($size>0) ob_end_flush();
		//flush();
		ob_start();
	}
}

// Логирование
function ServerLog($line='',$router=0,$separate=1){
	global $IsLog;
	if(!$IsLog) return false;//logging off
	$separate=0; //for testing
	global $ServerId;
	if($separate){
		if($router) $fname='router.log';
		else $fname='server'.$ServerId.'.log';
	} else $fname='all.log';
	$f=fopen('log/'.$fname,'a');
	if(!$router) fwrite($f,'Сервер №'.$ServerId.' - '.$line.chr(10));
	else fwrite($f,'Роутер: - '.$line.chr(10));
	fclose($f);
}

// Проверка упавших серверов
function CheckLost($type=0){
	//type 0 - запуск из любого другого места, при условии, что результат не отдаётся пользователю
	//type 1 - запуск от уже работающего сервера в ходе регулярной проверки
	global $mem, $CheckServerSeconds, $ServerId, $IsTest, $RunFile, $SystemName;
	$Seconds=time();
	$RunServers=$mem->get('RunServers'.$SystemName);
	$FreeServers=$mem->get('FreeServers'.$SystemName);
	foreach($RunServers AS $sid=>$time) if($time<$Seconds-$CheckServerSeconds && !isset($FreeServers[$sid]) && $mem->add('Check'.$sid.$SystemName,1)){
		if($mem->get('Query'.$sid.$SystemName)===false){
			// Сервер получил запрос
			$mem->set('Query'.$sid.$SystemName,Array(0,0,0,0,0,'signal'));
			if($type==0){
				$Answer=Pause('CheckAnswer', 1);
			} else {
				$OldServer=$ServerId;
				$ServerId=$sid;
				$Answer=Pause('CheckAnswer', 1);
				$ServerId=$OldServer;
			}
			if($Answer!=1){
				// если всё плохо, освобождаем место под новый сервер и если запущенный сервер всё-таки выполнит запрос, то даём ему указание закрыться (какой именно из двух серверов с одинаковым ServerId закрыться определять по time)
				if($IsTest) ServerLog('Сервер '.$sid.' потерян. Сервер удалён. Он будет перезапущен при следующем запросе');
				if(!CheckBusy()) Pause('CheckBusy');
				$RunServers=$mem->get('RunServers'.$SystemName);
				$FreeServers=$mem->get('FreeServers'.$SystemName);
				if(isset($FreeServers[$sid])) unset($FreeServers[$sid]);
				unset($RunServers[$sid]);
				$mem->set('StopServerByTime'.$sid.$SystemName,$time);
				ReleaseRouter();
			} else {
				// продлеваем время следующей проверки сервера
				if(!CheckBusy()) Pause('CheckBusy');
				$RunServers[$sid]=time();
				ReleaseRouter(3);
			}
			$mem->delete('Check'.$sid.$SystemName);
		} else {
			// Сервер не получил запрос, т.е. сервер выведен из строя
			if(!CheckBusy()) Pause('CheckBusy');
			$RunServers=$mem->get('RunServers'.$SystemName);
			$FreeServers=$mem->get('FreeServers'.$SystemName);
			// Перезапускаем сервер без запроса (он получит уже имеющийся запрос на вход)
			$Seconds=time();			
			if($type==0){
				if($IsTest) ServerLog('Сервер '.$sid.' потерян. Он будет перезапущен');
				// Если процедура запущена с роутера, то запускаем сервер
				$RunServers[$sid]=$Seconds;
				$FreeServers[$sid]=$sid;
				ReleaseRouter();
				$mem->delete('Check'.$sid.$SystemName);
				register_shutdown_function('ErrorServer');
				if(!empty($RunFile)) include_once($RunFile);
				$ServerDirectEcho=0;
				// Отсоеденяем клиента веб-сервера
				ResetClient();
				// Непосредственный старт сервера
				WaitQuery();
			} else {
				if($IsTest) ServerLog('Сервер '.$sid.' потерян. Его работу выполняет сервер '.$ServerId);
				// Если процедура активирована с сервера, то выполняем сервером нужное задание
				if(isset($FreeServers[$sid])) unset($FreeServers[$sid]);
				if(isset($RunServers[$sid])) unset($RunServers[$sid]);
				ReleaseRouter();
				$mem->delete('Check'.$sid.$SystemName);
				WorkServer($mem->get('Query'.$sid.$SystemName),$sid);
			}
		}
		break; // за один заход проверяем только один сервер
	}
}

// Пауза до совершения необходимого действия
function Pause($callback, $max_time=0, $collback_max_time='', $check_delay=0.001/*0.005*/){
	$now = microtime(true);
	$start = $now;
	while (true){
		if(microtime(true)-$now>$check_delay){
			$v=$callback();
			if($v!==false) return $v;
			$now = microtime(true);
			// max_time - время, после которого либо выдаётся false,
			// либо выполняется collback_max_time и если её результат положителен, то выдаётся false
			if($max_time!=0 && $max_time<$now-$start){
				if(!empty($collback_max_time)){
					if($collback_max_time()) return false;						
					else $max_time=0;
				} else return false;
			}
		}
		usleep($check_delay*1000);
		//time_nanosleep(0,$check_delay*1000000000);
	}
}

function StartWorker(){
	$Answer=main_request(1);
	if(!is_array($Answer)) $Answer=Array(Array(),$Answer);
	if(!isset($Answer[2])) $Answer[2]=$_COOKIE;
	return $Answer;
}

function FlushWorker(){
	//flush_cache(false);
	load_cache_at_start();
}

?>