CREATE TABLE `ex_group` (
  `ex_id` int(11) NOT NULL AUTO_INCREMENT,
  `ex_module` int(11) DEFAULT NULL,
  `ex_table` int(11) DEFAULT NULL,
  `ex_ex1` int(11) DEFAULT NULL,
  `ex_ex2` int(11) DEFAULT NULL,
  PRIMARY KEY (`ex_id`),
  KEY `ex_ex1` (`ex_ex1`),
  KEY `ex_ex2` (`ex_ex2`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `ex_module` (
  `ex_id` int(11) NOT NULL AUTO_INCREMENT,
  `ex_module` int(11) DEFAULT NULL,
  `ex_name` text,
  `ex_sname` text,
  `ex_uin` text,
  `ex_major` int(11) DEFAULT NULL,
  `ex_public` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`ex_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `ex_table` (
  `ex_id` int(11) NOT NULL AUTO_INCREMENT,
  `ex_table` int(11) DEFAULT NULL,
  `ex_module` int(11) DEFAULT NULL,
  `ex_name` text,
  PRIMARY KEY (`ex_id`),
  KEY `ex_table` (`ex_table`),
  KEY `ex_module` (`ex_module`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `ex_zone` (
  `ex_id` int(11) NOT NULL AUTO_INCREMENT,
  `ex_zone` int(11) DEFAULT NULL,
  `ex_module` int(11) DEFAULT NULL,
  `ex_module2` int(11) DEFAULT NULL,
  PRIMARY KEY (`ex_id`),
  KEY `ex_zone` (`ex_zone`),
  KEY `ex_module` (`ex_module`),
  KEY `ex_module2` (`ex_module2`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_col` (
  `col_id` int(11) NOT NULL AUTO_INCREMENT,
  `col_module` int(11) DEFAULT NULL,
  `col_table` int(11) DEFAULT NULL,
  `col_cat` int(11) DEFAULT NULL,
  `col_name` text,
  `col_sname` text,
  `col_uin` text,
  `col_type` tinyint(4) DEFAULT NULL,
  `col_target` tinyint(4) DEFAULT NULL,
  `col_link` int(11) DEFAULT NULL,
  `col_link2` tinyint(4) DEFAULT NULL,
  `col_link3` tinyint(4) DEFAULT NULL,
  `col_link4` tinyint(4) DEFAULT NULL,
  `col_index` tinyint(4) DEFAULT NULL,
  `col_deep` TINYTEXT DEFAULT NULL,
  `col_pos` int(11) DEFAULT NULL,
  `col_order` int(11) DEFAULT NULL,
  `col_bold` tinyint(4) DEFAULT NULL,
  `col_filter` int(11) DEFAULT NULL,
  `col_paramlink` int(11) DEFAULT NULL,
  `col_default` text,
  `col_deflist` text,
  `col_unique` tinyint(4) DEFAULT NULL,
  `col_required` tinyint(4) DEFAULT NULL,
  `col_url` tinyint(4) DEFAULT NULL,
  `col_tpl` tinyint(4) DEFAULT NULL,
  `module_url` tinyint(4) DEFAULT NULL,
  `module_type` int(11) DEFAULT NULL,
  `file_dir` text,
  `file_maxsize` int(11) DEFAULT NULL,
  `file_prefix` text,
  `file_types` text,
  `file_totalmax` int(11) DEFAULT NULL,
  `file_genname` tinyint(4) DEFAULT NULL,
  `col_inform` tinyint(4) DEFAULT NULL,
  `col_fastedit` tinyint(4) DEFAULT NULL,
  `col_part` int(11) DEFAULT NULL,
  `col_speclink` text,
  `col_onshow` text,
  `col_force_onshow` tinyint(4) DEFAULT NULL,
  `col_onform` text,
  `col_hint` text,
  `col_oninsert` text,
  `col_parts` longtext,
  `col_date` datetime DEFAULT '0000-00-00 00:00:00',
  `col_date2` datetime DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`col_id`),
  KEY `col_module` (`col_module`),
  KEY `col_table` (`col_table`),
  KEY `col_bold` (`col_bold`),
  KEY `col_url` (`col_url`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_module` (
  `module_id` int(11) NOT NULL AUTO_INCREMENT,
  `module_name` text,
  `module_sname` text,
  `module_uin` text,
  `module_icon` text,
  `module_info` text,
  `module_data` longtext,
  `module_parts` longtext,
  `module_date` datetime DEFAULT '0000-00-00 00:00:00',
  `module_date2` datetime DEFAULT '0000-00-00 00:00:00',
  `module_lastcheck` date DEFAULT '0000-00-00',
  `module_major` tinyint(4) DEFAULT NULL,
  `module_public_ex` int(11) DEFAULT NULL,
  `module_lock` tinyint(4) DEFAULT NULL,
  `module_phistory` tinyint(4) DEFAULT NULL,
  `module_cbparent` tinyint(4) DEFAULT NULL,
  `module_parents` text,
  PRIMARY KEY (`module_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_part` (
  `part_id` int(11) NOT NULL AUTO_INCREMENT,
  `part_module` int(11) DEFAULT NULL,
  `part_name` text,
  `part_sname` text,
  `part_uin` text,
  `part_date` datetime DEFAULT '0000-00-00 00:00:00',
  `part_date2` datetime DEFAULT '0000-00-00 00:00:00',
  `part_auth` INT DEFAULT '-1',
  `part_about` text,
  `part_access` tinyint(4) DEFAULT NULL,
  `part_type` tinyint(4) DEFAULT NULL,
  `part_table` int(11) DEFAULT NULL,
  `part_owner` int(11) DEFAULT NULL, 
  `part_body` longtext,
  `part_url` text,
  `part_ignore` tinyint(4) DEFAULT NULL,
  `part_iowner` tinyint(4) DEFAULT NULL,
  `part_sowner` tinyint(4) DEFAULT NULL,
  `part_parse` tinyint(4) DEFAULT NULL,
  `part_cat` int(11) DEFAULT NULL,
  `part_major` int(11) DEFAULT NULL,
  `part_proc` tinyint(4) DEFAULT NULL,
  `part_ex` int(11) DEFAULT NULL,
  `part_parts` longtext,
  `part_404` tinyint(4) DEFAULT NULL ,
  `timer_last` datetime DEFAULT '0000-00-00 00:00:00',
  `timer_act` tinyint(4) DEFAULT NULL,
  `timer_type` tinyint(4) DEFAULT NULL,
  `timer_date` date DEFAULT '0000-00-00',
  `timer_time` time DEFAULT '00:00:00',
  `timer_x` int(11) DEFAULT NULL,
  `timer_y` int(11) DEFAULT NULL,
  `timer_count` int(11) DEFAULT NULL,
  `part_file` text,
  `parser_end_ex` int(11) DEFAULT NULL,
  `part_shell` datetime DEFAULT '0000-00-00 00:00:00',
  `part_cur` text,
  `part_pic` text,
  `part_folder` text,
  `part_ifcase` text,
  `part_ifdetect` text,
  `part_ifrow` text,
  `part_unsafe` tinyint(4) DEFAULT NULL,
  `part_shelltime` float(11) DEFAULT NULL,
  `part_shellcount` int(11) DEFAULT NULL,
  `part_skipurl` int(11) DEFAULT NULL,
  `part_enable` tinyint(4) DEFAULT '1',
  PRIMARY KEY (`part_id`),
  KEY `part_module` (`part_module`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_row` (
  `row_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `row_module` int(11) DEFAULT NULL,
  `row_table` int(11) DEFAULT NULL,
  `row_ex` int(11) DEFAULT NULL,
  `row_enable` tinyint(4) DEFAULT '1',
  `row_sub` int(11) UNSIGNED DEFAULT NULL,
  `row_user` int(11) DEFAULT NULL, 
  `row_uin` TINYTEXT DEFAULT NULL,
  `backup_row` int(11) UNSIGNED DEFAULT NULL,
  `backup_date` datetime DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime DEFAULT '0000-00-00 00:00:00',
  `creation_date` datetime DEFAULT  '0000-00-00 00:00:00',
  PRIMARY KEY (`row_id`),
  KEY `row_module` (`row_module`),
  KEY `row_table` (`row_table`),
  KEY `row_ex` (`row_ex`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_table` (
  `table_id` int(11) NOT NULL AUTO_INCREMENT,
  `table_name` text,
  `table_sname` text,
  `table_uin` text,
  `table_icon` text,
  `table_module` int(11) DEFAULT NULL,
  `table_multy` tinyint(4) DEFAULT NULL,
  `table_cansub` tinyint(4) DEFAULT NULL,
  `major_col` int(11) DEFAULT NULL,
  `table_bold` tinyint(4) DEFAULT NULL,
  `table_onedit` text,
  `table_extype` tinyint(4) DEFAULT NULL,
  `table_counter` text,
  `table_bottom` text,
  `table_top` text,
  `table_parts` longtext,
  `table_date` datetime DEFAULT '0000-00-00 00:00:00',
  `table_date2` datetime DEFAULT '0000-00-00 00:00:00',
  `table_public` tinyint(4) DEFAULT NULL,
  PRIMARY KEY (`table_id`),
  KEY `table_module` (`table_module`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_zone` (
  `zone_id` int(11) NOT NULL AUTO_INCREMENT,
  `zone_active` int(11) DEFAULT '1',
  `zone_domain` text,
  `zone_email` text,
  `zone_folder` text,
  `zone_iprange` text,
  `zone_robots` text,
  `zone_safe` TINYINT DEFAULT '0',
  `zone_tpl` text,
  `zone_autosub` tinyint(4) DEFAULT NULL,
  `zone_redirect` int(11) DEFAULT NULL,
  `zone_module` tinytext,
  `zone_hide` tinyint(4) DEFAULT NULL,
  `zone_name` text,
  PRIMARY KEY (`zone_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `part_cat` (
  `cat_id` int(11) NOT NULL AUTO_INCREMENT,
  `cat_name` text,
  `cat_uin` text,
  `cat_type` tinyint(4) DEFAULT NULL,
  `cat_owner` int(11) DEFAULT NULL,
  `cat_pre` text,
  `cat_after` text,
  PRIMARY KEY (`cat_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `part_param` (
  `param_id` int(11) NOT NULL AUTO_INCREMENT,
  `param_part` int(11) DEFAULT NULL,
  `param_name` text,
  `param_sname` text,
  `param_uin` text,
  `param_default` text,
  `param_array` tinyint(4) DEFAULT NULL,
  `param_type` tinyint(4) DEFAULT NULL,
  `param_list` text,
  `param_link` int(11) DEFAULT NULL,
  `param_get` tinyint(4) DEFAULT NULL,
  `param_hide` tinyint(4) DEFAULT NULL,
  `param_connect` int(11) DEFAULT NULL,
  PRIMARY KEY (`param_id`),
  KEY `param_part` (`param_part`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `part_history` (
  `history_id` int(11) NOT NULL AUTO_INCREMENT,
  `history_part` int(11) DEFAULT NULL,
  `history_module` int(11) DEFAULT NULL,
  `history_body` longtext,
  `history_diff` longtext,
  `history_datetime` datetime DEFAULT '0000-00-00 00:00:00',
  `history_user` int(11) DEFAULT NULL,
  PRIMARY KEY (`history_id`),
  KEY `history_part` (`history_part`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_mail` (
  `mail_id` int(11) UNSIGNED NOT NULL auto_increment,
  `mail_from` int(11) DEFAULT NULL,
  `mail_to` int(11) DEFAULT NULL,
  `mail_read` text,
  `mail_topic` text,
  `mail_body` text DEFAULT NULL,
  `mail_date` datetime DEFAULT NULL,
  PRIMARY KEY  (`mail_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `row_owner` (
  `ro_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `ro_pos` int(11) DEFAULT NULL,
  `ro_ex` int(11) DEFAULT NULL,
  `ro_sub` int(11) UNSIGNED DEFAULT NULL,
  `ro_enable` tinyint(4) DEFAULT '1',
  `row_id` int(11) UNSIGNED DEFAULT NULL,
  `row_module` int(11) DEFAULT NULL,
  `row_table` int(11) DEFAULT NULL,
  `owner_id` int(11) UNSIGNED DEFAULT NULL,
  `owner_table` int(11) DEFAULT NULL,
  `owner_module` int(11) DEFAULT NULL,
  `ro_user` int(11) DEFAULT NULL, 
  `ro_users` tinyint(4) DEFAULT NULL,  
  PRIMARY KEY (`ro_id`),
  KEY `ro_ex` (`ro_ex`),
  KEY `row_id` (`row_id`),
  KEY `owner_id` (`owner_id`),
  KEY `row_module` (`row_module`),
  KEY `row_table` (`row_table`),
  KEY `owner_module` (`owner_module`),
  KEY `owner_table` (`owner_table`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `row_user` (
  `ru_id` int(11) NOT NULL AUTO_INCREMENT,
  `ru_user` int(11) DEFAULT NULL,
  `ru_row` int(11) UNSIGNED DEFAULT NULL,
  PRIMARY KEY (`ru_id`),
  KEY `ru_user` (`ru_user`),
  KEY `ru_row` (`ru_row`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `row_value` (
  `value_id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `value_module` int(11) DEFAULT NULL,
  `value_table` int(11) DEFAULT NULL,
  `value_row` int(11) UNSIGNED DEFAULT NULL,
  `value_col` int(11) DEFAULT NULL,
  `value_value` longtext,
  PRIMARY KEY (`value_id`),
  KEY `value_table` (`value_table`),
  KEY `value_module` (`value_module`),
  KEY `col_row` (`value_col`, `value_row`),
  KEY `row_table_col` (`value_row`, `value_table` ,`value_col`),
  KEY `value_value` ( `value_value` ( 11 ) )
  
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `table_sub` (
  `sub_id` int(11) NOT NULL AUTO_INCREMENT,
  `sub_table1` int(11) DEFAULT NULL,
  `sub_table2` int(11) DEFAULT NULL,
  `sub_module` int(11) DEFAULT NULL,
  PRIMARY KEY (`sub_id`),
  KEY `sub_table1` (`sub_table1`),
  KEY `sub_table2` (`sub_table2`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `auth_link` (
  `link_id` int(11) NOT NULL auto_increment,
  `link_user` int(11) DEFAULT NULL,
  `link_group` int(11) DEFAULT NULL,
  `link_expire` date DEFAULT NULL,
  `link_date` date DEFAULT NULL,
  `link_invite` int(11) DEFAULT NULL,
  PRIMARY KEY  (`link_id`),
  KEY `link_user` (`link_user`),
  KEY `link_group` (`link_group`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `auth_perm` (
  `perm_id` int(11) UNSIGNED NOT NULL auto_increment,
  `perm_target` tinyint(4) DEFAULT NULL,
  `perm_type` tinyint(4) DEFAULT NULL,
  `perm_auth` int(11) DEFAULT NULL,
  `perm_object` int(11) DEFAULT NULL,
  `perm_folder` text DEFAULT NULL,
  `perm_subtable` text DEFAULT NULL,
  `perm_view` tinyint(4) default '-1',
  `perm_edit` tinyint(4) default '-1',
  `perm_add` tinyint(4) default '-1',
  `perm_del` tinyint(4) default '-1',
  `perm_control` tinyint(4) default '-1',
  `perm_rules` tinyint(4) default '-1',
  `perm_upload` tinyint(4) default '-1',
  `perm_maxupl` int(11) DEFAULT NULL,
  `perm_reg` tinyint(4) default '-1',
  `perm_invite` tinyint(4) default '-1',
  `perm_leave` tinyint(4) default '-1',
  `perm_unreg` tinyint(4) default '-1',
  PRIMARY KEY  (`perm_id`),
  KEY `perm_auth` (`perm_auth`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_auth` (
  `auth_id` int(11) NOT NULL auto_increment,
  `auth_type` tinyint(4) DEFAULT NULL,
  `auth_owner` text DEFAULT NULL,
  `auth_date` date DEFAULT NULL,
  `user_login` text DEFAULT NULL,
  `user_pwl` text DEFAULT NULL,
  `user_fixedip` text DEFAULT NULL,
  `user_email` text DEFAULT NULL,
  `user_pwlcode` tinyint(4) DEFAULT NULL,
  `user_name` text DEFAULT NULL,
  `user_safe` text DEFAULT NULL,
  `user_lastlogin` int(11) DEFAULT NULL,
  `user_row` int(11) UNSIGNED DEFAULT NULL,
  `group_name` text DEFAULT NULL,
  `group_sname` text DEFAULT NULL,
  `group_module` int(11) DEFAULT NULL,
  `group_table` int(11) DEFAULT NULL,
  `group_owner` int(11) DEFAULT NULL,
  `group_uin` text DEFAULT NULL,
  `user_ip` TINYTEXT DEFAULT NULL,
  `auth_enable` tinyint(4) DEFAULT '1',
  `session_lifetime` int(11) DEFAULT NULL,
  `session_multy` int(11) DEFAULT NULL,
  PRIMARY KEY  (`auth_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `auth_session` (
  `session_id` int(11) NOT NULL auto_increment,
  `session_auth` int(11) DEFAULT NULL,
  `session_start` timestamp DEFAULT '0000-00-00 00:00:00',
  `session_last` timestamp DEFAULT '0000-00-00 00:00:00',
  `session_over` int(11) DEFAULT NULL,
  `session_active` tinyint(4) DEFAULT NULL,
  `session_hash` tinytext DEFAULT NULL,
  `session_ip` tinytext DEFAULT NULL,
  PRIMARY KEY  (`session_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `main_news` (
  `news_id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `news_title` TEXT DEFAULT NULL,
  `news_url` TEXT DEFAULT NULL,
  `news_group` INT DEFAULT NULL,
  `news_from` INT DEFAULT NULL,
  `news_fromip` TEXT DEFAULT NULL,
  `news_fromurl` TEXT DEFAULT NULL,
  `news_read` INT DEFAULT NULL,
  `news_module` INT DEFAULT NULL,
  `news_part` INT DEFAULT NULL,
  `news_row` INT UNSIGNED DEFAULT NULL,
  `news_ex` INT DEFAULT NULL,
  `news_datetime` DATETIME DEFAULT NULL,
  `news_day` INT DEFAULT NULL,
PRIMARY KEY (`news_id`),
KEY (`news_group`),
KEY (`news_from`),
KEY (`news_read`),
KEY (`news_module`),
KEY (`news_day`) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `row_index` (
  `index_word` INT UNSIGNED DEFAULT NULL,
  `index_pos` INT DEFAULT NULL,
  `index_row` INT UNSIGNED DEFAULT NULL,
  `index_col` INT DEFAULT NULL,
  `index_tex` INT DEFAULT NULL,
  `index_owner` INT UNSIGNED DEFAULT NULL,
KEY (`index_word`),
KEY (`index_row`),
KEY (`index_col`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `index_word` (
  `word_id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
  `word_lemma` VARCHAR(20) DEFAULT NULL,
PRIMARY KEY (`word_id`),
KEY ( `word_lemma` ) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `visit_ip` (
  `ip_zone` INT DEFAULT NULL,
  `ip_type` TINYINT DEFAULT NULL,
  `ip_action` INT DEFAULT NULL,
  `ip_value` INT UNSIGNED DEFAULT NULL,
  `ip_visit` INT DEFAULT NULL,
  `ip_time` INT DEFAULT NULL,
KEY (`ip_type`),
KEY (`ip_zone`),
KEY (`ip_value`),
KEY (`ip_time`) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `visit_object` (
  `visit_type` TINYINT DEFAULT NULL,
  `visit_object` INT DEFAULT NULL,
  `visit_period` TINYINT DEFAULT NULL,
  `visit_time` INT DEFAULT NULL,
  `visit_host` INT UNSIGNED DEFAULT NULL,
  `visit_hit` INT UNSIGNED DEFAULT NULL,
  `visit_zone` INT DEFAULT NULL,
KEY (`visit_type`),
KEY (`visit_object`),
KEY (`visit_period`),
KEY (`visit_time`),
KEY (`visit_zone`),
KEY `period_time` (`visit_period`,`visit_time`),
KEY `type_period_time` (`visit_type`,`visit_period`,`visit_time`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `visit_data` (
  `data_id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
  `data_name` VARCHAR( 200 ) DEFAULT NULL ,
  `data_type` TINYINT DEFAULT NULL ,
PRIMARY KEY ( `data_id` ) ,
KEY ( `data_name`),
KEY (`data_type` ) 
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `visit_source` (
  `source_zone` INT DEFAULT NULL ,
  `source_type` TINYINT DEFAULT NULL ,
  `source_domain` INT UNSIGNED DEFAULT NULL ,
  `source_data` INT UNSIGNED DEFAULT NULL ,
  `source_day` INT DEFAULT NULL ,
  `source_visit` INT DEFAULT NULL ,
KEY (`source_zone`),
KEY (`source_type`),
KEY (`source_domain`),
KEY (`source_day`) 
);



INSERT INTO `auth_perm` (perm_id,perm_target,perm_type,perm_auth,perm_object,perm_folder,perm_subtable,perm_view,perm_edit,perm_add,perm_del,perm_control,perm_rules,perm_upload,perm_maxupl,perm_reg,perm_invite,perm_leave,perm_unreg) VALUES
(62,6,5,1,0,'files/pub','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(63,1,0,1,1,'','',1,-1,-1,-1,-1,1,-1,0,-1,-1,-1,-1),
(64,1,1,1,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(65,3,4,1,8,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(66,3,4,1,5,'','',1,2,1,2,-1,-1,-1,0,-1,-1,-1,-1),
(67,3,4,1,10,'','',1,2,1,2,-1,-1,-1,0,-1,-1,-1,-1),
(68,3,4,1,9,'','',1,2,1,2,-1,-1,-1,0,-1,-1,-1,-1),
(69,1,5,1,0,'files/pub','',1,1,-1,1,-1,-1,-1,0,-1,-1,-1,-1),
(70,1,3,1,5,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(71,1,3,1,10,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(72,1,3,1,9,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(73,6,5,3,0,'files/pub','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(74,1,0,3,1,'','',1,-1,-1,-1,-1,1,-1,0,-1,-1,-1,-1),
(75,1,1,3,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(76,5,4,3,1,'','',1,1,1,1,-1,-1,-1,0,-1,-1,-1,-1),
(77,0,5,3,0,'0','',1,1,-1,1,-1,-1,-1,0,-1,-1,-1,-1),
(78,3,3,3,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(79,3,2,3,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(80,3,6,3,1,'','',1,1,-1,1,-1,1,-1,0,1,-1,-1,-1),
(81,3,8,3,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,1,1,-1),
(82,6,5,4,0,'','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(83,1,0,4,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(102,6,5,2,0,'files/design','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(103,1,0,2,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(104,1,1,2,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(105,3,4,2,8,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(106,3,4,2,7,'','',1,1,1,2,-1,-1,-1,0,-1,-1,-1,-1),
(107,3,4,2,11,'','',1,1,1,2,-1,-1,-1,0,-1,-1,-1,-1),
(108,1,5,2,0,'files/design','',1,1,-1,1,-1,-1,-1,0,-1,-1,-1,-1),
(109,1,3,2,7,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(110,1,3,2,11,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(111,3,2,2,1,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(265,6,5,0,0,'','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(266,0,0,0,0,'','',-1,0,0,0,-1,0,-1,0,-1,-1,-1,-1),
(267,1,0,0,1,'','',0,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(268,0,1,0,0,'','',0,0,0,0,-1,-1,-1,0,-1,-1,-1,-1),
(269,0,4,0,0,'','',1,0,0,0,-1,-1,-1,0,-1,-1,-1,-1),
(270,3,4,0,29,'','',1,-1,5,-1,-1,-1,-1,0,-1,-1,-1,-1),
(271,3,4,0,55,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(272,3,4,0,56,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(273,3,4,0,57,'','',1,1,1,1,-1,-1,-1,0,-1,-1,-1,-1),
(274,1,6,0,7,'','',1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(275,1,8,0,7,'','',-1,-1,-1,-1,-1,-1,-1,0,-1,1,-1,-1),
(276,0,3,0,0,'','',0,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(277,0,2,0,0,'','',0,0,0,0,-1,-1,-1,0,-1,-1,-1,-1),
(278,3,6,0,5,'','',-1,-1,-1,-1,-1,-1,-1,0,1,-1,-1,-1),
(286,6,5,7,0,'','',-1,-1,-1,-1,-1,-1,-1,0,-1,-1,-1,-1),
(287,3,4,7,29,'','',1,2,-1,2,-1,-1,-1,0,-1,-1,-1,-1),
(288,3,4,7,75,'','',-1,-1,1,-1,-1,-1,-1,0,-1,-1,-1,-1);

INSERT INTO `auth_session` (session_id,session_auth,session_start,session_last,session_active,session_hash,session_ip,session_over) VALUES
(122,8,'2016-04-06 20:20:24','2016-04-06 20:20:24',0,'2c65f125d7a1149b8a09bb877133fa21','192.168.137.1',0),
(123,9,'2016-04-06 20:29:14','2016-04-06 20:31:50',0,'7191b652b724e580dc552c82c765409f','192.168.137.1',0),
(125,4,'2016-04-06 20:34:45','2016-04-06 20:34:50',0,'d54d26b62417ea01ae9a50683baa682a','192.168.137.1',0),
(126,4,'2016-04-06 20:37:41','2016-04-06 20:38:42',0,'ebd5c0092c4447d0065445f702cfcbc3','192.168.137.1',0),
(127,4,'2016-04-06 20:38:42','2016-04-06 20:38:45',0,'b980f3951de972b2fa42a7cc649a2af3','192.168.137.1',0),
(128,4,'2016-04-06 20:38:59','2016-04-08 16:05:11',0,'bca60a2cf2c4fafc66a643cb67b0c50e','192.168.137.1',0),
(143,-1,'2016-05-22 10:30:19','2016-05-29 23:14:37',0,'61eb3d48ca72beb74102e1dde1a014bd','192.168.137.1',0),
(144,-1,'2016-05-29 23:42:50','2016-05-31 23:21:54',0,'df55ae70e06552c63d7190abb1316554','192.168.137.1',0),
(145,4,'2016-05-31 16:20:20','2016-05-31 16:20:32',0,'93011b05e76b0c422eac5bb693c6841c','192.168.137.1',0),
(146,4,'2016-05-31 16:20:32','2016-05-31 16:21:00',0,'f5feea2528f2eef2fd4825565e744f04','192.168.137.1',0),
(147,4,'2016-05-31 16:21:00','2016-05-31 16:21:08',0,'98d591c39789b71b9ab61ed26b2c36cb','192.168.137.1',0),
(148,4,'2016-05-31 16:21:08','2016-05-31 16:47:19',0,'7c4c580b14a7a89b00a0704c5634a585','192.168.137.1',0),
(149,8,'2016-05-31 22:51:30','2016-05-31 22:53:01',0,'f5e76b0c568e1a5e8042a2406c0be791','192.168.137.1',0),
(150,9,'2016-05-31 22:53:14','2016-05-31 22:55:05',0,'cf67c3f61fcae171535506bbfeb845b5','192.168.137.1',0),
(151,10,'2016-05-31 22:55:18','2016-05-31 22:55:58',0,'0e7fc168feb7996f0048cda23d730739','192.168.137.1',0),
(152,11,'2016-05-31 22:56:07','2016-05-31 22:56:39',0,'facacdfe556ceb2425a7bb6b16e132a4','192.168.137.1',0),
(153,12,'2016-05-31 22:56:46','2016-05-31 22:57:24',0,'244d6a876b5b98274dac1ec41603be5c','192.168.137.1',0),
(154,13,'2016-05-31 22:57:35','2016-05-31 22:58:05',0,'ce64751d1752075d034534273e4d65ca','192.168.137.1',0),
(155,14,'2016-05-31 22:58:15','2016-05-31 23:00:55',0,'7dd55f2ed00a258f21b8b9d01d8f4a6d','192.168.137.1',0),
(156,15,'2016-05-31 23:01:04','2016-05-31 23:02:04',0,'ff8973cf98607a2ffc8e5d87f3493ebf','192.168.137.1',0),
(157,16,'2016-05-31 23:02:13','2016-05-31 23:03:24',0,'e87f312d408bb889ac545b7dfac59263','192.168.137.1',0),
(158,17,'2016-05-31 23:03:32','2016-05-31 23:23:03',0,'3a4daef803f99ed6f325e99450b25501','192.168.137.1',0),
(159,18,'2016-05-31 23:22:07','2016-05-31 23:22:20',0,'a8cbc6c027c43761788b0a249bd8a48e','192.168.137.1',0),
(160,-1,'2016-05-31 23:22:20','2016-05-31 23:48:38',0,'0d75e8c1c3a88a56a7bd7539a307ff8f','192.168.137.1',0),
(161,19,'2016-05-31 23:23:13','2016-05-31 23:26:36',0,'7679875af6ff704e1b18def7bd1d3388','192.168.137.1',0),
(162,20,'2016-05-31 23:26:43','2016-05-31 23:26:43',0,'db7b8a80e509b6c13b84a497c0daa6a6','192.168.137.1',0),
(163,-1,'2016-06-01 10:13:31','2016-06-01 23:25:39',0,'ed5b31d4487e929ea0745119cd0b6087','192.168.137.1',0),
(164,-1,'2016-06-03 10:07:45','2016-06-03 10:07:55',1,'bf99e32219370d6613a7d09740f1f9b4','192.168.137.1',0),
(165,-1,'2016-06-05 06:34:06','2016-06-07 23:35:15',1,'00ce9efa8aff6d64aec6d111359dac32','192.168.137.1',0);

INSERT INTO `ex_group` (ex_id,ex_module,ex_table,ex_ex1,ex_ex2) VALUES
(1,2,1,1,2),
(2,1,5,2,1),
(3,1,7,3,1),
(4,1,8,4,1),
(5,1,9,5,1),
(6,1,10,6,1),
(7,1,11,7,1),
(8,1,12,8,1),
(9,1,13,9,1),
(10,1,14,10,1),
(11,3,15,11,3),
(12,3,16,12,3),
(13,3,17,13,3),
(14,1,18,14,1),
(15,1,19,15,1),
(16,1,20,16,1),
(17,4,21,17,4),
(18,4,22,18,4),
(19,4,23,19,4),
(20,4,24,20,4),
(21,4,25,21,4),
(22,4,26,22,4),
(23,4,27,23,4),
(24,4,28,24,4),
(25,5,29,25,5),
(26,2,31,26,2),
(27,2,32,27,2),
(28,2,34,28,2),
(29,6,35,29,6),
(30,6,36,30,6),
(43,6,42,43,6),
(45,6,43,44,6),
(47,7,45,46,7),
(48,7,46,47,7),
(49,7,47,48,7),
(50,7,48,49,7),
(51,7,49,50,7),
(52,7,50,51,7),
(53,5,51,52,5),
(54,7,52,53,7),
(55,8,53,54,8),
(56,8,54,55,8),
(57,8,55,56,8),
(58,8,56,57,8),
(59,8,57,58,8),
(60,8,58,59,8),
(61,6,59,60,6),
(62,6,60,61,6),
(63,6,61,62,6),
(68,10,67,67,10),
(69,10,68,68,10),
(70,10,69,69,10),
(71,10,70,70,10),
(72,10,71,71,10),
(73,7,72,72,7),
(75,7,74,74,7);

INSERT INTO `ex_module` (ex_id,ex_module,ex_name,ex_sname,ex_uin,ex_major,ex_public) VALUES
(1,1,'Демо-сайт','demo','70f3b39b4dff7d7a5b8de04a19b80dfd',0,1),
(2,2,'основной','base','40ea22c271e08a6e46a407333f06d491',0,0),
(3,3,'основной','base','384fec5ef6821de7ddad02431d5d99e8',0,1),
(4,4,'основной','base','8df0da9210c1b01dead43ae2bb8a9677',0,1),
(5,5,'основной','base','eed49816332fb7d4494e1997bf312a5f',0,1),
(6,6,'основной','base','ad3f656568628285cd6fe5cfd5f6714a',0,1),
(7,7,'основной','base','c7da137c820357446fa55236c853811a',0,1),
(8,8,'основной','base','800cff2ca1adbe4ea80d1719b17d5c12',0,1),
(10,10,'основной','base','6bd7465ee580a1fe159d4714aca226ba',0,1);

INSERT INTO `ex_table` (ex_id,ex_table,ex_module,ex_name) VALUES
(1,1,2,'основная'),
(2,5,1,'основная'),
(3,7,1,'основная'),
(4,8,1,'основная'),
(5,9,1,'основная'),
(6,10,1,'основная'),
(7,11,1,'основная'),
(8,12,1,'основная'),
(9,13,1,'основная'),
(10,14,1,'основная'),
(11,15,3,'основная'),
(12,16,3,'основная'),
(13,17,3,'основная'),
(14,18,1,'основная'),
(15,19,1,'основная'),
(16,20,1,'основная'),
(17,21,4,'основная'),
(18,22,4,'основная'),
(19,23,4,'основная'),
(20,24,4,'основная'),
(21,25,4,'основная'),
(22,26,4,'основная'),
(23,27,4,'основная'),
(24,28,4,'основная'),
(25,29,5,'основная'),
(26,31,2,'основная'),
(27,32,2,'основная'),
(28,34,2,'основная'),
(29,35,6,'основная'),
(30,36,6,'основная'),
(43,42,6,'основная'),
(44,43,6,'основная'),
(46,45,7,'основная'),
(47,46,7,'основная'),
(48,47,7,'основная'),
(49,48,7,'основная'),
(50,49,7,'основная'),
(51,50,7,'основная'),
(52,51,5,'основная'),
(53,52,7,'основная'),
(54,53,8,'основная'),
(55,54,8,'основная'),
(56,55,8,'основная'),
(57,56,8,'основная'),
(58,57,8,'основная'),
(59,58,8,'основная'),
(60,59,6,'основная'),
(61,60,6,'основная'),
(62,61,6,'основная'),
(67,67,10,'основная'),
(68,68,10,'основная'),
(69,69,10,'основная'),
(70,70,10,'основная'),
(71,71,10,'Шаблоны Вывод прайс-листа'),
(72,72,7,'основная'),
(74,74,7,'основная');

INSERT INTO `ex_zone` (ex_id,ex_zone,ex_module,ex_module2) VALUES
(1,3,1,1),
(3,3,2,2),
(4,3,6,6),
(5,3,4,4),
(6,3,10,10);

INSERT INTO `index_word` (word_id,word_lemma) VALUES
(1073,'1'),
(1045,'12'),
(988,'12`'),
(1060,'14'),
(1058,'15м'),
(1074,'2'),
(1048,'215'),
(1114,'25'),
(1068,'3'),
(186,'3%'),
(277,'4'),
(1056,'42lf'),
(1063,'52'),
(1053,'6'),
(188,'64%'),
(1050,'6s'),
(1067,'7184'),
(1044,'92'),
(1065,'atlant'),
(1062,'df'),
(270,'ferrari'),
(1021,'fullhd'),
(1046,'galaxy'),
(990,'height35'),
(1061,'indesit'),
(864,'iphone'),
(1055,'lg'),
(850,'lumia'),
(1196,'юж'),
(138,'стран'),
(977,'стать'),
(176,'сторон'),
(1109,'считан'),
(1154,'сраз'),
(38,'сайт'),
(957,'сам'),
(1168,'сбежал'),
(993,'связ'),
(1183,'своим'),
(133,'свеж'),
(1127,'сибир'),
(1184,'силам'),
(1112,'скал'),
(1135,'скот'),
(852,'смартфон'),
(271,'сниж'),
(175,'со'),
(1176,'сотрудник'),
(1173,'соверш'),
(1083,'сол'),
(1177,'сообщ'),
(144,'сообщен'),
(1202,'способств'),
(975,'спешит'),
(177,'специалист'),
(865,'спецпредло'),
(1157,'середин'),
(1191,'север'),
(149,'сегодн'),
(274,'сейчас'),
(189,'эт'),
(1158,'этом'),
(267,'эксклюзив'),
(1136,'эксперт'),
(275,'экономит'),
(878,'электроник'),
(1028,'электропли'),
(917,'услуг'),
(1171,'утр'),
(1137,'утвержд'),
(1110,'уч'),
(1091,'уборк'),
(986,'ул'),
(1051,'улучш'),
(1187,'тушканчик'),
(278,'тысяч'),
(1126,'трудовик'),
(44,'трактор'),
(74,'так'),
(1020,'тв'),
(180,'тот'),
(48,'тольк'),
(1115,'тонн'),
(1027,'техник'),
(168,'текущ'),
(759,'телефон'),
(880,'телевизор'),
(788,'флагман'),
(978,'фот'),
(991,'форм'),
(752,'цвет'),
(272,'цен'),
(973,'ценам'),
(1097,'чуж'),
(113,'час'),
(18,'чистк'),
(141,'хвостатик'),
(971,'хорош'),
(1149,'холодам'),
(1029,'холодильни'),
(1049,'рынк'),
(1201,'растен'),
(77,'рад'),
(167,'размножают'),
(1203,'размножен'),
(136,'росс'),
(1134,'рогат'),
(142,'реклам'),
(22,'ремонт'),
(1047,'s6'),
(1011,'samsung'),
(994,'submit`отправ'),
(1059,'terra'),
(996,'text`поздравΧ),
(1002,'title`title`'),
(1054,'ue32'),
(1001,'url`url`'),
(1064,'w'),
(989,'width425'),
(1148,'ассоциируе'),
(1144,'австрал'),
(997,'авторизаци'),
(998,'авторизаци'),
(1069,'авторизаци'),
(1070,'авторизаци'),
(1179,'агрессивен'),
(1172,'бур'),
(1093,'буйн'),
(1026,'быт'),
(231,'благодар'),
(1146,'близк'),
(1000,'блока`'),
(1185,'безопасн'),
(753,'белочк'),
(110,'вс'),
(1119,'встретить'),
(185,'всег'),
(1163,'втор'),
(76,'вы'),
(1198,'высуш'),
(184,'выросл'),
(1095,'вынос'),
(265,'вас'),
(1099,'владельц'),
(166,'внов'),
(173,'возмож'),
(268,'возможн'),
(1113,'вес'),
(1197,'ветер'),
(1052,'верс'),
(1084,'вежлив'),
(1188,'гран'),
(1121,'гот'),
(178,'год'),
(190,'год'),
(276,'до'),
(972,'доступ'),
(1082,'дорожк'),
(282,'добр'),
(1079,'долб'),
(279,'доллар'),
(1141,'дешев'),
(1174,'дерзк'),
(1103,'ден'),
(1161,'ждут'),
(139,'живот'),
(1123,'заст'),
(1131,'заготовк'),
(165,'зайц'),
(171,'зайцев'),
(273,'заказав'),
(1150,'заморозкам'),
(1178,'звер'),
(217,'зим'),
(1169,'зоопарк'),
(1106,'земл'),
(1189,'исчезновен'),
(143,'исключител'),
(1194,'изменившем'),
(69,'интерес'),
(955,'информац'),
(1133,'круп'),
(985,'красноярск'),
(1072,'категор'),
(958,'качеств'),
(1102,'кажд'),
(893,'камерофон'),
(1195,'климат'),
(1094,'клиент'),
(751,'кот'),
(70,'котик'),
(19,'ковр'),
(15,'компан'),
(984,'контакт'),
(1129,'конвейер'),
(1140,'конкуриров'),
(1142,'кегурятин'),
(1170,'кен'),
(235,'люд'),
(956,'лучш'),
(1078,'лист'),
(1182,'лов'),
(754,'лет'),
(1080,'лед'),
(987,'ленин'),
(1066,'м'),
(1132,'мяс'),
(1122,'мы'),
(1089,'мыть'),
(1071,'магазин'),
(21,'мир'),
(1147,'мног'),
(876,'мобил'),
(1139,'могут'),
(1087,'мойк'),
(1104,'метеор'),
(1057,'мечт'),
(1167,'медвед'),
(974,'нас'),
(27,'наш'),
(72,'нашег'),
(179,'назад'),
(73,'наконец'),
(1117,'нам'),
(124,'нов'),
(866,'новинк'),
(1155,'нескольк'),
(1166,'нег'),
(1111,'недоумен'),
(137,'необъят'),
(1199,'остатк'),
(1128,'остановил'),
(241,'от'),
(1098,'отсутств'),
(181,'отчет'),
(1165,'отход'),
(71,'открыт'),
(75,'открыл'),
(1153,'отмеч'),
(1086,'офис'),
(1180,'очен'),
(1096,'оргтехник'),
(992,'обрат'),
(1190,'обитател'),
(1107,'облетел'),
(1151,'однак'),
(174,'ожидан'),
(1193,'оказалис'),
(1088,'окон'),
(1120,'опасност'),
(1181,'опасен'),
(1192,'пустын'),
(140,'пушистик'),
(1156,'праздник'),
(1162,'праздник'),
(1077,'прайс'),
(1105,'приближает'),
(1152,'принят'),
(269,'приобрест'),
(187,'против'),
(1085,'прохожим'),
(976,'продаж'),
(1130,'производст'),
(1138,'производст'),
(1125,'промышленн'),
(172,'превысил'),
(1118,'предстоит'),
(995,'письмо`'),
(1200,'пит'),
(1124,'пищев'),
(23,'пк'),
(1116,'планет'),
(1143,'поставляем'),
(1081,'посып'),
(1092,'посл'),
(1175,'побег'),
(1075,'подкатегор'),
(1145,'подобралас'),
(283,'пожалов'),
(948,'поиска`'),
(949,'поиска`'),
(1090,'пол'),
(169,'полугод'),
(1160,'половин'),
(1164,'половин'),
(170,'популяц'),
(183,'популяц'),
(1186,'пестр'),
(1159,'перв'),
(182,'период'),
(266,'ест');

INSERT INTO `main_auth` (auth_id,auth_type,auth_owner,auth_date,user_login,user_pwl,user_fixedip,user_email,user_pwlcode,user_name,user_safe,user_lastlogin,user_row,group_name,group_sname,group_module,group_table,group_owner,group_uin,user_ip,auth_enable,session_lifetime,session_multy) VALUES
(1,1,'-1','2015-10-18','','','','',0,'','',0,0,'Редакторы контента','managers',1,0,0,'fed11b434c5046e07115004b7ddc609f','',1,-1,-1),
(2,1,'-1','2015-10-18','','','','',0,'','',0,0,'Дизайнеры','designers',1,0,0,'fcc6bbf28705a0fe1f892182b390d7f2','',1,-1,-1),
(3,1,'-1','2015-10-18','','','','',0,'','',0,0,'Главный редактор','main_editor',1,0,0,'b633f0de5469af6bd51b552c6180700a','',1,-1,-1),
(4,0,'0','2015-10-21','demo','demo','','',0,'Гостевой доступ','',24411501,0,'','',0,0,0,'','192.168.137.1',1,-1,-1),
(6,1,'-1','2016-03-23','','','','',0,'','',0,0,'Модераторы комментариев','comment_moderators',5,0,0,'b04d3e620974840486125728c4bad4bb','',1,-1,-1),
(7,1,'-1','2016-03-24','','','','',0,'','',0,0,'Авторы комментариев','comment_authors',5,0,0,'443cf35c59bea09f908597bd2379c11f','',1,-1,-1);

INSERT INTO `main_col` (col_id,col_module,col_table,col_cat,col_name,col_sname,col_uin,col_type,col_target,col_link,col_link2,col_link3,col_link4,col_index,col_deep,col_pos,col_order,col_bold,col_filter,col_paramlink,col_default,col_deflist,col_unique,col_required,col_url,col_tpl,module_url,module_type,file_dir,file_maxsize,file_prefix,file_types,file_totalmax,file_genname,col_inform,col_fastedit,col_part,col_speclink,col_onshow,col_force_onshow,col_onform,col_hint,col_oninsert,col_parts,col_date,col_date2) VALUES
(1,2,1,0,'Фотография','big_img','a2ea5d37fd01009ef2ab2669b1345923',3,0,1,0,0,0,0,'0',1,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','',0,'','','[func.big_to_small(mini=''mini'')]','','2015-10-07 15:55:28','2016-04-20 15:52:37'),
(2,2,1,0,'Миниатюра','mini','0f30149c75b2f41edb9a0a1be265812a',3,0,1,0,0,0,0,'0',2,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.shadowbox(big=col_current.table.col.big_img.value, small=col_current.value, name=''images'')]',0,'','','','','2015-10-07 15:56:10','2015-12-15 02:28:39'),
(3,2,1,0,'Название','name','dd71327fb4c59acfed1b209515103540',0,0,1,0,0,0,0,'0',3,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-08 00:12:40','2015-11-08 15:02:58'),
(4,2,1,-1,'Ссылка','link','2b45fc6eefec8f7de24fce179a381f7c',0,0,1,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-08 00:13:50','2015-12-09 11:53:16'),
(5,2,1,-1,'Дата загрузки','date','9528ae12cc5b5eaf81c0861281b2bd7e',0,0,1,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'[form.datepicker(value=global.date)]','','','','2015-10-13 16:11:14','2015-12-09 11:53:32'),
(6,2,0,0,'Высота миниатюры','min_height','081c8148b6210dedc28665f0ec886b86',0,0,1,0,0,0,0,'0',6,0,1,0,0,'120','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:24:56','2015-10-13 16:25:28'),
(7,2,0,0,'Ширина миниатюры','min_width','b9d918042fd4988b9fd66f4b52f1512a',0,0,1,0,0,0,0,'0',5,0,0,0,0,'200','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:25:18','0000-00-00 00:00:00'),
(8,2,0,0,'Высота большого изображения','big_height','9464fcc58ae5eadf47e9c3e144d0c91d',0,0,1,0,0,0,0,'0',2,0,0,0,0,'800','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:25:44','0000-00-00 00:00:00'),
(9,2,0,0,'Ширина большого изображения','big_width','b262168397ffc71a2fd3aad59a933707',0,0,1,0,0,0,0,'0',1,0,0,0,0,'1100','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:25:57','0000-00-00 00:00:00'),
(10,2,0,0,'Тип сжатия большого изображения','big_type','dd3bf463eb8a79e2fe3c5c1c2cee6957',0,0,1,0,0,0,0,'0',3,0,0,0,181,'1','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:26:32','2015-10-13 16:47:44'),
(11,2,0,0,'Тип сжатия миниатюры','min_type','d71d81abef3e5bd6030d18181f3c98e5',0,0,1,0,0,0,0,'0',7,0,0,0,181,'6','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:26:53','0000-00-00 00:00:00'),
(12,2,0,0,'Тип обрезки большого изображения','big_crop','9ae216780353288d04f405302574095c',0,0,1,0,0,0,0,'0',4,0,0,0,182,'2','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:27:34','0000-00-00 00:00:00'),
(13,2,0,0,'Тип обрезки миниатюры','min_crop','ab3c2a3b8842fd109ef8dbe5f816be5f',0,0,1,0,0,0,0,'0',8,0,0,0,182,'2','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-13 16:27:53','0000-00-00 00:00:00'),
(14,0,0,0,'Текст','body','64b68139f5b44d2d83b780e48b6f2b85',0,0,0,0,0,0,1,'0',4,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','a:1:{s:43:"col_onform_64b68139f5b44d2d83b780e48b6f2b85";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}}','2015-10-16 13:47:13','2015-10-16 21:26:37'),
(15,0,0,0,'Url страницы','url','6a6e6c36138cd6e3a851ff05c67da91b',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url(first_empty=true)]','','[form.url(first_empty=true)]','a:2:{s:45:"col_oninsert_6a6e6c36138cd6e3a851ff05c67da91b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_6a6e6c36138cd6e3a851ff05c67da91b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','2015-10-16 14:39:05','2016-03-23 19:25:46'),
(16,0,0,0,'Шаблон','tpl','7d167460c96c4b9cdecc7dcf326a70e6',0,0,0,0,0,0,0,'0',5,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','a:1:{s:43:"col_onform_7d167460c96c4b9cdecc7dcf326a70e6";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}}','2015-10-16 21:26:20','0000-00-00 00:00:00'),
(18,0,0,0,'Миниатюра','mini','d9cf6ca7b9207e817452d494ce259418',3,0,0,0,0,0,0,'0',6,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','a:1:{s:43:"col_onshow_d9cf6ca7b9207e817452d494ce259418";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','2015-10-16 21:50:49','2015-10-16 22:07:33'),
(19,0,0,0,'Изображение','big_img','efb49e591b7f8aaa339b0bbb05905203',3,0,2,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','a:2:{s:45:"col_oninsert_efb49e591b7f8aaa339b0bbb05905203";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_efb49e591b7f8aaa339b0bbb05905203";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','2015-10-16 22:05:30','2016-04-20 15:24:45'),
(20,0,0,0,'Дата','date','f27bfeedb6e9fcf1d16b2e68f15b64f2',0,0,0,0,0,0,0,'0',8,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','[col_current.value.ndate]',0,'[form.datepicker]','','','a:1:{s:43:"col_onform_f27bfeedb6e9fcf1d16b2e68f15b64f2";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}}','2015-10-16 22:22:45','0000-00-00 00:00:00'),
(21,0,0,0,'Заголовок','title','a1e532d67594d36a5e1936d3b56f6a09',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','a:0:{}','2015-10-16 22:23:32','0000-00-00 00:00:00'),
(22,0,0,0,'Большое поле текста','big_text','0542f3622e14221cff34668b6b3a9cf5',0,0,0,0,0,0,1,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''300px'')]','','','a:1:{s:43:"col_onform_0542f3622e14221cff34668b6b3a9cf5";a:1:{i:3;a:1:{s:8:"textarea";s:8:"textarea";}}}','2015-10-17 18:03:36','0000-00-00 00:00:00'),
(23,0,2,0,'Заголовок','title','32801e7fbeec2edc8ef31442fe7c5028',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 00:30:21','0000-00-00 00:00:00'),
(24,0,2,0,'Url','url','0cfe7aa2c23b737c75c342a1425a304b',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url(first_empty=true)]','','[form.url(first_empty=true)]','','2015-10-18 00:30:27','2016-03-23 19:30:28'),
(25,0,2,0,'Текст','body','6fcc88fd8c44795cc09d41d17a245ff3',0,0,0,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-18 00:30:37','0000-00-00 00:00:00'),
(26,0,3,0,'Заголовок','title','ebea83634b4ef80f2a4e14c71b429477',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 00:37:21','0000-00-00 00:00:00'),
(27,0,3,0,'Url','url','9cc533c73502ead4c49f5ba5a8e623e9',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-10-18 00:37:24','2016-03-23 19:30:45'),
(28,0,3,0,'Текст','body','30010e38ff6d827bd1383f57c78ef0d4',0,0,0,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-18 00:37:29','0000-00-00 00:00:00'),
(29,0,3,0,'Миниатюра','mini','7af8a8bc31b2a826377b05346a4693f0',3,0,0,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-10-18 00:37:35','0000-00-00 00:00:00'),
(30,0,3,0,'Изображение','big_img','41ab374afda20cdc3a4dceec9c49f75b',3,0,2,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-10-18 00:37:39','2016-04-20 15:32:39'),
(31,0,4,0,'Миниатюра','mini','44730f34f2465e50b3ec07f01ed98f8b',3,0,0,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-10-18 00:56:23','0000-00-00 00:00:00'),
(32,0,4,0,'Изображение','big_img','ab7f474b05e88a74640516102d2ef4ff',3,0,2,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-10-18 00:56:31','2016-04-20 15:32:19'),
(33,1,5,0,'Заголовок','title','a7a44d78d7e84378e996bc6180c4580f',0,0,5,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:44:39','2016-03-30 04:25:40'),
(34,1,5,-1,'Url','url','89f0bc40e3e7481d06382740bf08e9f2',0,0,5,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url(first_empty=true)]','','[form.url(first_empty=true)]','','2015-10-18 14:44:39','2016-03-23 19:20:15'),
(35,1,5,0,'Текст','body','ac3fde6953c19e57d666c913880f4eaa',0,0,5,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-18 14:44:39','2015-10-25 22:38:52'),
(36,0,6,0,'Заголовок','title','a2b704243bc988260a25076337ac04f5',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:45:15','2015-10-18 15:11:12'),
(37,0,6,0,'Шаблон','body','7df942532644fe6abf84db1f89cb317a',0,0,2,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2015-10-18 14:45:20','2016-03-26 09:32:56'),
(38,1,7,0,'Заголовок','title','de16ea10e8841fa986096ac4d153ef5c',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:45:51','2015-10-18 15:11:24'),
(39,1,7,0,'Шаблон','body','ab421491b6fc81f552f918d535b9b33a',0,0,5,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[default='''']\r\n[if f_action==''add'']\r\n    [default=''<html>\r\n<head>\r\n    [* title, css, scripts, meta, favicon *]\r\n    [cm.part.head]\r\n</head>\r\n<body>\r\n\r\n    [* h1 *]\r\n    [cm.part.title]\r\n    \r\n    [* content *]\r\n    [cm.part.body]\r\n    \r\n</body>\r\n</html>'']\r\n[/if]\r\n[form.meditor(table=cex.pages, value=$default, vars=(''glob.tpl|Текущий шаблон|CMD_ROW|''+cex.tpl.rid) )]','','','','2015-10-18 14:45:51','2016-02-15 12:39:32'),
(40,1,8,0,'Позиция','name','7d677116cc2c285ae9bc08a1e8fe09da',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:52:33','2015-10-18 14:57:30'),
(41,1,9,0,'Название группы','title','fb96832ae4efc5cfe63054d8de274584',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:56:53','2015-10-18 14:57:12'),
(42,0,0,0,'Заголовок (без индексации)','title','22471bfa703ce499b4b374d10cdc8fe1',0,0,2,0,0,0,0,'0',10,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','a:0:{}','2015-10-18 14:59:16','0000-00-00 00:00:00'),
(43,1,10,0,'Заголовок','title','9c7e66fbce7812238ca8c399cd9dbf58',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 14:59:44','2015-10-18 14:59:49'),
(44,1,10,0,'Текст','body','d3aff7f97b8312980d87fa582a207af1',0,0,5,0,0,0,1,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-18 14:59:57','2015-10-19 13:10:55'),
(45,1,10,0,'Блок','block','189ce09effcf466fc4520eb2f219f832',4,0,5,0,0,0,0,'0',3,0,1,0,0,'','',0,0,0,0,0,1,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 15:00:30','0000-00-00 00:00:00'),
(46,1,10,0,'Прилегание','align','c1ee55496f72107d0408d327c154cf04',1,0,8,0,0,0,0,'0',4,0,0,3,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 15:01:09','0000-00-00 00:00:00'),
(48,1,11,0,'Заголовок','title','9b324a05cf18204e5c6b98f62da94d1e',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 15:08:26','2015-10-18 15:11:01'),
(49,1,11,0,'Шаблон','body','2b34f4b7fc78df8c8691458174adca8b',0,0,5,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[default='''']\r\n[if f_action==''add'']\r\n    [default=''<div class="block_title">\r\n    [current.title]\r\n</div>\r\n<div class="block_body">\r\n    [current.body]\r\n</div>\r\n<div class="block_dynamic">\r\n    [current.block.url_run]\r\n</div>'']\r\n[/if]\r\n[form.meditor(cur_table=cex.blocks, value=$default)]','','','','2015-10-18 15:08:26','2015-11-02 12:06:21'),
(50,1,7,0,'Связанные шаблоны блоков','block_tpl','a8c0814dbc28f014e4ac100decb13942',1,0,11,1,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-10-18 15:09:40','2015-10-21 14:37:08'),
(51,1,7,0,'Доступные позиции для блоков','block_align','3df25182f6cd1834d855446f7cc4bbd6',1,0,8,1,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-10-18 15:10:28','2015-10-18 16:57:46'),
(52,1,11,0,'Возможные прилегания','align','be4dbb62f9d5d3562e42199148411649',1,0,8,1,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-10-18 15:13:59','2015-10-18 15:31:47'),
(53,1,0,0,'Заголовок','title','10e104b79cde30e3b1a1015a4fb6c5e6',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','a:0:{}','2015-10-18 15:25:50','2015-10-18 15:26:00'),
(54,1,0,0,'Шаблон','tpl','ea56e29ba0e06b0c0c515ca6473ce6a4',1,0,7,0,2,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-18 15:26:38','2016-02-15 10:53:55'),
(55,1,0,0,'Основная группа блоков','block_array','463c7261223d39fdae56dd0ccb4effd8',1,0,9,0,2,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-18 15:27:05','0000-00-00 00:00:00'),
(56,1,5,-1,'Свой шаблон','tpl','cabda48aaf0b97baa02c00f6957d2fce',1,0,7,0,2,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 16:50:57','2016-02-15 10:54:15'),
(57,1,5,-1,'Своя группа блоков','block_array','3501935c3b7c5b8317840dff8913dd8b',1,0,9,0,2,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 16:51:29','2015-10-18 17:28:35'),
(58,1,10,0,'Шаблон','tpl','56322dbc49cd1cd3efef7e59d3df7767',1,0,11,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 17:07:08','0000-00-00 00:00:00'),
(59,1,5,-1,'Связь с модулем','module','889b0cb404e02608c7c9f3113b4b15f8',4,0,5,0,0,0,0,'0',6,0,1,0,0,'','',0,0,0,0,1,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 17:24:09','2015-10-18 17:28:29'),
(60,1,12,0,'Название','name','2c116290c390b07c79c75228ee19ea49',0,0,5,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 17:26:24','0000-00-00 00:00:00'),
(61,1,12,0,'Url','url','7ba02eec927e6eadd12498846eb03318',0,0,5,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[col_current.form_noprocess]\r\n[if is_admin? && f_action==''add'']\r\n<input type="hidden" name="[col_current.formname]_edited" id="[col_current.formname]_edited" value="">\r\n<script>\r\n    if(typeof window[[''translate_latinica'']] == ''function''){\r\n        var dst=$(''#[col_current.table.major.formname]'');\r\n        var src=$(''#[col_current.formname]'');\r\n        var edited=$(''#[col_current.formname]_edited'');\r\n        dst.blur(function() {\r\n            if(src.val()=='''' && !edited.val()) src.val(translate_latinica(dst.val()));\r\n        });\r\n        src.focus(function() {\r\n            edited.val(1);\r\n        });\r\n    }\r\n</script>\r\n[/if]','','[if f_action==''add'' && !post.{[current_col.formname]_edited}]\r\n    [func.latinica]\r\n[/if]','','2015-10-18 17:26:40','2015-11-15 18:56:19'),
(62,1,0,0,'Язык сайта','lng','47e4b90334023a2b26945e34b9089f47',1,0,12,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-18 17:27:22','0000-00-00 00:00:00'),
(63,1,5,-1,'Язык страницы','lng','a12402861d0b153e7fb425a42bb3e4ab',1,0,12,0,0,0,0,'0',7,0,0,2,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-18 17:27:54','2015-10-18 17:28:14'),
(64,1,14,0,'URL','url','798aff98650e8f2de9e6633857cb9a31',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',2,0,1,0,0,0,'/files/uploads/content/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 17:35:32','0000-00-00 00:00:00'),
(65,1,14,0,'JS код','body','e7c8ecb7fa33e1aa0f835a6673be2a87',0,0,5,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'[form.jeditor]','','','','2015-10-18 17:36:03','0000-00-00 00:00:00'),
(66,1,13,0,'URL','url','afe28d282d4ef6621a2eb130966c2ff2',0,0,5,0,0,0,0,'0',1,0,1,1,0,'','',2,0,1,0,0,0,'/files/uploads/content/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-18 17:36:35','0000-00-00 00:00:00'),
(67,1,13,0,'CSS стили','body','ea913b012792057c548a8a156468f80c',0,0,5,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'[form.seditor]','','','','2015-10-18 17:37:02','0000-00-00 00:00:00'),
(68,1,5,-1,'Ключевые слова для поисковых машин','meta_keywords','1be2423d846c711e3c1611843964903f',0,0,5,0,0,0,0,'0',8,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','через запятую','','','2015-10-18 18:59:45','0000-00-00 00:00:00'),
(69,1,5,-1,'Описание для поисковых машин','mera_description','dcd2dac49b3c7e57ba79bf66fe4d9cd2',0,0,5,0,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''150px'')]','','','','2015-10-18 19:00:19','0000-00-00 00:00:00'),
(70,1,0,0,'Иконка','favicon','220786e9ab3ab694c170be5401db125c',3,0,5,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/favicon/',0,'fav','ico,png,jpg,jpeg,gif',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-18 19:21:10','0000-00-00 00:00:00'),
(71,1,0,0,'Логотип','logo','1d452abb3a7e07f6c983226905da6b14',3,0,5,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/sites/',0,'logo','jpg,png,gif,jpeg',0,1,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 07:29:28','0000-00-00 00:00:00'),
(72,1,0,0,'Название компании','company_name','b8233cb2692b0eddfc650ddc3496a2a1',0,0,5,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 07:29:53','0000-00-00 00:00:00'),
(73,1,0,0,'Слоган компании','company_slogan','d787b60270a78779f13381e23a4142c8',0,0,5,0,0,0,0,'0',8,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 07:30:15','0000-00-00 00:00:00'),
(74,1,0,0,'Номер телефона','phone','310484bcfd9d4adf35ec559164571dde',0,0,5,0,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 07:30:22','0000-00-00 00:00:00'),
(75,1,0,0,'Счётчики посещений','counters','46c8b30b613dc57f65394f83e4d38295',0,0,5,0,0,0,0,'0',10,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''300px'')]','','','a:1:{s:43:"col_onform_46c8b30b613dc57f65394f83e4d38295";a:1:{i:3;a:1:{s:8:"textarea";s:8:"textarea";}}}','2015-10-21 07:31:02','0000-00-00 00:00:00'),
(76,3,15,0,'Заголовок','title','c675b796488b8c3e2b295275322d7e8d',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-21 08:17:30','0000-00-00 00:00:00'),
(77,3,15,0,'Шаблон','tpl','8395149807e31d2200013e1cd5dd8086',0,0,15,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor(cur_part=''list'')]','','','','2015-10-21 08:17:30','2015-10-21 09:34:48'),
(78,3,16,0,'Заголовок','title','5cb3a2ef82fafc0c814f5ef1ace6bb1b',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-21 08:21:16','0000-00-00 00:00:00'),
(79,3,16,0,'Шаблон','tpl','9e67edbd2bf120af0a77493226d26bac',0,0,0,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2015-10-21 08:21:16','0000-00-00 00:00:00'),
(80,3,17,0,'Заголовок','title','f698e058d54cac93f0c7d94d77ab7dcd',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-21 08:21:39','0000-00-00 00:00:00'),
(81,3,17,0,'Шаблон','tpl','a3b4d2c3a30173ee47c33aa29761df85',0,0,0,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2015-10-21 08:21:39','0000-00-00 00:00:00'),
(82,1,7,0,'Папка с изображениями','folder','86246c18efb5cc7527a75cc9623a7a37',6,0,5,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/design/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-21 08:54:16','0000-00-00 00:00:00'),
(83,1,18,0,'Название','name','123cbcedf06894d0295dd86d44eabae5',0,0,5,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-21 14:27:01','0000-00-00 00:00:00'),
(84,1,19,0,'Ссылка на страницу','page','e91410bd3ff04279ccce11018638f40f',1,0,5,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-21 14:28:24','0000-00-00 00:00:00'),
(85,1,19,0,'Произвольная ссылка','link','a2f24be3fcd331075f674a07dd453956',0,0,5,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,0,1,0,'','',0,'','','','','2015-10-21 14:29:16','2015-10-23 20:31:01'),
(87,1,20,0,'Изображение','big_img','abba3acb02411974b9e5b153326f5883',3,0,5,0,0,0,0,'0',2,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'slider','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=450, image_big=col_current.value)]',0,'','','[func.preview(height=cex.param.slider_height, width=cex.param.slider_width, type=''6'', crop=cex.param.slider_crop)]','','2015-10-21 14:41:41','2015-10-21 18:04:07'),
(88,1,0,0,'Ширина изображения слайдера','slider_width','715272b63bf9416ac43707a9de9bf335',0,0,5,0,0,0,0,'0',11,0,0,0,0,'1100','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 14:44:31','0000-00-00 00:00:00'),
(89,1,0,0,'Высота изображения слайдера','slider_height','5db26122ed207e0eff160e2087cf5c99',0,0,5,0,0,0,0,'0',12,0,0,0,0,'200','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 14:44:47','0000-00-00 00:00:00'),
(90,1,5,0,'Отображать в меню','in_menu','2a2fba51e87833a733c688c9e0e0ce9e',2,0,5,0,0,0,0,'0',10,0,1,1,0,'1','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-21 15:37:18','0000-00-00 00:00:00'),
(91,1,20,0,'Заголовок','title','a1c9c455f2aaa92659fc2fb0945b9c49',0,0,5,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-21 15:42:51','0000-00-00 00:00:00'),
(92,1,0,0,'Позиция обрезки изображения слайдера','slider_crop','ee26d44afec5864799ac039946405a6c',0,0,5,0,0,0,0,'0',13,0,0,0,182,'2','',0,0,0,0,0,0,'/files/uploads/content/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-21 18:03:01','0000-00-00 00:00:00'),
(93,4,21,0,'Заголовок','title','983059a6d73ebffc11b0a58530797862',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 02:54:31','0000-00-00 00:00:00'),
(94,4,21,-1,'Url','url','fc376db046134e99ec444507589fdaf8',0,0,21,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-10-26 02:54:31','2016-03-23 19:28:21'),
(95,4,21,0,'Текст','body','ef44680795002aea99e4512bf18be8c0',0,0,21,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-26 02:54:31','2015-11-04 23:40:44'),
(98,0,0,0,'Ширина большого изображения','big_width','65aaee71887389bfa5465ba86ffbffa9',0,0,2,0,0,0,0,'0',100,0,0,0,0,'1100','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:06:57','0000-00-00 00:00:00'),
(99,0,0,0,'Высота большого изображения','big_height','c1c1840ec6e4ae108e481fdb1b79b3ef',0,0,2,0,0,0,0,'0',101,0,0,0,0,'800','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:07:28','0000-00-00 00:00:00'),
(100,0,0,0,'Тип сжатия большого изображения','big_type','38b0d1a5c0c5dd427ad6f42f98aed5e7',0,0,2,0,0,0,0,'0',102,0,0,0,181,'1','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:08:00','0000-00-00 00:00:00'),
(101,0,0,0,'Тип обрезки большого изображения','big_crop','1efb60a2dc9af6c440277e462916f479',0,0,2,0,0,0,0,'0',103,0,0,0,182,'1','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:08:21','0000-00-00 00:00:00'),
(102,0,0,0,'Ширина миниатюры','min_width','49b80736e19aaccd0bb934a6fac7de48',0,0,2,0,0,0,0,'0',104,0,0,0,0,'150','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:09:10','0000-00-00 00:00:00'),
(103,0,0,0,'Высота миниатюры','min_height','5bfc60c2def0d4309318d2f3a1df8491',0,0,2,0,0,0,0,'0',105,0,0,0,0,'100','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:09:22','0000-00-00 00:00:00'),
(104,0,0,0,'Тип сжатия миниатюры','min_type','32cdf39874af837cd46d51867082c9b6',0,0,2,0,0,0,0,'0',106,0,0,0,181,'6','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:09:38','0000-00-00 00:00:00'),
(105,0,0,0,'Тип обрезки миниатюры','min_crop','f7182afe13adfad8538911809c7a02a4',0,0,2,0,0,0,0,'0',107,0,0,0,182,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 03:09:54','2016-04-12 04:55:08'),
(106,4,21,0,'Миниатюра','mini','a8f7e520b5d26beaee27ad8b3b1691c3',3,0,0,0,0,0,0,'0',5,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-10-26 03:13:05','0000-00-00 00:00:00'),
(107,4,21,0,'Изображение','big_img','fc1839d6f049d779913c5c79714c41b3',3,0,21,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-10-26 03:13:12','2016-04-20 15:13:21'),
(108,4,22,0,'Заголовок','title','517556de2f671eece382c32404f3819e',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 03:13:56','0000-00-00 00:00:00'),
(109,4,22,0,'Шаблон','tpl','353242c4820761c26cdd1d69fab9f168',0,0,21,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor(vars=(''rows|Статьи|CMD_ARRAY'',''count|Количество статей всего|CMD_STRING'',''num|Количество статей на странице|CMD_STRING'',''main_page|Главная страница или страница категории|CMD_STRING''))]\r\n','','','','2015-10-26 03:13:56','2015-12-09 05:35:03'),
(112,4,23,0,'Заголовок','title','22ab85b0cbffc51493f172f2f3b093da',0,0,21,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 03:14:37','2015-10-26 03:14:50'),
(113,4,23,0,'Шаблон','tpl','e419e1a7735542ad49fd8221562b9002',0,0,21,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor(table=cex.articles)]','','','','2015-10-26 03:14:45','2015-10-26 10:34:09'),
(114,4,24,0,'Заголовок','title','fe3f6e18b00a4460493cc803212c759b',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 03:17:05','0000-00-00 00:00:00'),
(116,4,24,0,'Описание','body','f8849d54f8f653b6751c5c25059e1af8',0,0,21,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-10-26 03:17:05','2015-10-26 03:17:17');

INSERT INTO `main_col` (col_id,col_module,col_table,col_cat,col_name,col_sname,col_uin,col_type,col_target,col_link,col_link2,col_link3,col_link4,col_index,col_deep,col_pos,col_order,col_bold,col_filter,col_paramlink,col_default,col_deflist,col_unique,col_required,col_url,col_tpl,module_url,module_type,file_dir,file_maxsize,file_prefix,file_types,file_totalmax,file_genname,col_inform,col_fastedit,col_part,col_speclink,col_onshow,col_force_onshow,col_onform,col_hint,col_oninsert,col_parts,col_date,col_date2) VALUES
(117,4,25,0,'Заголовок','title','f9105d5ed50e4dd1371c28b3c32e4b39',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 03:25:15','0000-00-00 00:00:00'),
(118,4,25,0,'Шаблон','tpl','cfa4ddcfd4e56491b5f4cb0860fec339',0,0,21,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor(vars=(''rows''))]','','','','2015-10-26 03:25:15','2015-11-02 21:54:52'),
(119,4,26,0,'Название','name','ac68ea1c525d0dd3479e454136326d34',0,0,21,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 04:33:38','2015-10-26 04:33:55'),
(120,4,26,0,'Url','url','d2ad7bbba300342e66f75c766d7fea66',0,0,21,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-10-26 04:33:38','2016-03-23 19:28:35'),
(122,4,21,0,'Метки','tags','744b97788be191188c3919a4af0eccad',1,0,26,1,0,0,0,'0',7,0,0,2,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'[form.select2(lng=''ru'', ajax=''off'')]','','[form.select2]','','2015-10-26 04:38:21','2015-12-07 15:17:02'),
(123,4,27,0,'Заголовок','title','1f8d26ae5384ed99526a39b0752e75f1',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 04:43:28','0000-00-00 00:00:00'),
(124,4,27,0,'Шаблон','tpl','c0eedebfd4dbfcccaee35c94c6a3566c',0,0,0,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2015-10-26 04:43:28','0000-00-00 00:00:00'),
(125,4,21,0,'Дата публикации','date','42d74de04923e5031a014a87c935aa29',0,0,21,0,0,0,0,'0',8,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','[col_current.value.ndate]',0,'[form.datepicker]','','','','2015-10-26 05:05:50','2015-10-26 05:06:00'),
(126,4,28,0,'Заголовок','title','1afcb41d24b1ba80e15e1321004ce101',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 05:16:42','0000-00-00 00:00:00'),
(127,4,28,0,'Шаблон','tpl','25e5a7c774cefe0c9ac1fa5507c38fca',0,0,0,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2015-10-26 05:16:42','0000-00-00 00:00:00'),
(128,4,21,-1,'Свой шаблон','tpl','29422aa3692e047a1ddd220fcf281032',1,0,23,0,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-26 05:21:43','0000-00-00 00:00:00'),
(129,4,0,0,'Шаблон статьи','article_tpl','231a82e3b48c0a5dac952921e52e9cde',1,0,23,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:30:48','2015-10-26 11:44:25'),
(130,4,0,0,'Шаблон списка','feed_tpl','2ba143c2b7f06c61a5149407c967d66c',1,0,22,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:31:25','0000-00-00 00:00:00'),
(131,4,0,0,'Шаблон блока статей','block_tpl','0b90a03d82d7e4961601008f02f75b27',1,0,25,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:33:14','0000-00-00 00:00:00'),
(132,4,0,0,'Шаблон блока категорий','block_cat_tpl','6f601f006c324e6e86fbb07b9f9d7909',1,0,28,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:34:00','0000-00-00 00:00:00'),
(133,4,0,0,'Шаблон блока меток','block_tag_tpl','bb5af4535324b5a5ad1ad03dba060dbd',1,0,27,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:34:16','0000-00-00 00:00:00'),
(134,4,0,-1,'Иконка для RSS ленты','rss_icon','828d03f9ce39414761caac0c9ec704f0',3,0,21,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','jpg,png,gif,jpeg',0,1,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:35:34','2015-11-02 16:22:02'),
(135,4,0,0,'Количество символов в анонсе','anons_length','965fc7f903f3227b419b7f4acd49f223',0,0,21,0,0,0,0,'0',7,0,0,0,0,'1500','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:37:05','0000-00-00 00:00:00'),
(136,4,0,-1,'Альтернативный адрес для ленты RSS','rss_link','870d6aed5c750983f0dcf03fd257562e',0,0,21,0,0,0,0,'0',8,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:37:33','2015-11-02 16:22:13'),
(137,4,0,0,'Встроить блок архива в список статей','embed_archive','fd889b7408a2590525a555bc50c1b8f0',2,0,21,0,0,0,0,'0',9,0,0,0,0,'1','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:39:01','0000-00-00 00:00:00'),
(138,4,0,0,'Количество статей в блоке анонса','articles_in_block','cbda7a0b6a39d987bf77635e36ae7ccf',0,0,21,0,0,0,0,'0',10,0,0,0,0,'10','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:39:31','0000-00-00 00:00:00'),
(139,4,0,0,'Использовать отдельное поле для анонса','use_anons_field','37c6982e1982dda94609ec2e9c1bf556',2,0,21,0,0,0,0,'0',11,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:40:38','0000-00-00 00:00:00'),
(140,4,21,0,'Анонс','anons','19eb4ff7cdd7dc5f919b08451c54b601',0,0,21,0,0,0,0,'0',4,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[if cex.param.use_anons_field][form.ckeditor][/if]','','','','2015-10-26 05:40:50','2015-10-26 05:41:31'),
(141,4,0,0,'Показывать автора','show_author','08239977839507247e28e638a7cfdcbc',2,0,21,0,0,0,0,'0',12,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 05:42:32','0000-00-00 00:00:00'),
(142,5,29,0,'Имя автора','name','72416ce457501eab712308a56a54014b',0,0,29,0,0,0,0,'0',2,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-26 05:50:24','0000-00-00 00:00:00'),
(143,5,29,-1,'Email автора','email','12b2a18d7fda7e9a5024bbb2c296e79e',0,0,29,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-26 05:50:47','0000-00-00 00:00:00'),
(144,5,29,0,'Комментарий','body','7b4591feb0f58facf99715190cca49f7',0,0,29,0,0,0,0,'0',4,0,1,0,0,'','',0,1,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''150px'', width=''100%'')]','','[current_col.set(current_col.value.safe_input)]','','2015-10-26 05:52:19','2016-04-07 20:39:23'),
(145,5,29,0,'Дата и время добавления','date','c2df92876c0a60c5a9b866055a8719ff',0,0,29,0,0,0,0,'0',5,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','[col_current.value.gdate.ndate] [col_current.value.gtime]',0,'','','[if f_action==''add''][col_current.set(glob.datetime)][/if]','','2015-10-26 05:52:29','2016-03-24 00:37:43'),
(146,5,29,0,'На модерации','moderation','291242e83ee90d03b3b292233483621d',2,0,29,0,0,0,0,'0',6,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-10-26 05:54:23','2016-04-08 15:32:27'),
(147,4,24,-1,'Свой шаблон списка статей','tpl','9aae5967d1107f39b7e0884861a868b4',1,0,22,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-10-26 06:03:18','2015-10-29 15:36:16'),
(148,4,0,0,'Количество статей на одной странице списка','on_page','9aa274490f9e20ac004ad92be7755786',0,0,21,0,0,0,0,'0',13,0,0,0,0,'20','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-10-26 09:34:44','0000-00-00 00:00:00'),
(149,4,21,-1,'Мета-описание','meta_description','137915a56b759d7572419e50c9880353',0,0,21,0,0,0,0,'0',10,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''150px'')]','описание для поисковых машин','','','2015-10-26 10:59:32','2015-10-26 11:57:56'),
(150,4,21,-1,'Мета-ключевые слова','meta_keywords','a744e5225544222cb99729918af204e0',0,0,21,0,0,0,0,'0',11,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','ключевые слова для поисковых машин','','','2015-10-26 10:59:56','0000-00-00 00:00:00'),
(151,0,0,0,'Url','url','e158baa8abbb9d538bbd8d53c02696de',0,0,2,0,0,0,0,'0',3,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','a:2:{s:45:"col_oninsert_e158baa8abbb9d538bbd8d53c02696de";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_e158baa8abbb9d538bbd8d53c02696de";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','2015-10-26 11:22:11','2016-03-25 22:48:02'),
(154,4,24,-1,'Url','url','0511814f51fe64912f469eb6bc858d3b',0,0,21,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-10-29 16:44:20','2016-03-23 19:28:27'),
(155,4,0,0,'Отображать на главной статьи из всех категорий','show_all','e417d11f914920e6a849f291d6beffde',2,0,21,0,0,0,0,'0',14,0,0,0,0,'1','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-02 16:21:42','0000-00-00 00:00:00'),
(156,4,0,-1,'Категория по умолчанию для блока последних статей','main_category','45f332ccb44ab3a3669902d753798e8d',1,0,24,0,2,0,0,'0',15,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-02 16:32:22','2015-11-02 22:40:50'),
(157,4,0,-1,'Показывать в блоке "Последние статьи" статьи текущей категории','show_current_articles','158af9ab3c14682619ec75fc5d75cde1',2,0,21,0,0,0,0,'0',16,0,0,0,0,'1','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-02 16:34:14','2015-11-02 22:40:41'),
(158,4,0,-1,'Показывать блок последних статей только на главной','show_block_on_main','b79baabe0a841e5ff230458bb930268f',2,0,21,0,0,0,0,'0',17,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-02 22:47:29','2015-11-02 22:47:35'),
(159,4,21,0,'Просмотров','hint','12ada808303cd7440a23d526994ff622',0,0,21,0,0,0,0,'0',12,0,1,0,0,'0','',0,0,0,0,0,0,'/files/uploads/articles/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-11-02 22:54:46','2015-11-03 04:12:07'),
(160,0,30,0,'Заголовок','title','d84fde9e101a93bfb9c8248149372992',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-11-03 04:25:00','0000-00-00 00:00:00'),
(161,0,30,0,'Url','url','6a140690824909be38529bc594cc44b4',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-11-03 04:25:03','2016-03-23 19:31:02'),
(162,0,30,0,'Текст','body','cf4c5e3c7c130c2ac1cbfb24dae1b95a',0,0,0,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-11-03 04:25:10','0000-00-00 00:00:00'),
(163,0,30,0,'Миниатюра','mini','8cc7283a29021a0facfcd25f18521654',3,0,0,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-11-03 04:25:14','0000-00-00 00:00:00'),
(164,0,30,0,'Дата','date','336f8ada1e6c00938721a7a2daa70a9a',0,0,0,0,0,0,0,'0',6,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','[col_current.value.ndate]',0,'[form.datepicker]','','','','2015-11-03 04:25:56','0000-00-00 00:00:00'),
(165,2,31,0,'Заголовок','title','41b72587e3e5484072b4352fcf007f68',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-11-03 04:26:15','0000-00-00 00:00:00'),
(166,2,31,0,'Url','url','cf618b049eed9191f9f67e0687e06122',0,0,1,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-11-03 04:26:15','2016-03-23 19:29:05'),
(167,2,31,0,'Текст','body','c44518c2ff71aadbcc4537e539ee720a',0,0,0,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-11-03 04:26:15','0000-00-00 00:00:00'),
(168,2,31,0,'Миниатюра','mini','e7848d5d8ec172c362f8fc24bdd6f1a4',3,0,0,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-11-03 04:26:15','0000-00-00 00:00:00'),
(169,2,31,-1,'Дата','date','a8105956f89a51d7cccf35f84a276661',0,0,1,0,0,0,0,'0',6,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','[col_current.value.ndate]',0,'[form.datepicker]','','','','2015-11-03 04:26:15','2015-12-09 05:15:48'),
(170,0,30,0,'Изображение','big_img','f6013c03f5ec3ca9d25e3986d8f56f8d',3,0,2,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-11-03 04:27:03','2016-04-20 15:32:54'),
(171,2,31,0,'Изображение','big_img','400aebbe0cb9852bf005a0d604aa1b89',3,0,1,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-11-03 04:27:18','2016-04-20 15:14:52'),
(172,2,32,0,'Заголовок','title','2b6af858f0c7f8a789df426233d96a1e',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-11-03 11:04:41','0000-00-00 00:00:00'),
(173,2,32,0,'Шаблон','tpl','784accca7f43cd4e2c5a514e2c88d83f',0,0,1,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor(table=cex.photo, vars=(''rows|Фотографии|CMD_ARRAY'',''count|Количество фотографий всего|CMD_STRING'',''num|Количество фотографий на странице|CMD_STRING'',''main_page|Главная страница или страница категории|CMD_STRING''))]','','','','2015-11-03 11:04:41','2015-12-09 05:35:10'),
(174,0,33,0,'Заголовок','title','a0d4c342289ec9b86c254058241b9573',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-11-08 13:36:39','0000-00-00 00:00:00'),
(175,0,33,0,'Url','url','09011b458d2a77fa0a3a0b42e0edb5d6',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-11-08 13:36:44','2016-05-13 13:10:40'),
(176,2,34,0,'Заголовок','name','61c8cef08a1de2d565a12e52b969adb4',0,0,1,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-11-08 13:37:09','2015-12-09 12:39:33'),
(177,2,34,0,'Url','url','0ecb91d9d985697c082a3ea155d0521c',0,0,1,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-11-08 13:37:10','2016-03-23 19:29:11'),
(178,2,1,0,'Метки','tags','72aecb26aeee9b8dbc884de08fe5a976',1,0,34,1,0,0,0,'0',6,0,0,3,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'[form.select2(lng=''ru'', ajax=''off'')]','','[form.select2]','','2015-11-08 15:02:48','2015-12-08 05:36:06'),
(179,2,0,0,'Водяной знак (PNG)','watermark','3a6eb4872277c426afc962b4a9d3f647',3,0,1,0,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/watermarks/',0,'wm','png',0,1,1,0,0,'','',0,'','','','a:0:{}','2015-11-13 19:13:36','2016-04-20 15:36:31'),
(180,2,0,0,'Прозрачность водяного знака (в процентах)','watermark_transparent','f2cde8f18c555fa1f66f686787763c3c',0,0,1,0,0,0,0,'0',10,0,0,0,0,'50','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-13 19:14:04','0000-00-00 00:00:00'),
(181,2,0,0,'Тип наложения водяного знака','watermark_position','58077d9e76a3c1801e891b149c40a5c9',0,0,1,0,0,0,0,'0',11,0,0,0,186,'tile','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-11-13 19:14:26','2016-04-20 15:21:55'),
(182,2,0,0,'Шаблон галереи','tpl','9a3c9adda8241bd9516880e3be684a9a',1,0,32,0,0,0,0,'0',12,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-09 05:14:54','0000-00-00 00:00:00'),
(183,2,31,-1,'Шаблон категории','tpl','8f20e38c385305e59789c7df8f6d2b22',1,0,32,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-12-09 05:15:33','0000-00-00 00:00:00'),
(184,2,0,0,'Количество фотографий на странице','num','8b7f8903e37efb6c367994c8de47d523',0,0,1,0,0,0,0,'0',13,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','0 - все фотографии на одной странице','','a:0:{}','2015-12-09 05:32:54','0000-00-00 00:00:00'),
(185,2,0,0,'Шаблон блока','tpl_block','f96618054c72b3eaee701fd9416b74ad',1,0,32,0,0,0,0,'0',14,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-09 05:54:44','0000-00-00 00:00:00'),
(186,2,0,0,'Количество фотографий в блоке','block_count','889927a7fc521fea94681ac245bcedcf',0,0,1,0,0,0,0,'0',15,0,0,0,0,'20','',0,0,0,0,0,0,'/files/uploads/photo/',0,'','',0,0,1,0,0,'','',0,'','0 - все','','a:0:{}','2015-12-09 05:55:45','0000-00-00 00:00:00'),
(187,6,35,0,'Заголовок','title','4c6a2197ea745a4b096aef1b545ac6ee',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-12-11 09:52:48','0000-00-00 00:00:00'),
(188,6,35,0,'Url','url','e1b0cba9d6df55c81de12288abcc14cb',0,0,35,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-12-11 09:52:48','2016-03-23 19:29:38'),
(189,6,35,0,'Описание','description','81ea0b54b49fd63a29d578e099156613',0,0,35,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-12-11 09:52:48','2015-12-11 09:53:04'),
(190,6,35,-1,'Миниатюра','mini','75cb4a5fd4affd4fb9a46e00b931ed7e',3,0,35,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.image(width=150, image_big=col_current.table.col.big_img.value)]',0,'','','','','2015-12-11 09:52:48','2015-12-15 03:12:51'),
(192,6,35,0,'Изображение','big_img','5523107df85efc9573ad9b62ec6d4ae7',3,0,35,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-12-11 09:52:48','2016-04-20 15:10:08'),
(193,6,36,0,'Название','name','bd1dda0b6217105d635be524f7d936e8',0,0,35,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-12-11 09:55:16','2015-12-11 09:55:36'),
(194,6,36,0,'Url','url','de70d659d6945373dcefd8a4e6678092',0,0,35,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2015-12-11 09:55:16','2016-03-23 19:29:48'),
(212,6,42,0,'Название','name','29a14a72ad8db4edc9d091daa01f4186',0,0,35,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-12-14 00:24:10','0000-00-00 00:00:00'),
(214,6,43,0,'Название','name','e6f08192c3574313207d83dce3b366a4',0,0,35,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-12-14 00:43:42','2015-12-14 00:44:24'),
(215,6,43,-1,'Url','url','7fdaedc5094a8d2ca4a1193ebec598e5',0,0,35,0,0,0,0,'0',12,0,0,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.url]','','[form.url]','','2015-12-14 00:43:42','2016-03-23 19:30:00'),
(216,6,43,0,'Описание','description','178bf7ee63ef9826f924dab1af2ef433',0,0,35,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2015-12-14 00:43:42','2015-12-14 00:45:43'),
(217,6,43,0,'Миниатюра','mini','5c0ec6353ad5c71f7a79897dc9459c4d',3,0,35,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'mini','jpg,png,gif,jpeg',0,1,0,0,0,'','[show.shadowbox(big=col_current.table.col.big_img.value, small=col_current.value, name=''images'')]',0,'','','','','2015-12-14 00:43:42','2015-12-15 00:53:19'),
(218,6,43,0,'Дата добавления','date','9c177a9139138f715b82c17de43065d9',0,0,35,0,0,0,0,'0',6,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,0,0,0,'','[col_current.value.ndate]',0,'[form.datepicker]','','[if !current_col.value]\r\n    [current_col.set(glob.date)]\r\n[/if]','','2015-12-14 00:43:42','2015-12-14 00:45:28'),
(219,6,43,0,'Изображение','big_img','a2d1f7b9d6f9464ad823b068dfcf9844',3,0,35,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/photo/',0,'big','jpg,png,gif,jpeg',0,1,1,0,0,'','[show.image(width=150, image_big=col_current.value)]',0,'','','[func.big_to_small(mini=''mini'')]','','2015-12-14 00:43:42','2016-04-20 15:12:09'),
(220,6,0,-1,'Ширина большого изображения','big_width','9db55c948f3d83641c0d96de41d46395',0,0,35,0,0,0,0,'0',1,0,0,0,0,'1100','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:10','2015-12-14 04:34:52'),
(221,6,0,-1,'Высота большого изображения','big_height','3725981638bf9e989fa1cddc8fa32ef1',0,0,35,0,0,0,0,'0',2,0,0,0,0,'800','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:15','2015-12-14 02:52:01'),
(222,6,0,-1,'Тип сжатия большого изображения','big_type','bb0b9dd7460e3096a7f8de88eac5ee5c',0,0,35,0,0,0,0,'0',3,0,0,0,181,'1','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:19','2015-12-14 02:52:07'),
(223,6,0,-1,'Тип обрезки большого изображения','big_crop','ae7d122141dafb46980e3070bda749e1',0,0,35,0,0,0,0,'0',4,0,0,0,182,'1','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:23','2015-12-14 02:52:15'),
(224,6,0,-1,'Ширина миниатюры','min_width','b6bdfc0a94c86f6889fdaa7285a1fc60',0,0,35,0,0,0,0,'0',5,0,0,0,0,'150','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:26','2015-12-14 02:52:21'),
(225,6,0,-1,'Высота миниатюры','min_height','2851eeec0a295594a0846de5ab1406d5',0,0,35,0,0,0,0,'0',6,0,0,0,0,'100','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:31','2015-12-14 02:52:26'),
(226,6,0,-1,'Тип сжатия миниатюры','min_type','fa1270f235b15aa7c5c9874d2b27ae60',0,0,35,0,0,0,0,'0',7,0,0,0,181,'6','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:35','2015-12-14 02:52:31'),
(227,6,0,-1,'Тип обрезки миниатюры','min_crop','8889a9808e513e6feca70b7b78e8f5d8',0,0,35,0,0,0,0,'0',8,0,0,0,182,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2015-12-14 02:50:39','2015-12-14 02:51:56'),
(228,6,43,0,'Просмотров','view','700bd03ac4d575d878fa22ddb0bfff87',0,0,35,0,0,0,0,'0',7,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-12-14 03:02:51','0000-00-00 00:00:00'),
(229,6,43,0,'Покупок','buy','48e5e0998bb143cfac1d52e684ca79a3',0,0,35,0,0,0,0,'0',8,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-12-14 03:03:09','0000-00-00 00:00:00'),
(230,6,43,0,'Теги','tags','c0c6540e57e11a99673b1e4c35f7de6b',1,0,36,1,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'[form.select2(ajax=''off'')]','','[form.select2]','','2015-12-14 03:04:05','2016-04-18 12:19:09'),
(231,6,43,0,'Артикул','number','2d0060d4e713218bced7c663d7390acb',0,0,35,0,0,0,0,'0',2,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-12-14 03:05:19','0000-00-00 00:00:00'),
(232,6,43,-1,'ID для синхронизации','sinc','7c037c9917ffdda74b9cb3e1c2777db8',0,0,35,0,0,0,0,'0',11,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2015-12-14 03:05:59','0000-00-00 00:00:00'),
(233,6,43,0,'Рейтинг (сумма баллов)','rate_summ','6b6fa274ae05fe8148137adbd23f45d1',0,0,35,0,0,0,0,'0',13,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-12-14 03:07:13','0000-00-00 00:00:00'),
(234,6,43,0,'Рейтинг (кол-во голосов)','rate_count','4bc3c16b6526ccc5189fd79539b0cfa0',0,0,35,0,0,0,0,'0',14,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,0,0,0,'','',0,'','','','','2015-12-14 03:07:27','0000-00-00 00:00:00'),
(235,6,43,0,'Цена','price','d0d6175d8e67a177ba30df06a690a848',0,0,35,0,0,0,0,'0',15,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-12-14 03:07:46','0000-00-00 00:00:00'),
(236,6,43,0,'Старая цена','old_price','64f52e479f0158f6edc05ceea490d3dc',0,0,35,0,0,0,0,'0',16,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,1,0,'','',0,'','','','','2015-12-14 03:07:59','0000-00-00 00:00:00'),
(237,6,43,0,'Остаток','oddments','677faec09e4895094903b5efde6b00ea',0,0,35,0,0,0,0,'0',17,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,1,0,'','',0,'','поставьте поле пустым для того, чтобы данный товар можно было покупать бесконечное число раз','','','2015-12-14 03:12:52','2015-12-14 03:16:22'),
(238,6,43,0,'Ожидаемая дата привоза','date_income','a48b0827cb5b814509266ad9f46fa0c9',0,0,35,0,0,0,0,'0',18,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','[col_current.value.ndate]',0,'','в формате ГГГГ-ММ-ДД','','','2015-12-14 03:14:39','2015-12-14 07:30:51'),
(245,6,43,0,'Доступен для продажи','available','76697f5ae4ad918120568904e9fe2597',2,0,35,0,0,0,0,'0',21,0,0,0,0,'1','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-01-30 10:57:01','2016-04-20 13:46:20'),
(249,7,46,0,'Название','name','5c971fea569b285a3096472e8e94679b',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:37:52','0000-00-00 00:00:00'),
(250,7,46,0,'Компонент ввода','input','f9864b40c7a0defbfc155474c3909198',0,0,45,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-03-22 04:38:49','2016-03-22 05:18:11'),
(251,7,46,0,'JS-валидатор','js_validate','5e6bf7568ddae8b90690304dd7a9292c',0,0,45,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','Строка JS кода, которая работает с переменной value и возвращает ошибку (через return), либо ничего не возвращает','','','2016-03-22 04:40:05','2016-03-22 05:14:49'),
(253,7,47,0,'Название','name','424e647ba2b11c88fa7b6d93e090b663',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:47:10','0000-00-00 00:00:00'),
(254,7,47,0,'Действие','action','94ae2f10416c4e376392bb81780a7e86',0,0,45,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-03-22 04:47:27','2016-03-22 05:17:52'),
(255,7,48,0,'Заголовок','title','10617e880f3dc2c24741383c9a3f73c4',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:48:19','0000-00-00 00:00:00'),
(256,7,48,0,'Тип','type','67849021a570cacb1e684b8aab0d1f9f',1,0,46,0,0,0,0,'0',2,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:48:30','2016-03-22 08:32:18'),
(259,7,48,0,'Значение по умолчанию','default','242bda514568dcf592a07e4667fbe0d7',0,0,45,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:49:36','2016-03-22 11:02:51'),
(260,7,48,0,'Обязательно к заполнению','required','dd09ab496487c92cab8e606b9e066bcf',2,0,45,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 04:50:24','2016-03-22 08:32:13'),
(261,7,46,0,'Валидатор перед действием','a_validate','ee121743a744fe41ce78d81681ddba6d',0,0,45,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','Строка кода шаблона, принимающая на вход $value и возвращающая ошибку','','','2016-03-22 04:54:30','2016-03-22 06:47:09');

INSERT INTO `main_col` (col_id,col_module,col_table,col_cat,col_name,col_sname,col_uin,col_type,col_target,col_link,col_link2,col_link3,col_link4,col_index,col_deep,col_pos,col_order,col_bold,col_filter,col_paramlink,col_default,col_deflist,col_unique,col_required,col_url,col_tpl,module_url,module_type,file_dir,file_maxsize,file_prefix,file_types,file_totalmax,file_genname,col_inform,col_fastedit,col_part,col_speclink,col_onshow,col_force_onshow,col_onform,col_hint,col_oninsert,col_parts,col_date,col_date2) VALUES
(262,7,45,0,'Название','name','99b978a02bd0896c613f646a2de5415b',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 05:15:41','0000-00-00 00:00:00'),
(263,7,45,0,'Действие','action','9ae18b68c4670e7d367d703669721ad4',1,0,47,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 05:16:18','0000-00-00 00:00:00'),
(264,7,45,0,'Название кнопки "Отправить"','submit','594ba20e0db35d922e77249a0cd488eb',0,0,45,0,0,0,0,'0',3,0,0,0,0,'Отправить','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 05:16:53','0000-00-00 00:00:00'),
(265,7,49,0,'Заголовок','title','4da698348508599e19e16f6b9d6cb7ba',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-03-22 05:17:20','0000-00-00 00:00:00'),
(266,7,49,0,'Шаблон формы','tpl','9e2ab1d6d29b67dd0e06b59525633a2e',0,0,45,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-03-22 05:17:20','2016-03-22 05:43:01'),
(267,7,45,0,'Шаблон','tpl','4a7d4a8dd78a605cb8cbd81c2aa06d18',1,0,49,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-03-22 05:18:47','0000-00-00 00:00:00'),
(268,7,49,0,'Шаблон сообщения об ошибке','error','8437a8c38411a92f042e4388a93e022e',0,0,45,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','JS-код. В качестве аргумента используйте переменную error','','','2016-03-22 05:43:21','2016-03-22 05:55:06'),
(269,7,50,0,'Значение','value','792840b193f3f365f8446e075691ac20',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-03-22 07:53:40','0000-00-00 00:00:00'),
(270,7,46,0,'Обработчик перед действием','a_prepend','b1a2ee2c02d33f10f153e224bf1a612a',0,0,45,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-03-22 10:52:17','0000-00-00 00:00:00'),
(271,7,48,0,'Фиксированное поле','fix_field','d3f2578e307a6592c1757c075df09b29',2,0,45,0,0,0,0,'0',5,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','(нельзя менять название)','','','2016-03-22 12:28:32','0000-00-00 00:00:00'),
(272,5,29,0,'Пользователь','u','4cde28e69bebb56b8c04df6000924d07',5,0,0,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','[if f_action==''add'' && user.type!=''guest'']\r\n    [current_col.set(user)]\r\n[/if]','','2016-03-23 20:13:49','2016-03-24 00:44:53'),
(288,5,51,0,'Заголовок','title','6d8d348d44d09f4ae70823ca9c32821d',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-03-23 21:32:12','0000-00-00 00:00:00'),
(289,5,51,0,'Шаблон','tpl','20e0c8e352dab49cb0c2524a2e03bc9c',0,0,29,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-03-23 21:32:12','2016-03-23 21:37:10'),
(290,5,0,0,'Шаблон','tpl','a3b8e3dfda4ab492552690a03c59f792',1,0,51,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-03-23 21:33:30','0000-00-00 00:00:00'),
(292,7,52,0,'Файл','file','d1bf4c49a1ee085ecb9ef7e7e89029c6',3,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,1,1,0,0,'','',0,'','','','','2016-03-23 21:55:06','0000-00-00 00:00:00'),
(293,5,29,0,'IP пользователя','ip','9ccc85f43ed2c5c8395b2187a9fbc974',0,0,29,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','[if f_action==''add'']\r\n    [current_col.set(user.ip)]\r\n[/if]','','2016-03-23 23:47:02','2016-03-24 00:46:08'),
(294,7,49,0,'Комментарий к шаблону','comment','fb44428b234ef98049933382c46f5a02',0,0,45,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'[form.textarea(height=''300px'')]','','','','2016-04-05 12:32:20','0000-00-00 00:00:00'),
(295,8,54,0,'Значение','value','8138401e602e95775c02c77bae2062e6',0,0,53,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:25:37','0000-00-00 00:00:00'),
(296,8,55,0,'Название','name','c23b087e411bb7bae66b0db06d6bf377',0,0,53,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:27:29','0000-00-00 00:00:00'),
(297,8,56,0,'Заголовок','title','ac1841dabb599c26ab0f29b9b5e0ce92',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:30:12','0000-00-00 00:00:00'),
(298,8,56,0,'Шаблон','body','8064910644bb628b047d287fbd4e1958',0,0,2,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 08:30:12','0000-00-00 00:00:00'),
(299,8,57,0,'Ссылка на параметр','param','bed5738306d2d66d09f5ed16eeb70596',1,0,53,0,2,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:35:12','0000-00-00 00:00:00'),
(300,8,57,0,'Значение','value','9fcc923a7233f0c0e00963f3eb4f909b',0,0,53,0,0,0,0,'0',2,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:35:23','2016-04-17 18:57:06'),
(302,8,53,0,'Название','name','05d4885fbd3cd4ff928808603d7fc9b3',0,0,53,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:37:41','0000-00-00 00:00:00'),
(304,8,53,0,'Тип','type','a5cd55c7061e51e9bdacdb56712408e0',1,0,58,0,0,2,0,'0',3,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:38:40','2016-04-18 09:34:26'),
(305,8,53,0,'Важный','bold','8839c57047b2a05da58611e95b037f30',2,0,53,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:39:02','0000-00-00 00:00:00'),
(306,8,53,0,'Участвует в фильтрации','filter','d088c6e96e48ebded7bdb071b2e70df2',2,0,53,0,0,0,0,'0',5,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-12 08:39:22','0000-00-00 00:00:00'),
(307,8,53,0,'Обязательно к заполнению','required','a8b9fd807121254159b9749671b5980b',2,0,53,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,0,1,0,'','',0,'','','','','2016-04-12 08:39:53','2016-04-17 12:55:38'),
(308,8,53,0,'Значение по умолчанию','default','8db23615e6f6f5d1063047c7e46bf231',0,0,53,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:40:15','0000-00-00 00:00:00'),
(309,8,53,0,'Связь с коллекцией','collection','378182eb7f0b2c701e01a5ca4a4d0caa',1,0,55,0,2,2,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:40:54','2016-04-14 18:58:22'),
(310,8,58,0,'Название','name','d18d73ffed046ade10aec1785d129772',0,0,53,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-12 08:43:09','0000-00-00 00:00:00'),
(311,8,58,0,'Компонент формы','on_form','c0ef0886959923cbdf1283ec0c5a479f',0,0,53,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 08:43:59','2016-04-12 09:17:37'),
(312,8,58,0,'Обработчик формы','on_edit','a417e5721d9ce2e241d882e28fb8bf90',0,0,53,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 08:47:23','2016-04-12 09:17:26'),
(313,8,58,0,'Отображение','on_show','251dba5caf32c4ce2c184a058c24479c',0,0,53,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 08:50:30','2016-04-12 09:17:20'),
(314,8,58,-1,'JS-валидатор','js_validate','7b2483cfecd204e7caf638aa5ce9af1a',0,0,53,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,0,0,0,'','',0,'','','','','2016-04-12 08:50:57','2016-04-17 13:20:05'),
(315,8,58,-1,'Валидатор при добавлении','validate','f836bb413e895a1b91f63752bfc6a0bf',0,0,53,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,0,0,0,'','',0,'','серверный','','','2016-04-12 08:52:01','2016-04-17 13:19:57'),
(316,8,58,-1,'Компонент фильтра','on_filter','e7d1d83b17c7e27196929e2965c4fa71',0,0,53,0,0,0,0,'0',7,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 09:14:22','0000-00-00 00:00:00'),
(317,8,58,-1,'Обработчик фильтра','filtered','b636f303e51151ea8d3809fbfb1562bb',0,0,53,0,0,0,0,'0',8,0,0,0,0,'','',0,0,0,1,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-12 09:16:55','2016-04-12 09:24:12'),
(318,8,54,0,'Url','url','7555c405c441609af0cd1ca1ef89e5d2',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2016-04-17 18:40:58','0000-00-00 00:00:00'),
(319,8,54,0,'Описание','description','164c873439633c1867856d14a17caeed',0,0,53,0,0,0,1,'0',3,0,0,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.ckeditor]','','','','2016-04-17 18:41:20','2016-04-17 18:41:32'),
(320,8,53,-1,'Спец.имя','sname','b87c807cbe2b3233ae365b66aa562323',0,0,53,0,0,0,0,'0',10,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2016-04-17 19:29:50','2016-04-17 19:30:13'),
(321,6,43,0,'Характеристики','dparam','001f12e6725f3296b422ea54c5e83f1c',0,0,35,0,0,0,0,'0',20,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'[widget.dpar.base.on_form]','','[widget.dpar.base.on_edit]','','2016-04-18 11:14:55','0000-00-00 00:00:00'),
(322,8,53,0,'Значения по умолчанию для фильтра','filter_default','24877d8304bd2fee920202798a89a943',0,0,53,0,0,0,0,'0',8,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-18 19:05:15','0000-00-00 00:00:00'),
(323,0,0,0,'Водяной знак (PNG)','watermark','7f425c6e7552fad39dcdf58a8743d491',3,0,2,0,0,0,0,'0',108,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/watermarks/',0,'wm','png',0,1,1,0,0,'','',0,'','','','a:0:{}','2016-04-20 15:26:11','0000-00-00 00:00:00'),
(324,0,0,0,'Прозрачность водяного знака (в процентах)','watermark_transparent','b6f4cc218a919af3ad5bf5621f7a5fa4',0,0,2,0,0,0,0,'0',109,0,0,0,0,'50','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-04-20 15:28:02','0000-00-00 00:00:00'),
(325,0,0,0,'Тип наложения водяного знака','watermark_position','6fdc462a1c7c09220460080ce2a0ae9c',0,0,2,0,0,0,0,'0',110,0,0,0,186,'tile','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-04-20 15:28:12','2016-04-20 15:28:50'),
(326,8,57,0,'Ссылка на элемент коллекции','link','943e59245b54567c1d00cfceba1faf2a',1,0,-54,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/dpar/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-22 19:43:04','0000-00-00 00:00:00'),
(327,6,59,0,'Заголовок','title','178973d9f0aacdba4dd82a5642556e97',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-23 16:44:43','0000-00-00 00:00:00'),
(328,6,59,0,'Шаблон','body','4d519f932ce78a7ab1e42eae6346bce4',0,0,2,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-23 16:44:43','0000-00-00 00:00:00'),
(329,6,60,0,'Заголовок','title','d8179892d99382abd9af0e3870f13636',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-23 16:45:11','0000-00-00 00:00:00'),
(330,6,60,0,'Шаблон','body','076d3a35401c16517bb19899daeed777',0,0,2,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-23 16:45:11','0000-00-00 00:00:00'),
(331,6,61,0,'Заголовок','title','c9ce8af813e249093553ef129cb8c2a5',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-04-23 16:45:26','0000-00-00 00:00:00'),
(332,6,61,0,'Шаблон','body','49efaa212c9cd1b41b84eb18df26d8c3',0,0,2,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-04-23 16:45:26','0000-00-00 00:00:00'),
(333,6,35,-1,'Свой шаблон','tpl','9f86c358000f2bd41e9ab8301ed0e5ec',1,0,60,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-23 16:46:25','2016-04-23 16:47:23'),
(334,6,43,-1,'Свой шаблон','tpl','0d1c4d7408b51dfadacb0abe1a42a537',1,0,61,0,0,0,0,'0',22,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-23 16:46:59','2016-04-23 16:47:10'),
(335,6,0,0,'Шаблон главной страницы','main_tpl','9ca6088f466506d89d7206e991ad6073',1,0,59,0,0,0,0,'0',9,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-04-23 16:48:02','0000-00-00 00:00:00'),
(336,6,0,0,'Шаблон категории','cat_tpl','5c142e49a985c59c80f8d021d070d528',1,0,60,0,0,0,0,'0',10,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-04-23 16:48:22','0000-00-00 00:00:00'),
(337,6,0,0,'Шаблон товара','item_tpl','52ff95e874bf924de018c4d9c9411204',1,0,61,0,0,0,0,'0',11,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-04-23 16:48:37','0000-00-00 00:00:00'),
(338,6,43,-1,'Отображать на главной странице','on_start_page','af0b5d0dc2faf5a6f05d667394ea0a4a',2,0,35,0,0,0,0,'0',23,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/shop/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-04-25 09:01:55','0000-00-00 00:00:00'),
(339,0,62,0,'Заголовок','title','e08be628795a067f73899b2f7b1e1120',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-05 08:55:37','0000-00-00 00:00:00'),
(340,0,62,0,'Url','url','2060f6e1b1a77fc081adeea5731b1525',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2016-05-05 08:55:51','0000-00-00 00:00:00'),
(341,7,48,-1,'Использовать статичное имя для POST переменной','static_name','cc9bc3d245ad6f198d52ae81b531ba31',0,0,45,0,0,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-09 22:44:51','0000-00-00 00:00:00'),
(342,5,0,0,'Количество комментариев за интервал','comments_limit','088855bb97af9fa3d8c8cd20d953279a',0,0,29,0,0,0,0,'0',2,0,0,0,0,'10','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-05-12 03:28:47','2016-05-12 03:32:22'),
(343,5,0,0,'Интервал (в минутах)','limit_minute','01513bd1c4a78d7a4132cd0f54178e26',0,0,29,0,0,0,0,'0',3,0,0,0,0,'5','',0,0,0,0,0,0,'/files/uploads/comments/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-05-12 03:29:06','2016-05-12 03:32:28'),
(353,10,67,0,'Заголовок','title','86d35d07149584a93a54900d9b23fe43',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-13 13:30:17','0000-00-00 00:00:00'),
(354,10,67,0,'Url','url','c88fd68922c90b4e9a919401cc92c85c',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2016-05-13 13:30:17','0000-00-00 00:00:00'),
(355,10,68,0,'Заголовок','title','3888a9e3a8955a4971e8f5fe05f3104d',0,0,0,0,0,0,1,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-13 13:30:37','0000-00-00 00:00:00'),
(356,10,68,0,'Url','url','aaafdc046503c228aa9e1c7fc2f27a23',0,0,2,0,0,0,0,'0',2,0,1,1,0,'','',1,0,1,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'[form.url]','','[form.url]','','2016-05-13 13:30:37','0000-00-00 00:00:00'),
(357,10,69,0,'Название','title','f9509139fd9167169045c1796cfc3df1',0,0,67,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-13 13:31:30','0000-00-00 00:00:00'),
(358,10,70,0,'Название','title','7c10160802e20f8f11757fc1eaaf9bdf',0,0,67,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-13 13:31:43','0000-00-00 00:00:00'),
(359,10,68,0,'Цена','price','fd28c933ce599a115be9b0b08ae9f222',0,0,67,0,0,0,0,'0',3,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-13 13:33:18','0000-00-00 00:00:00'),
(360,10,68,0,'Тип цены','ptype','ea24db168bbe73f59bc2abf0cf60910d',1,0,69,0,0,0,0,'0',4,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-13 13:33:31','0000-00-00 00:00:00'),
(361,10,68,0,'Единицы измерения','units','f485e176aceacab7d05c1e9a2a8bfca5',1,0,70,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-13 13:33:48','0000-00-00 00:00:00'),
(362,10,0,0,'Фон заголовка','bg1','08a08fc6941f8cc41e410da8807403ff',0,0,67,0,0,0,0,'0',1,0,1,0,0,'#696F82','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'[form.colorpicker]','','','a:1:{s:43:"col_onform_08a08fc6941f8cc41e410da8807403ff";a:1:{i:3;a:1:{s:11:"colorpicker";s:11:"colorpicker";}}}','2016-05-13 13:46:49','0000-00-00 00:00:00'),
(363,10,0,0,'Фон элемента','bg2','31ea73d695e9b001336bf629b267f0f8',0,0,67,0,0,0,0,'0',2,0,0,0,0,'#F7F7F7','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'[form.colorpicker]','','','a:1:{s:43:"col_onform_31ea73d695e9b001336bf629b267f0f8";a:1:{i:3;a:1:{s:11:"colorpicker";s:11:"colorpicker";}}}','2016-05-13 13:47:18','0000-00-00 00:00:00'),
(364,10,0,0,'Разрешить калькуляцию','calc','eae15396fd1359d43d4c0f2c5b0d8c05',2,0,67,0,0,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-05-13 13:47:33','0000-00-00 00:00:00'),
(365,10,71,0,'Имя','name','e8db6cc1587b8668987cf3bf0125ffc8',0,0,0,0,0,0,0,'',1,0,1,0,0,'','',0,0,0,0,0,0,'',0,'','',0,0,1,1,0,'','',0,'','','','','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(366,10,71,0,'Шаблон','body','5cbf18f1a9c4e6b2c57f5a60a7c629bb',0,0,67,0,0,0,0,'0',2,0,0,0,0,'','',0,0,0,1,0,0,'',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','0000-00-00 00:00:00','2016-05-13 17:16:30'),
(367,10,0,0,'Шаблон прайс-листа','tpl','0223076bde82e164931f900b122c1f82',1,1,71,0,0,0,0,'0',4,0,1,0,0,'','',0,0,0,0,0,0,'',0,'','',0,0,1,1,0,'','',0,'','','','a:0:{}','0000-00-00 00:00:00','2016-05-13 17:15:05'),
(368,10,0,0,'Ссылка для оформления договора','doc_href','d8120f4e4fe90b1c108ada19410a21da',0,0,67,0,0,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/price/',0,'','',0,0,1,0,0,'','',0,'','','','a:0:{}','2016-05-13 17:25:19','0000-00-00 00:00:00'),
(369,7,72,0,'Заголовок','title','014f22f073f7b633d11a6d9de361b9f6',0,0,2,0,0,0,0,'0',1,0,1,1,0,'','',0,0,0,0,0,0,'/files/uploads/',0,'','',0,0,1,1,0,'','',0,'','','','','2016-05-31 15:27:28','0000-00-00 00:00:00'),
(370,7,72,0,'Шаблон','tpl','00440c2682b9df93d6b2e583cd00dc2d',0,0,45,0,0,0,0,'0',2,0,0,1,0,'','',0,0,0,1,0,0,'/files/uploads/',0,'','',0,0,1,0,0,'','',0,'[form.meditor]','','','','2016-05-31 15:27:28','2016-05-31 15:27:35'),
(375,7,74,0,'Название','title','2bbe868f52d5283940de53c62e80b9ab',0,0,45,0,0,0,0,'0',1,0,1,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 15:58:15','0000-00-00 00:00:00'),
(376,7,74,0,'Форма регистрации','reg_form','f1df1eb2153235ef8a8d754bdf06036a',1,0,45,0,2,0,0,'0',2,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 15:58:29','2016-05-31 16:05:42'),
(377,7,74,0,'Шаблон формы регистрации','reg_tpl','eaeb575d2e3de3b33c929b0941eff3ad',1,0,49,0,2,0,0,'0',3,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 15:58:40','2016-05-31 16:05:45'),
(379,7,74,0,'Форма авторизации','auth_form','8fcf8668ddffd46565cd08d01c5852c3',1,0,45,0,2,0,0,'0',5,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 15:59:50','2016-05-31 16:05:48'),
(380,7,74,0,'Шаблон формы авторизации','auth_tpl','a408e6b1b825e0da26e9902b31beb3bc',1,0,49,0,2,0,0,'0',6,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 16:00:15','2016-05-31 16:05:52'),
(382,7,74,0,'Общий шаблон','tpl','0c0cd958e646b5363df9a0e7a67efa5c',1,0,72,0,2,0,0,'0',8,0,0,0,0,'','',0,0,0,0,0,0,'/files/uploads/forms/',0,'','',0,0,1,0,0,'','',0,'','','','','2016-05-31 16:00:54','2016-05-31 16:05:56');

INSERT INTO `main_module` (module_id,module_name,module_sname,module_uin,module_icon,module_data,module_parts,module_date,module_date2,module_lastcheck,module_major,module_public_ex) VALUES
(1,'Содержимое','content','10dabcb62704e08843888db8001180df','/files/editor/modules/module-icon2309645de466ac273e45fd8a00ba78c8.png','','b:0;','0000-00-00 00:00:00','2016-05-22 17:03:30','2015-12-09',1,1),
(2,'Фотографии','photo','53f941145a544486ba5c0038f67a8dad','/files/editor/modules/module-icon79e1effe025c0cfa92e52794e77c7ad2.png','','a:14:{s:45:"col_oninsert_72aecb26aeee9b8dbc884de08fe5a976";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:43:"col_onform_72aecb26aeee9b8dbc884de08fe5a976";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:43:"col_onform_a8105956f89a51d7cccf35f84a276661";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}s:43:"col_onform_784accca7f43cd4e2c5a514e2c88d83f";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_9528ae12cc5b5eaf81c0861281b2bd7e";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}s:45:"table_bottom_edb68f41366d30cd29c7703956ecef42";a:1:{i:2;a:1:{s:12:"img_uploader";s:12:"img_uploader";}}s:43:"col_onshow_0f30149c75b2f41edb9a0a1be265812a";a:1:{i:1;a:1:{s:9:"shadowbox";s:9:"shadowbox";}}s:45:"col_oninsert_cf618b049eed9191f9f67e0687e06122";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_cf618b049eed9191f9f67e0687e06122";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_0ecb91d9d985697c082a3ea155d0521c";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_0ecb91d9d985697c082a3ea155d0521c";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_400aebbe0cb9852bf005a0d604aa1b89";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_400aebbe0cb9852bf005a0d604aa1b89";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:45:"col_oninsert_a2ea5d37fd01009ef2ab2669b1345923";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}}','0000-00-00 00:00:00','2016-04-20 15:52:37','2015-12-09',0,0),
(3,'Шаблоны элементов','templates','eff66dc8d2d774b48d9954a50f2c9b64','/files/editor/modules/module-iconf28ea8ea1c78ac888165c4b955bd8732.png','','a:1:{s:43:"col_onform_8395149807e31d2200013e1cd5dd8086";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}}','0000-00-00 00:00:00','2016-04-05 21:52:22','2015-12-09',0,3),
(4,'Статьи','articles','7d156a5c16d5c8145f05a7f48698fbbc','/files/editor/modules/module-icon7ed6915ba4a1d21e2dfc1aa8c03aa43c.png','','a:23:{s:43:"col_onshow_a8f7e520b5d26beaee27ad8b3b1691c3";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:43:"col_onform_f8849d54f8f653b6751c5c25059e1af8";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onform_42d74de04923e5031a014a87c935aa29";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}s:43:"col_onform_19eb4ff7cdd7dc5f919b08451c54b601";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onform_e419e1a7735542ad49fd8221562b9002";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_137915a56b759d7572419e50c9880353";a:1:{i:3;a:1:{s:8:"textarea";s:8:"textarea";}}s:37:"part_741c860a30efb2fa8399f576acd8d4f4";a:1:{i:2;a:1:{s:3:"rss";s:3:"rss";}}s:37:"part_c5af39ae6bbb03f61a6742a87f047ac5";a:1:{i:2;a:1:{s:13:"month_archive";s:13:"month_archive";}}s:37:"part_706e5f1cfd0c0a0323303664376569b9";a:1:{i:2;a:1:{s:13:"sitemap_array";s:13:"sitemap_array";}}s:43:"col_onform_cfa4ddcfd4e56491b5f4cb0860fec339";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_ef44680795002aea99e4512bf18be8c0";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:45:"col_oninsert_744b97788be191188c3919a4af0eccad";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:43:"col_onform_744b97788be191188c3919a4af0eccad";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:43:"col_onform_353242c4820761c26cdd1d69fab9f168";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:45:"col_oninsert_fc376db046134e99ec444507589fdaf8";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_fc376db046134e99ec444507589fdaf8";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_0511814f51fe64912f469eb6bc858d3b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_0511814f51fe64912f469eb6bc858d3b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_d2ad7bbba300342e66f75c766d7fea66";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_d2ad7bbba300342e66f75c766d7fea66";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:37:"part_1769bc42fe28be0ff5c9da6c6a797967";a:1:{i:2;a:1:{s:6:"b_icon";s:6:"b_icon";}}s:45:"col_oninsert_fc1839d6f049d779913c5c79714c41b3";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_fc1839d6f049d779913c5c79714c41b3";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','0000-00-00 00:00:00','2016-05-26 23:42:59','2015-12-09',0,0),
(5,'Комментарии','comments','ccdf34032778332a2f827f7cecc54af0','/files/editor/modules/module-icon144a783f4b937cb2d88c976792c174c4.png','','a:3:{s:43:"col_onform_20e0c8e352dab49cb0c2524a2e03bc9c";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_7b4591feb0f58facf99715190cca49f7";a:1:{i:3;a:1:{s:8:"textarea";s:8:"textarea";}}s:37:"part_1af50f7abb725f8c771bb97b0eeed2a4";a:1:{i:2;a:1:{s:4:"form";s:4:"form";}}}','0000-00-00 00:00:00','2016-06-05 10:53:08','2015-12-09',0,5),
(6,'Магазин','shop','7c208221c9c3cddea90dba1fc6b4e57d','/files/editor/modules/module-icon82551179fe62ededb278f4bc03ec7e14.png','','a:24:{s:43:"col_onform_81ea0b54b49fd63a29d578e099156613";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:45:"col_oninsert_bbd40c4c6a568b325ad692aabf5dc26c";a:1:{i:0;a:1:{s:8:"latinica";s:8:"latinica";}}s:43:"col_onform_cf3c6ec2e7b853882611677761bf87d1";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onform_9c177a9139138f715b82c17de43065d9";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}s:43:"col_onform_178bf7ee63ef9826f924dab1af2ef433";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onform_ead9edae0294b9411569d0d648970687";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_07d0cdf8221f1a1f96fc2d0ba857dcae";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_4a8b63b2edfd62f8c4d34c14374b7603";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_da1c3d7cc6ae8b98b34f29fe17f4eb20";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onshow_5c0ec6353ad5c71f7a79897dc9459c4d";a:1:{i:1;a:1:{s:9:"shadowbox";s:9:"shadowbox";}}s:43:"col_onshow_75cb4a5fd4affd4fb9a46e00b931ed7e";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:43:"col_onform_c3849edb1222b71c33d1f6efb228257b";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:45:"col_oninsert_e1b0cba9d6df55c81de12288abcc14cb";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_e1b0cba9d6df55c81de12288abcc14cb";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_de70d659d6945373dcefd8a4e6678092";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_de70d659d6945373dcefd8a4e6678092";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_7fdaedc5094a8d2ca4a1193ebec598e5";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_7fdaedc5094a8d2ca4a1193ebec598e5";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_c0c6540e57e11a99673b1e4c35f7de6b";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:43:"col_onform_c0c6540e57e11a99673b1e4c35f7de6b";a:1:{i:3;a:1:{s:7:"select2";s:7:"select2";}}s:45:"col_oninsert_5523107df85efc9573ad9b62ec6d4ae7";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_5523107df85efc9573ad9b62ec6d4ae7";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:45:"col_oninsert_a2d1f7b9d6f9464ad823b068dfcf9844";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_a2d1f7b9d6f9464ad823b068dfcf9844";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','0000-00-00 00:00:00','2016-05-12 20:27:44','0000-00-00',0,6),
(7,'Формы','forms','adba24f02440b291927021addd983811','/files/editor/modules/module-icon433ec174fd78a499b23e443c40f3c972.png','','a:13:{s:43:"col_onform_5e6bf7568ddae8b90690304dd7a9292c";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_94ae2f10416c4e376392bb81780a7e86";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_f9864b40c7a0defbfc155474c3909198";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_8437a8c38411a92f042e4388a93e022e";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_ee121743a744fe41ce78d81681ddba6d";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:42:"table_top_fe6d078b78dbaafc155c479823dfa25c";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:45:"table_bottom_fe6d078b78dbaafc155c479823dfa25c";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:43:"col_onform_b1a2ee2c02d33f10f153e224bf1a612a";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:37:"part_795b7d7875bd988701ed62c40f57a2fc";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}s:43:"col_onform_fb44428b234ef98049933382c46f5a02";a:1:{i:3;a:1:{s:8:"textarea";s:8:"textarea";}}s:37:"part_58a3b0b3efa2ac2f3066e101ecd0e812";a:1:{i:2;a:1:{s:15:"capcha_question";s:15:"capcha_question";}}s:43:"col_onform_00440c2682b9df93d6b2e583cd00dc2d";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}}','0000-00-00 00:00:00','2016-05-31 23:47:38','0000-00-00',0,7),
(8,'Динамические параметры','dpar','89e00ec0e049c4cddb95b460f5d37af1','/files/editor/modules/module-iconc3b0adfa056d6c1007037c84c6a8cc31.png','','a:12:{s:42:"table_top_6b89c15e7daf4b42b8887ad302c162e5";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:45:"table_bottom_6b89c15e7daf4b42b8887ad302c162e5";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:43:"col_onform_e7d1d83b17c7e27196929e2965c4fa71";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_251dba5caf32c4ce2c184a058c24479c";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_a417e5721d9ce2e241d882e28fb8bf90";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_c0ef0886959923cbdf1283ec0c5a479f";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:43:"col_onform_b636f303e51151ea8d3809fbfb1562bb";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:45:"col_oninsert_7555c405c441609af0cd1ca1ef89e5d2";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_7555c405c441609af0cd1ca1ef89e5d2";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_164c873439633c1867856d14a17caeed";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:45:"col_oninsert_b87c807cbe2b3233ae365b66aa562323";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_b87c807cbe2b3233ae365b66aa562323";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','0000-00-00 00:00:00','2016-05-11 21:06:04','0000-00-00',0,8),
(10,'Прайс-лист','price','45ae615374b29476401b133f8211e5f7','/files/editor/modules/module-icond0b607b473b8d3e7cd86f716c57e8f12.png','','a:5:{s:43:"col_onform_5cbf18f1a9c4e6b2c57f5a60a7c629bb";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}s:42:"table_top_93214a31e2633878cbf9987de6a73e28";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:45:"table_bottom_93214a31e2633878cbf9987de6a73e28";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:42:"table_top_60526f189a3d3be2f491d97e5578647c";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}s:45:"table_bottom_60526f189a3d3be2f491d97e5578647c";a:1:{i:2;a:1:{s:5:"multy";s:5:"multy";}}}','0000-00-00 00:00:00','2016-05-13 17:30:35','0000-00-00',0,10);

INSERT INTO `main_part` (part_id,part_module,part_name,part_sname,part_uin,part_date,part_date2,part_auth,part_about,part_access,part_type,part_table,part_owner,part_body,part_url,part_ignore,part_iowner,part_sowner,part_parse,part_cat,part_major,part_proc,part_ex,part_parts,part_404,timer_last,timer_act,timer_type,timer_date,timer_time,timer_x,timer_y,timer_count,part_file,parser_end_ex,part_shell,part_cur,part_pic,part_folder,part_ifcase,part_ifdetect,part_ifrow,part_unsafe,part_shelltime,part_shellcount,part_skipurl,part_enable) VALUES
(1,0,'Карта Google','google_map','cfde803c011598a2f273055d527398d6','2015-10-07 07:43:13','2015-10-08 19:40:06',-1,'',0,2,0,0,'<iframe width="[$width]" height="[$height]" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" src="http://maps.google.ru/maps?f=q&source=s_q&geocode=&output=embed&q=[$address.urlencode]"></iframe>','',0,0,0,0,1,1,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(2,0,'Flash аудиоплеер','flash_audio','3b4716038e8453f15825c20eb1a36d6d','2015-10-07 07:49:02','2015-10-08 19:39:59',-1,'',0,2,0,0,'<script language="JavaScript" src="[cpart.folder]audio-player.js"></script>\n<object type="application/x-shockwave-flash" data="[cpart.folder]player.swf" id="audioplayer1" height="24" width="290">\n    <param name="movie" value="[cpart.folder]player.swf"></param>\n    <param name="FlashVars" value="playerID=1&amp;soundFile=[$src]&amp;autostart=yes"></param>\n    <param name="quality" value="high"></param>\n    <param name="menu" value="false"></param>\n    <param name="wmode" value="transparent"></param>\n</object>','',0,0,0,0,2,4,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/player/','','','',0,0,0,0,1),
(3,0,'JQuery','jquery','3d51836abc904abea510f1184f624ca7','2015-10-07 08:59:39','2016-04-05 22:05:37',-1,'',0,2,0,0,'[skip enter]\n[if glob.use_jquery][xbreak][/if]\n[if $remote]<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/[$version]/jquery.min.js"></script>[glob.use_jquery=1][xbreak][/if]\n[file_url=base_dir++cpart.folder+''jquery-''+$version+''.min.js'']\n[if !file.exists($file_url)]\n    [if !file.write($file_url, file.get(''http://ajax.googleapis.com/ajax/libs/jquery/''+$version+''/jquery.min.js''))]\n        [cpart.shell(remote=true)]\n    [/if]\n[/if]\n<script type="text/javascript" src="[$file_url]"></script>\n[glob.use_jquery=1]','',0,0,0,0,4,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/adapters/jquery/','','','',0,0,0,0,1),
(4,0,'JQuery UI','jquery_ui','90f596a58b61ffea973f9299194164b8','2015-10-07 09:05:31','2016-02-08 15:06:59',-1,'',0,2,0,0,'[skip enter]\n[if glob.use_jquery_ui][xbreak][/if]\n[if $remote]\n    <link rel="stylesheet" href="https://ajax.googleapis.com/ajax/libs/jqueryui/[$version]/themes/smoothness/jquery-ui.css">\n    <script src="http://ajax.googleapis.com/ajax/libs/jqueryui/[$version]/jquery-ui.min.js"></script>\n    [glob.use_jquery_ui=1]\n    [xbreak]\n[/if]\n[file_js_url=base_dir++cpart.folder+''jquery-ui-''+$version+''.min.js'']\n[if !file.exists($file_js_url)]\n    [if !file.write($file_js_url, file.get(''http://ajax.googleapis.com/ajax/libs/jqueryui/''+$version+''/jquery-ui.min.js''))]\n        [cpart.run(remote=true)]\n        [xbreak]\n    [/if]\n[/if]\n[file_css_url=cpart.folder+''jquery-ui-''+$version+''.css'']\n[if !file.exists($file_css_url)]\n    [t=file.write($file_css_url, file.get(''http://ajax.googleapis.com/ajax/libs/jqueryui/''+$version+''/themes/smoothness/jquery-ui.css''))]\n[/if]\n<link rel="stylesheet" href="[$file_css_url]">\n<script type="text/javascript" src="[$file_js_url]"></script>\n[glob.use_jquery_ui=1]','',0,0,0,0,4,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/adapters/jquery-ui/','','','',0,0,0,0,1),
(5,0,'NivoSlider','nivoslider','9526a99217cb0d2278aaa9590c16e304','2015-10-07 14:54:38','2015-10-09 21:15:20',-1,'',0,2,0,0,'[* Подключение скриптов и стилей виджета *]\n[if !glob.use_nivoslider]\n    [glob.use_nivoslider=1]\n    [head]\n        <link rel="stylesheet" href="[cpart.folder]nivo-slider.css" type="text/css" media="screen" />\n        <link rel="stylesheet" href="[cpart.folder]style.css" type="text/css" media="screen" />\n        [component.jquery(version=''1.4.3'')]\n        <script type="text/javascript" src="[cpart.folder]jquery.nivo.slider.pack.js"></script>\n    [/head]\n[/if]\n\n<style>\n    #slider-wrapper {width:[$width]px;height:[$height]px;}\n    #slider {width:[$width]px;height:[$height]px;}\n</style>\n\n[sid=''slider''+global.rand(0, 1000)]\n\n<div id="slider-wrapper"><div id="[$sid]" class="nivoSlider">\n[* Загрузка изображений в слайдер *]\n[tree $rows]\n    [* ссылка *]        [if $url] <a href="[$url_prefix][cur.col($url)]"> [/if]\n    [* изображение *]   <img src="[cur.col($photo)]" title="[if $title][cur.col($title)][/if]" height="[$height]" />\n    [* ссылка *]        [if $url] </a> [/if]\n[/tree]\n</div></div>\n\n[* Инициализация слайдера *]\n<script type="text/javascript">\n    $(window).load(function(){\n        $(''#[$sid]'').nivoSlider({\n            pauseTime:[$time*1000]\n        });\n    });\n</script>','',0,0,0,0,5,7,2,0,'a:1:{s:37:"part_9526a99217cb0d2278aaa9590c16e304";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/nivo-slider/','','','',0,0,0,0,1),
(6,2,'Вывод галереи','main','21b6a63bed687c27488c408cad6b167e','2015-10-07 16:01:05','2016-03-26 15:43:27',-1,'',0,0,0,0,'[main_page=false]\n[if !$tpl]\n    [tpl=cex.param.tpl]\n[/if]\n[if !$table]\n    [table=cex.photo]\n    [main_page=true]\n[/if]\n[num=cex.param.on_page]\n\n[count=$table.count]\n[if !$num]\n    [rows=$table.fastget(0 !''date'',!''id'')]\n[else]\n    [rows=$table.fastget(0 !''date'',!''id'' $page*$num $num)]\n[/if]\n\n[$tpl.tpl.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(7,0,'Изображение','image','36c7306f9b11caeadc1ec423e5238d6b','2015-10-08 00:50:49','2015-10-21 17:55:57',-1,'',0,2,0,0,'[if !$image][xbreak][/if][if $image_big]<a href="[$image_big]" target="_blank">[/if]<img src="[$image]" [if $width]width="[$width]"[/if] [if $heght]height="[$height]"[/if] [if $align]align="[$align]"[/if] border="0" />[if $image_big]</a>[/if]','',0,0,0,0,3,44,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(8,0,'CloudZoom','cloudzoom','b16c344a3465ee3653942c790d3b6c21','2015-10-08 17:57:05','2015-10-09 13:20:08',-1,'',0,2,0,0,'[if !global.use_cloudzoom]\n    [head]\n    	<link rel="stylesheet" href="[cpart.folder]shadowbox.css" type="text/css" />\n        [component.jquery(version=''1.4.2'')]\n        [component.jquery_ui(version=''1.7.2'')]  \n    	<script type="text/javascript" src="[cpart.folder]cloud-zoom.1.0.2.js"></script>\n	[/head]\n	[global.use_cloudzoom=1]\n[/if]\n<a href="[$big]" class=''cloud-zoom'' rel="adjustX: 6, showTitle: false[if $position], position: ''[$position]''[/if][if $width2], zoomWidth:[$width2][/if][if width3], owidth: [$width3][/if]"><img src="[$small]"[if $width] width="[$width]"[/if][if $height] height="[$height]"[/if] border=0 [if $style] style="[$style]"[/if][if $class!=""] class="[$class]"[/if] title="[$title]"></a>','',0,0,0,0,3,19,1,0,'a:1:{s:37:"part_b16c344a3465ee3653942c790d3b6c21";a:1:{i:2;a:2:{s:6:"jquery";s:6:"jquery";s:9:"jquery_ui";s:9:"jquery_ui";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/cloudzoom/','','','',0,0,0,0,1),
(9,0,'ColorBox','colorbox','b2cb971483430d4d450c3b8304934cd6','2015-10-08 18:18:06','2015-10-08 19:40:32',-1,'',0,2,0,0,'[if glob.use_colorbox]\n    [glob.use_colorbox=1]\n    [head]\n        <link media="screen" rel="stylesheet" href="[cpart.folder]colorbox.css" />\n        <script src="[cpart.folder]jquery.colorbox-min.js"></script>\n        [component.jquery(version=''1.5.2'')]\n    [/head]\n    <script>\n    $(document).ready(function(){\n    	$("a[[rel=''[$name]'']]").colorbox();\n    });\n    </script>\n[/if]\n[if !$small][small=$big][/if]\n[if $big][big=$small][/if]\n<a href="[$big]" rel="[$name]" title="[$title]"><img src="[$small]" [if $width!=""] width="[$width]"[/if][if $height] height="[$height]"[/if]></a>','',0,0,0,0,3,29,1,0,'a:1:{s:37:"part_b2cb971483430d4d450c3b8304934cd6";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/colorbox/','','','',0,0,0,0,1),
(10,0,'SpaceGallery','spacegallery','a327ad094b25996a923b19747a03e446','2015-10-08 19:00:25','2015-10-08 19:39:42',-1,'',0,2,0,0,'[if !glob.use_spacegal]\n    [glob.use_spacegal=1]\n    [head]\n        <link rel="stylesheet" media="screen" type="text/css" href="[cpart.folder]css/spacegallery.css" />\n        <link rel="stylesheet" media="screen" type="text/css" href="[cpart.folder]css/custom.css" />\n        [component.jquery(version=''1.4.1'')]\n        <script type="text/javascript" src="[cpart.folder]js/eye.js"></script>\n        <script type="text/javascript" src="[cpart.folder]js/utils.js"></script>\n        <script type="text/javascript" src="[cpart.folder]js/spacegallery.js"></script>\n    [/head]\n[/if]\n\n<div id="myGallery" class="spacegallery">\n[tree $rows]\n	<img src="[cur.col($photo)]" alt="[cur.col($title)]" />\n[/tree]\n</div>\n\n<script>$(''#myGallery'').spacegallery({loadingClass: ''loading''});</script>','',0,0,0,0,5,35,2,0,'a:1:{s:37:"part_a327ad094b25996a923b19747a03e446";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/spacegal/','','','',0,0,0,0,1),
(11,0,'Zoomy','zoomy','7589f0204d23cf2c2d6c0f7055be28d7','2015-10-08 19:18:00','2015-10-08 19:40:37',-1,'',0,2,0,0,'[if !glob.zoomy]\n    [glob.zoomy=1]\n    [head]\n        [component.jquery(version=''1.4.2'')]\n        <script type="text/javascript" src="[cpart.folder]jquery.zoomy0.5.js"></script>\n        <link rel="stylesheet" href="[cpart.folder]zoomy.css" type="text/css" />\n    [/head]\n   <script type="text/javascript">\n	$(function(){\n		$(''.zoom'').zoomy({\n			zoomSize: [$zoom]\n		});\n	});\n  </script>\n[/if]\n\n<a href="[$img_big]" class="zoom"><img src="[$img]" border=0/></a>','',0,0,0,0,3,39,1,0,'a:1:{s:37:"part_7589f0204d23cf2c2d6c0f7055be28d7";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/zoomy/','','','',0,0,0,0,1),
(12,0,'SlideMenu','slidemenu','bb39212329d3fbd72e39c82e68f1d4eb','2015-10-08 19:36:28','2015-10-23 20:21:35',-1,'',0,2,0,0,'[head]\n    [component.jquery(version=''1.4.1'')]\n    <script type="text/javascript" src="/images/js/slidemenu.js"></script>\n[/head]\n\n<style>\n.accsm {list-style:none; width:[$width]px; height:[$height]px; display:block; overflow:hidden; padding: 0; margin: 0;}\n.accsm li {float:left; display:inline; overflow:hidden; padding: 0; margin: 0;}\n</style>\n\n<ul id="accsm" class="accsm">\n[tree linear $rows]\n     <li><img src="[cur.col($photo)]" alt="" /></li>\n[/tree]\n</ul>\n\n<script>\n$(document).ready(function() {  \n           slideMenu.build("accsm",430,10,10,1);\n}\n</script>','',0,0,0,0,6,40,2,0,'a:1:{s:37:"part_bb39212329d3fbd72e39c82e68f1d4eb";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/slidemenu/','','','',0,0,0,0,1),
(13,0,'Coda Slider','coda_slider','648326ae8040e004fc3f02c58ca62965','2015-10-09 10:04:46','2015-10-09 10:13:59',-1,'',0,2,0,0,'[if !glob.use_codaslider]\n    [glob.use_codaslider=1]\n    [head]\n        <link rel="stylesheet" href="[cpart.folder]coda-slider-2.0.css" type="text/css" media="screen" />\n        [component.jquery(version=''1.3.2'')]\n        <script type="text/javascript" src="[cpart.folder]jquery.easing.1.3.js"></script>\n        <script type="text/javascript" src="[cpart.folder]jquery.coda-slider-2.0.js"></script>\n    [/head]\n[else]\n    [glob.use_codaslider=glob.use_codaslider+1]\n[/if]\n<script>\n$().ready(function() {\n       $(''#coda-slider-[glob.use_codaslider]'').codaSlider({\n           autoSlide: true,\n           autoSlideInterval: [$time*1000],\n           autoSlideStopWhenClicked: true,\n           dynamicArrows: false,\n           dynamicTabs: false,\n           autoHeight:true\n       });\n   });\n</script>\n\n<div class="coda-slider-wrapper"> \n  <div class="coda-slider preload" id="coda-slider-[glob.use_codaslider]" style="[if $width]width: [$width]px;[/if]">\n      [tree $rows]\n       	<div class="panel" style="width: [if $width!=""]width: [$width]px;[/if]px;">\n            <div class="panel-wrapper" style="width: [if $width!=""]width: [$width]px;[/if]px; padding: 0px;">\n                [cur.col($data)]\n            </div>\n        </div>\n      [/tree]\n  </div>\n</div>','',0,0,0,0,5,0,2,0,'a:1:{s:37:"part_648326ae8040e004fc3f02c58ca62965";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/coda/','','','',0,0,0,0,1),
(14,0,'FishEye','fisheye','d96fb102374a674660dee9396b090dcf','2015-10-09 21:01:03','2015-10-23 20:21:51',-1,'',0,2,0,0,'[if !glob.use_fisheye]\n    [glob.use_fisheye=1]\n    [head]\n        [component.jquery(version=''1.1.2'')]\n        <script type="text/javascript" src="[cpart.folder]interface.js"></script>\n        <link rel="stylesheet" media="screen" type="text/css" href="[cpart.folder]style.css" />\n    [/head]\n[/if]\n\n<div id="fisheye" class="fisheye">\n<div class="fisheyeContainter">\n[tree linear $rows]\n    <a href="[$url_prefix][cur.col($url)]" class="fisheyeItem[if $talign==''top'']2[/if]">\n        [if $talign==''top'']<span>[cur.col($title)]</span>[/if]\n        <img hspace="2" src="[cur.col($img)]" width="30" />\n        [if $talign==''bottom'']<span>[cur.col($title)]</span>[/if]\n    </a>\n[/tree]\n</div>\n</div>\n<script type="text/javascript">\n	$(document).ready(\n		function()\n		{\n			$(''#fisheye'').Fisheye(\n				{\n					maxWidth: [$maxwidth],\n					items: ''a'',\n					itemsText: ''span'',\n					container: ''.fisheyeContainter'',\n					itemWidth: [$minwidth],\n					proximity: 90,\n					alignment : ''[$align]'',\n					halign : ''center'',\n 					valign : ''[$valign]''\n				}\n			)\n		}\n	);\n</script>','',0,0,0,0,7,51,2,0,'a:1:{s:37:"part_d96fb102374a674660dee9396b090dcf";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/fisheye/','','','',0,0,0,0,1),
(15,0,'Поделиться (от Яндекса)','yandex_share','3c431514690400bdebdd2e27a59e80ba','2015-10-09 22:33:58','2015-10-09 22:45:34',-1,'',0,2,0,0,'<script type="text/javascript" src="http://yastatic.net/share/share.js" charset="utf-8"></script>\n[silent]\n    [if $vk][$res[]=''vkontakte''][/if]\n    [if $fb][$res[]=''facebook''][/if]\n    [if $tw][$res[]=''twitter''][/if]\n    [if $ok][$res[]=''odnoklassniki''][/if]\n    [if $mm][$res[]=''moimir''][/if]\n    [if $lj][$res[]=''lj''][/if]\n    [if $gp][$res[]=''gplus''][/if]\n[/silent]\n<div class="yashare-auto-init" data-yashareL10n="ru" data-yashareType="[$theme]" data-yashareQuickServices="[$res.implode('','')]"[if $theme==''small''] data-yashareTheme="counter"[/if]></div> ','',0,0,0,0,8,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(16,0,'Лайк VK','like_vk','5f6b53502e7823504ab46b0cb34df7b3','2015-10-09 22:48:18','2015-10-09 23:22:12',-1,'',0,2,0,0,'[head]\n    <script type="text/javascript" src="http://vk.com/js/api/openapi.js?115"></script>\n    <script type="text/javascript">\n        VK.init({apiId: [$id], onlyWidgets: true});\n    </script>\n[/head]\n<div id="vk_like"></div>\n<script type="text/javascript">\n    VK.Widgets.Like("vk_like", {type: "[$type]"});\n</script>','',0,0,0,0,8,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(17,0,'Сообщество VK','community_vk','b5f9714e9d71dd975be6e339ff447da4','2015-10-09 22:54:31','2015-10-09 23:15:21',-1,'',0,2,0,0,'<script type="text/javascript" src="http://vk.com/js/api/openapi.js?117"></script>\n\n<!-- VK Widget -->\n<div id="vk_groups"></div>\n<script type="text/javascript">\nVK.Widgets.Group("vk_groups", {mode: [$mode], width: "[$width]", height: "[$height]"}, color1: ''[$background]'', color2: ''[$font]'', color3: ''[$buttons]'', [$id]);\n</script>','',0,0,0,0,8,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(18,0,'Комментарии VK','comments_vk','23dcc97b515e21c1dd69846f579cf4ae','2015-10-09 23:16:23','2015-10-09 23:20:54',-1,'',0,2,0,0,'[head]\r\n    <script type="text/javascript" src="http://vk.com/js/api/openapi.js?117"></script>\r\n    \r\n    <script type="text/javascript">\r\n      VK.init({apiId: [$id], onlyWidgets: true});\r\n    </script>\r\n[/head]\r\n\r\n<div id="vk_comments"></div>\r\n<script type="text/javascript">\r\nVK.Widgets.Comments("vk_comments", {limit: [$limit], width: "[$width]", attach: "*"});\r\n</script>','',0,0,0,0,8,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(19,0,'Постраничная навигация','paginator','0ae9ce622be7e056dc8dceb8339a08a4','2015-10-09 23:42:21','2016-03-30 04:23:04',-1,'',0,2,0,0,'[* Определение количества страниц *]\n[if !$count][return false][/if]\n[if !$page]\n    [page="0"]\n[/if]\n[if glob.page]\n    [page=glob.page]\n[/if]\n[total_pages=$count//$num]\n[if $count%$num!=0]\n    [total_pages=$total_pages+1]\n[/if]\n[if $total_pages<=1][return false][/if]\n\n[compile css u]\n.page{\n    padding: 3px;\n    border: 1px solid #BBBBBB;\n    margin-left: 2px;\n    margin-right: 2px;\n}\n.page:hover{\n    border: 1px solid #999999;\n    background-color: #EEEEEE;\n    color: #555555;\n}\n.select_page{\n    padding: 3px;\n    border: 1px solid #999999;\n    margin-left: 2px;\n    margin-right: 2px;\n    background-color: #EEEEEE;\n    color: #555555;\n}\n.page_padding{\n    padding-left: 6px;\n    padding-right: 6px;\n}\n[/compile]\n\n[* Первая страница *]\n[num2=4]\n[if $page<$num2*2]\n   [start=0]\n[else]\n   [start=$page-$num2]\n   [if $page!="0"]\n           <span class="page page_padding"><a href="[url2 "page" 0]">1</a></span> ...\n   [else]\n           <span class="select_page page_padding">1</span> ... \n   [/if]\n[/if]\n\n[* Определение первой и последней страницы *]\n[if $page>$total_pages-$num2-3]\n    [end=$total_pages-1]\n    [if $start>$total_pages-$num2-$num2-1]\n        [start=$total_pages-$num2-$num2-1]\n    [/if]\n[else]\n    [end=$start+$num2+$num2]\n[/if]\n[if $start>$total_pages]\n    [start=$total_pages-1]\n[/if]\n[if $end<0]\n    [end="0"]\n[/if]\n[if $end>=$total_pages]\n    [end=$total_pages-1]\n[/if]\n[if $start<0]\n    [start="0"]\n[/if]\n\n[* Вывод страниц *]\n[tree $start..$end]\n    [if (index+1).length==1][pp=" page_padding"][else][pp=""][/if]\n    [if $page+1==index+1]\n       <span class="select_page[$pp]">[index+1]</span>\n    [else]\n       <span class="page[$pp]"><a href="[url2 "page" index]">[index+1]</a></span>\n    [/if]\n[/tree]\n\n[* Последняя страница *]\n[if $page<$total_pages-$num2*2 && $end!=$total_pages-1]\n  [if $total_pages.length==1][pp=" page_padding"][else][pp=""][/if]\n  [if $page!=$total_pages-1]\n     ... <span class="page[$pp]"><a href="[url2 "page" $total_pages-1]">[$total_pages]</a></span>\n  [else]\n     ... <span class="select_page[$pp]">[$total_pages]</span>\n  [/if]\n[/if]\n\n[* Отдаём заголовок 404, если совершён переход на несуществующую страницу *]\n[if $page>=$total_pages][#header("HTTP/1.0 404 Not Found")][/if]','',0,0,0,0,9,82,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(21,0,'Объекты текущей страницы (из таблицы)','obj_paginator','c2007340df004b4b356ef1429ee6622a','2015-10-12 00:06:49','2016-05-26 23:35:16',-1,'',0,2,0,0,'[return $table.find.sort($sort,if($reverse,''desc'')).start($page*$num).limit($num)]','',0,0,0,0,9,85,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(22,0,'Изменение значения объекта','ajax_edit','12843648564c047defed16e63db72706','2015-10-12 00:32:56','2015-10-15 01:18:03',-1,'',0,2,0,0,'[skip dblspace]\n[if !ajax?]\n    [if !$jq]\n        [return cpart.ajax(row=$row, col=$col, value=$value)]\n        [xbreak]\n    [else]\n        [component.jquery(version=1)]\n        $.ajax({\n          method: "POST",\n          url: "[cpart.ajax(row=$row, col=$col)]",\n          data: { value: [$value] }\n        }).done(function(){\n          [$done]\n        });\n    [/if]\n[else][$row.col($col).set($value)][/if]','',0,0,0,0,10,88,2,0,'a:1:{s:37:"part_12843648564c047defed16e63db72706";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(23,0,'Bootstrap','bootstrap','eed3a60bbb069d4ade97d4373b9f97ee','2015-10-12 01:17:46','2016-02-08 15:06:22',-1,'',0,2,0,0,'[if glob.use_bootstrap][xbreak][/if]\n[head]\n    [glob.use_bootstrap=1]\n    <link href="[base_dir][cpart.folder]css/bootstrap.min.css" rel="stylesheet">\n    [component.jquery]\n    <script src="[base_dir][cpart.folder]js/bootstrap.min.js"></script>\n[/head]','',0,0,0,0,4,0,2,0,'a:1:{s:37:"part_eed3a60bbb069d4ade97d4373b9f97ee";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/adapters/bootstrap/','','','',0,0,0,0,1),
(24,0,'Навигация Bootstrap','b_navigation','114878e4e5db0e2086c077b1ee401f35','2015-10-12 03:07:44','2015-11-03 20:46:05',-1,'',0,2,0,0,'[component.bootstrap]\n<nav class="navbar [switch $theme][case "light"]navbar-default[case "dark"]navbar-inverse[/switch][if $fixed_top] navbar-fixed-top[/if]">\n    <div class="container">\n      <div class="navbar-header">\n        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target=".navbar-collapse">\n          <span class="sr-only">Toggle navigation</span>\n          <span class="icon-bar"></span>\n          <span class="icon-bar"></span>\n          <span class="icon-bar"></span>\n        </button>\n        <a class="navbar-brand" href="[if !$title_href][$title_href][else]#[/if]">[$title]</a>\n      </div>\n      <div class="navbar-collapse collapse">\n        <ul class="nav navbar-nav">\n            [tree deep(2) $rows]\n                [if cur.sub && step==0]\n                    <li class="dropdown[if cur.sub.sel(cur.selected?)] active[/if]">\n                        <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">[cur.col($name)] <span class="caret"></span></a>\n                        <ul class="dropdown-menu">\n                [else]\n                    <li[if cur.selected?] class="active"[/if]><a href="[$url_prefix][cur.wayback.sc($url).implode(''/'')]">[cur.col($name)]</a></li>\n                [/if]\n            [after]\n                [if cur.sub && step==0]\n                        </ul>\n                    </li>\n                [/if]\n            [/tree]\n        </ul>\n      </div>\n    </div>\n</nav>','',0,0,0,0,7,91,2,0,'a:1:{s:37:"part_114878e4e5db0e2086c077b1ee401f35";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(25,0,'Панель Bootstrap','bootstrap_panel','ec1b3c91a399a7f5518b1284e627dcd0','2015-10-12 11:43:48','2016-03-24 01:13:16',-1,'',0,2,0,0,'[if !$body][xbreak][/if]\n[component.bootstrap]\n<div class="panel panel-[$theme]">\n	<div class="panel-heading">\n		<h3 class="panel-title">[$title]</h3>\n	</div>\n	<div class="panel-body">\n		[$body]\n	</div>\n</div>','',0,0,0,0,11,99,2,0,'a:1:{s:37:"part_ec1b3c91a399a7f5518b1284e627dcd0";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(26,0,'Архив по месяцам','month_archive','d103d251057d8aa373149ab3e737d2f5','2015-10-12 11:54:00','2016-03-22 05:06:52',-1,'',0,2,0,0,'^*!\n[skip dblspace]\n[lurl=host2+$table.ex.own.wayback_url.uopen]\n[darkcolor=''#08ADF4'']\n[compile css u]\n.archive{\n    padding: 20px;\n}\n.archive_bg{\n    background-color: #F9F9F9;\n    border: 1px solid #EDEDED;\n}\n.archive h2 {\n     font-size: 22px;\n     color: [$darkcolor];\n     margin-top: 0px;\n     font-weight: normal;\n     margin-bottom: 13px;\n}\n.lnk{\n     color: #08ADF4;\n     text-decoration:none;\n     cursor: pointer;\n}\n.lnk:hover {\n     color: #75CFF6;\n     text-decoration:none;\n     cursor: pointer;\n}\n.box{\n     width: 30%;\n     float: left;\n     border: 1px solid #EEEEEE;\n     padding-left: 15px;\n     padding-top: 7px;\n     padding-bottom: 7px;\n}\n.box1{\n     background-color: #FFFFFF;\n}\n.box2{\n     background-color: #F8F8F8;\n}\n.box_first{\n    border-bottom: 0px;\n    border-top: 1px solid #EEEEEE;\n}\n[/compile]\n\n[tree if($rows,$rows.sc($date).deldouble.kasc,$table.allcol_uniq($date).kasc)][x=value][cm[$x.year][$x.month]=1][cy[$x.year]=$x.year][/tree]\n\n<div class="archive[if !$nobg] archive_bg[/if]">\n    <div style="padding-bottom: 16px;">\n    [tree $cy.kasc]\n        [if !last?]\n            <span class="lnk" id="[var]" OnClick="change_year(this);">[var]</span>\n        [else]\n            <span class="lnk" style="color: #3F3F3F;" id="[var]" OnClick="change_year(this);">[var]</span><script>var lyear=[var];</script>\n        [/if]\n    [/tree]\n    </div>\n    [tree $cy.kasc]\n        <div id="year[var]" style="[if !last? AND $cy.count>1]display: none;[/if] height: [32*cmd($cm[var].count//3+1)]px;">\n            [tree $cm[var]]\n                <div class="box box[if index%2!=0 AND index>0]2[else]1[/if][if first?] box_first[/if]">\n                    <a href="[$lurl]/archive/[up.var]-[var]">[var.monthB.firstcaps]</a>\n                </div>\n            [/tree]\n        </div>\n    [/tree]\n</div>\n[compile js u]\n    function change_year(obj){\n        if(obj.id==lyear) return;\n        obj.style.color=''#3F3F3F'';\n        document.getElementById(lyear).style.color='''';\n        document.getElementById(''year''+lyear).style.display=''none'';\n        document.getElementById(''year''+obj.id).style.display='''';\n        lyear=obj.id;\n    }\n[/compile]','',0,0,0,0,11,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(27,0,'Секция HEAD','head','63d253f828acc5ecf4d0dbe411281100','2015-10-12 15:03:39','2016-02-15 11:06:03',-1,'',0,2,0,0,'    <title>[$title]</title>\n    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">\n    [if $keywords]<meta name="keywords" content="[$keywords]"/>[/if]\n    [if $description]<meta name="description" content="[$description]"/>[/if]\n    [if $favicon]<link rel="shortcut icon" href="[$favicon]">[/if]\n    [tree $js][if !value][continue][/if]\n        <script src="[$js_prefix][value]"></script>\n    [/tree]\n    [tree $css][if !value][continue][/if]\n        <link href="[$css_prefix][value]" rel="stylesheet">\n    [/tree]','',0,0,0,0,12,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(28,0,'Секция sitemap для массива объектов','sitemap_array','5847ca97ee65e628197900df8e36d8bc','2015-10-12 15:19:34','2016-03-16 15:22:21',-1,'',0,2,0,0,'[silent]\n[if $include_next]\n    [include_col='''']\n    [tree $rows.first.table.cols]\n        [if cur.type==is_module]\n            [include_col=cur.sname]\n            [break]\n        [/if]\n    [/tree]\n[/if]\n[if !$base_url][base_url=''/''][/if]\n[/silent]\n[tree $rows][silent]\n[if first? || $ltable!=cur.table]\n    [ltable=cur.table]\n    [if $base_url.uclose++cur.аllway_url!=cur.full_url]\n        [use_furl=1]\n    [else]\n        [use_furl=0]\n    [/if]\n[/if]\n[if !$use_furl]\n    [u=$base_url.uclose++cur.allway_url]\n[else]\n    [u=cur.full_url]\n[/if]\n[/silent]<url>\n    <loc>[$u]</loc>\n    <lastmod>[#date(''Y-m-d'')]</lastmod>\n    <changefreq>weekly</changefreq>\n    <priority>0.[$base_step-step]</priority>\n</url>[if $include_col && cur.col($include_col)][silent]\n        [do_include=0]\n        [nex=cur.col($include_col)]\n        [tmp=$nex.part.sitemap]\n        [if !$tmp]\n            [r=$nex.major.rows]\n            [tree $r.first.table.cols]\n                [if cur.is_url]\n                    [do_include=1]\n                    [break]\n                [/if]\n            [/tree]\n        [/if]\n        [if $do_include && $r.count>0]\n            [tmp=cpart.run(rows=$r, base_step=$base_step-1, base_url=$u, include_next=true)]\n        [/if]\n[/silent][$tmp][/if]\n[/tree]','',0,0,0,0,12,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(29,0,'Sitemap','sitemap','94d8f9eef373d0ef18784389c8c03ffe','2015-10-12 15:24:35','2015-10-26 02:36:53',-1,'',0,2,0,0,'^*~![stand alone][#header("HTTP/1.0")][#header("Content-Type: application/xml")]<?xml version="1.0" encoding="UTF-8"?>\n<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">\n    [if $autogen]\n        [component.sitemap_array(rows=zone.module.major.rows, base_step=8, base_url=host, include_next=true)]\n    [else]\n        [$sitemap_body]\n    [/if]\n</urlset>','',0,0,0,0,12,0,2,0,'a:1:{s:37:"part_94d8f9eef373d0ef18784389c8c03ffe";a:1:{i:2;a:1:{s:13:"sitemap_array";s:13:"sitemap_array";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1);

INSERT INTO `main_part` (part_id,part_module,part_name,part_sname,part_uin,part_date,part_date2,part_auth,part_about,part_access,part_type,part_table,part_owner,part_body,part_url,part_ignore,part_iowner,part_sowner,part_parse,part_cat,part_major,part_proc,part_ex,part_parts,part_404,timer_last,timer_act,timer_type,timer_date,timer_time,timer_x,timer_y,timer_count,part_file,parser_end_ex,part_shell,part_cur,part_pic,part_folder,part_ifcase,part_ifdetect,part_ifrow,part_unsafe,part_shelltime,part_shellcount,part_skipurl,part_enable) VALUES
(30,0,'Bootstrap Slider','bootstrap_slider','e61480485141e8a6d64a587a75b5433a','2015-10-13 02:39:32','2015-10-21 18:16:30',-1,'',0,2,0,0,'[component.bootstrap]\n<div id="carousel-example-generic" class="carousel slide" data-ride="carousel">\n    <ol class="carousel-indicators">\n    [selected=glob.rand(0,$rows.count-1)]\n    [tree $rows]\n        <li data-target="#carousel-example-generic" data-slide-to="[index]"[if index==$selected] class="active"[/if]></li>\n    [/tree]\n    </ol>\n    <div class="carousel-inner" role="listbox">\n    [tree $rows]\n      <div class="item[if index==$selected] active[/if]">\n        [if $img]<img src="[cur.col($img)]" alt="[cur.col($title)]">[/if]\n        [if $body][cur.col($body)][/if]\n      </div>\n    [/tree]\n    </div>\n    <a class="left carousel-control" href="#carousel-example-generic" role="button" data-slide="prev">\n      <span class="glyphicon glyphicon-chevron-left" aria-hidden="true"></span>\n      <span class="sr-only">Previous</span>\n    </a>\n    <a class="right carousel-control" href="#carousel-example-generic" role="button" data-slide="next">\n      <span class="glyphicon glyphicon-chevron-right" aria-hidden="true"></span>\n      <span class="sr-only">Next</span>\n    </a>\n</div>','',0,0,0,0,5,113,2,0,'a:1:{s:37:"part_e61480485141e8a6d64a587a75b5433a";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(31,0,'Таблица Bootstrap','bootstrap_table','519d0fee336d0ebbe9d25ee511f5c438','2015-10-13 03:04:27','2015-10-23 20:50:25',-1,'',0,2,0,0,'[component.bootstrap]\n<table class="table [$theme]">\n    <thead>\n      <tr>\n        [if $show_number]<th>#</th>[/if]\n        [tree $rows.first.table.cols]\n            [if !$cols || cur.sname^$cols]\n                <th>[cur.name]</th>\n            [/if]\n        [/tree]\n      </tr>\n    </thead>\n    <tbody>\n    [tree linear $rows]\n      <tr>\n        [if $show_number]\n                <td>[index+1]</td>\n        [/if]\n        [tree $rows.first.table.cols]\n            [if !$cols || cur.sname^$cols]\n                <td>[up.col(cur.sname)]</td>\n            [/if]\n        [/tree]\n      </tr>\n      [if cur.sub]\n        <tr>\n            <td colspan="[if($show_number,$cols.count+1,$cols.count)]">\n              [cpart.run(rows=cur.sub, cols=$cols, theme=$theme, show_number=$show_number)]\n            </td>\n        </tr>\n      [/if]\n    [/tree]\n    </tbody>\n</table>','',0,0,0,0,12,0,2,0,'a:1:{s:37:"part_519d0fee336d0ebbe9d25ee511f5c438";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(32,0,'Лента RSS','rss','86d251376c778ab402fcf2d410f30350','2015-10-13 04:31:49','2015-10-26 12:09:44',-1,'',0,2,0,0,'[stand alone][#header("HTTP/1.0")][#header("Content-Type: application/xml")][lup=-1]<?xml version="1.0"?>\n<rss version="2.0" xmlns:atom="http://www.w3.org/2005/Atom">\n  <channel>\n    <atom:link href="[url]" rel="self" type="application/rss+xml" ></atom:link>\n    <title>[$title]</title>\n    <link>[url]</link>\n    <description>[$description]</description>\n    <language>[$lang]</language>\n    <pubDate>[glob.date]</pubDate>\n    <lastBuildDate>[glob.date]</lastBuildDate>\n    <generator>E5</generator>\n    [tree $rows]\n        [if cur.up!=$lup]\n            [fu=cur.full_url]\n            [pref_url=$fu.copy(0,$fu.length-cur.col($item_link).length).uclose]\n        [/if]\n         [*if first?]\n            [cur.allway.with(value.del(value.count-1).each(urls[]=cur.geturl))]\n            [if $urls]\n                [$pref_url=$pref_url.uclose+$urls.implode(''/'').uclose]\n            [/if]\n         [/if*]\n         <item>\n            [if $item_photo]\n                <enclosure url="[host2][cur.col($item_photo)]"/>\n            [/if]\n          <title>[cur.col($item_title)]</title>\n          <link>[$pref_url][cur.col($item_link)]</link>\n          [if $item_desc]\n            <description>[cur.col($item_desc).clear.safe_input.with(if(value.length>400,value.scopy(400)+''...'',value))]</description>\n          [/if]\n          <pubDate>[cur.col($item_date)]</pubDate>\n          <guid>[cur.col($item_link)]</guid>\n        </item>\n    [/tree]\n</channel>\n</rss>','',0,0,0,0,12,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(33,0,'Отделить анонс','make_anons','0f852757d0e375e72297624e8e9b5adb','2015-10-13 05:07:09','2015-10-13 05:10:24',-1,'',0,2,0,0,'[return $src.clear.scopy($length)]','',0,0,0,0,13,128,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(34,0,'Загрузка изображений','img_uploader','3efb732657c2c1d8e0c5f0ec44846dfa','2015-10-13 05:12:35','2015-11-02 03:31:52',-1,'',0,2,0,0,'[if ajax?][skip dblspace][strip spaces]\n[x=post_files]\n[x=$x["Filedata"]]\n[y=$x["tmp_name"]]\n[t=$x["name"]]\n[tree $t]\n     [z["tmp_name"]=$y[index]]\n     [z["name"]=$t[index]]\n     [$photo->$z]\n     [addrow $table]\n[/tree]\nstatus=1\n\n[else]\n[if !$table][table=ctbl][/if]\n[url=cpart.ajax(table=$table, photo=$photo, width=$width, height=$height, upload=1).replace("&","%26")]\n<script type="text/javascript" src="/files/js/fastupload/swfobject.js"></script>\n		<script type="text/javascript">\n			var flashvars = {};\n			flashvars.path = "[$url]";\n			flashvars.path2 = "";\n			flashvars.path3 = "";\n			flashvars.box_width = 220;\n			flashvars.box_height = 220;\n			flashvars.max_width = [$width];\n			flashvars.max_height = [$height];\n			var params = {};\n			params.menu = "false";\n			params.scale = "noscale";\n			params.salign = "tm";\n			var attributes = {};\n			attributes.align = "middle";\n			\n			swfobject.embedSWF("[cpart.folder]imgUpload.swf", "flashHolder", "100%", "100%", "10.0.0", false, flashvars, params, attributes);\n		</script>\n<p><b>Пакетная загрузка</b></p><div id="mainHolder" style="width:692px;height:263px;">\n		<div id="flashHolder">\n			<a href="http://www.adobe.com/go/getflashplayer">\n				<img src="http://www.adobe.com/images/shared/download_buttons/get_flash_player.gif" alt="Get Adobe Flash player" />\n			</a>\n		</div>\n	</div>\n	[if is_admin?]<br><br><div>После завершения загрузки нажмите <a href="[a_url]">здесь</a></div>[/if]\n[/if]','',0,0,0,0,14,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/fastupload/','','','',0,0,0,0,1),
(35,0,'Форма добавления/изменения объекта','form','d7c66e741876ecc2ae2abae2233424eb','2015-10-13 05:26:27','2016-05-22 12:42:42',-1,'',0,2,0,0,'[if $action!="add" && $action!="edit"]\n    [if $row && !$row.edit? || !$row && !$table.add?]\n        <div>Недостаточно привелегий для операции [if $row]сохранения[else]добавления[/if]</div>\n        [xbreak]\n    [/if]\n    [if $limit]\n        [if !$time][time=60][/if]\n        [left=stat.view_action(''add-row-''++$table.sname, ''!''++$time)]\n        [if $left>=$limit]\n            <p>Вы израсходовали лимит [if !$row]добавления[else]сохранения[/if] ([$limit] в [$time] [$time.strnum(''минут'',''минуту'',''минут'')])</p>\n            [xbreak]\n        [/if]\n    [/if]\n    <form action="[url]#add_form" method="post" enctype="multipart/form-data"[if $on_submit!=""] OnSubmit="[$on_submit]"[/if]>\n        [form_protect]\n        <input type="hidden" name="table" value="[$table]">\n        <input type="hidden" name="action" value="[if $row]edit[else]add[/if]">\n        [tree $cols]\n            [if component.is_bootstrap]\n                <div class="form-group">\n                    <label for="[$table.col(value).formname]">[$table.col(value).name]</label>\n                    [if($row,$row,$table).col(value).form.replace(''id="''++$table.col(value).formname++''"'',''id="''++$table.col(value).formname++''" class="form-control" '')]\n                </div>\n            [else]\n                <div>\n                    <br><b>[$table.col(value).name]</b><br>\n                    [if $row]\n                        [$row.col(value).form]\n                    [else]\n                        [$table.col(value).form]\n                    [/if]\n                </div>\n            [/if]\n        [/tree]\n        [if $capcha]\n            [component.capcha_question]\n        [/if]\n        [if component.is_bootstrap]\n            <input type="submit" value="[if $row]Сохранить[else]Добавить[/if]" class="btn btn-primary">\n            [if $reset]<input type="reset" value="Сбросить" class="btn btn-default">[/if]\n        [else]\n            <br><input type="submit" value="[if $row]Сохранить[else]Добавить[/if]">\n            [if $reset]<input type="reset" value="Сбросить">[/if]\n        [/if]\n    </form>\n    \n    [if $limit && $show_left]\n        <p align="right">В ближайшее время вы можете осуществить [if !$row]добавление[else]изменение[/if] [$limit-$left] [($limit-$left).strnum(''раз'',''раза'',''раз'')]</p>\n    [/if]\n[else]\n    <a name="add_form"></a>\n    [if !$capcha || component.capcha_question(type=''check'')]\n        [tree $cols]\n           [value->post.{[$table.col(value).formname]}]\n        [/tree]\n        [if $row]\n            [editrow $table $row]\n        [else]\n            [addrow $table]\n        [/if]\n        [if cancel?==""]\n            [$after.shell]\n            <div>Информация [if $row]cохранена[else]добавлена[/if]</div>\n            [if $limit]\n                [if !$time][time=60][/if]\n                [stat.check(''add-row-''++$table.sname, $limit, ''!''++$time)]\n            [/if]\n        [else]\n            <div>Информация не [if $row]cохранена[else]добавлена[/if]. Ошибка: [cancel?]</div>\n        [/if] \n        [if !$row]<div><a href="[url]">Добавить ещё</a></div>[/if]\n    [else]\n        <div>Информация не добавлена. Ошибка: Неправильный ответ на контрольный вопрос</div>\n        <div><a href="[url]">Попробовать ещё</a></div>\n    [/if]\n[/if]','',0,0,0,0,14,0,2,0,'a:1:{s:37:"part_d7c66e741876ecc2ae2abae2233424eb";a:1:{i:2;a:2:{s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(36,0,'Капча-вопрос','capcha_question','34cbb98da96e4e3020d6b7527ea9e165','2015-10-13 05:58:35','2016-05-09 19:15:01',-1,'',0,2,0,0,'[if $type==''check'']\n    [if post.capcha2]\n        [return post.capcha1.md5==post.capcha2]\n    [else]\n        [return $capcha1.md5==$capcha2]\n    [/if]\n[else]\n        [v1=glob.rand(10,20)]\n        [v2=glob.rand(1,20)]\n        [v3=glob.rand(1,10)]\n        <input type="hidden" name="capcha2" value="[($v1+$v2-$v3).md5]">\n        \n        [if component.is_bootstrap]\n            <div class="form-group">\n                <label for="capcha1">Контрольный вопрос:</label>\n                Сколько будет: [$v1]+[$v2]-[$v3]<br>\n                <input type="text" name="capcha1" class="form-control">\n            </div>\n        [else]\n            <div>\n                <b>Контрольный вопрос:</b><br>\n                Сколько будет: [$v1]+[$v2]-[$v3]<br>\n                <input type="text" name="capcha1">\n            </div>\n        [/if]\n[/if]','',0,0,0,0,15,0,2,0,'a:1:{s:37:"part_34cbb98da96e4e3020d6b7527ea9e165";a:1:{i:2;a:1:{s:12:"is_bootstrap";s:12:"is_bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(37,0,'Форма обратной связи','feedback','99a0d351f34705196f64be4216a02596','2015-10-13 06:29:00','2016-04-22 10:01:18',-1,'',0,2,0,0,'[if $action!="send_email"]\n    [component.jquery(version=1)]\n    <form action="[url]" method="post" enctype="multipart/form-data" OnSubmit="return check_send_form();">\n        <input type="hidden" name="action" value="send_email">\n        [if component.is_bootstrap]\n            <div class="form-group">\n                <label for="email_name">Ваше имя:</label>\n                <input type="text" name="email_name" id="email_name" value="" class="form-control">\n            </div>\n            <div class="form-group">\n                <label for="email_name">Ваш email:</label>\n                <input type="text" name="email_email" id="email_email" value="" class="form-control">\n            </div>\n            <div class="form-group">\n                <label for="email_body">Текст письма:</label>\n                <textarea name="email_body" id="email_body" style="height: 200px;" class="form-control">[$text]</textarea>\n            </div>\n            [component.capcha_question]\n            <br><input type="submit" value="[$submit]" class="btn btn-primary">\n        [else]\n            <table>\n                <tr><td align="left" width="100">Ваше имя:</td><td align="left"><input type="text" name="email_name" id="email_name" value=""></td></tr>\n                <tr><td align="left" width="100">Ваш e-mail:</td><td align="left"><input type="text" name="email_email" id="email_email" value=""><span id="valid"></span></td></tr>\n                <tr><td colspan="2" align="left">Текст письма:</b><br>\n                <textarea name="email_body" style="width: 100%; height: 150px;">[$text]</textarea></td></tr>\n            </table>\n            [component.capcha_question]\n            <br><input type="submit" value="[$submit]">\n        [/if]\n    </form>\n    \n    [compile js]\n    [~\n    $(document).ready(function() {\n        $(''#email_email'').blur(function() {\n            if($(this).val() != '''') {\n                var pattern = /^([a-z0-9_\\.-])+@[a-z0-9-]+\\.([a-z]{2,4}\\.)?[a-z]{2,4}$/i;\n                if(pattern.test($(this).val())){\n                    $(this).css({''border'' : ''1px solid #569b44''});\n                    $(''#valid'').text(''Верно'');\n                } else {\n                    $(this).css({''border'' : ''1px solid #ff0000''});\n                    $(''#valid'').text(''Не верно'');\n                }\n            } else {\n                $(this).css({''border'' : ''1px solid #ff0000''});\n                $(''#valid'').text(''Поле email не должно быть пустым'');\n            }\n        });\n    });\n    \n    function check_send_form(){\n       var obj=document.getElementById(''email_name'');\n       if(obj.value==''''){alert(''Введите имя''); return false;}\n       var obj=document.getElementById(''email_email'');\n       if(obj.value==''''){alert(''Введите Email''); return false;}\n       return true;\n    }\n    ~]\n    [/compile]\n    \n[else]\n\n    [if component.capcha_question(type=''check'')]\n        [topic=''Письмо с сайта ''++host]\n        [cont='' <div>Вам пришло письмо с страницы ''++url++''</div>\n                <div><br>Имя отправителя: ''++post.email_name++''</div>\n                <div><br><b>Текст письма</b>:<br> ''++post.email_body++''<div>'']\n        [if $silent]\n            [cont=post.email_body]\n            [topic="Вам пишет "++post.email_name]\n        [/if]\n        [if !$email][email=zone_email][/if]\n        [if !post.email_email || !post.email_email.valid_email][from=zone_email][else][from=post.email_email][/if]\n        [#simple_mail($from,$email,$topic,$cont,''utf-8'')]\n        <div>Письмо успешно отправлено</div>\n    [else]\n        <div>Письмо не отправлено. Ошибка: Неправильный ответ на контрольный вопрос</div>\n        <div><a href="[url]">Попробовать ещё</a></div>\n    [/if]\n\n[/if]','',0,0,0,0,14,140,2,0,'a:1:{s:37:"part_99a0d351f34705196f64be4216a02596";a:1:{i:2;a:3:{s:6:"jquery";s:6:"jquery";s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(38,0,'Кнопка Bootstrap','bootstrap_button','0e08a8e9aaf94b4b5cf5c7214375c3bb','2015-10-13 07:37:06','2015-10-25 00:23:29',-1,'',0,2,0,0,'[component.bootstrap]\n<button type="[$type]" [if $id]id="[$id]"[/if] class="btn [$size] [$class]" OnClick="[$onclick]">[$title]</button>','',0,0,0,0,12,146,2,0,'a:1:{s:37:"part_0e08a8e9aaf94b4b5cf5c7214375c3bb";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(39,0,'Shadowbox','shadowbox','41cf57b42ef037786c54a7564b172aba','2015-10-13 07:56:08','2015-12-09 11:59:24',-1,'',0,2,0,0,'[skip dblspace]\n[if !glob.use_shadowbox]\n    [head]\n    	<link rel="stylesheet" href="[cpart.folder]shadowbox.css" type="text/css" />\n        [component.jquery(version=''1.5.2'')]\n	    <script type="text/javascript" src="[cpart.folder]shadowbox.js"></script>\n    [/head]\n	<script type="text/javascript">\n		$(document).ready(function(){\n			Shadowbox.init();\n		});\n	</script>\n	[glob.use_shadowbox=1]\n[/if]\n<a href="[$big]" rel="shadowbox[[[$name]]]" title="[$title]">[if $text][$text][else]<img src="[$small]"[if $width] width="[$width]"[/if][if $height] height="[$height]"[/if] border="0">[/if]</a>','',0,0,0,0,3,150,1,0,'a:1:{s:37:"part_41cf57b42ef037786c54a7564b172aba";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/shadowbox/','','','',0,0,0,0,1),
(40,0,'Выбор цвета','colorpicker','3c6bf36d36507bd6fe647228e5c85c63','2015-10-13 08:04:55','2015-10-13 08:20:59',-1,'',0,2,0,0,'[if !glob.jpicker]\n    [head]\n        <link type="text/css" rel="stylesheet" href="[cpart.folder]css/jpicker-1.1.6.css">\n        <script type="text/javascript" src="[cpart.folder]jpicker-1.1.6.js"></script>\n        [component.jquery(version=''1.4.4'')]\n    [/head]\n    [glob.jpicker=1]\n[else]\n    [glob.jpicker=glob.jpicker+1]\n[/if]\n<script type="text/javascript">        \n  $(document).ready(\n    function()\n    {\n      $(''#[$src.formname]'').jPicker();\n    });\n</script>\n<input name="[$src.formname]" id="[$src.formname]" type="text" style="width: 100px;" value="[if $src.value==""][if $value!=""][$value][else]ffffff[/if][else][$src.value][/if]" />','',0,0,0,0,16,157,3,0,'a:1:{s:37:"part_3c6bf36d36507bd6fe647228e5c85c63";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/jpicker/','','','',0,0,0,0,1),
(41,0,'Большое поле текста','textarea','c4df3fed31dd60623695fb43c5f5cae6','2015-10-13 08:22:32','2016-03-23 23:29:15',-1,'',0,2,0,0,'<textarea name="[$src.formname]" style="height: [$height];[if $width!=""] width:[$width];[/if]">[if !$value][$src.value.safe_input][else][$value.safe_input][/if]</textarea>','',0,0,0,0,17,159,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(42,0,'Дата','datepicker','644e19ebc79fc097a42bf4d4bcb5ddd0','2015-10-13 08:26:32','2015-10-13 16:15:26',-1,'',0,2,0,0,'[if !glob.use_datepicker]\n    [glob.use_datepicker=1]\n    [head]\n        [component.jquery(version=''1.3.2'')]\n        <link rel="stylesheet" media="screen" type="text/css" href="[cpart.folder]datepicker.css" />\n        <script type="text/javascript" src="[cpart.folder]datepicker.js"></script>\n    [/head]\n[/if]\n\n<input class="button" id="i[$src.formname]" name="[$src.formname]" value="[if $src.value==""][if $value!=""][$value][else][glob.date][/if][else][$src.value][/if]" />\n\n[if user.browser!="ie"]\n<script>\n$(''#i[$src.formname]'').DatePicker({\n	format:''Y-m-d'',\n	date: $(''#i[$src.formname]'').val(),\n	current: $(''#i[$src.formname]'').val(),\n	starts: 1,\n	position: ''top'',\n	onChange: function(formated, dates){\n		var tmp=$(''#i[$src.formname]'').val();\n		$(''#i[$src.formname]'').val(formated);\n		if(tmp!=formated) $(''#i[$src.formname]'').DatePickerHide();\n	}\n});\n</script>\n[/if]','',0,0,0,0,16,163,3,0,'a:1:{s:37:"part_644e19ebc79fc097a42bf4d4bcb5ddd0";a:1:{i:2;a:1:{s:6:"jquery";s:6:"jquery";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/date/','','','',0,0,0,0,1),
(43,0,'Добавить массив элементов','multy','6edf837e8a1fec64a2c8cb0489f4e50b','2015-10-13 08:31:56','2016-03-26 09:48:49',-1,'добавлять в шапку и подвал таблицы',0,2,0,0,'[if $table][tbl=$table][else][tbl=ctbl.self][/if]\n\n[val=post.val]\n[if f_type=="top" && $val!=""]\n   [tree $val.exp2("\n")][if value!=""]\n          [$tbl.major.sname->value.trim]\n          [addrow $tbl]\n   [/if][/tree]\n[/if]\n\n[if f_type=="bottom"]\n   <form action="[a_url]" method="post">\n         [form_protect]\n         <br><div><b>Быстрое добавление</b> (по строчке на значение - поле "[$tbl.major.name]"):</div>\n         <textarea name="val" style="height: 300px;"></textarea>\n         <input type="submit" value="Добавить">\n  </form>\n[/if]','',0,0,0,0,14,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(44,0,'Поле текста (с переводом)','input','bfda56a0c6f9a4134be765138f0ce9aa','2015-10-13 08:35:28','2015-10-13 08:39:11',-1,'',0,2,0,0,'<input type="text" name="[$src.formname]" value="[$src.value.safe_input]"[if $trans] OnBlur="translate2(this,[$trans.formname]);"[/if]>','',0,0,0,0,17,0,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(45,0,'Поле текста (с подсказками)','tagarea','9127e7b7aff74a9879890a9c7c8c5ddb','2015-10-13 12:39:25','2015-10-13 13:23:26',-1,'',0,2,0,0,'<textarea id="[$src.formname]" name="[$src.formname]" style="height: [$height];[if $width!=""] width:[$width][/if];">[if $value==""][$src.value.safe_input][else][$value.safe_input][/if]</textarea>\n[tree $tags]\n  [title=value.exp2("|")[0]]\n  [code=value.exp2("|")[1]]\n  [glob.riiid=glob.riiid+1]\n  <textarea style="display:none;" id="z[glob.riiid]">[$code]</textarea>\n  [[<span OnClick="insertAtCursor([$src.formname],document.getElementById(''z[glob.riiid]'').value,1);" class="link">[$title]</span>]][if !last?] - [/if]\n[/tree]','',0,0,0,0,17,168,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(46,0,'Редактор CKEditor','ckeditor','39ec86b187678617c5235aa3ba23af8d','2015-10-13 13:29:42','2016-04-10 21:06:07',-1,'',0,2,0,0,'[if !glob.ckeditor]\n    [glob.ckeditor=1]\n    [head]\n        <script type="text/javascript" src="[cpart.folder]ckeditor.js"></script>\n    [/head]\n    <div id="finder" style=""></div>\n[/if]\n\n[if !$name][name=$src.formname][/if]\n[if !$value][value=$src.value][/if]\n<script>addLoadEventCK("CKEDITOR.replace(''[$name]''[if $config!=""],{[$config]}[/if]);");</script>\n<textarea name="[$name]">[$value]</textarea>\n[if $src && $src.is_tpl==1]\n<script>\n\n[if cm]\n    selectModule=[cm];\n	selectModuleSname=''[cm.sname]'';\n[/if]\n[if ctbl]\n	selectTable=[ctbl.rid];\n[/if]\n\nif(typeof window[''ckeditor_exists''] != ''function''){\n    function ckeditor_exists(name){\n        if(typeof($(''#cke_top_''+name).get(0))==''undefined''){\n            setTimeout(''ckeditor_exists("''+name+''");'',500);\n        } else {\n            var toolbar=$(''#cke_top_''+name+'' .cke_toolbox > *:nth-child(3)'');\n            toolbar.find(''.cke_toolbar_end'').before(''<span class="cke_separator" role="separator"></span><span class="cke_toolgroup" role="presentation"><span class="cke_button"><a id="cke_new_78" class="cke_off cke_button_image" href="javascript:void(\\''Вставка значения\\'')" title="Вставка значения" tabindex="-1" hidefocus="true" role="button" aria-labelledby="cke_new_78_label" onkeydown="return CKEDITOR.ui.button._.keydown(50, event);" onfocus="return CKEDITOR.ui.button._.focus(50, event);" onclick="show_op_editor_ckeditor(\\''''+name+''\\''); return false;"><span class="cke_icon" style="background-image: url(\\''[base_root]/files/editor/classic/code.png\\''); background-position: 0 0;">&nbsp;</span><span id="cke_new_78_label" class="cke_label">Вставка значения</span></a></span></span>'');\n        }\n    }\n}\n$(document).ready(function(){\n    ckeditor_exists(''[$name]'');\n});\n</script>\n[/if]','',0,0,0,0,17,173,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/ckeditor/','','','',0,0,0,0,1),
(48,0,'Миниатюра','preview','b46b49a3b5f5df9b74847f6afe3ed7ae','2015-10-13 13:51:44','2015-10-13 14:08:11',-1,'',0,2,0,0,'[if $src.value!=""]\n     [if $dst.id!=""]\n        [$dst.set($src.file.clone)]\n        [#preview($dst.value,$width,$height,$type,$crop)]\n     [else]\n        [#preview($src.value,$width,$height,$type,$crop)]\n     [/if]\n[/if]','',0,0,0,0,19,177,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(49,0,'Наложение водяного знака','watermark','68d684afdd50a76b9df6294beb66f13a','2015-10-13 15:20:57','2015-11-13 19:17:02',-1,'',0,2,0,0,'if(!function_exists(''create_watermark'')){\r\n\r\n	function create_watermark( $main_img_obj, $watermark_img_obj, $alpha_level = 100, $ext=''.jpg'', $position=''tile'' ) {\r\n	        $alpha_level     /= 100;\r\n	\r\n	        $main_img_obj_w        = imagesx( $main_img_obj );\r\n	        $main_img_obj_h        = imagesy( $main_img_obj );\r\n	        $watermark_img_obj_w        = imagesx( $watermark_img_obj );\r\n	        $watermark_img_obj_h        = imagesy( $watermark_img_obj );\r\n	\r\n	        $main_img_obj_min_x        = floor( ( $main_img_obj_w / 2 ) - ( $watermark_img_obj_w / 2 ) );\r\n	        $main_img_obj_max_x        = ceil( ( $main_img_obj_w / 2 ) + ( $watermark_img_obj_w / 2 ) );\r\n	        $main_img_obj_min_y        = floor( ( $main_img_obj_h / 2 ) - ( $watermark_img_obj_h / 2 ) );\r\n	        $main_img_obj_max_y        = ceil( ( $main_img_obj_h / 2 ) + ( $watermark_img_obj_h / 2 ) );\r\n	\r\n	        $return_img        = imagecreatetruecolor( $main_img_obj_w, $main_img_obj_h );\r\n	        \r\n	        if($ext==''.png''){\r\n		        imagealphablending($return_imgp, false);\r\n    		    imagesavealpha($return_img,true);\r\n    		    $transparent = imagecolorallocatealpha($return_img, 255, 255, 255, 127);\r\n		        imagefilledrectangle($return_img, 0, 0, $main_img_obj_w, $main_img_obj_h, $transparent);\r\n	        }\r\n	\r\n	        if($position==''tile''){\r\n	            for( $y = 0; $y < $main_img_obj_h; $y++ ) {\r\n	                for( $x = 0; $x < $main_img_obj_w; $x++ ) {\r\n	                        $return_color        = NULL;\r\n	                        $watermark_x        = ($x/* - $main_img_obj_min_x*/) % $watermark_img_obj_w;\r\n	                        $watermark_y        = ($y/* - $main_img_obj_min_y*/) % $watermark_img_obj_h;\r\n	                        $main_rgb = imagecolorsforindex( $main_img_obj, imagecolorat( $main_img_obj, $x, $y ) );\r\n	                        if ($watermark_x >= 0 && $watermark_x < $watermark_img_obj_w && $watermark_y >= 0 && $watermark_y < $watermark_img_obj_h ) {\r\n	                                $watermark_rbg = imagecolorsforindex( $watermark_img_obj, imagecolorat( $watermark_img_obj, $watermark_x, $watermark_y ) );\r\n	                                $watermark_alpha        = round( ( ( 127 - $watermark_rbg[''alpha''] ) / 127 ), 2 );\r\n	                                $watermark_alpha        = $watermark_alpha * $alpha_level;\r\n	                                $avg_red                = _get_ave_color( $main_rgb[''red''], $watermark_rbg[''red''], $watermark_alpha);\r\n	                                $avg_green              = _get_ave_color( $main_rgb[''green''], $watermark_rbg[''green''], $watermark_alpha);\r\n	                                $avg_blue               = _get_ave_color( $main_rgb[''blue''], $watermark_rbg[''blue''], $watermark_alpha);\r\n		    			            $return_color           = _get_image_color( $return_img, $avg_red, $avg_green, $avg_blue);\r\n	                        } else {\r\n	                                $return_color           = imagecolorat( $main_img_obj, $x, $y );\r\n	                        }\r\n	                        imagesetpixel( $return_img, $x, $y, $return_color );\r\n	                }\r\n	            }\r\n	        }\r\n	        if($position==''bottom right'' || $position==''bottom left'' || $position==''bottom center''){\r\n	            imagecopy($return_img,$main_img_obj,0,0,0,0,$main_img_obj_w,$main_img_obj_h);\r\n	            for($y=0;$y<$watermark_img_obj_h;$y++)\r\n	                for($x=0;$x<$watermark_img_obj_w;$x++){\r\n	                    $return_color=NULL;\r\n			            if($position==''bottom left''){\r\n			                $dx=$x;\r\n			            }\r\n			            if($position==''bottom right''){\r\n			                $dx=$main_img_obj_w-$watermark_img_obj_w+$x;\r\n			            }\r\n			            if($position==''bottom center''){\r\n			                $dx=floor($main_img_obj_w/2-$watermark_img_obj_w/2+$x);\r\n			            }\r\n			            $dy=$main_img_obj_h-$watermark_img_obj_h+$y;\r\n			            $main_rgb = imagecolorsforindex( $main_img_obj, imagecolorat( $main_img_obj, $dx, $dy ) );\r\n                        $watermark_rbg = imagecolorsforindex($watermark_img_obj, imagecolorat($watermark_img_obj,$x,$y));\r\n                        $watermark_alpha        = round(((127 - $watermark_rbg[''alpha'']) / 127), 2);\r\n                        $watermark_alpha        = $watermark_alpha * $alpha_level;\r\n                        $avg_red                = _get_ave_color($main_rgb[''red''], $watermark_rbg[''red''], $watermark_alpha);\r\n                        $avg_green              = _get_ave_color($main_rgb[''green''], $watermark_rbg[''green''], $watermark_alpha);\r\n                        $avg_blue               = _get_ave_color($main_rgb[''blue''], $watermark_rbg[''blue''], $watermark_alpha);\r\n			            $return_color           = _get_image_color($return_img, $avg_red, $avg_green, $avg_blue);\r\n			            imagesetpixel( $return_img, $dx, $dy, $return_color );\r\n	                }\r\n	        }\r\n	        return $return_img;\r\n	}\r\n	\r\n	\r\n	function _get_ave_color( $color_a, $color_b, $alpha_level ) {\r\n	        return round( ( ( $color_a * ( 1 - $alpha_level ) ) + ( $color_b        * $alpha_level ) ) );\r\n	}\r\n	\r\n	\r\n	function _get_image_color($im, $r, $g, $b) {\r\n	        $c=imagecolorexact($im, $r, $g, $b);\r\n	        if ($c!=-1) return $c;\r\n	        $c=imagecolorallocate($im, $r, $g, $b);\r\n	        if ($c!=-1) return $c;\r\n	        return imagecolorclosest($im, $r, $g, $b);\r\n	}\r\n	\r\n	\r\n	function wtrmark($img,$mask){\r\n	        $ext=strtolower(get_ext($img));\r\n	        if($ext==''.jpg'' || $ext==''.jpeg'') $main_img_obj=imagecreatefromjpeg($img);\r\n        	if($ext==''.gif'') $main_img_obj=imagecreatefromgif($img);\r\n	        if($ext==''.png'') $main_img_obj=imagecreatefrompng($img);\r\n	        $watermark_img_obj = imagecreatefrompng($mask);\r\n	        $return_img_obj = create_watermark($main_img_obj, $watermark_img_obj, $GLOBALS["p_par"]["transparent"], $ext, $GLOBALS["p_par"]["position"]);\r\n        	if($ext==''.jpg'' || $ext==''.jpeg'') imagejpeg($return_img_obj,$img,80);\r\n        	if($ext==''.gif'') imagegif($return_img_obj,$img);\r\n        	if($ext==''.png'') imagepng($return_img_obj,$img);\r\n        	imagedestroy($return_img_obj);\r\n        	imagedestroy($watermark_img_obj);\r\n	}\r\n\r\n}\r\n\r\nwtrmark(DOCUMENT_ROOT.''/''.$GLOBALS["p_par"]["img"],DOCUMENT_ROOT.''/''.$GLOBALS["p_par"]["watermark"]);','',0,0,0,1,19,184,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1);

INSERT INTO `main_part` (part_id,part_module,part_name,part_sname,part_uin,part_date,part_date2,part_auth,part_about,part_access,part_type,part_table,part_owner,part_body,part_url,part_ignore,part_iowner,part_sowner,part_parse,part_cat,part_major,part_proc,part_ex,part_parts,part_404,timer_last,timer_act,timer_type,timer_date,timer_time,timer_x,timer_y,timer_count,part_file,parser_end_ex,part_shell,part_cur,part_pic,part_folder,part_ifcase,part_ifdetect,part_ifrow,part_unsafe,part_shelltime,part_shellcount,part_skipurl,part_enable) VALUES
(50,0,'Генерация URL','latinica','2fd85d1f531484be781a1606708ec0d0','2015-10-13 15:33:15','2016-05-09 08:14:31',-1,'',0,2,0,0,'[if !$dst]\n    [dst=col_current]\n[/if]\n[if !$src]\n    [src=col_current.table.major]\n[/if]\n[if $src.type==is_user]\n    [v=$src.value.name.latinica]\n[else]\n    [v=$src.value.latinica]\n[/if]\n[while ''--''^$v]\n    [v=$v.replace(''--'',''-'')]\n[/while]\n[v=$v.trim(''-'')]\n[if $v.length>35]\n    [v=$v.copy(0,35)]\n[/if]\n[bv=$v]\n[i=2]\n[n=$dst.row.neighbors_wo_sub.sc($dst.sname)]\n[while $v^$n]\n    [v=$bv++$i]\n    [i=$i+1]\n[/while]\n[$dst.set($v)]','',0,0,0,0,13,196,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(51,0,'Отправка Email','email','78030f58e90de819d457b6dfd324b4ef','2015-10-15 01:20:50','2015-10-15 01:23:43',-1,'',0,2,0,0,'[#simple_mail($from,$to,$subject,$msg)]','',0,0,0,0,20,0,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(52,0,'HTTP Заголовок','header','c5c7e052fa2cf4a1285dc5e649375fb7','2015-10-15 18:55:09','2016-06-01 10:40:11',-1,'',0,2,0,0,'[#header($content)]','',0,0,0,0,20,0,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(53,0,'Редактор шаблонов','meditor','e48f574e242da7e151a66076f08c8191','2016-05-12 05:02:19','2015-10-26 09:47:38',-1,'',0,2,0,0,'$form_name=shell_tpl(''[$src.formname]'');\r\n$form_value=shell_tpl(''[$src.value]'');\r\n$def_value=shell_tpl(''[$value]'');\r\nif(!empty($def_value) && empty($form_value))$form_value=$def_value;\r\nglobal $id,$table_id;\r\n//$tt=$table_id;\r\n$tt=0;\r\n$tt2=0;\r\n$prt=0;\r\n$replt=shell_tpl(''[$table]'');\r\nif(!empty($replt)) $tt=$replt;\r\n$replt=shell_tpl(''[$cur_table]'');\r\nif(!empty($replt)) $tt2=$replt;\r\n$replt=shell_tpl(''[$cur_part]'');\r\nif(!empty($replt)){\r\n        $tmp=seek_part($replt);\r\n        $prt=$tmp[''id''];\r\n}\r\nglobal $p_par;\r\nif(!empty($p_par[''vars''])){\r\n    $replt=$p_par[''vars''];\r\n    if(!empty($replt)){\r\n        $vars=$replt;\r\n        if(!is_array($vars)) $vars=Array($vars);\r\n    } else $vars=Array();\r\n} else $vars=Array();\r\nif(shell_tpl(''[f_action]'')==''edit''){\r\n    $can_save=true;\r\n    if($_GET[''action'']==''edit_ex_form'') $cow=-$_GET[''id2''];\r\n    else $cow=$_GET[''id3''];\r\n} else {\r\n    $can_save=false;\r\n    $cow=0;\r\n}\r\nide($form_value,-1,$id,$tt,-1,$form_name,''form'',$GLOBALS["use_ace"],$can_save,$tt2,$prt,$vars,$cow,shell_tpl(''[current_col]''));','',0,0,0,1,17,194,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(54,1,'Страница','page','f97bca0c75253eeb9a25bbc85191d28d','2015-10-18 15:28:50','2016-05-22 17:03:30',-1,'',0,0,5,0,'[cow.prepare(''*'')][if cow.tpl][glob.tpl=cow.tpl][else][glob.tpl=cex.param.tpl][/if][glob.tpl.body.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(55,1,'Группа блоков','block_array','1b073eb35d7761ccaa98e0375824a734','2015-10-18 16:56:32','2015-10-21 17:29:15',-1,'',0,0,5,0,'[tree if(cow.block_array, cow.block_array.blocks.rows, cex.param.block_array.blocks.rows).sel(cur.align==$align)]\n    [cur.tpl.body.shell]\n[/tree]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(56,0,'Редактор стилей','seditor','dd5f1b7095105d4e9ff79550d61ef542','2015-10-18 18:01:37','2015-10-18 17:41:45',-1,'',0,2,0,0,'$name=shell_tpl(''[$src.formname]'');\r\n$value=shell_tpl(''[$src.value]'');\r\nshow_ace_editor_simple(''css'',$name,$value,$width=''95%'',$height=''600px'','''',''chrome'');','',0,0,0,1,17,200,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(57,0,'Редактор JS скриптов','jeditor','5a834d16a4b026a0213a8887a5fcae81','2015-10-18 18:01:02','2015-10-18 17:41:56',-1,'',0,2,0,0,'$name=shell_tpl(''[$src.formname]'');\r\n$value=shell_tpl(''[$src.value]'');\r\nshow_ace_editor_simple(''javascript'',$name,$value,$width=''95%'',$height=''600px'','''',''chrome'');','',0,0,0,1,17,201,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(58,1,'Секция HEAD для шаблона','head','2f04be8af19257d35da8cba556921e38','2015-10-18 17:38:15','2015-10-18 19:20:08',-1,'',0,0,5,0,'[if cow.module]\n    [meta_keywords=cow.module.url_part.meta_keywords]\n    [meta_description=cow.module.url_part.meta_description]\n[/if]\n[return component.head(\n    title=cm.part.title(type=''title''),\n    css_prefix=''/styles/'',\n    js_prefix=''/scripts/'',\n    css=(global.tpl.styles.allcol(''url'')),\n    js=(global.tpl.scripts.allcol(''url'')),\n    keywords=if($meta_keywords,$meta_keywords,cow.meta_keywords),\n    description=if($meta_description,$meta_description,cow.meta_description),\n    favicon=cex.param.favicon\n)]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(59,1,'Заголовок','title','cf4c888b9968558d583e27381081139e','2015-10-18 18:06:41','2016-05-12 11:20:06',-1,'',0,0,5,0,'[if cm.selpart.sname==''404_error''][return ''Страница не найдена''][/if]\n[if cm.selpart.sname==''search''][return ''Поиск''][/if]\n[if !glob.title]\n    [if cow.module]\n        [glob.title=cow.module.url_part.title]\n    [/if]\n    [if !glob.title]\n        [glob.title=cow.title]\n    [/if]\n[/if]\n[if $type==''h1''][return glob.title][/if]\n[if $type==''title''][return glob.title+'' - ''+cex.param.title][/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(60,1,'Таблица стилей шаблона','tpl_style','ad6acfdcc040a60aee8771742565fda0','2015-10-18 19:17:13','2015-10-18 19:25:20',-1,'',0,0,13,0,'[func.header(content=''HTTP/1.0'')]\n[func.header(content=''Content-Type: text/css'')]\n[cow.body]\n[hard_cache]','styles',0,1,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(61,1,'Файл JS скриптов для шаблона','tpl_script','0fe0978d268d66bb5dcb47d786d11fa6','2015-10-18 19:21:52','2015-10-18 19:25:08',-1,'',0,0,14,0,'[func.header(content=''HTTP/1.0'')]\n[func.header(content=''Content-Type: text/javascript'')]\n[cow.body]\n[hard_cache]','scripts',0,1,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(62,1,'Содержимое страницы','body','babeb930a32be0519b628ce9de948e8c','2015-10-19 00:55:03','2016-03-30 04:33:48',-1,'',0,0,5,0,'[if cm.selpart.sname!=''page'']\n    [block.body]\n[else]\n    [cow.body.shell]\n    [if cow.module]\n        [cow.module.auto]\n    [/if]\n[/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(63,3,'Список','list','970b72611e23d89bbdd132f14020db2f','2015-10-21 08:23:55','2015-11-02 22:17:01',-1,'',1,1,15,0,'[$tpl.tpl.shell]','',1,0,0,0,0,209,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(64,3,'Навигация','nav','8db39fd6c9daa7dc6c5ed06a9fb88ace','2015-10-21 08:24:07','2015-10-21 14:24:21',-1,'',1,1,16,0,'[$tpl.tpl.shell]','',1,0,0,0,0,207,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(65,3,'Сетка','net','1abc7ad563acfa38e9793f49e3b85470','2015-10-21 08:24:20','2015-10-21 14:24:42',-1,'',1,1,17,0,'[$tpl.tpl.shell]','',1,0,0,0,0,211,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(66,0,'Хлебные крошки Bootstrap','b_breadcrumbs','6dab267eba38b81505be0acc8a62be91','2015-10-22 00:03:13','2015-11-02 15:01:27',-1,'',0,2,0,0,'[component.bootstrap]\n[*res=component.breadcrumbs_array(url_prefix=$url_prefix, url=$url, title=$title, home_link=$home_link, home=$home, row=$row)*]\n[res=component.breadcrumbs_array(home_link=$home_link, home=$home)]\n[if $res]\n    <ol class="breadcrumb">\n    [tree $res]\n        [if !last?]\n            <li><a href="[var]">[value]</a></li>\n        [else]\n            <li class="active">[value]</li>\n        [/if]\n    [/tree]\n    </ol>\n[/if]','',0,0,0,0,7,0,2,0,'a:1:{s:37:"part_6dab267eba38b81505be0acc8a62be91";a:1:{i:2;a:2:{s:9:"bootstrap";s:9:"bootstrap";s:17:"breadcrumbs_array";s:17:"breadcrumbs_array";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(67,0,'Иконки Bootstrap','b_icon','597021d48811ad8967e68fcfe18ee9d3','2015-10-23 19:53:11','2015-10-23 20:05:41',-1,'',0,2,0,0,'[component.bootstrap]<span class="glyphicon glyphicon-[$icon][if $size] [$size][/if]" aria-hidden="true"></span>','',0,0,0,0,21,0,2,0,'a:1:{s:37:"part_597021d48811ad8967e68fcfe18ee9d3";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(68,0,'Выпадающий список Bootstrap','b_dropdown','4306c908fe6878ffc9d5a55f10a1435e','2015-10-23 20:11:56','2015-10-23 21:14:17',-1,'',0,2,0,0,'[component.bootstrap]\n[glob.dropdown_id=glob.dropdown_id+1]\n<div class="[if $separate]btn-group [/if][$direction]">\n  [if $separate]\n      <button type="button" class="btn btn-default"[if $on_click] OnClick="[$on_click]"[/if]>[$text]</button>\n      <button class="btn [$class] [$size] dropdown-toggle" type="button" id="dropdownMenu[glob.dropdown_id]" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">\n        <span class="caret"></span>\n      </button>\n  [else]\n      <button class="btn [$class] [$size] dropdown-toggle" type="button" id="dropdownMenu[glob.dropdown_id]" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">\n        [$text]\n        <span class="caret"></span>\n      </button>\n  [/if]\n  <ul class="dropdown-menu" aria-labelledby="dropdownMenu[glob.dropdown_id]">\n  [tree linear $rows]\n    <li><a href="[$url_prefix][cur.col($url)]">[cur.col($title)]</a></li>\n  [/tree]\n  </ul>\n</div>','',0,0,0,0,12,0,2,0,'a:1:{s:37:"part_4306c908fe6878ffc9d5a55f10a1435e";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(69,0,'Табы Bootstrap','b_tabs','266fb0f9cd358ceb9d630cfbb416684d','2015-10-23 21:23:05','2015-10-23 22:02:11',-1,'',0,2,0,0,'[component.bootstrap]\n[glob.tab_group_id=glob.tab_group_id+1]\n[if $theme==''pills nav-stacked'']\n    [justified=false]\n    <div class="row">\n        <div class="col-sm-3">\n[/if]\n<ul class="nav nav-[$theme][if $justified] nav-justified[/if]">\n    [tree linear $rows]\n      <li id="t[cur]" role="presentation"  class="tab[glob.tab_group_id][if first?] active[/if]" style="cursor: pointer;"><a>[cur.col($title)]</a></li>\n    [/tree]\n</ul>\n<script>\n    $(''.tab[glob.tab_group_id]'').click(function(){\n        $(''.tab-box[glob.tab_group_id]'').each(function(index){$(this).hide()});\n        $(''#tab-body-''+this.id).show();\n        $(''.tab[glob.tab_group_id].active'').removeClass(''active'');\n        $(this).addClass(''active'');            \n    });\n</script>\n[if $theme==''pills nav-stacked'']\n    </div>\n    <div class="col-sm-9">\n[else]\n    <br>\n[/if]\n<div class="container">\n    [tree linear $rows]\n        <div id="tab-body-t[cur]" [if !first?]style="display: none;"[/if] class="tab-box[glob.tab_group_id]">\n            [if $shell_body]\n                [cur.col($body).shell]\n            [else]\n                [cur.col($body)]\n            [/if]\n        </div>\n    [/tree]\n</div>\n[if $theme==''pills nav-stacked'']\n    </div>\n    </div>\n[/if]','',0,0,0,0,12,0,2,0,'a:1:{s:37:"part_266fb0f9cd358ceb9d630cfbb416684d";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(70,0,'Пагинация Bootstrap','b_paginator','d07f2683005672b06f4ab21e56f099fa','2015-10-23 22:13:30','2016-03-26 14:34:52',-1,'',0,2,0,0,'[component.bootstrap]\n[if !$page]\n    [page="0"]\n[/if]\n[if glob.page]\n    [page=glob.page]\n[/if]\n[total_pages=$count//$num]\n[if $count%$num!=0]\n    [total_pages=$total_pages+1]\n[/if]\n[if $theme==''pagination'']\n    [$back=''&laquo;'']\n    [$fwd=''&raquo;'']\n[else]\n    [$back=''Назад'']\n    [$fwd=''Вперёд'']\n[/if]\n[if $btn_fwd][fwd=$btn_fwd][/if]\n[if $btn_back][back=$btn_back][/if]\n<nav>\n  <ul class="[$theme] [$size]">\n    <li class="[if !$page] disabled[/if][if $align] previous[/if]">\n     [if $page]<a href="[url2 "page" $page-1]" aria-label="Previous">[/if]\n        <span aria-hidden="true">[$back]</span>\n     [if $page]</a>[/if]\n    </li>\n    [if $theme==''pagination'']\n        [tree 1..$total_pages]\n            [if $page==index]\n                <li class="active"><span>[index+1]</span></li>\n            [else]\n                <li><a href="[url2 "page" index]">[index+1]</a></li>\n            [/if]\n        [/tree]\n    [/if]\n    <li class="[if $page==$total_pages-1] disabled[/if][if $align] next[/if]">\n      [if $page<$total_pages-1]<a href="[url2 "page" $page+1]" aria-label="Next">[/if]\n        <span aria-hidden="true">[$fwd]</span>\n      [if $page<$total_pages-1]</a>[/if]\n    </li>\n  </ul>\n</nav>','',0,0,0,0,9,0,2,0,'a:1:{s:37:"part_d07f2683005672b06f4ab21e56f099fa";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(71,0,'Метки Bootstrap','b_label','68e1c8a36e767c1d1881fbe508ac8639','2015-10-23 22:38:04','2015-11-02 11:01:24',-1,'',0,2,0,0,'[component.bootstrap]<span class="label label-[$class]">[$title]</span>','',0,0,0,0,22,253,1,0,'a:1:{s:37:"part_68e1c8a36e767c1d1881fbe508ac8639";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(72,0,'Счётчик Bootstrap','b_counter','e752b0f1cc7dc176350607e1ee4d071b','2015-10-24 01:22:15','2015-10-24 01:24:31',-1,'',0,2,0,0,'[component.bootstrap]<span class="badge">[$num]</span>','',0,0,0,0,22,254,1,0,'a:1:{s:37:"part_e752b0f1cc7dc176350607e1ee4d071b";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(73,0,'Большой блок Bootstrap Jumbotron','jumbotron','d218d19f35a6184db6580f067a72a054','2015-10-24 01:26:05','2015-10-24 01:28:16',-1,'',0,2,0,0,'[component.bootstrap]\n<div class="jumbotron">\n    <div class="container">\n      [$text]\n    </div>\n</div>','',0,0,0,0,22,0,1,0,'a:1:{s:37:"part_d218d19f35a6184db6580f067a72a054";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(75,0,'Заголовок Bootstrap','b_title','3c8f719081b4aeac601b3e920fa70fd8','2015-10-24 01:31:47','2015-10-24 01:33:10',-1,'',0,2,0,0,'[component.bootstrap]\n<div class="page-header">\n  <[$type]>[$title]</[$type]>\n</div>','',0,0,0,0,22,256,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(76,0,'Уведомление Bootstrap','b_alert','a37121b3b891a5fa95e7c4ee0f9bdb4b','2015-10-24 03:18:15','2015-10-24 03:21:23',-1,'',0,2,0,0,'[if !$close]\n    <div class="alert alert-[$type]" role="alert">[$text]</div>\n[else]\n    <div class="alert alert-[$type] alert-dismissible" role="alert">\n        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>\n        [$text]\n    </div>\n[/if]','',0,0,0,0,12,259,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(77,0,'Строка прогресса Bootstrap','b_progressbar','4c7d01ebf2132808bebac7ff3b249cea','2015-10-24 07:13:13','2015-10-24 12:58:58',-1,'',0,2,0,0,'[component.bootstrap]\n<div class="progress">\n  <div class="progress-bar [$theme][if $show_stripes] [$theme][if $animate] active[/if][/if]" role="progressbar" aria-valuenow="[$value]" aria-valuemin="[$min]" aria-valuemax="[$max]" style="width: [$value/(($max-$min)/100)]%;">\n    [if $show_value][$value][if $max==100]%[/if][/if]\n  </div>\n</div>','',0,0,0,0,12,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(78,0,'Блок подразделов Bootstrap','b_link_block','7a500aa7f5aa7d1391eea6cdd6ff0576','2015-10-24 12:58:37','2016-04-10 21:21:58',-1,'',0,2,0,0,'[component.bootstrap]\n<div class="list-group">\n [tree linear $rows]\n  [if !$url_prefix]\n     [u=cur.wayback.sc($url).implode(''/'').uopen]\n  [else]\n     [u=$url_prefix.uclose++cur.wayback.sc($url).implode(''/'')]\n  [/if]\n  <a href="[if($u,$u,''/'')]" class="list-group-item[if cur.selected?] active[/if]">\n	 [if $count]\n	    <span class="badge">[cur.col($count)]</span>\n	 [else]\n    	 [if $linked_count]\n    	     <span class="badge">[cur.linked_count]</span>\n    	 [/if]\n	 [/if]\n	 [cur.col($title)]\n  </a>\n [/tree]\n</div>','',0,0,0,0,7,269,2,0,'a:1:{s:37:"part_7a500aa7f5aa7d1391eea6cdd6ff0576";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(79,0,'Всплывающее окно Bootstrap','b_window','525de7f0cfa91bc58da33142bd3947a2','2015-10-25 00:17:06','2015-10-25 01:19:05',-1,'',0,2,0,0,'[component.bootstrap]\n[glob.b_window=glob.b_window+1]\n<script>\n    $(document).ready(function(){\n        $(''#[$clicker_id]'').click(function(){\n            $(''#modal[glob.b_window]'').modal(''show'');\n        });\n    });\n</script>\n\n<!-- Modal -->\n<div class="modal fade" id="modal[glob.b_window]" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">\n  <div class="modal-dialog" role="document">\n    <div class="modal-content">\n      <div class="modal-header">\n        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>\n        <h4 class="modal-title" id="myModalLabel">[$title]</h4>\n      </div>\n      <div class="modal-body">\n        [$body]\n      </div>\n      <div class="modal-footer">\n        <button type="button" class="btn btn-default" data-dismiss="modal">[$btn_cancel]</button>\n        <button type="button" class="btn btn-primary" data-dismiss="modal" OnClick="[$action]">[$btn_ok]</button>\n      </div>\n    </div>\n  </div>\n</div>','',0,0,0,0,12,0,2,0,'a:1:{s:37:"part_525de7f0cfa91bc58da33142bd3947a2";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(80,0,'Аккордион Bootstrap','b_accordion','f050f8224020d31e2b90174eef1109b8','2015-10-25 01:20:15','2015-10-25 01:43:59',-1,'',0,2,0,0,'[component.bootstrap]\r\n[glob.b_accordion=glob.b_accordion+1]\r\n<div class="panel-group" id="accordion[glob.b_accordion]" role="tablist" aria-multiselectable="true">\r\n	[tree linear $rows]\r\n    	[glob.b_accordion_collapse=glob.b_accordion_collapse+1]\r\n		<div class="panel panel-default">\r\n			<div class="panel-heading" role="tab" id="heading[glob.b_accordion_collapse]">\r\n				<h4 class="panel-title">\r\n					<a [if !first?]class="collapsed"[/if] role="button" data-toggle="collapse" data-parent="#accordion[glob.b_accordion]" href="#collapse[glob.b_accordion_collapse]" aria-expanded="[if first?]true[else]false[/if]" aria-controls="collapse[glob.b_accordion_collapse]">\r\n						[cur.col($title)]\r\n					</a>\r\n				</h4>\r\n			</div>\r\n			<div id="collapse[glob.b_accordion_collapse]" class="panel-collapse collapse[if first?] in[/if]" role="tabpanel" aria-labelledby="heading[glob.b_accordion_collapse]">\r\n				<div class="panel-body">\r\n					[cur.col($body)]\r\n				</div>\r\n			</div>\r\n		</div>\r\n	[/tree]  \r\n</div>','',0,0,0,0,6,281,2,0,'a:1:{s:37:"part_f050f8224020d31e2b90174eef1109b8";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(81,0,'Поле текста Bootstrap','b_input','918da41b4063e7579409ec5255b13e96','2015-10-25 01:44:31','2015-10-25 01:54:20',-1,'',0,2,0,0,'[component.bootstrap]\n[if $src]\n    [id=$src.formname]\n    [name=$src.formname]\n    [value=$src.value]\n[/if]\n[if $title]\n    <div class="form-group">\n        <label for="[$id]">[$title]</label>\n        <input type="input" class="form-control" id="[$id]" name="[$name]" value="[$value]">\n    </div>\n[else]\n    <input type="input" class="form-control" id="[$id]" name="[$name]" value="[$value]">\n[/if]','',0,0,0,0,17,284,3,0,'a:1:{s:37:"part_918da41b4063e7579409ec5255b13e96";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(82,0,'Большое поле текста Bootstrap','b_textarea','d7b14a41618f93835ac75d995ac35026','2015-10-25 01:57:53','2015-10-25 02:00:00',-1,'',0,2,0,0,'[component.bootstrap]\n[if $src]\n    [id=$src.formname]\n    [name=$src.formname]\n    [value=$src.value]\n[/if]\n<textarea class="form-control" id="[$id]" name="[$name]" rows="[$rows]">[$value]</textarea>','',0,0,0,0,17,289,3,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(83,0,'Список Bootstrap','b_select','2a3d3153b1453bda8f6ef116f0661644','2015-10-25 02:00:57','2015-10-25 03:45:14',-1,'',0,2,0,0,'[component.bootstrap]\n[if $src]\n    [name=$src.formname]\n    [id=$src.formname]\n    [selected=$src.value]\n[/if]\n<select name="[$name]" id="[$id]" class="form-control">\n[if !$src]\n    [tree $rows]\n        <option name="[cur]" [if $selected==cur]selected[/if]>[cur.col($title)]</option>\n    [/tree]\n[else]\n    [$src.form_noprocess.gettag_all(''<option '',''</option>'').with(value.last.contain(''value="new"'').if(value.del(value.count-1),value)).implode(''</option><option '').with(value.if(''<option ''+value+''</option>''))]\n[/if]\n</select>','',0,0,0,0,23,294,3,0,'a:1:{s:37:"part_2a3d3153b1453bda8f6ef116f0661644";a:1:{i:2;a:1:{s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(84,1,'Карта сайта','sitemap','d4629dd73167c8cb9320d056599f6eba','2015-10-26 02:31:23','2015-10-26 02:33:34',-1,'',0,0,0,0,'[component.sitemap(autogen=true)]','sitemap.xml',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(85,4,'Лента статей','feed','62c4d3155c8d94cabf6865947d7a9e89','2015-10-26 03:26:03','2016-05-26 23:42:59',-1,'',0,0,0,0,'[main_page=false]\n[show_all=false]\n[if !$tpl]\n    [tpl=cex.param.feed_tpl]\n[/if]\n[if !$table]\n    [if cex.param.show_all]\n        [show_all=true]\n    [else]\n        [table=cex.articles]\n    [/if]\n    [main_page=true]\n[/if]\n[num=cex.param.on_page]\n[if !$num][num=20][/if]\n[if $show_all]\n    [count=cex.articles.find_count(ignore_owner, ignore_ex)]\n    [rows=cex.articles.find(ignore_owner, ignore_ex).sort(date, desc).sort(id, desc).start($page*$num).limit($num)]\n[else]\n    [count=$table.count]\n    [rows=$table.find.sort(date, desc).sort(id, desc).start($page*$num).limit($num)]\n[/if]\n[$tpl.tpl.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(86,4,'Статья','article','2f6f32541e662e960c20775f6b22211c','2015-10-26 03:26:34','2015-11-02 23:02:24',-1,'',0,0,21,0,'[if cow.tpl][main_tpl=cow.tpl][else][main_tpl=cex.param.article_tpl][/if]\n[$main_tpl.tpl.shell]\n[if stat.check(''VPage''+cow,1,1)]\n    [cow.hint.set(cow.hint+1)]\n[/if]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(87,4,'Категория статей','category','4ad86dc02f75dd7d96a742c3ec5bcc77','2015-10-26 03:26:51','2016-03-30 04:49:32',-1,'',0,0,24,0,'[if cow.body]<p>[cow.body]</p>[/if]\n[cm.part.feed(table=cow.articles, tpl=cow.tpl)]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(88,4,'Статья в категории','cat_article','7b702362bc37294ef7e65f78b5b1b271','2015-10-26 03:27:20','2015-11-02 23:03:11',-1,'',0,0,21,87,'[if cow.tpl][main_tpl=cow.tpl][else][main_tpl=cex.param.article_tpl][/if]\n[$main_tpl.tpl.shell]\n[if stat.check(''VPage''+cow,1,1)]\n    [cow.hint.set(cow.hint+1)]\n[/if]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(89,4,'Блок архива','block_archive','c5af39ae6bbb03f61a6742a87f047ac5','2015-10-26 04:52:29','2015-10-26 13:39:13',-1,'',1,1,0,0,'[component.month_archive(nobg=true, date=''date'', table=if(cex.major==cex.articles, cex.articles), rows=if(cex.major==cex.category,cex.category.st.feed))]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(91,4,'Блок популярных статей','block_popular','59e9c16c443ac83f6bc161b22aea099d','2015-10-26 04:54:14','2016-04-22 10:26:27',-1,'',1,1,0,0,'[if cm.selpart.sname!=''feed'' && cex.param.show_block_on_main]\n    [return false]\n[/if]\n\n[if !$block_tpl][block_tpl=cex.param.block_tpl][/if]\n[num=5]\n[if cex.param.articles_in_block]\n    [num=cex.param.articles_in_block]\n[/if]\n\n[if cex.param.show_current_articles && cex.category.sel]\n    [rows=cex.category.sel.articles.fastget(0 !''hint'' 0 $num)]\n[elseif cex.param.main_category]\n    [rows=cex.param.main_category.articles.fastget(0 !''hint'' 0 $num)]\n[else]\n    [rows=cex.articles.eifastget(0 !''hint'' 0 $num)]\n[/if]\n\n\n[if $rows.count>0]\n    [$block_tpl.tpl.shell]\n[else]\n    [return false]\n[/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(92,4,'Блок последних статей','block_last','92ce51dbff0b70240cf8b0a7bb031963','2015-10-26 04:54:32','2016-04-22 10:22:31',-1,'',1,1,0,0,'[if cm.selpart.sname!=''feed'' && cex.param.show_block_on_main]\n    [return false]\n[/if]\n\n[if !$block_tpl][block_tpl=cex.param.block_tpl][/if]\n[num=5]\n[if cex.param.articles_in_block]\n    [num=cex.param.articles_in_block]\n[/if]\n\n[if cex.param.show_current_articles && cex.category.sel]\n    [rows=cex.category.sel.articles.fastget(0 !''date'',!''id'' 0 $num)]\n[elseif cex.param.main_category]\n    [rows=cex.param.main_category.articles.fastget(0 !''date'',!''id'' 0 $num)]\n[else]\n    [rows=cex.articles.eifastget(0 !''date'',!''id'' 0 $num)]\n[/if]\n\n\n[if $rows.count>0]\n    [$block_tpl.tpl.shell]\n[else]\n    [return false]\n[/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(93,4,'Блок категорий','block_cat','fda51b3be0c1a7f7ade716f342587d52','2015-10-26 04:55:07','2015-11-02 21:21:20',-1,'',1,1,0,0,'[if !$block_tpl][block_tpl=cex.param.block_cat_tpl][/if]\n[$block_tpl.tpl.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(95,4,'Блок меток','block_tags','2f800633c7c3db5614ad06bdee18ca0e','2015-10-26 04:55:55','2015-11-02 21:21:24',-1,'',1,1,0,0,'[if !$block_tpl][block_tpl=cex.param.block_tag_tpl][/if]\n[$block_tpl.tpl.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(96,4,'Просмотр архива статей за месяц','month_article','131f3b801f72d03ab8aed32c2f9b481b','2015-10-26 06:55:05','2016-02-02 21:22:25',-1,'',0,0,0,0,'[skip dblspace]\n[d=lefturl.exp(''-'')]\n[start=lefturl++''-01'']\n[end=$start.month(1)]\n\n[trows3=cex.articles.eifastget("date">=$start,"date"<$end "date")]\n\n[ld=''''][first=0]\n[if $trows3.count==0]\n   [#404]\n   Страница не найдена\n[/if]\n[tree $trows3]\n   [if $ld!=cur.date.day]\n        [if $first==1]</ul>[/if]\n        [$first=1]\n        [cur.date.day] [cur.date.monthR2]<ul>\n        [ld=cur.date.day]\n   [/if]\n   <li>\n    <a href="[host][modurl2][cur.allway_url]" class="lnk">[if cur.title.length>150][cur.title.scopy(1550)]...[else][cur.title][/if]</a>\n   </li>\n[/tree]\n[if param.first==1]</ul>[/if]','archive',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,1,1),
(97,4,'Лента RSS','rss','741c860a30efb2fa8399f576acd8d4f4','2015-10-26 06:55:34','2015-10-26 12:00:45',-1,'',0,0,0,0,'[component.rss(rows=cex.articles.eifastget(0 !''date'' 0 15), title=cex.name, item_photo=''mini'', item_title=''title'', item_link=''url'', item_desc=''body'', item_date=''date'', lang=''ru-ru'')]','rss.xml',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1);

INSERT INTO `main_part` (part_id,part_module,part_name,part_sname,part_uin,part_date,part_date2,part_auth,part_about,part_access,part_type,part_table,part_owner,part_body,part_url,part_ignore,part_iowner,part_sowner,part_parse,part_cat,part_major,part_proc,part_ex,part_parts,part_404,timer_last,timer_act,timer_type,timer_date,timer_time,timer_x,timer_y,timer_count,part_file,parser_end_ex,part_shell,part_cur,part_pic,part_folder,part_ifcase,part_ifdetect,part_ifrow,part_unsafe,part_shelltime,part_shellcount,part_skipurl,part_enable) VALUES
(98,4,'Просмотр статей с меткой','tag_article','64b3bdd00a731356b360a54c026e4225','2015-10-26 07:19:44','2016-03-26 15:44:43',-1,'',0,0,26,0,'[num=cex.param.on_page]\n[if !$num][num=20][/if]\n[rows=cex.articles.eifastget(''tags''==cow !''date'' $page*$num $num)]\n[count=cex.articles.eifastgetc(''tags''==cow)]\n[cex.param.feed_tpl.tpl.shell]','tag',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(99,4,'Заголовок','title','ec6d8c09e77716760aa5da29e6408a66','2015-10-26 10:47:17','2015-12-09 05:47:12',-1,'',0,0,0,0,'[if cm.selpart.sname==''month_article'']\n    [return ''Архив за ''+lefturl.explode(''-'').with(value[1].monthB+'' ''+value[0])]\n[/if]\n[if cex.sel==cm.articles]\n	[x=cow.title]\n	[if $x.length>400]\n		[return $x.scopy(0,400)++''...'']\n	[else]\n		[return $x]\n	[/if]\n[/if]\n[if cex.sel==cm.category]\n	[return cow.title]\n[/if]\n[if cex.sel==cm.tags]\n	[return ''Тег "''+cow.name+''"'']\n[/if]\n[return false]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(100,4,'Мета-описание','meta_description','1f57d196f01edc2521643f3275d585da','2015-10-26 11:01:03','2015-10-26 11:01:53',-1,'',0,0,0,0,'[return cow.meta_description]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(101,4,'Мета-ключевые слова','meta_keywords','7208269f17fecd49279c35aa9012f343','2015-10-26 11:01:21','2015-10-26 11:01:48',-1,'',0,0,0,0,'[return cow.meta_keywords]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(102,4,'Карта сайта','sitemap','706e5f1cfd0c0a0323303664376569b9','2015-10-26 11:03:09','2015-10-29 16:57:42',-1,'',0,0,0,0,'[return component.sitemap_array(rows=cex.articles.rows+cex.category.rows+cex.category.st.articles, base_step=7, base_url=host+modurl.uclose)]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(103,0,'Массив хлебных крошек','breadcrumbs_array','f3d47df1063577f69c62f882b06b80d3','2015-10-26 19:14:52','2015-11-02 15:00:55',-1,'',0,2,0,0,'[if $home_link]\n    [res[$home_link]=$home]\n[/if]\n\n[if !$row][row=deeper_cow][/if]\n\n[tree rev $row.allway]\n    [if first?]\n        [x=$row.allway.last.ex.owner]\n        [if $x]\n            [res=cpart.run(row=$x, res=$res)]\n        [/if]\n    [/if]\n    [res[cur.full_url]=cur.major]\n[/tree]\n\n[return $res]\n\n[*\n[include_col='''']\n\n[tree $row.table.cols]\n    [if cur.type==is_module]\n        [include_col=cur.sname]\n        [break]\n    [/if]\n[/tree]\n\n[if $home_link]\n    [res[$home_link]=$home]\n[/if]\n\n[tree rev linear $row.wayback]\n    [res[$url_prefix++cur.wayback.sc($url).implode(''/'')]=cur.col($title)]\n[/tree]\n\n[if $include_col && $row.col($include_col)]\n    [nex=$row.col($include_col)]\n    [r=$nex.sel.sel]\n    [if $r]\n        [u=''''][m='''']\n        [tree $r.table.cols]\n            [if cur.is_url]\n                [$u=cur.sname]\n            [/if]\n            [if cur.is_major]\n                [$m=cur.sname]\n            [/if]\n        [/tree]\n        [if $u && $m]\n            [res=cpart.run(row=$r, recursive=1, url_prefix=$url_prefix.uclose++$row.wayback.sc($url).implode(''/'').uclose, home_link=false, url=$u, title=$m, res=$res)]\n        [/if]\n    [/if]\n[/if]\n[return $res]\n*]','',0,0,0,0,7,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(105,4,'Предыдущая / Следующая','next_prev','1769bc42fe28be0ff5c9da6c6a797967','2015-11-03 04:19:59','2016-03-30 05:09:37',-1,'',0,0,0,0,'[if glob.use_bootstrap]\n    <div class="row">\n        <div class="col-sm-6">\n            [if cow.prev_simple]\n                <a href="[cow.prev_simple.full_url]">[component.b_icon(icon=''circle-arrow-left'', size='' '')] [cow.prev_simple.title]</a>\n            [/if]\n        </div>\n        <div class="col-sm-6" align="right">\n            [if cow.next_simple]\n                <a href="[cow.next_simple.full_url]">[cow.next_simple.title] [component.b_icon(icon=''circle-arrow-right'', size='' '')]</a>\n            [/if]\n        </div>\n    </div>\n[else]\n    <div style="height: 30px;">\n        <div style="float: left; margin-right: 10px;">\n            [if cow.prev_simple]\n                <a href="[cow.prev_simple.full_url]">&lt;- [cow.prev_simple.title]</a>\n            [/if]\n        </div>\n        <div style="float: right; margin-left: 10px;" align="right">\n            [if cow.next_simple]\n                <a href="[cow.next_simple.full_url]">[cow.next_simple.title] -&gt;</a>\n            [/if]\n        </div>\n    </div>\n[/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(106,0,'Переключатель для логических типов','switch','df9145f5be800391e29fefee8356ab91','2015-11-10 03:28:42','2015-11-10 03:57:10',-1,'Устанавливать в обработчик отображения логического поля объекта. У поля должно быть выключено быстрое редактирование, но включено "показывать в таблице".',0,2,0,0,'[if !is_admin? || !cow.edit?][xbreak][/if]\n[if $type==''single'']\n    [if $c_row==cow]\n        [cucol.set(1)]\n    [elseif $c_row]\n        [cucol.set(0)]\n    [/if]\n    [if cucol.value]\n        [$selected_text]\n    [else]\n        <a href="[a_url]&c_row=[cow]">[$normal_text]</a>\n    [/if]\n[else]\n    [if $c_row==cow && $c_action==''on'']\n        [cucol.set(1)]\n    [elseif $c_row==cow && $c_action==''off'']\n        [cucol.set(0)]\n    [/if]\n    [if cucol.value]\n        <a href="[a_url]&c_row=[cow]&c_action=off">[$selected_text]</a>\n    [else]\n        <a href="[a_url]&c_row=[cow]&c_action=on">[$normal_text]</a>\n    [/if]\n[/if]','',0,0,0,0,24,0,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(107,0,'AudioJS','audiojs','a8b346695ad91112cce8b28ee5c7ff76','2015-12-05 05:37:46','2015-12-05 05:38:50',-1,'',0,2,0,0,'[if !glob.use_audiojs]\n	[glob.use_audiojs=1]\n	[head]\n	    <script src="[cpart.folder]audio.min.js"></script>\n	    <script>\n	      audiojs.events.ready(function() {\n	        audiojs.createAll();\n	      });\n	    </script>\n	[/head]\n[/if]   \n<audio src="[$src]"></audio>','',0,0,0,0,2,0,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/audiojs/','','','',0,0,0,0,1),
(108,0,'Теги Select2','select2','06ad970b1b97219a9ecd4e3b86e62fd3','2015-12-06 12:56:14','2015-12-14 05:55:09',-1,'Необходимо добавить компонент не только в компонент формы, но и в обработчик при добавлении/изменении',0,2,0,0,'[if ctbl.owner!=0 && ctbl.owner.table.module.sname!=current_col.table.module.sname]\n    [xbreak]\n[/if]\n\n[if ajax?]\n    [if !get.page]\n        [page=1]\n    [else]\n        [page=get.page]\n    [/if]\n    [req=get.q]\n    [count=$col.linked.fastgetc(''major''^$req)]\n    [func.header(content=''Content-Type: application/json'')]\n    {\n          "total_count": [$count],\n          "incomplete_results": false,\n          "items": [[\n            [tree $col.linked.fastget(''major''^$req ''pos'' ($page-1)*30 30)]\n                    {\n                      "id": [cur],\n                      "text": "[cur.major.value.replace(''"'',"''")]"\n                    }\n                    [if !last?],[/if]\n            [/tree]\n          ]]\n    }\n    [xbreak]\n[/if]\n\n[if f_type==''onedit'']\n    [tags=post($col.formname+''_spec'').explode('','')]\n    [if !$tags || $tags.count==1 && !$tags[0]]\n        [xbreak]\n    [/if]\n    [tree $tags]\n        [if !value.is_numeric]\n            [x=value.lower]\n            [y=$col.linked.fastget(''major''==$x).first]\n            [if !$y]\n                [$col.linked.add(''major''=value)]\n                [tags[var]=li]\n            [else]\n                [tags[var]=$y]\n            [/if]\n        [/if]\n    [/tree]\n    [$col.set($tags)]\n    [xbreak]\n[/if]\n\n[if glob.select2_id]\n    [glob.select2_id=glob.select2_id+1]\n[else]\n    [glob.select2_id=1]\n[/if]\n\n[if !glob.use_select2]\n    [glob.use_select2=1]\n    [head]\n        [component.jquery(version=''2.1.0'')]\n        [if $use_bootstrap]\n            [component.bootstrap]\n        [/if]\n        <script type="text/javascript" src="[cpart.folder]select2.full.min.js"></script>\n        [if $lng]<script type="text/javascript" src="[cpart.folder]i18n/[$lng].js"></script>[/if]\n        <link href="[cpart.folder]select2.css" type="text/css" rel="stylesheet" />\n    [/head]\n    <script>\n        function formatRepo (repo) {\n        	if (repo.loading) return repo.text;	\n        	var markup=''<div class="select2-result-repository clearfix">''+repo.text+''</div>'';\n        	return markup;\n        }\n        function formatRepoSelection (repo) {\n        	return repo.text;\n        }\n    </script>\n    [if !glob.use_bootstrap]\n        <style>\n            .select2-dropdown{\n                margin-left: 8px;\n                margin-top: 8px;\n            }\n            .select2-container{\n                min-width: 500px;\n            }\n        </style>\n    [/if]\n[/if]\n\n[id=''select2''+glob.select2_id]\n\n<p><b>[$col.name]</b>:<br>\n<input type="hidden" name="[$col.formname]_spec" id="[$col.formname]" value="">\n<select class="js-select2 form-control" id="[$id]" multiple="multiple">\n    [if $ajax==''on'']\n        [tree $col.value]\n		    <option value="[cur]" selected>[cur.major.value]</option>\n		[/tree]\n	[else]\n    	[tree $col.linked.rows]\n    	    <option value="[cur]"[if cur^$col.value] selected[/if]>[cur.major.value]</option>\n    	[/tree]\n	[/if]\n</select>\n</p>\n\n<script>\n$("#[$id]").select2({\n  tags: true,\n  tokenSeparators: Array('',''),\n  [if $ajax==''on'']minimumInputLength: 2,[/if]\n  [if $lng]language: "[$lng]",[/if]\n  [if $ajax==''on'']\n      ajax: {\n        url: "[cpart.ajax]",\n        dataType: ''json'',\n        delay: 250,\n        data: function (params) {\n          return {\n            q: params.term, // search term\n            page: params.page\n          };\n        },\n        processResults: function (data, params) {\n          params.page = params.page || 1;\n          return {\n            results: data.items,\n            pagination: {\n              more: (params.page * 30) < data.total_count\n            }\n          };\n        },\n        cache: true\n      },\n  [/if]\n\n  templateResult: formatRepo,\n  templateSelection: formatRepoSelection,\n  escapeMarkup: function (markup) { return markup; }\n  \n});\n\n$(document).ready(function(){    \n	$("#[$id]").parents("form").get(0).onsubmit=function(e){\n        $("#[$col.formname]").val($(''#[$id]'').val());\n    };\n});\n\n</script>','',0,0,0,0,23,325,3,0,'a:1:{s:37:"part_06ad970b1b97219a9ecd4e3b86e62fd3";a:2:{i:0;a:1:{s:6:"header";s:6:"header";}i:2;a:2:{s:6:"jquery";s:6:"jquery";s:9:"bootstrap";s:9:"bootstrap";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/select2/','','','',0,0,0,0,1),
(109,2,'Категория фотографий','cat','199f26dce3f2236f951a9e8cc7d7b584','2015-12-09 05:13:21','2015-12-09 05:20:24',-1,'',0,0,31,0,'[cm.part.main(table=cow.photo, tpl=cow.tpl)]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(110,2,'Просмотр фотографий с меткой','tag_photo','7796a52ef4d9bb6d50db745cf3b97f3e','2015-12-09 05:37:53','2016-03-26 15:44:00',-1,'',0,0,34,0,'[num=cex.param.on_page]\n[if !$num]\n    [rows=cex.photo.eifastget(''tags''==cow !''date'')]\n[else]\n    [rows=cex.photo.eifastget(''tags''==cow !''date'' $page*$num $num)]\n[/if]\n[count=cex.photo.eifastgetc(''tags''==cow)]\n[cex.param.tpl.tpl.shell]','tag',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(111,2,'Заголовок','title','acdd7dc0b72d93501e49515934af6502','2015-12-09 05:46:05','2015-12-09 05:48:41',-1,'',0,0,0,0,'[if cex.sel==cm.category]\n	[return cow.title]\n[/if]\n[if cex.sel==cm.tags]\n	[return ''Тег "''+cow.name+''"'']\n[/if]\n[return false]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(112,2,'Блок фотографий','block_photo','55f12cf49d170a49cf4a6f0d688e070b','2015-12-09 05:49:20','2015-12-09 14:44:50',-1,'',1,1,0,0,'[if !$tpl]\n    [tpl=cex.param.tpl_block]\n[/if]\n\n[num=cex.param.block_count]\n[if !$num]\n    [rows=cex.photo.eifastget(0 !''date'',!''id'')]\n[else]\n    [rows=cex.photo.eifastget(0 !''date'',!''id'' 0 $num)]\n[/if]\n\n[$tpl.tpl.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(113,6,'Главная страница','main_page','94e52cc50c8949ae7256fad220e55638','2015-12-16 13:29:22','2016-04-23 16:48:53',-1,'',0,0,0,0,'[cex.param.main_tpl.body.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(114,6,'Категория товара','category','3c2ebca7b5ff7ed87feb5a57e1f9029b','2015-12-16 13:29:47','2016-04-25 09:39:19',-1,'',0,0,35,0,'[if cex.sel]\n    [cats=cow.category.rows]\n    [items=cow.items.rows]\n[else]\n    [cats=cex.category.rows]\n    [items=cex.items.eifastget(''on_start_page'')]\n[/if]\n[if(cow.tpl,cow.tpl,cex.param.cat_tpl).body.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(115,0,'SyntaxHightlighter','shightlighter','10874cb59afdd55cab9e5d96d17e4bc3','2016-02-15 08:00:52','2016-02-16 12:02:03',-1,'',0,2,0,0,'[if !glob.use_syntaxhighlighter]\n    [glob.use_syntaxhighlighter=1]\n    [head]\n        <script type="text/javascript" src="[cpart.folder]scripts/shCore.js"></script>\n        <link href="[cpart.folder]styles/shCore.css" rel="stylesheet" type="text/css" />\n        <link href="[cpart.folder]styles/shThemeDefault.css" rel="stylesheet" type="text/css" />\n        <script type="text/javascript">SyntaxHighlighter.all();</script>\n    [/head]\n[/if]\n[if !glob.syntaxhighlighter[$lng]]\n    [head]\n        <script type="text/javascript" src="[cpart.folder]scripts/shBrush[$lng].js"></script>\n    [/head]\n    [glob.syntaxhighlighter[$lng]=1]\n[/if]\n<pre class="brush: [$lng.lower]; [if $hide_gutter]gutter: false; [/if][if $first_lint]first-line: [$first_line]; [/if][if $html_script]html-script: true; [/if]">\n  [$src]\n</pre>','',0,0,0,0,25,0,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','/files/js/syntaxhighlighter/','','','',0,0,0,0,1),
(118,7,'Отобразить форму','echo','795b7d7875bd988701ed62c40f57a2fc','2016-03-22 05:21:55','2016-04-12 05:05:39',-1,'',1,1,45,0,'[if glob.form_id]\n    [glob.form_id=glob.form_id+1]\n[else]\n    [glob.form_id=1]\n[/if]\n[if !$tpl]\n    [tpl=$form.tpl]\n[/if]\n[if !$ajax && $action==''submit''++glob.form_id]\n    [cm.part.action(form=$form, url_from=url, form_id=glob.form_id)]\n    [xbreak]\n[/if]\n[component.jquery(version=''1.3.2'')]\n<script>\n    function form_check[glob.form_id](){\n        var f, value;\n        [tree $form.fields.rows.sel(cur.required || cur.type.js_validate)]\n            f=$(''#field[cur]_[glob.form_id]'');\n            value=f.val();\n            [if cur.type.js_validate]\n                [cur.type.js_validate]\n            [/if]\n            [if cur.required]\n                if(!value) return ''Поле "[cur.title]" обязательно к заполнению'';\n            [/if]\n        [/tree]\n        return false;\n    }\n    function gain_error[glob.form_id](error){\n        [$tpl.error.shell]\n    }\n    [compile js u]\n        function submit_form(id,ajax,url){\n            var f=''form_check''+id;\n            var fe=''gain_error''+id;\n            var error=window[[f]]();\n            if(error!='''' && error!=false){\n                window[[fe]](error);\n                return false;\n            } else {\n                if(ajax){\n                    jQuery.ajax({\n                        url:      url,\n                        type:     "POST",\n                        dataType: "html",\n                        data: jQuery("#form"+id).serialize(),\n                        success: function(response) {\n                            $(''#form''+id).hide();\n                            $(''#answer_body''+id).show();\n                            $(''#answer_body''+id).html(response);\n                        }\n                    });\n                    return false;\n                } else return true;\n            }\n        }\n    [/compile]\n</script>\n\n[if $ajax]<div id="answer_body[glob.form_id]" style="display: none;"></div>[/if]\n[$tpl.tpl.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(119,7,'Исполнение формы','action','58a3b0b3efa2ac2f3066e101ecd0e812','2016-03-22 05:28:55','2016-05-09 22:51:41',-1,'',0,0,0,0,'[if $capcha && !component.capcha_question(type=''check'')]\n    [error=''Неправильно введён ответ на контрольный вопрос. <a href="''++url++''">Попробовать ещё раз</a>'']\n    [if ajax?]\n        [$error]\n        <script>\n            $(''#form[$form_id]'').show();\n        </script>\n    [/if]\n    [return $error]\n[/if]\n[tree $form.fields.rows]\n    [if !cur.static_name]\n        [value=post.{field[cur]_[$form_id]}]\n    [else]\n        [value=post.{[cur.static_name]}]\n    [/if]\n    [if cur.type.a_prepend]\n        [value=cur.type.a_prepend.shell]\n    [/if]\n    [v[cur.title]=$value]\n\n    [if cur.type.a_validate]\n        [x=cur.type.a_validate.shell]\n        [if $x]\n            [$x]\n            [xbreak]\n        [/if]\n    [/if]\n[/tree]\n[$form.action.action.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',1,0,0,0,1),
(120,7,'Шапка формы','top','78f715b199bac68b8d180da34bf76555','2016-03-23 18:38:54','2016-04-06 20:38:35',-1,'',0,0,0,0,'<form action="[url3 "action"][url][if $anchor]#[$anchor][/if]" id="form[glob.form_id]" OnSubmit="return submit_form([glob.form_id],[if($ajax,1,0)],''[if $ajax][cm.part.ajax.action(form=$form, capcha=$capcha, form_id=glob.form_id, url_from=url)][/if]'');" method="post" enctype="multipart/form-data">\n    [if $protect][form_protect][/if]\n    <input type="hidden" name="action" value="submit[glob.form_id]">\n    <input type="hidden" name="form_id" value="[glob.form_id]">\n    <input type="hidden" name="form_name" value="[$form.name]">\n    <input type="hidden" name="action_name" value="[$form.action.name]">','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(121,7,'Подвал формы','bottom','d164e597722d91870589f68005e4dbc2','2016-03-23 18:39:25','2016-04-05 11:58:49',-1,'',0,0,0,0,'    <input type="submit" value="[$form.submit]"[$submit_class.if('' class="''+$submit_class+''"'')]>\n</form>','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(122,0,'Поле URL','url','06f371f041ce7955df4dba90e4f3c006','2016-03-23 19:11:22','2016-03-27 05:42:06',-1,'Добавлять в компонент и обработчик (с одинаковыми параметрами)',0,2,0,0,'[if f_type==''onform'']\n    [col_current.form_noprocess]\n    [if $first_empty]\n        [if ctbl.count==0][break][/if]\n    [/if]\n    [if is_admin? && f_action==''add'']\n    <input type="hidden" name="[col_current.formname]_edited" id="[col_current.formname]_edited" value="">\n    <script>\n        if(typeof window[[''translate_latinica'']] == ''function''){\n            var dst=$(''#[col_current.table.major.formname]'');\n            var src=$(''#[col_current.formname]'');\n            var edited=$(''#[col_current.formname]_edited'');\n            dst.blur(function() {\n                if(src.val()=='''' && !edited.val()) src.val(translate_latinica(dst.val()));\n            });\n            src.focus(function() {\n                edited.val(1);\n            });\n        }\n    </script>\n    [/if]\n[/if]\n[if f_type==''onedit'' && f_action==''add'' && !post.{[current_col.formname]_edited}]\n    [if $first_empty && current_col.table.rows.count==1]\n        [if !current_col.value]\n            [current_col.set('''')]\n        [/if]\n    [else]\n        [func.latinica]\n    [/if]\n[/if]','',0,0,0,0,17,0,3,0,'a:1:{s:37:"part_06f371f041ce7955df4dba90e4f3c006";a:1:{i:0;a:1:{s:8:"latinica";s:8:"latinica";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(123,5,'Список комментариев','list','8d41c5a3a50206d5b01874645242c8bc','2016-03-23 21:31:24','2016-03-23 21:52:09',-1,'',0,0,0,0,'[t=cex.param.tpl]\n[if !$t]\n    [t=cex.tpl.rows.first]\n[/if]\n[$t.tpl.shell]\n[cm.part.form]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(124,5,'Форма добавления комментария','form','1af50f7abb725f8c771bb97b0eeed2a4','2016-03-23 21:31:48','2016-06-05 10:53:08',-1,'',0,0,0,0,'<hr>\n[widget.forms.base.auth_reg(\n    form=uin:127201205acfb0680bbf52ed3b9f0ec2:''Обычная'',\n    group=''comment_authors'',\n    condition=(user.guest? || !cex.comment.add?),\n    reg_text={% для возможности [if cex.comments.add?]упрощённого[/if] добавления комментариев }\n)]\n[if cex.comments.add?]\n    [after={!\n        [li.signal(''Новый комментарий - ''++li.body, ''moderators'')]\n        [if $comment_after][$comment_after.shell][/if]\n    }]\n    [if user.guest?]\n        [component.form(table=cex.comments, cols=(''name'', ''email'', ''body''), capcha=true, after=$after, limit=cex.param.comments_limit, time=cex.param.limit_minute, show_left=1)]\n    [else]\n        [component.form(table=cex.comments, cols=(''body''), after=$after, limit=cex.param.comments_limit, time=cex.param.limit_minute, show_left=1)]\n    [/if]\n[/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(129,1,'Страница 404','404_error','14d043f05601512421833a9fe51c1209','2016-03-30 03:42:50','2016-03-30 04:34:26',-1,'',0,0,0,0,'[block name="body" silent]\n    <div>Страница не найдена</div>\n    [func.header(content=''HTTP/1.0 404 Not Found'')]\n[/block][cm.part.page]','',0,0,0,0,0,0,0,-1,'',1,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(130,1,'Поиск','search','934a32fcf402a16ecf772753b115d42c','2016-03-30 03:56:10','2016-04-05 12:11:47',-1,'',0,0,0,0,'[block name="body" silent]\n    [if get.query]\n    \n        [compile css]\n            .hightlight{\n                font-weight: bold;\n            }\n        [/compile]\n    \n        <p>Вы искали "<b>[get.query.safe_input]</b>"</p>\n        [result=cex.pages.rows.search(get.query, regular)]\n        [tree cex.pages.rows.sel(cur.module && cur.module.part.search.sname)]\n            [result=$result+cur.module.part.search]\n        [/tree]\n        \n        [count=$result.count]\n        [if !$count]\n            <p>Ничего не найдено. Попробуйте изменить поисковую фразу.</p>\n        [else]\n            <p>[$count.strnum(''Найден'',''Найдено'',''Найдено'')] [$count] [$count.strnum(''результат'',''результата'',''результатов'')]:</p>\n        [/if]\n        \n        [component.paginator(count=$count, num=20)]\n        \n        <ol start="[get.page*20+1]">\n        [tree linear component.obj_paginator_arr(objects=$result, num=20)]\n            <li>\n                [cur.highlight(get.query, ''hightlight'', 5, 3)]. <a href="[cur.full_url]">Подробнее</a>\n            </li>\n        [/tree]\n        </ol>\n        \n        [component.paginator(count=$count, num=20)]\n        \n    [/if]\n    \n    [widget.forms.base.echo(form=uin:c7ea703338bbdc8cfc551d5846034b48:''Форма поиска'', tpl=uin:81148d58e789a0c40bea530aa186e886:''Форма поиска'')]\n    \n[/block][cm.part.page]','search',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(131,0,'Объекты текущей страницы (из массива)','obj_paginator_arr','50f1911d232517e8b2c23cd79689f368','2016-03-30 04:06:20','2016-03-30 04:10:32',-1,'',0,2,0,0,'[return $objects.limit($page*$num,$num)]','',0,0,0,0,9,351,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(132,0,'Сайт использует Bootstrap?','is_bootstrap','9759e2c65c06440c57062e462c437e81','2016-03-30 04:40:21','2016-04-22 09:59:55',-1,'',0,2,0,0,'[return glob.use_bootstrap]','',0,0,0,0,4,0,2,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(133,4,'Поиск','search','09234d9cc722a0d54d07249f01c970bb','2016-03-30 04:43:12','2016-03-30 04:48:19',-1,'',0,0,0,0,'[return cex.articles.irows.search(get.query, regular)+cex.category.rows.search(get.query, regular)+cex.tags.rows.search(get.query, regular)]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(134,0,'Сколько прошло времени','time_passed','483101fbdc8551b93cd3ab84dcbd6345','2016-04-08 12:05:24','2016-05-29 07:46:16',-1,'',0,2,0,0,'[passed=glob.datetime.minute_passed-$datetime.minute_passed]\n[if $future_look]\n    [passed=$passed.abs]\n[/if]\n\n[if $postfix][postfix='' ''+$postfix][/if]\n[if $prefix][prefix=$prefix+'' ''][/if]\n[if $passed>60*24]\n    [days=$passed//60//24]\n    [return $prefix++$days++'' ''++$days.strnum(''день'',''дня'',''дней'')++$postfix].\n[elseif $passed>=60]\n    [$hours=$passed//60]\n    [return $prefix++$hours++'' ''++$hours.strnum(''час'',''часа'',''часов'')++$postfix].\n[elseif $passed>0]\n    [return $prefix++$passed++'' ''++$passed.strnum($minute1,$minute2,''минут'')++$postfix].\n[else]\n    [return $now].\n[/if]','',0,0,0,0,26,356,1,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(135,1,'Массив страниц для доп.навигации','array_navigation','754c6723d21ab67961f27456f7b09aca','2016-04-10 20:47:08','2016-04-15 20:44:34',-1,'',0,0,5,0,'[return $navig.page_links.rows.sc(''page'')]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(136,0,'Найти или вставить','find_or_insert','43630ac1bdd0dfe68bec277e8db9bc8f','2016-04-13 14:14:25','2016-04-13 18:10:42',-1,'Находит объект в указанной таблице, либо добавляет новый объект и возвращает его.',0,2,0,0,'[if !$value]\n    [return false]\n[/if]\n\n[t='''']\n[if $field]\n    [t=$table.get($field,$value)]\n[else]\n    [t=$table.get($value)]\n[/if]\n[if $t]\n    [return $t]\n[/if]\n\n[start_operation]\n[if $field]\n    [$field->$value]\n[else]\n    [$table.major.sname->$value]\n[/if]\n[if !cancel?]\n    [return li]\n[else]\n    [return false]\n[/if]','',0,0,0,0,27,0,0,0,'a:0:{}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(137,8,'Компонент формы','on_form','242c3207f751c5eb70342108ec9fb76d','2016-04-17 11:45:23','2016-05-11 21:06:04',-1,'',1,1,0,0,'[silent]\n    [if glob.form_id]\n        [glob.form_id=glob.form_id+1]\n    [else]\n        [glob.form_id=1]\n    [/if]\n    \n    [table=cm.part.seek_table]\n    [if !$table][return false][/if]\n    \n    [if f_action==''edit'']\n        [v=cow.dvalues.rows]\n    [/if]\n[/silent]\n\n[tree $table.rows]\n    [pv=$v.sel(cur.param.rid==up.rid)]\n    [values=$pv.sc.value]\n    [links=$pv.sc.link]\n    [value=$values.first]\n    [link=$links.first]\n    [items=cur.dlist.rows]\n    [if cur.collection]\n        [items=$items+cur.collection.dlist.rows]\n    [/if]\n    [if f_action==''add'']\n        [value=cur.default]\n        [if $value.contain('','')]\n            [values=$items.sel(cur.value^$value.explode('',''))]\n        [/if]\n        [link=$value]\n        [links=$values]\n    [/if]\n    [cur.type.on_form.shell(values=$values, value=$value, items=$items, link=$link, links=$links)]\n[/tree]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1);

INSERT INTO `main_part` (part_id,part_module,part_name,part_sname,part_uin,part_date,part_date2,part_auth,part_about,part_access,part_type,part_table,part_owner,part_body,part_url,part_ignore,part_iowner,part_sowner,part_parse,part_cat,part_major,part_proc,part_ex,part_parts,part_404,timer_last,timer_act,timer_type,timer_date,timer_time,timer_x,timer_y,timer_count,part_file,parser_end_ex,part_shell,part_cur,part_pic,part_folder,part_ifcase,part_ifdetect,part_ifrow,part_unsafe,part_shelltime,part_shellcount,part_skipurl,part_enable) VALUES
(138,8,'Обработчик формы','on_edit','c337a1913376606cbce559ce90f263ae','2016-04-17 12:58:35','2016-04-17 14:20:15',-1,'',1,1,0,0,'[table=cm.part.seek_table]\n[if !$table][return false][/if]\n\n[cow.dvalues.rows.del_all]\n\n[tree $table.rows]\n    [cur.type.on_edit.shell]\n[/tree]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(139,8,'Поиск таблицы с параметрами','seek_table','46baa039c413d214551bb3374aaf6b65','2016-04-17 13:08:43','2016-05-11 20:47:07',-1,'',0,0,0,0,'[table=0]\n[if f_action==''edit'']\n    [tree cow.allway]\n        [if cur.sut.dparams]\n            [table=cur.sut.dparams]\n            [break]\n        [/if]\n    [/tree]\n[else]\n    [tree ctbl.owner+ctbl.owner.allway]\n        [if cur.sut.dparams]\n            [table=cur.sut.dparams]\n            [break]\n        [/if]\n    [/tree]\n[/if]\n[return $table]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(140,8,'Форма фильтра','on_filter','18a38b0112b9c350c1e991f6b7141c72','2016-04-18 18:59:37','2016-04-22 19:54:08',-1,'',1,1,0,0,'[silent]\n    [if glob.form_id]\n        [glob.form_id=glob.form_id+1]\n    [else]\n        [glob.form_id=1]\n    [/if]\n    \n    [if !$table]table=cm.part.seek_table][/if]\n    [if !$table][return false][/if]\n[/silent]\n\n[tree $table.rows]\n    [items=cur.dlist.rows]\n    [if cur.collection]\n        [items=$items+cur.collection.dlist.rows]\n    [/if]\n    [values=()]\n    [value=cur.filter_default]\n    [if $value.contain('','')]\n        [values=$items.sel(cur.value^$value.explode('',''))]\n    [/if]\n    [links=$values]\n    [link=$value]\n    [cur.type.on_filter.if(cur.type.on_filter,cur.type.on_form).shell(values=$values, value=$value, items=$items, link=$link, links=$links)]\n[/tree]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(141,8,'Обработчик фильтра','do_filter','c894619c2299f4ac8beaea33558d0a90','2016-04-18 19:06:49','2016-04-18 21:33:16',-1,'',1,1,0,0,'[tree $table.fastget(''filter'')]\n    [val=post.dpar[cur]]\n    [if !$val || !cur.filter]\n        [continue]\n    [/if]\n    [cur.type.filtered.shell]\n[/tree]\n[return $objs]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(142,0,'Обработчик большого изображения для миниатюры','big_to_small','81bc8bd7f5d275effd6c8cd20574661a','2016-04-20 15:06:25','2016-04-21 14:07:57',-1,'',0,2,0,0,'[big_height=800]    [if cex.param.big_height][big_height=cex.param.big_height][/if]\n[big_width=1100]    [if cex.param.big_width][big_width=cex.param.big_width][/if]\n[big_type=1]        [if cex.param.big_type][big_type=cex.param.big_type][/if]\n[big_crop=1]        [if cex.param.big_crop][big_crop=cex.param.big_crop][/if]\n[min_height=100]    [if cex.param.min_height][min_height=cex.param.min_height][/if]\n[min_width=150]     [if cex.param.min_width][min_width=cex.param.min_width][/if]\n[min_type=6]        [if cex.param.min_type][min_type=cex.param.min_type][/if]\n[min_crop=2]        [if cex.param.min_crop][min_crop=cex.param.min_crop][/if]\n[func.preview(height=$big_height, width=$big_width, type=$big_type, crop=$big_crop)]\n[if $mini && current_col.table.col($mini)]\n    [func.preview(dst=$mini, height=$min_height, width=$min_width, type=$min_type, crop=$min_crop)]\n[/if]\n[if cex.param.watermark]\n    [transparent=0]         [if cex.param.watermark_transparent][transparent=cex.param.watermark_transparent][/if]\n    [position=''tile'']       [if cex.param.watermark_position][position=cex.param.watermark_position][/if]\n    [t=current_col.value._function.watermark(watermark=cex.param.watermark, transparent=$transparent, position=$position)]\n[/if]','',0,0,0,0,19,0,0,0,'a:1:{s:37:"part_81bc8bd7f5d275effd6c8cd20574661a";a:1:{i:0;a:2:{s:7:"preview";s:7:"preview";s:9:"watermark";s:9:"watermark";}}}',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','','','','','','',0,0,0,0,1),
(143,6,'Страница товара','item','dafa0b6e9995d4594b120ef577cc8390','2016-04-23 16:53:14','2016-04-23 16:53:14',-1,'',0,0,43,114,'','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(144,6,'Блок корзины','block_cart','04f275dd4a93b6d9ac99064fb424b96f','2016-04-25 08:49:04','2016-05-12 20:27:44',-1,'',1,1,0,0,'','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(145,7,'Имя компонента','f_name','7a651640c562db6732f54535c6245d7d','2016-05-09 22:49:00','2016-05-09 22:49:18',-1,'',0,0,0,0,'[if $input_name][$input_name][else][if $field.static_name][$field.static_name][else]field[$field]_[glob.form_id][/if][/if]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(146,10,'Вывод прайс-листа','vivod_prais_lista','d0545ef6efce67f00e527498451edc14','2016-05-13 13:35:19','2016-05-13 17:16:22',-1,'',0,0,0,0,'[cex.param.tpl.body.shell]','',0,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1),
(147,7,'Форма авторизации / регистрации','auth_reg','f9bef4e47b698cec1d2ee58086d57d5e','2016-05-31 14:23:55','2016-05-31 22:02:12',-1,'',1,1,0,0,'[$form.tpl.tpl.shell]','',1,0,0,0,0,0,0,-1,'',0,'0000-00-00 00:00:00',0,0,'0000-00-00','00:00:00',0,0,0,'',0,'0000-00-00 00:00:00','0','','','','','',0,0,0,0,1);

INSERT INTO `main_row` (row_id,row_module,row_table,row_ex,row_enable,row_sub,row_user,row_uin,backup_row,backup_date,modified_date,creation_date) VALUES
(1,1,8,4,1,0,-1,'2154b3bd21f88fc9cb934c76e85e9c05',0,'0000-00-00 00:00:00','2015-10-18 14:53:10','0000-00-00 00:00:00'),
(2,1,8,4,1,0,-1,'fec19dd3bce30a3dad36ea88b8c408ec',0,'0000-00-00 00:00:00','2015-10-18 14:53:14','0000-00-00 00:00:00'),
(3,1,8,4,1,0,-1,'c90c46619a0df16b92763866fa70f549',0,'0000-00-00 00:00:00','2015-10-18 14:53:19','0000-00-00 00:00:00'),
(4,1,8,4,1,0,-1,'f8d8e10771ed2c579ac9ad046bce509e',0,'0000-00-00 00:00:00','2015-10-18 14:53:22','0000-00-00 00:00:00'),
(5,1,8,4,1,0,-1,'ae1b2b415a172d7afca7dfa18df08f41',0,'0000-00-00 00:00:00','2015-10-18 14:53:26','0000-00-00 00:00:00'),
(6,1,8,4,1,0,-1,'b534f80c49b8e5394261296bfc8eb3b2',0,'0000-00-00 00:00:00','2015-10-18 14:53:35','0000-00-00 00:00:00'),
(7,1,8,4,1,0,-1,'a758f0bd04b2c04d1e97ddd9134f62a4',0,'0000-00-00 00:00:00','2015-10-18 14:54:43','0000-00-00 00:00:00'),
(8,1,8,4,1,0,-1,'499c3efbf4959c733b845437dc4eb558',0,'0000-00-00 00:00:00','2015-10-18 14:54:53','0000-00-00 00:00:00'),
(9,1,8,4,1,0,-1,'1fc5aef395e1187a33ff64d447861ac1',0,'0000-00-00 00:00:00','2015-10-18 14:54:58','0000-00-00 00:00:00'),
(10,1,8,4,1,0,-1,'f6529e6d55bbaf4de432df48d7bf920c',0,'0000-00-00 00:00:00','2015-10-18 14:55:04','0000-00-00 00:00:00'),
(11,1,0,0,0,0,0,'',1,'2015-10-18 14:56:02','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(12,1,12,8,1,0,-1,'00bfada5f0d52c12694af62c37e76488',0,'0000-00-00 00:00:00','2015-10-18 17:26:54','0000-00-00 00:00:00'),
(13,1,12,8,1,0,-1,'0bcf63ca0af9c0ae6cbc3eff048bae91',0,'0000-00-00 00:00:00','2015-10-18 17:26:54','0000-00-00 00:00:00'),
(14,1,7,3,1,0,-1,'b88d6e33ba6d77049fa3c4e1bd862a12',0,'0000-00-00 00:00:00','2015-11-02 15:25:38','0000-00-00 00:00:00'),
(15,1,7,3,1,0,0,'',14,'2015-10-19 16:21:48','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(16,3,15,11,1,0,-1,'0f9120b0a13ed22d2106fdcc1c369c09',0,'0000-00-00 00:00:00','2016-03-21 11:57:25','0000-00-00 00:00:00'),
(17,1,11,7,1,0,-1,'976f8a18890e7d4168c790465d63ad6d',0,'0000-00-00 00:00:00','2015-10-21 17:34:57','0000-00-00 00:00:00'),
(18,1,0,0,0,0,0,'',1,'2015-10-21 14:50:17','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(19,1,9,5,1,0,-1,'09f629cce36099c440ee9659b608660e',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(20,1,0,0,0,0,0,'',1,'2015-10-21 14:51:39','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(21,1,0,0,0,0,0,'',1,'2015-10-21 14:53:26','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(22,1,0,0,0,0,0,'',1,'2015-10-21 14:54:02','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(23,1,0,0,0,0,0,'',1,'2015-10-21 14:54:44','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(24,1,0,0,0,0,0,'',1,'2015-10-21 14:54:47','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(25,1,0,0,0,0,0,'',1,'2015-10-21 14:54:51','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(26,1,0,0,0,0,0,'',1,'2015-10-21 14:55:50','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(27,1,0,0,0,0,0,'',1,'2015-10-21 15:00:35','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(28,1,0,0,0,0,0,'',1,'2015-10-21 15:00:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(29,1,0,0,0,0,0,'',1,'2015-10-21 15:00:52','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(30,1,0,0,0,0,0,'',1,'2015-10-21 15:01:31','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(31,1,0,0,0,0,0,'',1,'2015-10-21 15:01:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(32,1,0,0,0,0,0,'',1,'2015-10-21 15:01:52','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(33,1,0,0,0,0,0,'',1,'2015-10-21 15:04:04','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(34,1,0,0,0,0,0,'',1,'2015-10-21 15:04:20','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(35,1,0,0,0,0,0,'',1,'2015-10-21 15:04:35','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(36,1,0,0,0,0,0,'',1,'2015-10-21 15:04:48','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(37,1,0,0,0,0,0,'',1,'2015-10-21 15:05:03','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(38,1,0,0,0,0,0,'',1,'2015-10-21 15:05:38','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(39,1,0,0,0,0,0,'',1,'2015-10-21 15:06:04','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(40,1,0,0,0,0,0,'',1,'2015-10-21 15:10:44','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(41,1,0,0,0,0,0,'',1,'2015-10-21 15:10:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(42,1,0,0,0,0,0,'',1,'2015-10-21 15:11:26','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(43,1,0,0,0,0,0,'',1,'2015-10-21 15:15:17','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(44,1,0,0,0,0,0,'',1,'2015-10-21 15:15:56','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(45,1,0,0,0,0,0,'',1,'2015-10-21 15:16:10','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(46,1,0,0,0,0,0,'',1,'2015-10-21 15:16:15','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(47,1,0,0,0,0,0,'',1,'2015-10-21 15:16:36','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(48,1,0,0,0,0,0,'',1,'2015-10-21 15:16:40','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(49,1,0,0,0,0,0,'',1,'2015-10-21 15:17:39','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(50,1,0,0,0,0,0,'',1,'2015-10-21 15:17:44','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(51,1,0,0,0,0,0,'',1,'2015-10-21 15:17:56','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(52,1,0,0,0,0,0,'',1,'2015-10-21 15:18:00','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(53,1,0,0,0,0,0,'',1,'2015-10-21 15:18:45','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(54,1,0,0,0,0,0,'',1,'2015-10-21 15:19:02','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(55,1,0,0,0,0,0,'',1,'2015-10-21 15:19:31','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(56,1,0,0,0,0,0,'',1,'2015-10-21 15:19:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(57,1,0,0,0,0,0,'',1,'2015-10-21 15:19:50','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(58,1,5,2,1,0,-1,'2a182c9000bae5015b1d62a23e9b8d2e',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(59,1,5,2,1,0,-1,'e4fbac09f1550c6f6339171cf7795763',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(60,1,5,2,1,0,-1,'7b7385c98883bd0cc1d7d0aaac10d35f',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(61,1,5,2,1,0,-1,'645c9f13dd55a44a3d50e7eddf544785',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(62,1,5,2,1,0,-1,'cc7548bef42643229e5f55f6ce338219',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(63,1,0,0,0,0,0,'',1,'2015-10-21 16:44:47','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(64,1,0,0,0,0,0,'',1,'2015-10-21 16:45:40','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(65,1,0,0,0,0,0,'',1,'2015-10-21 17:22:58','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(66,1,10,5,1,19,-1,'648acc6380376dedd6ecf4ce9afdde83',0,'0000-00-00 00:00:00','2015-12-09 22:20:21','0000-00-00 00:00:00'),
(67,1,0,0,0,0,0,'',1,'2015-10-21 17:52:12','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(68,1,0,0,0,0,0,'',1,'2015-10-21 17:53:41','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(69,1,0,0,0,0,0,'',1,'2015-10-21 17:59:47','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(70,1,0,0,0,0,0,'',1,'2015-10-21 18:03:08','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(72,1,20,16,1,0,-1,'0e5e6efa6807632b13aca37b1791da38',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(73,1,20,16,1,0,-1,'3801c2e01599f78b3f1da85b9a093301',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(74,1,20,16,1,0,-1,'33f9a97ad36eb86a03dc9de71b5ae272',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(75,1,20,16,1,0,-1,'5c4368d2133a31fab8e3394fd877cca4',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(76,1,20,16,1,0,-1,'96b7271f121b6dd006101a2dd3b0fad5',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(77,1,20,16,1,0,-1,'270f914b8b34445fd2a3b75a9b24a1e1',0,'0000-00-00 00:00:00','2015-10-21 18:05:40','0000-00-00 00:00:00'),
(78,1,5,2,1,0,-1,'a6ff131365aee288faf4017b3dfad469',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(79,1,18,14,1,0,-1,'bcfb52ecf26e3c252c94e7aac3884578',0,'0000-00-00 00:00:00','2015-10-23 20:30:25','0000-00-00 00:00:00'),
(80,1,19,14,1,79,-1,'67ceac5f13969a87f41a14cfeba2c372',0,'0000-00-00 00:00:00','2015-10-23 20:30:32','0000-00-00 00:00:00'),
(81,1,19,14,1,79,-1,'02583af1996fa4d8233009b34b19694c',0,'0000-00-00 00:00:00','2015-10-23 20:31:48','0000-00-00 00:00:00'),
(82,1,19,14,1,79,-1,'2a77853b753db0a172169174d836e650',0,'0000-00-00 00:00:00','2015-10-23 20:31:54','0000-00-00 00:00:00'),
(83,1,19,14,1,79,-1,'fcd0dfc5b38498219d377e77e62bb5ce',0,'0000-00-00 00:00:00','2015-10-23 20:31:57','0000-00-00 00:00:00'),
(84,4,22,18,1,0,-1,'a4a0b594dfcd263bb1b685e65270f237',0,'0000-00-00 00:00:00','2016-02-10 17:22:59','0000-00-00 00:00:00'),
(85,4,0,0,0,0,0,'',4,'2015-10-26 10:30:08','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(86,4,21,17,1,0,-1,'2859cf511f6f9887f4c7cf010590a696',0,'0000-00-00 00:00:00','2016-05-28 20:54:29','0000-00-00 00:00:00'),
(87,4,23,19,1,0,-1,'a7e8c8313ca0979fa757ff8379c0e48a',0,'0000-00-00 00:00:00','2015-11-03 04:02:12','0000-00-00 00:00:00'),
(88,1,5,2,1,0,-1,'d4fc28f0358172b651b64f07397add26',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(89,4,26,22,1,0,-1,'946c4e189d52d4e055c99744b0b98726',0,'0000-00-00 00:00:00','2015-12-09 07:57:50','0000-00-00 00:00:00'),
(90,4,26,22,1,0,-1,'92dfe307541e16b3d84260df4e7cae7c',0,'0000-00-00 00:00:00','2015-12-09 07:57:50','0000-00-00 00:00:00'),
(91,4,0,0,0,0,0,'',4,'2015-10-26 11:47:36','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(93,4,0,0,0,0,0,'',4,'2015-10-26 11:51:10','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(96,4,24,20,1,0,-1,'5c759c41ee0be5b6ef84a083b290bec3',0,'0000-00-00 00:00:00','2016-05-22 12:45:51','0000-00-00 00:00:00'),
(97,4,24,20,1,0,-1,'d439354225f261a51830aed77bac0d73',0,'0000-00-00 00:00:00','2015-10-29 16:46:13','0000-00-00 00:00:00'),
(98,4,24,20,1,0,-1,'5b1aaeea523eb7c086797cb9ac35191c',0,'0000-00-00 00:00:00','2015-10-29 16:46:13','0000-00-00 00:00:00'),
(99,4,24,20,1,0,-1,'1500e0b1cbc643779a5ba10a78a8056d',0,'0000-00-00 00:00:00','2015-10-29 16:46:13','0000-00-00 00:00:00'),
(100,4,21,20,1,98,-1,'d50dd5c0490899a0e3a4efa296bf7c8a',0,'0000-00-00 00:00:00','2016-05-28 20:51:29','0000-00-00 00:00:00'),
(101,4,21,20,1,98,-1,'1faf6bace1e6cdfd99d447c523c73813',0,'0000-00-00 00:00:00','2016-05-22 12:49:36','0000-00-00 00:00:00'),
(102,4,21,20,1,97,-1,'aa7e622046619c6650c5d5c5bbaad953',0,'0000-00-00 00:00:00','2016-05-28 20:51:20','0000-00-00 00:00:00'),
(103,4,21,20,1,96,-1,'981abe35fdf9918c4a66c705c6249977',0,'0000-00-00 00:00:00','2016-05-28 20:51:05','0000-00-00 00:00:00'),
(104,4,21,20,1,99,-1,'abd73eff9b7ac958a664306db8271d99',0,'0000-00-00 00:00:00','2016-03-27 18:06:57','0000-00-00 00:00:00'),
(105,1,11,7,1,0,-1,'cc6884405821c3a8c8bebc6d0e6587fb',0,'0000-00-00 00:00:00','2015-10-31 02:57:38','0000-00-00 00:00:00'),
(106,4,27,23,1,0,-1,'f0e6e496a8b5c894fea803570d4dcae1',0,'0000-00-00 00:00:00','2015-12-09 07:36:58','0000-00-00 00:00:00'),
(107,4,27,23,1,0,-1,'4e505a85942da67c1adbdc47f1d29bf7',0,'0000-00-00 00:00:00','2015-11-02 12:02:44','0000-00-00 00:00:00'),
(108,4,0,0,0,0,0,'',4,'2015-11-02 11:29:14','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(109,1,9,5,1,0,-1,'b32a5e3f0cbfb4f324c781210b779462',0,'0000-00-00 00:00:00','2015-11-02 11:34:13','0000-00-00 00:00:00'),
(110,1,10,5,1,109,-1,'83ef53794b8b6c129e240342d94315a5',0,'0000-00-00 00:00:00','2016-04-25 08:50:05','0000-00-00 00:00:00'),
(111,1,11,7,1,0,-1,'061b1adf53897bde38f7aba001bac2ce',0,'0000-00-00 00:00:00','2015-11-02 12:03:18','0000-00-00 00:00:00'),
(112,1,10,5,1,109,-1,'799c84a2dd33e628a81e588c7a923d9c',0,'0000-00-00 00:00:00','2016-04-25 08:50:05','0000-00-00 00:00:00'),
(113,4,0,0,0,0,0,'',4,'2015-11-02 16:22:49','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(114,4,0,0,0,0,0,'',4,'2015-11-02 16:26:37','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(115,4,0,0,0,0,0,'',4,'2015-11-02 16:35:12','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(116,4,28,24,1,0,-1,'23c8c350cbfa8ab85ec054a35c817027',0,'0000-00-00 00:00:00','2015-11-02 16:52:03','0000-00-00 00:00:00'),
(117,4,0,0,0,0,0,'',4,'2015-11-02 16:54:40','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(118,4,0,0,0,0,0,'',4,'2015-11-02 16:54:53','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(119,4,28,24,1,0,-1,'b3d0543c4ea048b05443ab24ceef82d7',0,'0000-00-00 00:00:00','2015-11-02 21:31:35','0000-00-00 00:00:00'),
(120,4,0,0,0,0,0,'',4,'2015-11-02 21:31:45','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(121,4,25,21,1,0,-1,'30ee89107b54871c808654963085da39',0,'0000-00-00 00:00:00','2015-11-02 22:16:45','0000-00-00 00:00:00'),
(122,1,10,5,1,109,-1,'2d302dc10f7ce61911451d4838952289',0,'0000-00-00 00:00:00','2016-04-25 08:50:05','0000-00-00 00:00:00'),
(123,4,0,0,0,0,0,'',4,'2015-11-02 22:18:54','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(124,4,0,0,0,0,0,'',4,'2015-11-02 22:20:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(125,4,0,0,0,0,0,'',4,'2015-11-02 22:24:06','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(126,3,15,11,1,0,-1,'63ff7ca0e551e04caf2ece0cb5485876',0,'0000-00-00 00:00:00','2015-11-02 22:33:05','0000-00-00 00:00:00'),
(127,4,0,0,0,0,0,'',4,'2015-11-02 22:38:39','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(128,4,0,0,0,0,0,'',4,'2015-11-02 22:47:40','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(129,4,21,20,1,98,-1,'4fadf1f552aa75c16a6dab056b767a58',0,'0000-00-00 00:00:00','2016-05-31 16:13:54','0000-00-00 00:00:00'),
(131,1,0,0,0,0,0,'',1,'2015-11-03 20:44:56','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(133,1,0,0,0,0,0,'',1,'2015-11-03 20:55:57','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(171,4,21,17,1,0,0,'',94,'2015-12-07 14:17:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(173,2,32,27,1,0,-1,'76d22ac167e23d107c16e73c2d54eaf1',0,'0000-00-00 00:00:00','2015-12-09 12:28:02','0000-00-00 00:00:00'),
(174,4,26,22,1,0,-1,'37df183f622c95091bdd44d529d0f31f',0,'0000-00-00 00:00:00','2015-12-09 07:57:50','0000-00-00 00:00:00'),
(175,2,0,0,0,0,0,'',2,'2015-12-09 11:51:35','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(192,2,1,1,1,0,-1,'a5b20fa2399656514d7bd3c3f01d60ab',0,'0000-00-00 00:00:00','2015-12-09 12:37:23','0000-00-00 00:00:00'),
(193,2,1,1,1,0,-1,'ea26dc14e56e6a425e74bc3031c5b807',0,'0000-00-00 00:00:00','2015-12-09 11:55:21','0000-00-00 00:00:00'),
(194,2,1,1,1,0,-1,'db8eadb44d738f8953b90a40e0cfc8bc',0,'0000-00-00 00:00:00','2015-12-09 11:55:22','0000-00-00 00:00:00'),
(195,2,1,1,1,0,-1,'5fec4a9bcb20a1c4ae60baa91ba4b6b0',0,'0000-00-00 00:00:00','2015-12-09 12:37:33','0000-00-00 00:00:00'),
(196,2,1,1,1,0,-1,'71daab1971ffcf954e8fbf565ed1f0aa',0,'0000-00-00 00:00:00','2015-12-09 12:37:47','0000-00-00 00:00:00'),
(197,2,1,1,1,0,-1,'5c75283b0645cac6deeaf6ff61cbb98f',0,'0000-00-00 00:00:00','2015-12-09 12:38:29','0000-00-00 00:00:00'),
(198,2,1,1,1,0,-1,'7cc4a6526f2bfb2c9bd383fda7374521',0,'0000-00-00 00:00:00','2015-12-09 11:55:22','0000-00-00 00:00:00'),
(199,2,1,1,1,0,-1,'c0d4201d945f25a3f19398a75cdc7c4f',0,'0000-00-00 00:00:00','2015-12-09 12:38:17','0000-00-00 00:00:00'),
(200,2,1,1,1,0,-1,'9ee46cf5a882c806b4d3db2287f56f9b',0,'0000-00-00 00:00:00','2015-12-09 11:55:22','0000-00-00 00:00:00'),
(201,2,1,1,1,0,-1,'4ae67eb6547563a0a03517c5ca37db81',0,'0000-00-00 00:00:00','2015-12-09 12:38:01','0000-00-00 00:00:00'),
(202,2,1,1,1,0,-1,'c0c27cef4f5ef267dccb12431d775b8f',0,'0000-00-00 00:00:00','2015-12-09 12:38:09','0000-00-00 00:00:00'),
(203,1,5,2,1,0,-1,'5745d0caf80588d57abe84c586b8716b',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','0000-00-00 00:00:00'),
(204,2,32,27,1,0,-1,'ca19833f9eb923ec6a1f326a7f1d8ed0',0,'0000-00-00 00:00:00','2015-12-09 12:31:37','0000-00-00 00:00:00'),
(205,2,0,0,0,0,0,'',2,'2015-12-09 12:29:45','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(206,1,10,5,1,19,0,'d78187fc1211b659ae1f035bdf228798',0,'0000-00-00 00:00:00','2015-12-09 22:20:21','0000-00-00 00:00:00'),
(207,2,31,26,1,0,-1,'6c9f60ac846975c573280cae54bbf4bc',0,'0000-00-00 00:00:00','2015-12-09 12:32:54','0000-00-00 00:00:00'),
(208,2,31,26,1,0,-1,'4633da8e738fbddb16ac564fcb7faf56',0,'0000-00-00 00:00:00','2015-12-09 12:33:05','0000-00-00 00:00:00'),
(209,2,1,26,1,207,-1,'b7adb6b3f3c9ed6f801addc68a1c0828',0,'0000-00-00 00:00:00','2015-12-09 12:33:38','0000-00-00 00:00:00'),
(210,2,1,26,1,207,-1,'12c2ebf711b0a96684dd65ac627b08b5',0,'0000-00-00 00:00:00','2015-12-09 15:11:09','0000-00-00 00:00:00'),
(211,2,1,26,1,207,-1,'086c55208592817e9cf20b25da2624de',0,'0000-00-00 00:00:00','2015-12-09 12:33:38','0000-00-00 00:00:00'),
(212,2,1,26,1,207,-1,'7b17d2474705c2f4d403b9fa2dbb5118',0,'0000-00-00 00:00:00','2015-12-09 15:11:16','0000-00-00 00:00:00'),
(214,2,1,26,1,208,-1,'fc23830c096612812f51c69d9bc531f5',0,'0000-00-00 00:00:00','2015-12-09 12:34:33','0000-00-00 00:00:00'),
(215,2,1,26,1,208,-1,'cd440ebfb8f84e1f6a3c4eef1400e417',0,'0000-00-00 00:00:00','2015-12-09 12:34:33','0000-00-00 00:00:00'),
(216,2,1,26,1,208,-1,'dc42fd7b5903ba544d8affa76dda6844',0,'0000-00-00 00:00:00','2015-12-09 12:34:33','0000-00-00 00:00:00'),
(217,2,1,26,1,208,-1,'29b18504094ee3e809f0c7b2500b0c6e',0,'0000-00-00 00:00:00','2015-12-09 12:34:33','0000-00-00 00:00:00'),
(219,2,34,28,1,0,-1,'71ada3d8d8bb03cff98ffb3cc01e480e',0,'0000-00-00 00:00:00','2015-12-09 12:37:23','0000-00-00 00:00:00'),
(221,2,34,28,1,0,-1,'c76c336a2a28f48dc9fef5b23309c04d',0,'0000-00-00 00:00:00','2015-12-09 12:37:47','0000-00-00 00:00:00'),
(223,2,34,28,1,0,-1,'113265c23d1e155e19b8eaaf862fcc36',0,'0000-00-00 00:00:00','2015-12-09 12:38:01','0000-00-00 00:00:00'),
(224,2,34,28,1,0,-1,'88c47409c0680ee861acbfd078fd221e',0,'0000-00-00 00:00:00','2015-12-09 12:38:01','0000-00-00 00:00:00'),
(226,2,34,28,1,0,-1,'0dbc62d7639a293fc9164b261047b3f8',0,'0000-00-00 00:00:00','2015-12-09 12:38:09','0000-00-00 00:00:00'),
(227,1,9,5,1,0,-1,'31780203fea113a7a751a25231a016c8',0,'0000-00-00 00:00:00','2015-12-09 22:17:59','0000-00-00 00:00:00'),
(399,6,42,43,1,0,-1,'aeb1ee5c6475fa91bdacb2f8a0036b94',0,'0000-00-00 00:00:00','2015-12-14 00:26:26','0000-00-00 00:00:00'),
(400,6,42,43,1,0,-1,'4ebdca75cfab120bc1fdbf4046c43d06',0,'0000-00-00 00:00:00','2015-12-14 00:26:34','0000-00-00 00:00:00'),
(401,6,42,43,1,0,-1,'fca07777deef20bef8dc765c534e3aea',0,'0000-00-00 00:00:00','2015-12-14 00:26:36','0000-00-00 00:00:00'),
(402,6,42,43,1,0,-1,'285c9fd233a7758ed38a540ec3b0bd89',0,'0000-00-00 00:00:00','2015-12-14 00:26:38','0000-00-00 00:00:00'),
(403,6,42,43,1,0,-1,'eb928dfedd02b9a638230ac25028bc83',0,'0000-00-00 00:00:00','2015-12-14 00:26:46','0000-00-00 00:00:00'),
(404,6,42,43,1,0,-1,'d467c5cbebdfea75fdb404efbe8b0cbd',0,'0000-00-00 00:00:00','2015-12-14 00:26:48','0000-00-00 00:00:00'),
(405,6,42,43,1,0,-1,'4fc2f13167ff7b42ad626ba400bf8eac',0,'0000-00-00 00:00:00','2015-12-14 00:27:00','0000-00-00 00:00:00'),
(406,6,42,43,1,0,-1,'0a61744f90fdab6a0065104a53c984fa',0,'0000-00-00 00:00:00','2015-12-14 00:27:10','0000-00-00 00:00:00'),
(407,6,42,43,1,0,-1,'522a770f23f761d847fa37ed2cf125ed',0,'0000-00-00 00:00:00','2015-12-14 00:27:12','0000-00-00 00:00:00'),
(408,6,42,43,1,0,-1,'b82ddecfcb1b7e61f14f1e6a88e0cd6d',0,'0000-00-00 00:00:00','2015-12-14 00:27:50','0000-00-00 00:00:00'),
(409,6,0,0,0,0,0,'',6,'2015-12-14 04:36:49','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(410,6,0,0,0,0,0,'',6,'2015-12-14 04:37:15','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(411,6,35,29,1,0,-1,'38be8d21b177fba3ea977fa5a292c251',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','0000-00-00 00:00:00'),
(422,6,0,0,0,0,0,'',6,'2015-12-14 04:54:21','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(423,6,0,0,0,0,0,'',6,'2015-12-14 05:21:04','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(424,6,43,29,1,411,-1,'cf79e340c88217ea07e9d16b3ec6d410',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','0000-00-00 00:00:00'),
(425,6,0,0,0,0,0,'',6,'2015-12-14 05:47:44','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(426,6,0,0,0,0,0,'',6,'2015-12-14 05:48:18','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(427,6,0,0,0,0,0,'',6,'2015-12-14 05:48:35','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(428,2,1,29,1,424,-1,'e7f0378f43a30b60f386ae76fb2290a5',0,'0000-00-00 00:00:00','2015-12-14 05:50:35','0000-00-00 00:00:00'),
(429,2,1,29,1,424,-1,'98b243443079136ea4913c11cb1710f5',0,'0000-00-00 00:00:00','2015-12-14 05:57:17','0000-00-00 00:00:00'),
(430,6,0,0,0,0,0,'',6,'2015-12-14 05:55:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(431,6,0,0,0,0,0,'',6,'2015-12-14 05:56:31','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(432,6,0,0,0,0,0,'',6,'2015-12-14 05:56:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(433,6,0,0,0,0,0,'',6,'2015-12-14 05:57:15','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(434,6,43,29,1,411,0,'',424,'2015-12-14 06:52:02','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(435,6,43,29,1,411,0,'',424,'2015-12-14 06:52:43','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(436,6,43,29,1,411,0,'',424,'2015-12-14 06:56:51','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(437,6,43,29,1,411,0,'',424,'2015-12-14 06:56:56','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(438,6,43,29,1,411,0,'',424,'2015-12-14 06:58:54','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(439,6,43,29,1,411,0,'',424,'2015-12-14 06:59:26','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(440,6,43,29,1,411,0,'',424,'2015-12-14 06:59:50','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(441,6,43,29,1,411,0,'',424,'2015-12-14 07:02:06','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(457,6,36,30,1,0,-1,'ebf6a94c13401311c3621544739837d6',0,'0000-00-00 00:00:00','2015-12-17 06:25:05','0000-00-00 00:00:00'),
(458,6,36,30,1,0,-1,'e171e527fec2c6c4c6b09651616c3ded',0,'0000-00-00 00:00:00','2015-12-17 06:25:08','0000-00-00 00:00:00'),
(708,6,43,29,1,411,-1,'38a90d57f9a7dd275b8b5684a02c5ce3',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','0000-00-00 00:00:00'),
(725,2,1,29,1,708,-1,'57bcb2b332c94d87a54ac507d660261d',0,'0000-00-00 00:00:00','2015-12-15 02:21:58','0000-00-00 00:00:00'),
(726,2,1,29,1,708,-1,'a58d49f71ceb434d5ae4f0ccb23060ef',0,'0000-00-00 00:00:00','2015-12-15 02:21:58','0000-00-00 00:00:00'),
(727,2,1,29,1,708,-1,'7120683088e70eeb77b93c8c9047b281',0,'0000-00-00 00:00:00','2015-12-15 02:21:58','0000-00-00 00:00:00'),
(728,6,43,29,1,411,-1,'3eb28a970c2f7dd6b2f759594da31b8d',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','0000-00-00 00:00:00'),
(746,2,1,29,1,728,-1,'0858c2f1f144cf0424096100ac2ac675',0,'0000-00-00 00:00:00','2015-12-15 02:28:02','0000-00-00 00:00:00'),
(747,2,1,29,1,728,-1,'49f75b8ff24ab37083c04fa834d87d4a',0,'0000-00-00 00:00:00','2015-12-15 02:28:02','0000-00-00 00:00:00'),
(748,2,1,29,1,728,-1,'694dc45883c1b113599d481b4690e7e1',0,'0000-00-00 00:00:00','2015-12-15 02:28:02','0000-00-00 00:00:00'),
(749,2,1,29,1,728,-1,'3693dee08ad332a9222c3abbb7edc998',0,'0000-00-00 00:00:00','2015-12-15 02:28:03','0000-00-00 00:00:00'),
(768,6,43,29,1,411,-1,'e6376b40faf395f50e987ba0509384af',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','0000-00-00 00:00:00'),
(769,6,36,30,1,0,-1,'13b67da51e22ace465fe6b042eec7b1f',0,'0000-00-00 00:00:00','2015-12-15 02:52:00','0000-00-00 00:00:00'),
(770,6,36,30,1,0,-1,'3d11afdc3e60684ae74177d3577b3c8c',0,'0000-00-00 00:00:00','2015-12-15 02:52:00','0000-00-00 00:00:00'),
(771,6,36,30,1,0,-1,'18cea6f66d23bc93e35107689c57ff5e',0,'0000-00-00 00:00:00','2015-12-15 02:52:00','0000-00-00 00:00:00'),
(787,2,1,29,1,768,-1,'dec572730d4376f0391b15c418ecffbb',0,'0000-00-00 00:00:00','2015-12-15 02:53:11','0000-00-00 00:00:00'),
(788,2,1,29,1,768,-1,'cefaf706c5f7afaa54b0db5ae7bf3b3a',0,'0000-00-00 00:00:00','2015-12-15 02:53:11','0000-00-00 00:00:00'),
(789,2,1,29,1,768,-1,'65e997fae1158cd06fb55a9a6f03f410',0,'0000-00-00 00:00:00','2015-12-15 02:53:11','0000-00-00 00:00:00'),
(790,2,1,29,1,768,-1,'d8cb4e6ae7841e920aa4263097f95dc4',0,'0000-00-00 00:00:00','2015-12-15 02:53:11','0000-00-00 00:00:00'),
(791,2,1,29,1,768,-1,'a45d161bbffe9c52ef2a406c88f9b3a7',0,'0000-00-00 00:00:00','2015-12-15 02:53:11','0000-00-00 00:00:00'),
(808,6,35,29,1,0,-1,'8b6ef4e91170de2ba1206d5dd4401ce3',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','0000-00-00 00:00:00'),
(809,6,35,29,1,0,-1,'5b9252f2a24b9cb710130afcf8a3a1ea',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','0000-00-00 00:00:00'),
(1132,3,0,0,0,0,0,'',3,'2016-03-21 10:41:26','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1133,7,46,47,1,0,-1,'81cd1c49a60aad9c856d43d9a0f72900',0,'0000-00-00 00:00:00','2016-03-22 10:13:31','2016-03-22 06:21:26'),
(1134,7,46,47,1,0,-1,'d071116f4e4e787024a739a938d02bf6',0,'0000-00-00 00:00:00','2016-03-22 10:13:41','2016-03-22 06:22:37'),
(1135,7,46,47,1,0,-1,'c7e0cfa1baf1bef3151a3c9041512430',0,'0000-00-00 00:00:00','2016-04-22 10:00:36','2016-03-22 06:29:33'),
(1137,7,49,50,1,0,-1,'cd82318c116e254948f244b0b69046bf',0,'0000-00-00 00:00:00','2016-04-22 10:00:16','2016-03-22 06:35:35'),
(1138,7,46,47,1,0,-1,'d1e2f0d78ae1c6a17d563291b8045484',0,'0000-00-00 00:00:00','2016-03-22 10:13:56','2016-03-22 07:55:22'),
(1139,7,46,47,1,0,-1,'9eb16eb565a066e04a6b3dd0f5912c00',0,'0000-00-00 00:00:00','2016-03-22 10:14:08','0000-00-00 00:00:00'),
(1142,7,45,46,1,0,-1,'18ef803d6adac074344241113fac6821',0,'0000-00-00 00:00:00','2016-03-22 08:29:04','2016-03-22 08:29:04'),
(1143,7,47,48,1,0,-1,'30e0afd2e2a70c035ef88ef9722e861c',0,'0000-00-00 00:00:00','2016-03-22 08:29:04','2016-03-22 08:29:04'),
(1144,7,48,46,1,1142,-1,'0d06ea6e88607466c283b3ac1a0201b1',0,'0000-00-00 00:00:00','2016-03-22 12:28:55','2016-03-22 08:31:46'),
(1145,7,48,46,1,1142,-1,'b59544fd6e459d345f4ff710803da78c',0,'0000-00-00 00:00:00','2016-03-22 12:28:58','2016-03-22 08:31:59'),
(1146,7,48,46,1,1142,-1,'f5ed2f9833ac09aeec93b59db8a5f63a',0,'0000-00-00 00:00:00','2016-03-22 11:04:36','2016-03-22 08:32:43'),
(1147,7,48,46,1,1142,-1,'53750e414bc2d1b070022a7687a875da',0,'0000-00-00 00:00:00','2016-03-22 11:03:25','2016-03-22 08:32:56'),
(1148,7,50,46,1,1146,-1,'cdcffe5770c959bf7aa9057ed6c984f9',0,'0000-00-00 00:00:00','2016-03-22 08:34:20','2016-03-22 08:34:20'),
(1149,7,50,46,1,1146,-1,'ef6afcc6016835f65afa8ed4c42947cc',0,'0000-00-00 00:00:00','2016-03-22 08:34:20','2016-03-22 08:34:20'),
(1150,7,50,46,1,1146,-1,'2a9136005b678749e4bf5dc3afe4bab1',0,'0000-00-00 00:00:00','2016-03-22 08:34:20','2016-03-22 08:34:20'),
(1151,7,50,46,1,1146,-1,'7f82b533cdff19b1759bc672bbfa6dcb',0,'0000-00-00 00:00:00','2016-03-22 08:34:20','2016-03-22 08:34:20'),
(1152,7,50,46,1,1147,-1,'f391abc4d1b043776cbef9d6f1622a21',0,'0000-00-00 00:00:00','2016-03-22 08:34:38','2016-03-22 08:34:38'),
(1153,7,50,46,1,1147,-1,'fc019cc14bc1ac0811b797c1c039eafa',0,'0000-00-00 00:00:00','2016-03-22 08:34:38','2016-03-22 08:34:38'),
(1154,7,50,46,1,1147,-1,'b2ee91924d11c764af6d1ffeeb85b126',0,'0000-00-00 00:00:00','2016-03-22 08:34:38','2016-03-22 08:34:38'),
(1155,7,50,46,1,1147,-1,'22073671f1e9d45d76641414c80c6e44',0,'0000-00-00 00:00:00','2016-03-22 08:34:38','2016-03-22 08:34:38'),
(1156,7,48,46,1,1142,-1,'876799778791be202817ce137a5ed16a',0,'0000-00-00 00:00:00','2016-03-22 12:29:01','2016-03-22 08:37:10'),
(1157,7,46,47,1,0,-1,'8cc9e3739ee7039e1b7b18c9359b3fb8',0,'0000-00-00 00:00:00','2016-03-22 11:13:51','0000-00-00 00:00:00'),
(1158,7,45,46,1,0,-1,'10c9cb802b02cc3dca281bfddcc8264b',0,'0000-00-00 00:00:00','2016-03-22 11:22:41','2016-03-22 11:22:41'),
(1159,7,47,48,1,0,-1,'b9bf6291ec9b0dda9d3705fe2e871702',0,'0000-00-00 00:00:00','2016-03-22 11:22:41','2016-03-22 11:22:41'),
(1160,7,49,50,1,0,-1,'2e1408e12b3122b2872e702912025b98',0,'0000-00-00 00:00:00','2016-03-23 19:41:41','2016-03-22 11:22:41'),
(1161,7,48,46,1,1158,-1,'0e28b9ef0699ffce8c4085504774110a',0,'0000-00-00 00:00:00','2016-03-22 12:29:05','2016-03-22 11:22:50'),
(1162,7,48,46,1,1158,-1,'ece061caf501afe4f9a2692ee3c7c9aa',0,'0000-00-00 00:00:00','2016-03-22 12:29:08','2016-03-22 11:22:56'),
(1163,7,0,0,0,0,0,'',7,'2016-03-23 18:38:03','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1166,1,10,5,1,109,-1,'aac1726d13e564dca532c0d7d2756d7d',0,'0000-00-00 00:00:00','2016-04-25 08:50:05','2016-03-23 19:38:05'),
(1167,7,49,50,1,0,-1,'f6daf3d74ababfaf47ea602883527b90',0,'0000-00-00 00:00:00','2016-04-22 10:00:22','2016-03-23 19:44:32'),
(1170,5,0,0,0,0,0,'',5,'2016-03-23 21:32:29','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1171,5,0,0,0,0,0,'',5,'2016-03-23 21:34:13','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1172,5,51,52,1,0,-1,'b78fdf086e4c2025a6aebda8b38102fd',0,'0000-00-00 00:00:00','2016-04-08 16:06:39','2016-03-23 21:34:13'),
(1173,4,0,0,0,0,0,'',4,'2016-03-23 21:49:43','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1174,7,46,47,1,0,-1,'d452ff117444d25dc7c2ee254897ec44',0,'0000-00-00 00:00:00','2016-03-23 22:01:03','2016-03-23 22:01:03'),
(1175,7,48,46,1,1142,-1,'850b02df1666700653a5754b82f17df1',0,'0000-00-00 00:00:00','2016-03-23 22:03:17','2016-03-23 22:03:17'),
(1211,7,45,46,1,0,-1,'7e35fd9d632d4c1cb24e3a6d95fa8b36',0,'0000-00-00 00:00:00','2016-03-30 02:10:02','2016-03-30 02:10:02'),
(1212,7,47,48,1,0,-1,'c7f2afccd30584acc51fce8e2dce2fd8',0,'0000-00-00 00:00:00','2016-03-30 02:10:02','2016-03-30 02:10:02'),
(1213,7,49,50,1,0,-1,'c12b5e2ae908b7436596e128d4aff762',0,'0000-00-00 00:00:00','2016-04-22 10:00:26','2016-03-30 02:10:02'),
(1214,7,45,46,1,0,-1,'c7ea703338bbdc8cfc551d5846034b48',0,'0000-00-00 00:00:00','2016-03-30 03:32:32','2016-03-30 02:17:08'),
(1215,7,49,50,1,0,-1,'bb159c0ec27b8c2d2225828574de71e0',0,'0000-00-00 00:00:00','2016-04-22 10:00:30','2016-03-30 02:17:08'),
(1216,7,48,46,1,1211,-1,'09afbbc8270a60bd159aa9dea17ed975',0,'0000-00-00 00:00:00','2016-04-05 11:47:46','2016-03-30 02:17:32'),
(1217,7,48,46,1,1211,-1,'c2184f62b36621dabe1166a269771e8f',0,'0000-00-00 00:00:00','2016-03-30 02:17:47','2016-03-30 02:17:47'),
(1218,7,48,46,1,1211,-1,'577569ecd7eccbaec6a8af624a19d4fa',0,'0000-00-00 00:00:00','2016-04-06 14:18:38','2016-03-30 02:18:01'),
(1219,7,48,46,1,1211,-1,'d92d29de50cf623f61948f35668e90d1',0,'0000-00-00 00:00:00','2016-03-30 02:18:39','2016-03-30 02:18:39'),
(1220,7,48,46,1,1214,-1,'ff5690c6cb27f37cf1c1789874da329e',0,'0000-00-00 00:00:00','2016-03-30 02:21:09','2016-03-30 02:21:09'),
(1221,1,10,5,1,19,-1,'c5096bf45c7a1dd359f9a5a6bc62bc33',0,'0000-00-00 00:00:00','2016-03-30 03:41:44','2016-03-30 03:38:04'),
(1222,3,0,0,0,0,0,'4398e30b27a3684d72959a0c5476b16a',3,'2016-04-05 21:52:02','0000-00-00 00:00:00','0000-00-00 00:00:00');

INSERT INTO `main_row` (row_id,row_module,row_table,row_ex,row_enable,row_sub,row_user,row_uin,backup_row,backup_date,modified_date,creation_date) VALUES
(1223,7,46,47,1,0,-1,'332a573978734907071e466726b8beda',0,'0000-00-00 00:00:00','2016-04-06 20:21:49','0000-00-00 00:00:00'),
(1228,1,5,2,1,0,-1,'715c4e19854b7120081bffa1faffded0',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','2016-04-08 16:05:51'),
(1229,1,10,5,1,19,-1,'4800aeda48b07d2d0fde05cab1b60ed0',0,'0000-00-00 00:00:00','2016-04-10 21:08:04','2016-04-10 21:08:04'),
(1232,8,58,59,1,0,-1,'2b766cc1a5272a2e72a9f0b0adb1586a',0,'0000-00-00 00:00:00','2016-04-17 11:04:04','2016-04-12 09:37:58'),
(1233,8,55,56,1,0,-1,'b8cd8c185d4da0656d0d210667de2bec',0,'0000-00-00 00:00:00','2016-04-18 09:29:12','2016-04-12 09:38:55'),
(1237,8,58,59,1,0,-1,'1addb59141ffe55c47d577f4a7790447',0,'0000-00-00 00:00:00','2016-04-18 21:29:25','2016-04-17 10:37:41'),
(1238,8,58,59,1,0,-1,'da023bc4c85a8b23be8e2b4235f869c5',0,'0000-00-00 00:00:00','2016-04-17 10:46:15','2016-04-17 10:46:15'),
(1239,8,58,59,1,0,-1,'d2add784f307eb4e4ae46c19c5560ee8',0,'0000-00-00 00:00:00','2016-04-18 21:30:19','2016-04-17 11:03:41'),
(1240,8,58,59,1,0,-1,'cbe1b2216cf48aaf0149814023525217',0,'0000-00-00 00:00:00','2016-04-22 19:45:23','2016-04-17 11:25:42'),
(1241,8,58,59,1,0,-1,'c08c0af78604037bb7b3c4e1350aa5bb',0,'0000-00-00 00:00:00','2016-04-22 19:45:33','2016-04-17 11:29:53'),
(1242,8,0,0,0,0,0,'',8,'2016-04-17 13:26:05','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1243,8,54,56,1,1233,-1,'b669de8b3870177f7c374019eac1bb84',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1244,8,54,56,1,1233,-1,'375096722de4bed3a65d31463ca780df',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1245,8,54,56,1,1233,-1,'a0ba18b09a3a9c9126e8f1a13c050e8d',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1246,8,54,56,1,1233,-1,'b912eab009e8cda436d39a8567f000c6',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1247,8,54,56,1,1233,-1,'f0819b688056d53f353e2800d51fbcd6',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1248,8,54,56,1,1233,-1,'87585ca47fa2ad6cd649f6d282df2816',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1249,8,54,56,1,1233,-1,'7601b18364135e7e679e33da1fbf0ebc',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1250,8,54,56,1,1233,-1,'26efddfa14b9762df45c0de54e7c79a3',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1251,8,54,56,1,1233,-1,'72e29e77c306e92905a090c9295b739a',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1252,8,54,56,1,1233,-1,'41745a08a6ceb90c33a92e2302f7c6d8',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1253,8,54,56,1,1233,-1,'bb73a7e292bd270bed49006afff113c5',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1254,8,54,56,1,1233,-1,'a290cf4e6bc6d139a70dc61f1e844db3',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1255,8,54,56,1,1233,-1,'9365ed0a3ba2cf7f51daa92df56a9a41',0,'0000-00-00 00:00:00','2016-04-17 19:00:34','2016-04-17 19:00:34'),
(1256,6,53,29,1,411,-1,'93332831cc8654e82475f86acdf7ddd1',0,'0000-00-00 00:00:00','2016-04-22 20:00:16','2016-04-18 09:28:18'),
(1257,8,55,56,1,0,-1,'147d9e3bd0595364644979926cdd2d7b',0,'0000-00-00 00:00:00','2016-04-18 09:29:21','2016-04-18 09:29:21'),
(1258,8,54,56,1,1257,-1,'574b9cc718efd31b570c926908640050',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1259,8,54,56,1,1257,-1,'c0ac17c22fd3a206fe4a023d57822674',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1260,8,54,56,1,1257,-1,'263fb4da2e9693d39b982b791fe7f997',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1261,8,54,56,1,1257,-1,'4e2c31807fef29c467fcad3c05159aac',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1262,8,54,56,1,1257,-1,'8ceb25c847dc87aec88328be76d11e98',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1263,8,54,56,1,1257,-1,'d39a46d1974a27f375aa8cf88d3959d7',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1264,8,54,56,1,1257,-1,'709e4177b3f94af170f17adcc92f433d',0,'0000-00-00 00:00:00','2016-04-18 09:29:28','2016-04-18 09:29:28'),
(1265,6,53,29,1,411,-1,'47d22cba2782f8a2b22706bc90571e07',0,'0000-00-00 00:00:00','2016-04-18 09:29:58','2016-04-18 09:29:58'),
(1266,8,54,29,1,1265,-1,'eaee8c3238b455046ed76f10d8b2a876',0,'0000-00-00 00:00:00','2016-04-18 09:30:05','2016-04-18 09:30:05'),
(1267,8,54,29,1,1265,-1,'f6f54e8d84191cf7936a274ec62dd05d',0,'0000-00-00 00:00:00','2016-04-18 09:30:05','2016-04-18 09:30:05'),
(1268,8,54,29,1,1265,-1,'f8be989f4baa494333aa572d6e995c7b',0,'0000-00-00 00:00:00','2016-04-18 09:30:05','2016-04-18 09:30:05'),
(1269,6,53,29,1,411,-1,'8c0def82c51b1c033b8f3e1a5d9523cd',0,'0000-00-00 00:00:00','2016-04-18 09:30:17','2016-04-18 09:30:17'),
(1270,8,54,29,1,1269,-1,'9353acdc1630c197247e2766e4e30124',0,'0000-00-00 00:00:00','2016-04-18 09:30:25','2016-04-18 09:30:25'),
(1271,8,54,29,1,1269,-1,'4a774ee99737981451d322c45e50c91c',0,'0000-00-00 00:00:00','2016-04-18 09:30:25','2016-04-18 09:30:25'),
(1272,8,54,29,1,1269,-1,'57691a3010e01f092612b9e9014fba2f',0,'0000-00-00 00:00:00','2016-04-18 09:30:25','2016-04-18 09:30:25'),
(1273,8,54,29,1,1269,-1,'06413594d7cb7a0d6341e44e7cf0bacd',0,'0000-00-00 00:00:00','2016-04-18 09:30:25','2016-04-18 09:30:25'),
(1274,6,53,29,1,411,-1,'6a090d42f297791c324d5d0fdbeaffba',0,'0000-00-00 00:00:00','2016-04-18 09:30:46','2016-04-18 09:30:46'),
(1275,6,53,29,1,411,-1,'746fa36d2a01e80c9f8a5b2168de35e8',0,'0000-00-00 00:00:00','2016-04-18 09:30:52','2016-04-18 09:30:52'),
(1276,6,53,29,1,411,-1,'deb76f6aad93d1abc6bd63c11a424c22',0,'0000-00-00 00:00:00','2016-04-18 09:30:57','2016-04-18 09:30:57'),
(1277,6,53,29,1,411,-1,'b875d8a189952f93f51f86cdb215f7ac',0,'0000-00-00 00:00:00','2016-04-22 20:00:30','2016-04-18 09:31:13'),
(1278,6,53,29,1,411,-1,'7d33610e3019c99fa55f855f70de9e97',0,'0000-00-00 00:00:00','2016-04-18 09:31:26','2016-04-18 09:31:26'),
(1279,8,54,29,1,1278,-1,'535c6f2a7f4ff7a9bf8c763f7a3dd8c4',0,'0000-00-00 00:00:00','2016-04-18 09:31:33','2016-04-18 09:31:33'),
(1280,8,54,29,1,1278,-1,'647067e39f5724bd85413e47b709766c',0,'0000-00-00 00:00:00','2016-04-18 09:31:33','2016-04-18 09:31:33'),
(1281,8,54,29,1,1278,-1,'ba8a396f58eb8cb058029858510d9563',0,'0000-00-00 00:00:00','2016-04-18 09:31:33','2016-04-18 09:31:33'),
(1282,8,54,29,1,1278,-1,'219f0595ec84db348f2dd12830b97bec',0,'0000-00-00 00:00:00','2016-04-18 09:31:33','2016-04-18 09:31:33'),
(1283,8,54,29,1,1278,-1,'25409c3945feff5260f72aaea32eae01',0,'0000-00-00 00:00:00','2016-04-18 09:31:33','2016-04-18 09:31:33'),
(1284,8,54,29,1,1278,-1,'84053345b7f59da48ce116c31ded0624',0,'0000-00-00 00:00:00','2016-04-18 09:31:34','2016-04-18 09:31:34'),
(1285,6,53,29,1,411,-1,'b9dd92b41d1f3dc2ba0429ab7f558950',0,'0000-00-00 00:00:00','2016-04-18 09:31:48','2016-04-18 09:31:48'),
(1286,8,54,29,1,1285,-1,'77b6107cd1a5d320886c41a93bb1c2fb',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1287,8,54,29,1,1285,-1,'18aa131a9a933f3c860580f58be2693f',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1288,8,54,29,1,1285,-1,'9ab874110b78ca60866a297c8018a3df',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1289,8,54,29,1,1285,-1,'34b2ab8ecfed5c615ed57229f7a2338f',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1290,8,54,29,1,1285,-1,'017e9f41aadb115a6e10ccf6b92990ff',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1291,8,54,29,1,1285,-1,'6d57997b9abc6c05cb4f48cb6d5eeabf',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1292,8,54,29,1,1285,-1,'a6ddc1b198939f4aac49362f906af4c5',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1293,8,54,29,1,1285,-1,'2a8a85b32daa39117d47e39072b9e12b',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1294,8,54,29,1,1285,-1,'a8f9f98c8c98b93d8e7fe07ede1c5179',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1295,8,54,29,1,1285,-1,'32836e198db5470edc850f36a1a807ef',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1296,8,54,29,1,1285,-1,'2d5aadf1f6c9d835f559b94b86c24a54',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1297,8,54,29,1,1285,-1,'e95342ea1fb398e42b81383741c25484',0,'0000-00-00 00:00:00','2016-04-18 09:31:56','2016-04-18 09:31:56'),
(1298,6,53,29,1,411,-1,'6819f4584f9d290e42954f1c02274c1e',0,'0000-00-00 00:00:00','2016-04-18 09:32:09','2016-04-18 09:32:09'),
(1299,6,53,29,1,411,-1,'ee57a0109ad60890584c75570c674c79',0,'0000-00-00 00:00:00','2016-04-18 09:32:19','2016-04-18 09:32:19'),
(1300,8,54,29,1,1299,-1,'12ff52581d83ac51c7693f42879cabd8',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1301,8,54,29,1,1299,-1,'24d05c4c4b756e2cad4b6303dc4e2a46',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1302,8,54,29,1,1299,-1,'f87458f2b8217cbf65ec8b6f39d44ab9',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1303,8,54,29,1,1299,-1,'cca284997bdd8cd625da3b734c8a13e5',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1304,8,54,29,1,1299,-1,'be98ec38c1a7750c91c6aa7c32876618',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1305,8,54,29,1,1299,-1,'0bf4663894c83a65b46a76c5417d5e8f',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1306,8,54,29,1,1299,-1,'e3c7df00ee8c15a6e61843341970ede6',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1307,8,54,29,1,1299,-1,'ff743e56dc3ee76430aca88fa418fa0d',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1308,8,54,29,1,1299,-1,'e8f063714de153e77f4d951b3cd4209b',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1309,8,54,29,1,1299,-1,'10d75aca8ffeae5dae900aa2d8433a15',0,'0000-00-00 00:00:00','2016-04-18 09:32:25','2016-04-18 09:32:25'),
(1310,6,53,29,1,411,-1,'b6e1d0548a81c1fe7305238323fe4724',0,'0000-00-00 00:00:00','2016-04-18 09:32:41','2016-04-18 09:32:41'),
(1311,8,54,29,1,1310,-1,'e41d563633aca9e26155b68bbcf9cba4',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1312,8,54,29,1,1310,-1,'f6b9f8679bf3cd4356b8eff6e0ef7810',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1313,8,54,29,1,1310,-1,'9960d9ecc8c33ee93792ace1ecd3127b',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1314,8,54,29,1,1310,-1,'a38e1b9f8b1b8c41eccf483d297eb40b',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1315,8,54,29,1,1310,-1,'607e177d4fadc03d932aec661a10633c',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1316,8,54,29,1,1310,-1,'1b9aadbb994c4c56fba14462354ba362',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1317,8,54,29,1,1310,-1,'3db2861f699ebc41c0e19a981fde2f57',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1318,8,54,29,1,1310,-1,'df1e930ab8f169f6de5c37347658ff19',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1319,8,54,29,1,1310,-1,'edb719be290f95b0bfd9641ceb3d6989',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1320,8,54,29,1,1310,-1,'18cb517bd891f049040e41bd97ebb1f0',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1321,8,54,29,1,1310,-1,'b4f4408338755e80dc68fdd7b661be81',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1322,8,54,29,1,1310,-1,'13a0f3dd37e96b9a907f42a3dd07e1f3',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1323,8,54,29,1,1310,-1,'f1da1df69bc645ecb9c531eba429f29d',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1324,8,54,29,1,1310,-1,'29e78b9a135b8939ea5aa9dc3b1f2e12',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1325,8,54,29,1,1310,-1,'37d78155e7204bbd269b8c45928ad686',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1326,8,54,29,1,1310,-1,'8b4e48bf9c028cd1e74cbdf0b79dfd3a',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1327,8,54,29,1,1310,-1,'d25c4724f394d0dc770e233402da3557',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1328,8,54,29,1,1310,-1,'ea3e3fb57099f49217e40934fadeed4c',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1329,8,54,29,1,1310,-1,'cbf8a598fbfba08270b3402cc0069eca',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1330,8,54,29,1,1310,-1,'920ad977af6177323629de60db9c534c',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1331,8,54,29,1,1310,-1,'0d16b5b000fdf43ddd3896e969eccf54',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1332,8,54,29,1,1310,-1,'9b3a9656722577442e8e5bab75b7f315',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1333,8,54,29,1,1310,-1,'408c0b365fd8e751377f108d345f6d84',0,'0000-00-00 00:00:00','2016-04-18 09:33:12','2016-04-18 09:33:12'),
(1334,6,53,29,1,411,-1,'aa61c303d57a016526bd29ec3387b71e',0,'0000-00-00 00:00:00','2016-04-18 09:33:28','2016-04-18 09:33:28'),
(1335,8,54,29,1,1334,-1,'49e8b2398b07be52a63fc2da4c4b71f6',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1336,8,54,29,1,1334,-1,'376cb78d4fa631c2763240fd5eaa70cd',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1337,8,54,29,1,1334,-1,'7374d8ab4b6ca95804285eb91f1870b7',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1338,8,54,29,1,1334,-1,'91c48b87f008694be16b7312c8670d16',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1339,8,54,29,1,1334,-1,'e8365a513ac4579cf479ea0a4578d537',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1340,8,54,29,1,1334,-1,'2ca49a603b243f67c9f9bdd517b3389b',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1341,8,54,29,1,1334,-1,'80f13bdb2c854a9da398975645c97b59',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1342,8,54,29,1,1334,-1,'3c5b3b4e3b4a040d506620de715db257',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1343,8,54,29,1,1334,-1,'7b5e38b24856dc2c175f89e17758c6ba',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1344,8,54,29,1,1334,-1,'1f4d1fbaa8df4e685fe7b413ae67a43b',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1345,8,54,29,1,1334,-1,'6d853c508013824ce75db6b7601f8c33',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1346,8,54,29,1,1334,-1,'8f17da3a486155f5dc1296f6f64e0384',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1347,8,54,29,1,1334,-1,'3e1832908d7919aa011ac9f21954fb60',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1348,8,54,29,1,1334,-1,'5f356b199f7ccad063562286fd0e875a',0,'0000-00-00 00:00:00','2016-04-18 09:33:36','2016-04-18 09:33:36'),
(1349,6,53,29,1,411,-1,'f058dfad7f97ed01146fdb7625012bdf',0,'0000-00-00 00:00:00','2016-04-22 19:59:54','2016-04-18 09:34:10'),
(1350,8,54,29,1,1349,-1,'813b27adc2748aed5b338de8650b99eb',0,'0000-00-00 00:00:00','2016-04-18 09:34:15','2016-04-18 09:34:15'),
(1351,8,54,29,1,1349,-1,'f799cd8139d2f2444bea8458c0c1661c',0,'0000-00-00 00:00:00','2016-04-18 09:34:15','2016-04-18 09:34:15'),
(1352,8,54,29,1,1349,-1,'9ba2c935afa5a4532fdf174f8452fd57',0,'0000-00-00 00:00:00','2016-04-18 09:34:15','2016-04-18 09:34:15'),
(1353,6,53,29,1,411,-1,'5a3e90df9c34af8c0483e41e4945ed5e',0,'0000-00-00 00:00:00','2016-04-18 09:34:42','2016-04-18 09:34:42'),
(1354,6,53,29,1,411,-1,'b8f5a67b1272450fb0ac5ab56ecac4c1',0,'0000-00-00 00:00:00','2016-04-22 20:00:38','2016-04-18 09:34:54'),
(1355,6,53,29,1,411,-1,'15e8fccce55af57d3ea5014aaac6246d',0,'0000-00-00 00:00:00','2016-04-18 09:35:05','2016-04-18 09:35:05'),
(1356,6,53,29,1,809,-1,'c80062c4f7a32a99b1c87b1f45d5c460',0,'0000-00-00 00:00:00','2016-04-18 11:13:21','2016-04-18 11:13:21'),
(1357,6,53,29,1,809,-1,'058f699465a09f280f0092c3f3aecfcf',0,'0000-00-00 00:00:00','2016-04-18 11:13:31','2016-04-18 11:13:31'),
(1358,6,53,29,1,809,-1,'43fc6d84234ba8859cf4c3d2471f3d7e',0,'0000-00-00 00:00:00','2016-04-18 11:13:40','2016-04-18 11:13:40'),
(1637,6,53,29,1,809,-1,'477b6ea99c6bed1ac873ad2bd6c0a820',0,'0000-00-00 00:00:00','2016-04-18 23:45:51','2016-04-18 23:45:51'),
(1638,6,53,29,1,809,-1,'96c40d0f53123e82a9a83cdd7a904e85',0,'0000-00-00 00:00:00','2016-04-19 19:00:54','2016-04-19 19:00:54'),
(1639,8,54,29,1,1638,-1,'0f285d7fdf982067b434e841f24b8a93',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1640,8,54,29,1,1638,-1,'d671a416c8570d77d38010c9ad69407b',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1641,8,54,29,1,1638,-1,'acdc2e39f9897aeced6e03ab11d0e94f',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1642,8,54,29,1,1638,-1,'7868b7a7277b247d32c69cf2dc8afd07',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1643,8,54,29,1,1638,-1,'280f323dcdcef51d804449d5362dcbde',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1644,8,54,29,1,1638,-1,'1faccdaf0feaf9c0458f1a37ad00e774',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1645,8,54,29,1,1638,-1,'0543392863e8bb2bd3ddca582e5bfb6e',0,'0000-00-00 00:00:00','2016-04-19 19:01:06','2016-04-19 19:01:06'),
(1646,6,53,29,1,809,-1,'22d2998c9ff22965242aa3fcb7f789e1',0,'0000-00-00 00:00:00','2016-04-19 19:01:31','2016-04-19 19:01:31'),
(1647,6,43,29,1,809,-1,'c768dfd85de34f5756136142b421bdc8',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-20 13:45:45'),
(1648,6,36,30,1,0,-1,'e2c70e29e45c1eafb9d1e479f33234c0',0,'0000-00-00 00:00:00','2016-04-20 13:45:46','2016-04-20 13:45:46'),
(1649,6,36,30,1,0,-1,'6d70996f63456c96a3870d7c0a27ced5',0,'0000-00-00 00:00:00','2016-04-20 13:45:46','2016-04-20 13:45:46'),
(1661,6,43,29,1,809,-1,'292985511465e06f2ee742764be5092b',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-20 13:49:01'),
(1668,6,35,29,1,0,-1,'c6d5f1a9b5852bc4577583b38f3a7c70',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','2016-04-20 13:49:27'),
(1669,6,35,29,1,0,-1,'0b17c2bc4aee37a04900ed68df21310a',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','2016-04-20 13:49:48'),
(1670,6,35,29,1,0,-1,'1bac6414cf0c7b1a0b2924bfe6f884cc',0,'0000-00-00 00:00:00','2016-04-22 19:47:43','2016-04-20 13:50:06'),
(1671,6,43,29,1,1670,-1,'2bd4ee3f9d4725523933e19959778b98',0,'0000-00-00 00:00:00','2016-04-22 19:48:52','2016-04-20 15:00:39'),
(1672,6,43,29,1,1670,-1,'f4cf1a1a932282645538832f9c54c6f4',0,'0000-00-00 00:00:00','2016-04-22 19:48:57','2016-04-20 15:02:48'),
(1673,6,43,29,1,1669,-1,'b7a72598c3da13d1ff10e5162432cb7e',0,'0000-00-00 00:00:00','2016-04-22 19:48:44','2016-04-20 15:03:36'),
(1674,6,43,29,1,1669,-1,'fc4c3ac7931a00948c3c7d687f10637e',0,'0000-00-00 00:00:00','2016-04-22 19:48:48','2016-04-20 15:04:34'),
(1675,2,0,0,0,0,0,'',2,'2016-04-20 15:35:49','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1676,2,0,0,0,0,0,'',2,'2016-04-20 15:36:41','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1677,2,0,0,0,0,0,'',2,'2016-04-20 15:36:45','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1678,2,0,0,0,0,0,'',2,'2016-04-20 15:37:42','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1679,2,0,0,0,0,0,'',2,'2016-04-20 15:38:34','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1680,2,0,0,0,0,0,'',2,'2016-04-20 15:39:17','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1687,2,0,0,0,0,0,'',2,'2016-04-20 15:42:22','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1689,2,0,0,0,0,0,'',2,'2016-04-20 15:42:39','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1694,2,0,0,0,0,0,'',2,'2016-04-20 15:45:17','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1698,2,0,0,0,0,0,'',2,'2016-04-20 15:48:09','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1703,2,0,0,0,0,0,'',2,'2016-04-20 15:49:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1705,2,0,0,0,0,0,'',2,'2016-04-20 15:50:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1707,8,57,29,1,424,-1,'518e4a79c2e33f644dceaf6202e3b81c',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1708,8,57,29,1,424,-1,'d87a40fb85b3bae85ffba46871473773',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1709,8,57,29,1,424,-1,'118234d7344a7ca69bfad0492fa0d476',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1710,8,57,29,1,424,-1,'0683a7fa5ebf88803fe404ad67581237',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1711,8,57,29,1,424,-1,'b7f5eea4f2a8645db414289e67b2a746',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1712,8,57,29,1,424,-1,'7764c74fad646ba09dae95fca003182c',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1713,8,57,29,1,424,-1,'8f887a235853366cf853738f2905a305',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1714,8,57,29,1,424,-1,'91c92b0dfff71dde5100fcdd77b8323b',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1715,8,57,29,1,424,-1,'f07950fb9f73241f8d5b3ae1e0f7797a',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1716,8,57,29,1,424,-1,'1fdf203448494be94ca2bccdbdb6ca61',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1717,8,57,29,1,424,-1,'551ea6dd5a2e9472ba278ff54151b98d',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1718,8,57,29,1,424,-1,'3b4adee9d0e5c0b5192d1a7d6284c1da',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1719,8,57,29,1,424,-1,'4683b31072949603d1e5ef5eb9fc2766',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1720,8,57,29,1,424,-1,'c0d09fd2d37e135a7ddf4fc654563e57',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1721,8,57,29,1,424,-1,'7021baa50a68c0da01e979fc9d9a386a',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1722,8,57,29,1,424,-1,'795b9f3c0173ce7186aa94c305eb314d',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1723,8,57,29,1,424,-1,'74a7265d310c963ad0c2cfad1c7dd290',0,'0000-00-00 00:00:00','2016-04-22 19:47:59','2016-04-22 19:47:59'),
(1725,8,57,29,1,708,-1,'1adcc284c451009339df9900781cec7f',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1726,8,57,29,1,708,-1,'1726e8cd97d798ab3f8bebd2b7c43742',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1727,8,57,29,1,708,-1,'f1f0159d2ed89bfe69b5f7d5ba44d82f',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1728,8,57,29,1,708,-1,'ef641f4dff47f1b146b392336382e465',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1729,8,57,29,1,708,-1,'42d320e72df605dd09b7aafa87613910',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1730,8,57,29,1,708,-1,'37e5d414c4e30cff29707713b7a40911',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1731,8,57,29,1,708,-1,'9fa0281c8c35f6561810ecad43bff492',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1732,8,57,29,1,708,-1,'94491cb8419a14d61ea6c1166fb385ef',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1733,8,57,29,1,708,-1,'c3e16769d240fba69ce51ceff8b875bd',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1734,8,57,29,1,708,-1,'0223c53df67a43893843d47ffddcb105',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1735,8,57,29,1,708,-1,'98c984276f575cb00869f4cdd3cf97b8',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1736,8,57,29,1,708,-1,'02280debc14bd155b4b7c40ba929c461',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1737,8,57,29,1,708,-1,'fd6fb4a40c0dbf352d93a3d2c19f4225',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1738,8,57,29,1,708,-1,'28984f27a9994c50ee08b05df7b193e5',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1739,8,57,29,1,708,-1,'618bb5c663a3c179f761b16d079a971d',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1740,8,57,29,1,708,-1,'d12d5d585016f0fbf6096285d00dd041',0,'0000-00-00 00:00:00','2016-04-22 19:48:18','2016-04-22 19:48:18'),
(1742,8,57,29,1,728,-1,'f0a351d658e796b122c877ea3e318f6b',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1743,8,57,29,1,728,-1,'e94d109184122b7e7b0d9b2101b58c24',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1744,8,57,29,1,728,-1,'68b4e0c1b94d205829583e68f8266021',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1745,8,57,29,1,728,-1,'7c19a17363615f9b60c4091d08f13b34',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1746,8,57,29,1,728,-1,'a60ffe6e5e7fe73adcb5cffbe6f5075d',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1747,8,57,29,1,728,-1,'a3c937ee02df0467f8050810ff2b969d',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1748,8,57,29,1,728,-1,'1517e43133fcf93e3f6a26ff804d681d',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1749,8,57,29,1,728,-1,'9836291b9ee37090fae03ec38f036e7c',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1750,8,57,29,1,728,-1,'ccfe8a6e6cf4d8e591880b4e6c18afbb',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1751,8,57,29,1,728,-1,'c713315ffb670190d151ef746cd4c4ba',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1752,8,57,29,1,728,-1,'2d297e4cbb101a1f0db3bb4f8001d8e9',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1753,8,57,29,1,728,-1,'80bb38a4a1ec737963f03a7a363b71dc',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1754,8,57,29,1,728,-1,'e561cb801f867044d2a8df6a6ebd2520',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1755,8,57,29,1,728,-1,'9809ba1ab59553ceb54eb5ca13cee3c6',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1756,8,57,29,1,728,-1,'93dc1fa838117cbf3d79b383b97ea503',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1757,8,57,29,1,728,-1,'77e97d9ef8ba6c242136dc76b35df8d9',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1758,8,57,29,1,728,-1,'c9ce4c95c97d620ee541eb83b2687f54',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1759,8,57,29,1,728,-1,'c1af5862abf0d831cddbee9ad1440152',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1760,8,57,29,1,728,-1,'eccbfd38dbf8dd062f64db1de4da264e',0,'0000-00-00 00:00:00','2016-04-22 19:48:23','2016-04-22 19:48:23'),
(1762,8,57,29,1,768,-1,'808e2b3699153e0e91e173519a51618e',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1763,8,57,29,1,768,-1,'240b928dcb03a1efe5dc4a571bcd4a8a',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1764,8,57,29,1,768,-1,'e9ea1bc72fb0d18a4214a2acb3c85871',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1765,8,57,29,1,768,-1,'a377b4d185d9f193fa761794b985f89f',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1766,8,57,29,1,768,-1,'9dd708065a3783047be43ef5c3eca060',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1767,8,57,29,1,768,-1,'7332c45ef12ca6cfa7b67ac00fb6e2cb',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1768,8,57,29,1,768,-1,'c123061ff0c4fd484cb803014fb3445c',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1769,8,57,29,1,768,-1,'97c0e4deea6f61eba87ec20fed486088',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1770,8,57,29,1,768,-1,'1f8ee93e8d519a74c0f628297d8cef37',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1771,8,57,29,1,768,-1,'c58d769894dd0bb478951b3bb9d27c3c',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1772,8,57,29,1,768,-1,'540f174ffe1f0341b38b8e499cbefe49',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1773,8,57,29,1,768,-1,'c94b546952e409bdcfe4b609b64917d9',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1774,8,57,29,1,768,-1,'49cb40c70e67b0ba0f5ad05fca5f1f70',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1775,8,57,29,1,768,-1,'694e93698622316be914d564e4ab9ed3',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1776,8,57,29,1,768,-1,'f81201d996580ca2769e1f11d67d66a5',0,'0000-00-00 00:00:00','2016-04-22 19:48:29','2016-04-22 19:48:29'),
(1778,8,57,29,1,1647,-1,'5fa52ba70a51f2f8bbae6cad2f199c68',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-22 19:48:35'),
(1779,8,57,29,1,1647,-1,'9d1365fde6934c7b7f2326611abf701d',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-22 19:48:35'),
(1780,8,57,29,1,1647,-1,'1ab72affc14363439dffa17600429db0',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-22 19:48:35'),
(1781,8,57,29,1,1647,-1,'01285adb34ae9a6932bcae8ffc67515e',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-22 19:48:35'),
(1782,8,57,29,1,1647,-1,'36fab00772358c81673bfaebb68ec293',0,'0000-00-00 00:00:00','2016-04-22 19:48:35','2016-04-22 19:48:35'),
(1784,8,57,29,1,1661,-1,'778aeea86a06dbc96b2b0a44c06de94f',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39'),
(1785,8,57,29,1,1661,-1,'afe60bdc10f20d3aeeda6cfefdcd8102',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39'),
(1786,8,57,29,1,1661,-1,'0f2470b3b2fc55f39d3d84b6187e5538',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39'),
(1787,8,57,29,1,1661,-1,'0f4f2a3f7d68cbff6acae0b1df12304a',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39'),
(1788,8,57,29,1,1661,-1,'0dee06d9954bd2bdaba63a5281aa1d55',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39'),
(1789,8,57,29,1,1661,-1,'d44f5bd7e9afbab829e3ff00a18ac8e1',0,'0000-00-00 00:00:00','2016-04-22 19:48:39','2016-04-22 19:48:39');

INSERT INTO `main_row` (row_id,row_module,row_table,row_ex,row_enable,row_sub,row_user,row_uin,backup_row,backup_date,modified_date,creation_date) VALUES
(1790,1,9,5,1,0,-1,'786ba6cb21038edf946bf794cb6975d5',0,'0000-00-00 00:00:00','2016-04-25 08:49:36','2016-04-25 08:49:36'),
(1791,1,10,5,1,1790,-1,'b112fa7da4f52810b44afdf639e576c4',0,'0000-00-00 00:00:00','2016-04-25 08:49:53','2016-04-25 08:49:53'),
(1792,1,10,5,1,1790,-1,'06c6493f6dc38cd46413ac5786353986',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1793,6,59,60,1,0,-1,'8c55e63a02b63bb263dff41f5b979b66',0,'0000-00-00 00:00:00','2016-04-25 08:55:10','2016-04-25 08:55:10'),
(1795,6,0,0,0,0,0,'',6,'2016-04-25 08:55:30','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1796,6,60,61,1,0,-1,'d8ad7a2310c1d4995ced200e315a95a5',0,'0000-00-00 00:00:00','2016-04-25 09:17:47','2016-04-25 09:17:28'),
(1797,6,0,0,0,0,0,'',6,'2016-04-25 09:17:40','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1798,7,49,50,1,0,-1,'a40d13a0041d1272a0cd73fabdfcea42',0,'0000-00-00 00:00:00','2016-05-10 08:16:42','2016-05-10 08:16:42'),
(1799,10,69,69,1,0,-1,'17f78b115c60fcc3ae380de49737d297',0,'0000-00-00 00:00:00','2016-05-13 13:32:32','2016-05-13 13:32:32'),
(1800,10,69,69,1,0,-1,'05514a6a524d580ebf5c0d52fbe1a357',0,'0000-00-00 00:00:00','2016-05-13 13:32:32','2016-05-13 13:32:32'),
(1801,10,69,69,1,0,-1,'bc37dd8fdbe61abb489b79c0c7f04143',0,'0000-00-00 00:00:00','2016-05-13 13:32:32','2016-05-13 13:32:32'),
(1802,10,69,69,1,0,-1,'6998592c8c9a3461121872344b08c870',0,'0000-00-00 00:00:00','2016-05-13 13:32:32','2016-05-13 13:32:32'),
(1803,10,69,69,1,0,-1,'69fb6dc144ef8cd4516d33c44935db62',0,'0000-00-00 00:00:00','2016-05-13 13:32:32','2016-05-13 13:32:32'),
(1804,10,70,70,1,0,-1,'9473f3f2b8a374599243bcaab9ca4870',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1805,10,70,70,1,0,-1,'b01c1c38e56ab383312b2280ce8156df',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1806,10,70,70,1,0,-1,'9acb29d9e6ef38eb64c35480ea4473c8',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1807,10,70,70,1,0,-1,'cb28a97e76ff05b620241bb69381694f',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1808,10,70,70,1,0,-1,'eec8cdeb54eafdd3331b6a374d5e50f4',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1809,10,70,70,1,0,-1,'17805ecf088f13abd8a56530e73edc05',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1810,10,70,70,1,0,-1,'acfeaefb29719b27734684429dfff5a5',0,'0000-00-00 00:00:00','2016-05-13 13:32:43','2016-05-13 13:32:43'),
(1811,10,67,67,1,0,-1,'8004fba427d80a7c292e5e31a5fa4bea',0,'0000-00-00 00:00:00','2016-05-13 14:02:50','2016-05-13 13:33:59'),
(1812,10,67,67,1,0,-1,'9b81a5a1c1d09bd77b4099e32680c140',0,'0000-00-00 00:00:00','2016-05-13 14:02:50','2016-05-13 13:34:04'),
(1813,10,67,67,1,0,-1,'78deed63475ad037f4c7d8b7ff9deee7',0,'0000-00-00 00:00:00','2016-05-13 14:02:50','2016-05-13 13:34:12'),
(1814,10,68,67,1,1813,-1,'6ce96e216d4742abe52432af734e6d76',0,'0000-00-00 00:00:00','2016-05-13 14:03:39','2016-05-13 13:34:35'),
(1815,10,68,67,1,1813,-1,'8d4e2e9c86288b24d2243dfbb424d01d',0,'0000-00-00 00:00:00','2016-05-13 14:03:51','2016-05-13 13:34:53'),
(1816,1,5,2,1,0,-1,'6c83597a9eda04d9695567245d006679',0,'0000-00-00 00:00:00','2016-05-13 17:27:17','2016-05-13 13:45:16'),
(1817,10,0,0,0,0,0,'',10,'2016-05-13 13:47:55','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1818,10,68,67,1,1812,-1,'d4e5e18b6f9fa4d4e60f42029434d37e',0,'0000-00-00 00:00:00','2016-05-13 14:02:07','2016-05-13 14:02:07'),
(1819,10,68,67,1,1812,-1,'38e14e7ab2b9c37a25f1483ce37d8b65',0,'0000-00-00 00:00:00','2016-05-13 14:02:21','2016-05-13 14:02:21'),
(1820,10,68,67,1,1812,-1,'8e5d28823482a9657b3e0c25a59a5911',0,'0000-00-00 00:00:00','2016-05-13 14:02:40','2016-05-13 14:02:40'),
(1821,10,67,67,1,0,-1,'2a4d7c09a94c47bf4d77335d086a8f1d',0,'0000-00-00 00:00:00','2016-05-13 14:02:57','2016-05-13 14:02:57'),
(1822,10,68,67,1,1821,-1,'e771672bdb91604493006360aeb4a535',0,'0000-00-00 00:00:00','2016-05-13 14:04:10','2016-05-13 14:04:10'),
(1823,10,68,67,1,1821,-1,'6ae7168b52b4d2605389a6289f794b8a',0,'0000-00-00 00:00:00','2016-05-13 14:04:35','2016-05-13 14:04:35'),
(1824,10,68,67,1,1821,-1,'3a551737c340ccb904ddb6cb89aecbad',0,'0000-00-00 00:00:00','2016-05-13 14:04:58','2016-05-13 14:04:58'),
(1825,10,71,71,1,0,0,'d491bbe45317601de416836f66c843f8',0,'0000-00-00 00:00:00','2016-05-13 17:15:24','0000-00-00 00:00:00'),
(1826,10,0,0,0,0,0,'',10,'2016-05-13 17:22:17','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1827,10,0,0,0,0,0,'',10,'2016-05-13 17:26:56','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1828,10,0,0,0,0,0,'',10,'2016-05-13 17:30:12','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1829,5,0,0,0,0,0,'',5,'2016-05-22 12:44:46','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1830,4,0,0,0,0,0,'',4,'2016-05-22 12:44:58','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1831,4,0,0,0,0,0,'',4,'2016-05-26 23:08:09','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1832,4,0,0,0,0,0,'',4,'2016-05-26 23:08:18','0000-00-00 00:00:00','0000-00-00 00:00:00'),
(1833,4,21,17,1,0,-1,'9ba81ef1c4752ece82db4ddcb848d53c',0,'0000-00-00 00:00:00','2016-05-28 20:54:29','0000-00-00 00:00:00'),
(1834,7,72,72,1,0,-1,'a20897bf7249eea2eb46a32087e7a316',0,'0000-00-00 00:00:00','2016-05-31 15:51:37','2016-05-31 15:40:39'),
(1835,7,74,74,1,0,-1,'127201205acfb0680bbf52ed3b9f0ec2',0,'0000-00-00 00:00:00','2016-05-31 16:06:55','2016-05-31 16:06:55');

INSERT INTO `main_table` (table_id,table_name,table_sname,table_uin,table_icon,table_module,table_multy,table_cansub,major_col,table_bold,table_onedit,table_extype,table_counter,table_bottom,table_top,table_parts,table_date,table_date2,table_public) VALUES
(1,'Фото','photo','edb68f41366d30cd29c7703956ecef42','',2,0,1,1,1,'',1,'','[component.img_uploader(table=ctbl, photo=''big_img'', width=cex.param.big_width, height=cex.param.big_height)]','','','0000-00-00 00:00:00','2016-04-20 15:52:37',0),
(2,'Страницы','pages','7d58f8308148b316587ed0c8a5c55866','',0,0,0,23,0,'',0,'','','','a:3:{s:43:"col_onform_6fcc88fd8c44795cc09d41d17a245ff3";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:45:"col_oninsert_0cfe7aa2c23b737c75c342a1425a304b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_0cfe7aa2c23b737c75c342a1425a304b";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','0000-00-00 00:00:00','2016-03-23 19:30:28',0),
(3,'Элемент с фотографией','item','4d98cb6056fc96ace3479f00bf813684','',0,0,0,26,0,'',0,'','','','a:6:{s:43:"col_onform_30010e38ff6d827bd1383f57c78ef0d4";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onshow_7af8a8bc31b2a826377b05346a4693f0";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:45:"col_oninsert_9cc533c73502ead4c49f5ba5a8e623e9";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_9cc533c73502ead4c49f5ba5a8e623e9";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_41ab374afda20cdc3a4dceec9c49f75b";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_41ab374afda20cdc3a4dceec9c49f75b";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','0000-00-00 00:00:00','2016-04-20 15:32:39',0),
(4,'Фото','photo','9d04a0ce5521b54f9481b6eb12844e23','',0,0,0,31,0,'',0,'','[component.img_uploader(photo=''big_img'', width=1100, height=800)]','','a:4:{s:43:"col_onshow_44730f34f2465e50b3ec07f01ed98f8b";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:45:"table_bottom_9d04a0ce5521b54f9481b6eb12844e23";a:1:{i:2;a:1:{s:12:"img_uploader";s:12:"img_uploader";}}s:45:"col_oninsert_ab7f474b05e88a74640516102d2ef4ff";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_ab7f474b05e88a74640516102d2ef4ff";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','0000-00-00 00:00:00','2016-04-20 15:32:19',0),
(5,'Страницы','pages','e0c912fb8f2e56bdbb4ea5a3c33cfa4d','',1,1,1,33,1,'',1,'','','','','0000-00-00 00:00:00','2016-03-30 04:25:40',1),
(6,'Шаблоны','tpl','e2fd3c80ad21855e77b1dd6fe55d6ba8','',0,0,0,36,0,'',0,'','','','a:1:{s:43:"col_onform_7df942532644fe6abf84db1f89cb317a";a:1:{i:3;a:1:{s:7:"meditor";s:7:"meditor";}}}','0000-00-00 00:00:00','2016-03-26 09:32:56',0),
(7,'Шаблоны','tpl','36ae157c31851dbc219e0f46841ac100','',1,0,0,38,0,'',2,'','','','','0000-00-00 00:00:00','2016-02-15 12:39:32',1),
(8,'Позиция блока в шаблоне','block_position','4c263229af2ae369e97f82b454aea33f','',1,0,0,40,2,'',2,'','','','','0000-00-00 00:00:00','2015-10-18 14:57:30',0),
(9,'Группы блоков','block_array','4c3fbb9705b9f50f905300e544817c94','',1,0,0,41,0,'',1,'','','','','0000-00-00 00:00:00','2015-10-18 14:57:12',0),
(10,'Блоки','blocks','8c1a741f8aaaff21dbe075d9429ac029','',1,0,1,43,2,'',1,'','','','','0000-00-00 00:00:00','2015-10-19 13:10:55',0),
(11,'Шаблоны блоков','block_tpl','50c51407766c46db9bffba6c2a80667c','',1,0,0,48,0,'',2,'','','','','0000-00-00 00:00:00','2015-11-02 12:06:21',0),
(12,'Язык','lng','c98ad360938c6c99ce22b83bccf843e0','',1,0,0,60,0,'',2,'','','','','0000-00-00 00:00:00','2015-11-15 18:56:19',0),
(13,'Таблицы стилей','styles','ef19789cf968f2ccf11e6a92feab7993','',1,0,1,66,2,'',2,'','','','','0000-00-00 00:00:00','2015-10-18 17:37:02',0),
(14,'JS-скрипты','scripts','f4d1e9a18776cdff385fd3444e23927f','',1,0,1,64,2,'',2,'','','','','0000-00-00 00:00:00','2015-10-18 17:36:03',0),
(15,'Список','list','fbda196d30f0cc0d3004cdf4b3a772b5','',3,0,0,76,1,'',1,'','','','','0000-00-00 00:00:00','2015-10-21 09:34:48',1),
(16,'Навигация','nav','9b7ddd5d23328efbcb9a2bd0c07fedde','',3,0,0,78,0,'',1,'','','','','0000-00-00 00:00:00','0000-00-00 00:00:00',1),
(17,'Сетка','net','d9940f003572661397b1b1a3437ee1e8','',3,0,0,80,0,'',1,'','','','','0000-00-00 00:00:00','0000-00-00 00:00:00',1),
(18,'Дополнительная навигации','navigations','76b14552bd6eb081fe993d385a410147','',1,0,0,83,0,'',1,'','','','','0000-00-00 00:00:00','2015-10-21 14:27:01',0),
(19,'Элементы навигации','page_links','d2335d9093ea77f6a6430ffe1485c138','',1,0,1,84,2,'',1,'','','','','0000-00-00 00:00:00','2015-10-23 20:31:01',0),
(20,'Изображения для слайдера','images','b42973c3b50d0c4163d6d5690c10ee8d','',1,0,0,86,0,'',1,'','[component.img_uploader(photo=''big_img'', width=cex.param.slider_height, height=cex.param.slider_width)]','','','0000-00-00 00:00:00','2015-10-21 18:04:07',0),
(21,'Статьи','articles','af322fff20d8bd62e142f7cd017379bf','',4,0,1,93,1,'',1,'','','','','0000-00-00 00:00:00','2016-04-20 15:13:21',0),
(22,'Шаблоны ленты','feed_tpl','22cbbd7eaaf88050c125fa3a2011802a','',4,0,0,108,0,'',2,'','','','','0000-00-00 00:00:00','2015-12-09 05:35:03',1),
(23,'Шаблоны статьи','article_tpl','f33e9a11600ff9dbbb693308e7e29df5','',4,0,0,112,0,'',2,'','','','','0000-00-00 00:00:00','2015-10-26 11:50:54',1),
(24,'Категории статей','category','2dc42485253b5a233d9b20fd28c515df','',4,1,0,114,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 19:28:27',0),
(25,'Шаблоны блока статей','block_tpl','a9d637893b71279640f6bc5d72319940','',4,0,0,117,0,'',2,'','','','','0000-00-00 00:00:00','2015-11-02 21:54:52',1),
(26,'Метки','tags','fc2f6f7dfaac9fc265b19e16c0aa3b55','',4,0,0,119,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 19:28:35',0),
(27,'Шаблоны блока меток','block_tag_tpl','fcecf4b931a7f0021cfe04eaf6a94f3b','',4,0,0,123,0,'',2,'','','','','0000-00-00 00:00:00','0000-00-00 00:00:00',0),
(28,'Шаблоны блока категорий','block_cat_tpl','a79388c885f69ad14e31283649dfeca7','',4,0,0,126,0,'',2,'','','','','0000-00-00 00:00:00','0000-00-00 00:00:00',0),
(29,'Комментарии','comments','a389bcb57f482ca0d48bf0718ca7e181','',5,1,1,142,1,'',1,'','','','','0000-00-00 00:00:00','2016-05-22 12:44:01',0),
(30,'Материалы (с фотографией и URL)','materials','58c670c0f597f8ea87fd8579cba7c31b','',0,0,0,160,0,'',0,'','','','a:7:{s:43:"col_onform_cf4c5e3c7c130c2ac1cbfb24dae1b95a";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}s:43:"col_onshow_8cc7283a29021a0facfcd25f18521654";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}s:43:"col_onform_336f8ada1e6c00938721a7a2daa70a9a";a:1:{i:3;a:1:{s:10:"datepicker";s:10:"datepicker";}}s:45:"col_oninsert_6a140690824909be38529bc594cc44b4";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_6a140690824909be38529bc594cc44b4";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:45:"col_oninsert_f6013c03f5ec3ca9d25e3986d8f56f8d";a:1:{i:0;a:1:{s:12:"big_to_small";s:12:"big_to_small";}}s:43:"col_onshow_f6013c03f5ec3ca9d25e3986d8f56f8d";a:1:{i:1;a:1:{s:5:"image";s:5:"image";}}}','0000-00-00 00:00:00','2016-04-20 15:32:54',0),
(31,'Категории фотографий','category','488b8f28cc837042929074b5c40535fc','',2,0,0,165,0,'',1,'','','','','0000-00-00 00:00:00','2016-04-20 15:14:52',0),
(32,'Шаблоны галереи','tpl','a47a85330ecce8e47990795c989ab97a','',2,0,0,172,0,'',2,'','','','','0000-00-00 00:00:00','2015-12-09 05:35:10',0),
(33,'Элемент с URL','url_table','19a2cfe6533c69eefe2e936539d457b4','',0,0,0,174,0,'',0,'','','','a:2:{s:45:"col_oninsert_09011b458d2a77fa0a3a0b42e0edb5d6";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_09011b458d2a77fa0a3a0b42e0edb5d6";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','0000-00-00 00:00:00','2016-05-13 13:10:40',0),
(34,'Метки','tags','ad1977a8a62cde98610e9a54e0eeb815','',2,0,0,176,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 19:29:11',0),
(35,'Категории','category','42e7328dd720e0a9915e1d705ed11518','',6,1,0,187,1,'',1,'','','','','0000-00-00 00:00:00','2016-04-23 16:47:23',1),
(36,'Метки','tags','2555ad4866168f7c0b143040f5617cf9','',6,0,0,193,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 19:29:48',1),
(42,'Единицы измерения','units','8b641c14a4fccccb61543c3dc5141714','',6,0,0,212,2,'',2,'','','','','0000-00-00 00:00:00','2015-12-16 16:16:33',1),
(43,'Товары','items','fd58c8b6fc807cd22bb5889830e3d3f7','',6,1,1,214,2,'',1,'','','','','0000-00-00 00:00:00','2016-04-25 09:01:55',1),
(45,'Формы','forms','19a9201012ce107d1b5cf1753c86d765','',7,0,0,262,1,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 18:38:11',1),
(46,'Типы полей','field_type','fdfb4368a9ae7ffbf5478c8945bd3cec','',7,0,0,249,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 18:38:18',1),
(47,'Действия','action','bd7cf8f8ba0a1f32d2d6fbf93a7bd218','',7,0,0,253,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 18:38:28',1),
(48,'Поля','fields','b84a37ec0f53f729ec23e3043361fe1f','',7,0,1,255,2,'',1,'','','','','0000-00-00 00:00:00','2016-05-09 22:44:51',0),
(49,'Шаблоны','tpl','cd3c78674caf9ba0bb550696dcde8dab','',7,0,0,265,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-05 12:32:20',1),
(50,'Значение полей','values','fe6d078b78dbaafc155c479823dfa25c','',7,0,1,269,2,'',1,'','[component.multy]','[component.multy]','','0000-00-00 00:00:00','2016-03-22 08:33:28',0),
(51,'Шаблон','tpl','d213577ee795003cc5b6f8fb6e739e36','',5,0,0,288,0,'',2,'','','','','0000-00-00 00:00:00','2016-03-23 21:37:10',1),
(52,'Передаваемые файлы','files','e57d020692ef8ea178e01b0a43fe9832','',7,0,0,292,0,'',1,'','','','','0000-00-00 00:00:00','2016-03-23 21:55:06',0),
(53,'Динамические параметры','dparams','ca63faf12ee1e5e4307c20c5ae4f1ac1','',8,0,1,302,2,'',1,'','','','','0000-00-00 00:00:00','2016-04-18 19:05:23',0),
(54,'Элементы','dlist','6b89c15e7daf4b42b8887ad302c162e5','',8,0,1,295,2,'',1,'','[component.multy]','[component.multy]','','0000-00-00 00:00:00','2016-04-17 18:41:32',0),
(55,'Коллекции','dcollection','b2c0f0a3c815b40000d9429fe0d8b566','',8,0,1,296,0,'',1,'','','','','0000-00-00 00:00:00','2016-04-12 08:27:29',0),
(56,'Шаблоны','tpl','8cd00b9802d1506a1cad3c7b401c85d3','',8,0,0,297,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-17 13:25:22',1),
(57,'Значения параметров','dvalues','93642c7aa69cc5d31d3e405ae83bc1ab','',8,0,1,299,2,'',2,'','','','','0000-00-00 00:00:00','2016-04-22 19:43:04',0),
(58,'Типы параметров','dtype','9d7a954fb7c37903d453285292c16d87','',8,0,0,310,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-17 13:25:26',1),
(59,'Шаблоны главной магазина','main_tpl','a9558aca4427e7565cedac1434332c01','',6,0,0,327,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-23 16:44:43',0),
(60,'Шаблоны категории товаров','cat_tpl','80748a9a0a5320a5c4c0eb8e56627a00','',6,0,0,329,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-23 16:45:11',0),
(61,'Шаблоны товара','item_tpl','7939f8373a80effce9545d70b0ad9f6f','',6,0,0,331,0,'',2,'','','','','0000-00-00 00:00:00','2016-04-23 16:45:26',0),
(62,'Метки','tags','3bf6811c935ff1d2c4a9f7008cd54847','',0,0,0,339,0,'',0,'','','','a:2:{s:45:"col_oninsert_2060f6e1b1a77fc081adeea5731b1525";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}s:43:"col_onform_2060f6e1b1a77fc081adeea5731b1525";a:1:{i:3;a:1:{s:3:"url";s:3:"url";}}}','0000-00-00 00:00:00','2016-05-05 08:55:51',0),
(67,'Категории','cat','aa031b531b3a1b57c6d3d7809766b93e','',10,1,0,353,1,'',1,'','','','','0000-00-00 00:00:00','2016-05-13 13:30:17',0),
(68,'Элементы','item','37d903e82b8a9fa092dd4e04f6581693','',10,0,1,355,0,'',1,'','','','','0000-00-00 00:00:00','2016-05-13 13:33:48',0),
(69,'Тип цены','ptype','93214a31e2633878cbf9987de6a73e28','',10,0,0,357,0,'',2,'','[component.multy]','[component.multy]','','0000-00-00 00:00:00','2016-05-13 17:30:20',1),
(70,'Единицы измерения','units','60526f189a3d3be2f491d97e5578647c','',10,0,0,358,0,'',2,'','[component.multy]','[component.multy]','','0000-00-00 00:00:00','2016-05-13 17:30:35',1),
(71,'Шаблоны прайс-листа','tpl','a7aab0c669573a25273f78b5190ec751','',10,0,0,365,0,'',2,'','','','','0000-00-00 00:00:00','2016-05-13 17:30:27',1),
(72,'Шаблоны для авторизации/регистрации','auth_reg_tpl','96b190c298ca819d19b81309046ca94c','',7,0,0,369,0,'',2,'','','','','0000-00-00 00:00:00','2016-05-31 23:47:31',1),
(74,'Собранные формы авторизации/регистрации','combined_auth_reg_forms','164a7fa523e0c600ef8c4de202cd7c01','',7,0,0,375,0,'',1,'','','','','0000-00-00 00:00:00','2016-05-31 23:47:38',1);

INSERT INTO `main_zone` (zone_id,zone_active,zone_domain,zone_email,zone_folder,zone_iprange,zone_robots,zone_safe,zone_tpl,zone_autosub,zone_redirect,zone_module,zone_name) VALUES
(1,1,'','','*admin','','',0,'',0,0,'-1','Control'),
(2,1,'','','update_server','','',0,'',0,0,'-2','Сервер обновлений'),
(3,1,'','','','','',0,'',0,0,'1:1','Demo');

INSERT INTO `part_cat` (cat_id,cat_name,cat_uin,cat_type,cat_owner,cat_pre,cat_after) VALUES
(1,'Картография','8be6dc6e42162e09fb95958cec587b63',1,0,'',''),
(2,'Медиа проигрыватели','af6bcbea1a37d0b66c99b89c113abb5d',1,0,'',''),
(3,'Изображения','667d67199b458deecd0a85ffcb7108ef',1,0,'',''),
(4,'Адаптеры','f649d6f2a0c99877cfd44fd32eccab13',2,0,'',''),
(5,'Слайдеры','49ded7f3748df2d3b4718e57140081fd',2,0,'',''),
(6,'Аккордионы','66aa004df7e167cad062700fa9e6f450',2,0,'',''),
(7,'Навигация','db4676ae8eaa2713fce5bfa2c1fba6c2',2,0,'',''),
(8,'Социальные','0f573d52bee9203d7975ca28ecef5ad9',2,0,'',''),
(9,'Пагинация','de2c61fa14b212bcc499405748121bfa',2,0,'',''),
(10,'Ajax','a820348a25e1446c5662ace594faebeb',2,0,'',''),
(11,'Блоки','ae48137a057f31756a750e329ca9e84e',2,0,'',''),
(12,'Элементы HTML','ad1f29225fb8c5728a2a419d7dcd3df7',2,0,'',''),
(13,'Работа с текстом','44dbb3d0dc5b8b800a62330ee2866dd0',0,0,'',''),
(14,'Динамические формы','de575eab23296f1c167b6c7167491ff2',2,0,'',''),
(15,'Капчи','cd04f9252fc25e56ec72e5f4e8d692f1',2,0,'',''),
(16,'Разное','4e7168dfe699bf3ba221658a86d9bb4c',3,0,'',''),
(17,'Текст','ad499fad28abf455f85d4bc02d3e356e',3,0,'',''),
(19,'Работа с изображениями','d33aa6970c0c611640e597bf60b52bee',0,0,'',''),
(20,'Системные','813c33cc08e6c9d1bb9443b37778b7a1',0,0,'',''),
(21,'Шрифты','461d457f294bfc5a464125c799a58710',2,0,'',''),
(22,'Текст','d67841151f9d94c759d8ad3056c8a3fb',1,0,'',''),
(23,'Список','73b4e227379a15f4dc12e63c6f333bbd',3,0,'',''),
(24,'Для администрирования','ef1fb3f07bdf0a910c1da6818b306137',1,0,'',''),
(25,'Код','9a7a9bdd853f7d1e0128b21debcc1ec4',1,0,'',''),
(26,'Дата','a7ba8a3a16ece317e490ca9afd0cb4b9',1,0,'',''),
(27,'Работа с объектами','b6d6a180a5f1ed0b3b92361de5f782fd',0,0,'','');

INSERT INTO `part_param` (param_id,param_part,param_name,param_sname,param_uin,param_default,param_array,param_type,param_list,param_link,param_get,param_connect,param_hide) VALUES
(1,1,'Адрес','address','4ab744b8f8e718c4a474630f97bed320','',0,0,'',0,0,0,0),
(2,1,'Ширина окна','width','ac3f3fdb32948f22d98d623f62186258','425',0,0,'',0,0,0,0),
(3,1,'Высота окна','height','5eaee6539412b27824d8f6872cea743c','350',0,0,'',0,0,0,0),
(4,2,'Путь до аудиофайла','src','22f8691cbde750d1c9d9045462fc98ea','',0,0,'',0,0,0,0),
(5,3,'Версия','version','e8574feef563089fb8df85d878b37de1','1',0,1,'1.3.2=1.3.2\r\n1.4.1=1.4.1\r\n1.4.2=1.4.2\r\n1.4.3=1.4.3\r\n1.5.2=1.5.2',1,0,0,0),
(6,4,'Версия','version','a37c62c4846fac5e0ba0b82a3ac3078e','1',0,1,'1.7.2=1.7.2',1,0,0,0),
(7,5,'Фотографии','rows','0af1f90d05b556a656bd4c56f0e3c442','',0,6,'',0,0,0,0),
(8,5,'Поле для изображения','photo','5a302cea6c83b0953968e5a3c306ba73','img',0,7,'',0,0,0,0),
(9,5,'Поле для заголовка','title','1b34845a14e7fadf59f511494940e904','',0,7,'',0,0,0,0),
(10,5,'Поле для ссылки','url','d0db3f0c80dd66d10c9c1b51c1d39bf2','',0,7,'',1,0,0,0),
(11,5,'Ширина','width','24e5d885536061563c3e5f1d64a95971','400',0,0,'',1,0,0,0),
(12,5,'Высота','height','e4cd744210cb48d7cf5ab33ed31669d3','128',0,0,'',1,0,0,0),
(13,5,'Время переключения (в секундах)','time','bb5ff2c37b80c79b7757b081698ec204','3',0,0,'',1,0,0,0),
(14,7,'Ширина','width','9d28f6a0f34907cc3a20a0250a08e9e2','150',0,0,'',1,0,0,0),
(15,7,'Высота','height','9f42c842f130270089e6b37a10ba6870','',0,0,'',1,0,0,0),
(16,7,'Полное изображение','image_big','fcb918ae42ca9c391fdc788128aa4d0a','',0,0,'',1,0,0,0),
(19,8,'Миниатюра','small','540fad6779dceac569e1799786cf6d4d','',0,0,'',1,0,0,0),
(20,8,'Большое изображение','big','900fc071a4d7b951f3757eb1b2458dd1','',0,0,'',1,0,0,0),
(21,8,'Позиция','position','e4e502de9043210d00c2db616bbc8e8a','',0,1,'Слева=left\r\nСправа=right\r\nСверху=top\r\nСнизу=bottom',1,0,0,0),
(22,8,'Класс изображения','class','96cb69958df2a31d9e3cfda96b43dedd','',0,0,'',1,0,0,0),
(23,8,'Стили изображения','style','ecc306f473e1f6d7801504698745ace0','',0,0,'',1,0,0,0),
(24,8,'Перекрыть высоту миниатюры','height','ab5a67242ba457dd940d7120527472c6','',0,0,'',1,0,0,0),
(25,8,'Перекрыть ширину миниатюры','width','ec1d7c78ce13f9088eab1b8e5e011dfd','',0,0,'',1,0,0,0),
(26,8,'Ширина zoom-окна','width2','bb3dcb575ed3f829cb03320dea38c246','auto',0,0,'',1,0,0,0),
(27,8,'Перекрыть ширину большого изображения','width3','c09496da81ceb6f07e799caf73937de3','',0,0,'',1,0,0,0),
(28,9,'Большое изображение','big','e79a3684e9e7e3968ba48e77ffae44f2','',0,0,'',1,0,0,0),
(29,9,'Миниатюра','small','fa7becca63fa40f4ad499d98f6d4657a','',0,0,'',1,0,0,0),
(30,9,'Имя группы изображений','name','0a5b043e54a6bea1cf305a6a637307f0','group1',0,0,'',1,0,0,0),
(31,9,'Название','title','706ab7c0e98bbba9ea77e5c03f4026dc','',0,0,'',1,0,0,0),
(32,9,'Высота миниатюры','height','ec5acabec53ff7348163c669f3dd1f2b','',0,0,'',1,0,0,0),
(33,9,'Ширина миниатюры','width','14ad58a2a5b5e23fae8faf74c16d83c7','',0,0,'',1,0,0,0),
(34,10,'Поле изображения','photo','2938a9782bda18d71f3ce4965c72c35d','photo',0,7,'',1,0,0,0),
(35,10,'Фотографии','rows','1191d05923cf45ea521c870e0bc932f9','',0,6,'',1,0,0,0),
(36,10,'Поле заголовка','title','31b624f847d5ef2e19cacd95b0c9e677','',0,7,'',1,0,0,0),
(37,11,'Значение зума в процентах','zoom','34f7df556857a259f995cacc8ccf1924','150',0,0,'',1,0,0,0),
(38,11,'Большое изображение','img_big','63a45d40837d75a2bfcdabc7a9f347e3','',0,0,'',1,0,0,0),
(39,11,'Маленькое изображение','img','4ac9631b0d8774fae444797d5d53d7a1','',0,0,'',1,0,0,0),
(40,12,'Фотографии','rows','3bcbf295058f06977b7c1aa2e2b39f4e','',0,6,'',1,0,0,0),
(41,12,'Поле с изображением','photo','1968c3a930ce800e0e97be2d4bdf8271','img',0,7,'',1,0,0,0),
(42,12,'Высота','height','67a3027a4ce559db6e647f40658bb977','200',0,0,'',1,0,0,0),
(43,12,'Ширина','width','fc6a97d4862f7c9b27df528a6bdf4f6d','600',0,0,'',1,0,0,0),
(44,7,'Изображение','image','917f79cea7ea100039c1069e5708ae25','',0,0,'',1,0,0,0),
(45,13,'Слайды','rows','15c769e33f9290f2687253674c569eee','',0,6,'',1,0,0,0),
(46,13,'Поле текста','data','9f61b1439068ad01831c77f007227aa2','body',0,7,'',1,0,0,0),
(47,13,'Интервал смены слайда (в секундах)','time','e50279cb0eb5d875dcfb49e3641e25a5','5',0,0,'',1,0,0,0),
(48,13,'Ширина','width','7d934417cf3f8923b8ef0512e00e6574','',0,0,'',1,0,0,0),
(49,3,'Загружать из Google CDN','remote','64d588e5d6502800e20fc40133602361','',0,4,'',1,0,0,0),
(50,4,'Загружать из Google CDN','remote','89eb64eecc846148bf3946d7e405e0ef','',0,4,'',1,0,0,0),
(51,14,'Иконки','rows','809081cbc9031857f5230e6478685beb','',0,6,'',1,0,0,0),
(52,14,'Поле с иконкой','img','170bcdbcc36a5d924477669aa13666c1','img',0,7,'',1,0,0,0),
(53,14,'Поле с заголовком','title','b269a2c2ea7d23c762a865161fb0f529','title',0,7,'',1,0,0,0),
(54,14,'Положение текста','talign','1509f033383c1cae08062e30fd3ae507','top',0,1,'вверху=top\r\nвнизу=bottom',1,0,0,0),
(55,14,'Поле с ссылкой','url','d8e5f2d7f4c2bfe49f17834210e6e42b','url',0,7,'',1,0,0,0),
(56,14,'Префикс URL','url_prefix','415927c54c1d625c3ff27217c7206652','',0,0,'',1,0,0,0),
(57,14,'Максимальная ширина иконки','maxwidth','efb82a8a59aad9f5ad58fb72eba32520','50',0,0,'',1,0,0,0),
(58,14,'Минимальная ширина иконки','minwidth','3e02baf3fc2a040f038b8a0f4dd9700a','40',0,0,'',1,0,0,0),
(59,14,'Выравнивание элементов по ширине','align','cd817f805affe5ca941a1873163fa1ed','center',0,1,'левый край=left\r\nсередина=center\r\nправый край=right',1,0,0,0),
(60,14,'Выравнивание по высоте','valign','2c1144284712f0ff7f0924a5fa545b59','bottom',0,1,'верх=top\r\nсередина=middle\r\nниз=bottom',1,0,0,0),
(61,5,'Префикс URL','url_prefix','0af9e1f5a1d2b5cf2676ff6763f4b8ce','',0,0,'',1,0,0,0),
(62,15,'Вид кнопок','theme','32a2006580550278ef5c3ae1c0d776e4','counter',0,1,'С счётчиками=small\r\nТолько иконки=none',1,0,0,0),
(63,15,'Вконтакте','vk','b9d3963e759c40a82d43c264fad08c60','',0,4,'',1,0,0,0),
(64,15,'Одноклассники','ok','4e1d9966445fe2c38b36614a69168475','',0,4,'',1,0,0,0),
(65,15,'Живой журнал','lj','69777e002578ac0461e671ff65179271','',0,4,'',1,0,0,0),
(66,15,'Facebook','fb','2b2acb012cc79e7fe30935333fc36677','',0,4,'',1,0,0,0),
(67,15,'Twitter','tw','bceda0949107b71239e658ecc1da88c2','',0,4,'',1,0,0,0),
(68,15,'Google Plus','gp','c11044e2c48c58459340ff8298111903','',0,4,'',1,0,0,0),
(69,15,'Мой Мир','mm','2469eb4ab65604789899cac7a51106da','',0,4,'',1,0,0,0),
(70,16,'Номер сайта (необходимо зарегистрировать сайт тут http://vk.com/dev/Like, номер брать из параметра apiId в коде)','id','9f54717a986ba140087068086c8ad2ab','',0,0,'',1,0,0,0),
(71,16,'Вид кнопки','type','b1d0f2a7fb4fbcd85f159581ec31ff2d','button',0,1,'Кнопка с миниатюрным счётчиком=button\r\nКнопка с текстовым счётчиком=full\r\nМиниатюрная кнопка=mini\r\nМиниатюрная кнопка, счётчик сверху=vertical',1,0,0,0),
(72,17,'Режим','mode','1776f857246efd12031e91caac87f915','0',0,1,'Участники=0\r\nНовости=2\r\nТолько название=1',1,0,0,0),
(73,17,'ID сообщества','id','2c90bd457ad566ac06ccab2d00c03551','',0,0,'',1,0,0,0),
(74,17,'Ширина','width','913031dbff09a348cdf93bc8ab6496df','220',0,0,'',1,0,0,0),
(75,17,'Высота','height','329dd510097681f8a4526ce44a19a8d9','400',0,0,'',1,0,0,0),
(76,17,'Цвет фона','background','eed8c0d28a94cee643dbc4c6149ca0ac','FFFFFF',0,0,'',1,0,0,0),
(77,17,'Цвет текста','font','c8500fb8aa2f3f6272b8ba5682572ff7','2B587A',0,0,'',1,0,0,0),
(78,17,'Цвет кнопок','buttons','f7bcfe8b5cdf35128de87e7120abea40','5B7FA6',0,0,'',1,0,0,0),
(79,18,'Номер сайта (необходимо зарегистрировать сайт тут http://vk.com/dev/Comments, номер брать из параметра apiId в коде)','id','5935d01723e323b2f740a8a7a3eafcd9','',0,0,'',1,0,0,0),
(80,18,'Ширина','width','1619a97d3cad6571bffde00ecbb86c30','665',0,0,'',1,0,0,0),
(81,18,'Количество комментариев','limit','e60808eea4357e9b034f98e4d352b168','5',0,1,'5=5\r\n10=10\r\n15=15\r\n20=20',1,0,0,0),
(82,19,'Количество элементов','count','14ea6dbce437ce5f82dc37e052e12ff4','',0,0,'',1,0,0,0),
(83,19,'Элементов на странице','num','d7d36a533b5f98d31d8c55ccb7c696b3','10',0,0,'',1,0,0,0),
(84,19,'Текущая страница','page','0d516647a3c5ecec7b32d7722f3e0612','',0,0,'',1,1,0,1),
(85,21,'Таблица','table','5a877effd4ec58426b457581ba8ebffb','',0,8,'',1,0,0,0),
(86,21,'Элементов на странице','num','8682ca800689a98dfae414c1e4705048','',0,0,'',1,0,0,0),
(87,21,'Текущая страница','page','232a6a91b26784207ead9b8981f2e77b','0',0,0,'',1,1,0,1),
(88,22,'Объект','row','8c1b901f224a087d38fdc04b4ee2a79b','',0,5,'',1,0,0,0),
(89,22,'Поле','col','294309d2611af776c07b9acb9b33515f','',0,7,'',1,0,0,0),
(90,22,'Значение','value','950c5c8f6ae6a4dccc8f3d088a101603','',0,0,'',1,0,0,0),
(91,24,'Элементы','rows','3f0cbf32dfd7acb0ddaf5bff4b3223c4','',0,6,'',1,0,0,0),
(92,24,'Тема','theme','49278ffd148c490c58026a558f7280a5','light',0,1,'светлая=light\r\nтёмная=dark',1,0,0,0),
(93,24,'Заголовок','title','687b49eb13eb7d9d565554bcf3f86db3','',0,0,'',1,0,0,0),
(94,24,'Ссылка заголовка','title_href','7a62a2c5a552c078a6a38b6872da82bc','/',0,0,'',1,0,0,0),
(95,24,'Префикс URL','url_prefix','d0d8eda7438dd983595f8cb715b94496','/',0,0,'',1,0,0,0),
(96,24,'Поле для заголовка','name','55e168709698c123b917d05de2e729ce','title',0,7,'',1,0,0,0),
(97,24,'Поле для ссылки','url','dcfb529c6efad187c2196169a4c8511e','url',0,7,'',1,0,0,0),
(98,25,'Заголовок','title','6c7393c57a9176020ec8eaf64c329b5f','',0,0,'',1,0,0,0),
(99,25,'Текст','body','868d4cd71753a9d96aeb1ec568e7c5e9','',0,0,'',1,0,0,0),
(100,25,'Тема','theme','93af35341b51b062f8a519a5905602ed','default',0,1,'Серый (обычный)=default\r\nСиний (основной)=primary\r\nЗелёный (успех)=success\r\nГолубой (информационный)=info\r\nОранжевый (предупреждение)=warning\r\nКрасный (опасность)=danger',1,0,0,0),
(101,26,'Прозрачный фон','nobg','08e38750a076398956d96851b7bca329','1',0,4,'',1,0,0,0),
(102,26,'Поле даты','date','427803c5e0bf1a0268a2f6b6463ebadf','date',0,7,'',1,0,0,0),
(103,26,'Таблица данных','table','4d62c044f06de1195d63a0220106d1cf','',0,8,'',1,0,0,0),
(104,27,'Заголовок','title','ddf798b35f2d4a77f12ba8d4631a2141','',0,0,'',1,0,0,0),
(105,27,'Файлы стилей CSS','css','51108084bf06d61bbcee49cc4aaad5f3','',1,0,'',1,0,0,0),
(106,27,'Файлы JS скриптов','js','81919f201fcc52a413c3f051862ce237','',1,0,'',1,0,0,0),
(107,27,'Meta-Keywords','keywords','86fce98b3765b9ba89e60916a72e3aef','',0,0,'',1,0,0,0),
(108,27,'Meta-Description','description','d06309bc11c224c61a9dab980ec2778d','',0,0,'',1,0,0,0),
(109,27,'Иконка','favicon','2cff1aa78bef67eb37560c69fa9d3ab9','',0,0,'',1,0,0,0),
(110,28,'Массив объектов','rows','82607a1ab7dc7484b945fa20072fcd35','',0,6,'',1,0,0,0),
(111,28,'Начальный шаг/уровень важности','base_step','1e31b789b4f3f2be80fba9f6a7f8729b','8',0,0,'',1,0,0,0),
(112,28,'Префикс URL','base_url','27447ec60d63d804885a4dda24ed4fb5','',0,0,'',1,0,0,0),
(113,30,'Изображения','rows','091b0a4734535f007bc0d9bbee37227e','',0,6,'',1,0,0,0),
(114,30,'Поле для изображения','img','be407812811ff9fc7f324097d0fc046d','img',0,7,'',1,0,0,0),
(115,30,'Поле для подсказки','title','0017c39268ac1a03aabf2a79f72dfa45','title',0,7,'',1,0,0,0),
(116,31,'Строки','rows','0e2dfe0319e0a3d037de2c06a250f84b','',0,6,'',1,0,0,0),
(117,31,'Оформление','theme','bf08e423c40748d10f6ca2aea6948810','table-striped',0,1,'Обычная=\r\nС бордюром=table-bordered\r\nС подсветкой=table-striped\r\nСжатая=table-condensed',1,0,0,0),
(118,31,'Показывать номер','show_number','24476bcdb4ede67f51765a1683873d35','',0,4,'',1,0,0,0),
(119,31,'Столбцы','cols','dc7853afd4ad78e6bbdd6f2ceec4fce5','',1,7,'',1,0,0,0),
(120,32,'Объекты','rows','9d0272ca2991fcaa184bee6d0393cb30','',0,6,'',1,0,0,0),
(121,32,'Заголовок','title','dc1d6e60d0d34603fc639c9982308a1c','',0,0,'',1,0,0,0),
(122,32,'Описание','description','9cc365a9023d38321bf957645693ffcc','',0,0,'',1,0,0,0),
(123,32,'Поле с фотографией','item_photo','d27451e359e1b2cfe478ac76c17f7597','',0,7,'',1,0,0,0),
(124,32,'Поле для заголовка','item_title','74b87f9e742252330045e0ef433a05ba','',0,7,'',1,0,0,0),
(125,32,'Поле для ссылки','item_link','d03d1f2c3fb6ac3ea3839c793876944c','',0,7,'',1,0,0,0),
(126,32,'Поле с описанием','item_desc','bd3996fe5ccb9bac01ac662000d1bd12','',0,7,'',1,0,0,0),
(127,32,'Поле с датой','item_date','b2885d10404fe6106cde00b13d80ae40','',0,7,'',1,0,0,0),
(128,33,'Исходный текст','src','ae87ddc41f2fa7107b33c9bd3a5e20b6','',0,0,'',1,0,0,0),
(129,33,'Длина анонса','length','7ce29b1ad513b15353fce6ff3d13e734','',0,0,'',1,0,0,0),
(130,34,'Таблица-приёмник','table','bbd0a340f708c041786bfc5efe4a3cf0','',0,8,'',1,0,0,0),
(131,34,'Поле для фотографии','photo','e77459411596d7a243683e76c7ed46d6','photo',0,7,'',1,0,0,0),
(132,34,'Ширина сжимания (на клиенте)','width','1f28027cc4ad29d407cafb0b5792c238','1100',0,0,'',1,0,0,0),
(133,34,'Высота сжимания (на клиенте)','height','5cfefb551fbdd3760e34c59b8bbfd5f3','800',0,0,'',1,0,0,0),
(134,36,'Тип','type','ebef1778845bab0719c2a72587e19b24','form',0,1,'Элемент формы=form\r\nПроверка=check',1,0,0,0),
(135,35,'Таблица-приёмник','table','9ed2ab8309c163627cf96af541acfeb2','',0,8,'',1,0,0,0),
(136,35,'Поля','cols','e7a40cd10aef11731e52641019f1f316','',1,7,'',1,0,0,0),
(137,35,'Кнопка сброса','reset','8dd39609678b7969b18077aa4755c040','',0,4,'',1,0,0,0),
(138,35,'Требовать капчу','capcha','b07bbed05ff7c15b98d9f7ef825be5df','',0,4,'',1,0,0,0),
(139,35,'Изменяемый объект (для сохранения, иначе будет выполнено добавление)','row','e756ef87c6dfeed6e19e6040e9ac463f','',0,5,'',1,0,0,0),
(140,37,'Адрес получателя','email','67d6a98984f887fd1b798ffec0742417','',0,0,'',1,0,0,0),
(141,37,'Текст кнопки Отправить','submit','dfcf862d5161dc8e40e51c2de3e6fd21','Отправить письмо',0,0,'',1,0,0,0),
(142,37,'Не уведомлять с какого URL пришло письмо','silent','c1d62cd983f71050648c9327c3c2f313','',0,4,'',1,0,0,0),
(143,37,'Текст по умолчанию','text','621906048a1b0bfb4eea524e4b532634','',0,0,'',1,0,0,0),
(144,32,'Язык','lang','f9eeffdf77743dc61d96c600f4ea5365','ru-ru',0,0,'',1,0,0,0),
(145,38,'Тип','type','1327f5e2a8d4a8e485713cb6854ce563','button',0,1,'Кнопка=button\r\nSubmit=submit',1,0,0,0),
(146,38,'Заголовок','title','a05aac433cc6480a5aa02c82b8dbfd66','',0,0,'',1,0,0,0),
(147,38,'Размер','size','6f1428261932ee3f34a034b945d8de8f','btn-lg',0,1,'Большая=btn-lg\r\nОбычная= \r\nМаленькая=btn-sm\r\nКрохотная=btn-xs',1,0,0,0),
(148,38,'Действие на щелчёк','on_click','eb519a25da5e7005a4c17467e4421ac5','',0,0,'',1,0,0,0),
(149,38,'Вид','class','d7086fdfe7259c7f3cb97b5a002111f9','btn-default',0,1,'по умолчанию=btn-default\r\nглавная=btn-primary\r\nуспех=btn-success\r\nинформация=btn-info\r\nпредупреждение=btn-warning\r\nопасность=btn-danger\r\nссылка=btn-link',1,0,0,0),
(150,39,'Большое изображение','big','821e6cf82e1944f60e94bcdff8ed7ec3','',0,0,'',1,0,0,0),
(151,39,'Миниатюра','small','965464cccfbf8240cb6154910f5870dd','',0,0,'',1,0,0,0),
(152,39,'Ширина миниатюры','width','372eed8b6f07240bd6848f81cd9e49b2','',0,0,'',1,0,0,0),
(153,39,'Высота миниатюры','height','f81e6675a171ca4a78cd2dba7dd50f61','',0,0,'',1,0,0,0),
(154,39,'Группа изображений','name','b93b2b196593519521d108bdfe020c10','images',0,0,'',1,0,0,0),
(155,39,'Название изображения','title','2a5595a79ccf231c2bd73b8c716d4d36','',0,0,'',1,0,0,0),
(156,39,'Текст ссылки (вместо миниатюры)','text','4cb2bb38f99d8c05deb7b05820706c40','',0,0,'',1,0,0,0),
(157,40,'Источник','src','cac50fdcfc67bc126db1baa6a88f15b5','',0,7,'',1,0,0,0),
(158,40,'Значение','value','bc3b40599f17e5f32cdbe6b48043cfef','',0,0,'',1,0,0,0),
(159,41,'Источник','src','d7445d4ee9fbbe231a6d67e5c06145f2','',0,7,'',1,0,0,0),
(160,41,'Значение','value','75fa0e50354dca7451bc5819a7f45544','',0,0,'',1,0,0,0),
(161,41,'Высота','height','86346317f75c1600e400e9c8e0f26a0d','300px',0,0,'',1,0,0,0),
(162,41,'Ширина','width','341337f867029d6f8556444b740cea9e','',0,0,'',1,0,0,0),
(163,42,'Источник','src','d2a6d8a95e6b53bd65e3ff7b2098c67a','',0,7,'',1,0,0,0),
(164,42,'Значение','value','bd27cc33203d1be3d9679b737a8c5648','',0,0,'',1,0,0,0),
(165,43,'Таблица-приёмник','table','672e6f1653f562ac619962cb297ca209','',0,8,'',1,0,0,1),
(166,44,'Источник','src','57c60759d54fcfe5560d941172890580','',0,7,'',1,0,0,0),
(167,44,'Поле для автоперевода (получает латинизированное содержимое поля)','trans','5a09253de03ae81c2b62856ec81f9aea','',0,7,'',1,0,0,0),
(168,45,'Источник','src','bbf674b80820c6b50ed54512ea0b0496','',0,7,'',1,0,0,0),
(169,45,'Значение','value','8f69be653b40a051a0177ef0726a3655','',0,0,'',1,0,0,0),
(170,45,'Массив тегов (в теге название от кода отделять знаком |)','tags','dfa0ada765a13e8ac4866796822710d2','',1,0,'',1,0,0,0),
(171,45,'Высота','height','28edacf7084d547f93eceb60d4fd51ea','400px',0,0,'',1,0,0,0),
(172,45,'Ширина','width','dc6bcc9226d2edc6c001e36c5d01fb50','',0,0,'',1,0,0,0),
(173,46,'Источник','src','9cbbb64bcc524b427fa3bd870cb96144','',0,7,'',1,0,0,0),
(174,46,'Имя поля','name','60e12244ef5477fd134513ba6f203d4f','',0,0,'',1,0,0,0),
(175,46,'Значение поля','value','bf49de2cbb13f2811127a0437dc0d2c7','',0,0,'',1,0,0,0),
(176,46,'Настройка','config','e276967e7c7dd77c4af3ed0f694df2c1','',0,0,'',1,0,0,0),
(177,48,'Источник','src','855884cd571f79a2de0d5ec8008cb15f','',0,7,'',1,0,0,0),
(178,48,'Приёмник (не указывайте для сохранения в источнике)','dst','c25caaec9afceb4d46e7fc98ccfb1384','',0,7,'',1,0,0,0),
(179,48,'Высота','height','879c46b6efc00fca968d1abd58cc00b5','800',0,0,'',1,0,0,0),
(180,48,'Ширина','width','9df122f49742f57c2294b7d0253daf74','1100',0,0,'',1,0,0,0),
(181,48,'Тип сжатия','type','2833aff1c8580ef719555fbd4b3a5ed3','6',0,1,'Подгонять по ширине=1\r\nПодгонять по высоте=2\r\nПодгонять по ширине и высоте=3\r\nПодгонять по ширине (обрезать по высоте)=4\r\nПодгонять по высоте (обрезать по ширине)=5\r\nВписать в квадрат=6',1,0,0,0),
(182,48,'Тип обрезки','crop','04fabb3e63c35c3ab981b5eb7213afc3','2',0,1,'Верх/Лево=1\r\nСередина=2\r\nНиз/Право=3',1,0,0,0),
(183,49,'Водяной знак (PNG)','watermark','7b4d000da07fcca5102b5c8b043116cb','',0,0,'',1,0,0,0),
(184,49,'Изображение','img','9c63106ccce6e1384da6359a1b2435ab','',0,0,'',1,0,0,0),
(185,49,'Прозрачность (в процентах)','transparent','6e1f8b2b424c230feb172ac4584c563a','50',0,0,'',1,0,0,0),
(186,49,'Тип наложения','position','7284e41dcc7f82b10a4b88063afac37e','tile',0,1,'Замостить=tile\r\nВнизу справа=bottom right\r\nВнизу слева=bottom left\r\nВнизу посередине=bottom center',1,0,0,0),
(187,22,'Вернуть JQuery.Ajax','jq','9c29d780c857573738643635326d289d','1',0,4,'',1,0,0,0),
(188,22,'JS скрипт, вызываемый после завершения операции','done','76ffea1d1f9b8593fb9fa3d93e232368','',0,0,'',1,0,0,0),
(189,51,'Получатель','to','fe71aec6fb5766a53ad3bc11233c822a','',0,0,'',1,0,0,0),
(190,51,'Отправитель','from','fb8540edaa76ced7e362a2fdba1bdc3e','',0,0,'',1,0,0,0),
(191,51,'Тема','subject','aabd366d58453bd0d94bae1cf69d3414','',0,0,'',1,0,0,0),
(192,51,'Сообщение','msg','3550f4fe1292c8a376a045b6b07f95f0','',0,0,'',1,0,0,0),
(193,52,'Содержимое заголовка','content','41a2614c9706088311f64e639188a9e9','',0,1,'Ошибка 404=HTTP/1.0 404 Not Found\r\nHTTP 1.0=HTTP/1.0\r\nCSS=Content-Type: text/css\r\nJS=Content-Type: text/javascript',1,0,0,0),
(194,53,'Источник','src','1ed5d9fe347369604de92375bd316655','',0,7,'',1,0,0,0),
(195,50,'Источник','src','f55e4d99f52ceec2c775ac3b36c5f3e8','',0,7,'',1,0,0,0),
(196,50,'Приёмник','dst','92d520fca335ca38a0a98a372fd2f892','',0,7,'',1,0,0,0),
(197,53,'Таблица текущего объекта (определённого через URL)','table','30605c7807ed26228f45851dab5c6f4e','',0,8,'',5,0,0,0),
(198,55,'Прилегание','align','beca0def37327fcd08b0ffbddb1d7d68','',0,2,'',8,0,0,0),
(199,53,'Таблица текущего объекта цикла','cur_table','f6cca434a59bcdf27ddb66c59eef198c','',0,8,'',5,0,0,0),
(200,56,'Источник','src','2022a69697b47b85ec63deba115a597b','',0,7,'',5,0,0,0),
(201,57,'Источник','src','60cb218aa67c28711a6e57c693770c49','',0,7,'',5,0,0,0),
(202,59,'Тип','type','8259684e699437521568782a23d99874','h1',0,1,'Для Title=title\r\nДля H1=h1',5,0,0,0),
(203,27,'Папка с файлами CSS','css_prefix','0b811b334104834ae3e4d2a015872fee','',0,0,'',5,0,0,0),
(204,27,'Папка с файлами JS','js_prefix','5b5566eb0968f43e68a215a31c2705cb','',0,0,'',5,0,0,0),
(205,53,'Значение по умолчанию','default','65fe07cd58ece92334d85960adbf0d0f','',0,0,'',5,0,0,0),
(206,64,'Шаблон','tpl','4343f84121ceec8524ca9a8757026daa','',0,2,'',16,0,0,0),
(207,64,'Элементы','rows','37f4d481c9c9f97fd281b0954bec39c3','',0,6,'',5,0,0,0),
(208,63,'Шаблон','tpl','44208deb0883fd3e364b4dc68fd0169d','',0,2,'',15,0,0,0),
(209,63,'Элементы','rows','7bee5cb14ebba5998e238c584a0b09e6','',0,6,'',5,0,0,0),
(210,65,'Шаблон','tpl','07d606950f93e3bb89bf5036db1ceddf','',0,2,'',17,0,0,0),
(211,65,'Элементы','rows','0e4120ccfe8708e8e66a6951e6271a75','',0,6,'',5,0,0,0),
(212,63,'Поле для изображения','img','74a40a97c198088da4b4e8b503cae29e','',0,7,'',5,0,0,0),
(213,65,'Поле для изображения','img','ca7fd7698ec9de237f1300c84757d22d','',0,7,'',5,0,0,0),
(215,63,'Название ссылки "Подробнее"','link','b4800727ad04bd1c9da3c234b8b6fbff','',0,0,'',5,0,0,0),
(216,53,'Текущая часть','cur_part','11eb306c00c374a00ea52a2ced6556e3','',0,10,'',5,0,0,0),
(217,63,'Префикс ссылок','url_prefix','cf193401484d8500a06d87e46d6db245','',0,0,'',5,0,0,0),
(218,63,'Поле с текстом','body','5cc3142a2d23f6a2d3029b03cc9a0594','',0,7,'',5,0,0,0),
(219,7,'Выравнивание','align','0f477d0f9e29991f6fcb7a17ed5edfa7','',0,1,'нет=\r\nабсолютная центровка=absmiddle\r\nцентровка=middle\r\nслева=left\r\nсправа=right\r\nснизу=bottom\r\nсверху=top',5,0,0,0),
(220,30,'Поле для текста','body','4febaf6a4d46c5494a53487716bef342','',0,7,'',5,0,0,0),
(221,66,'Название ссылки "Домой"','home','9c711cc703e4bbeabfb8022ef0f35b57','Домой',0,0,'',5,0,0,0),
(226,66,'Адрес ссылки "Домой"','home_link','3170eb6985d225b173c681845aa6be7b','',0,0,'',5,0,0,0),
(227,67,'Иконка','icon','e649a568da5083dbd427dd22af740810','',0,1,'Снежинка=asterisk\r\nПлюс=plus\r\nЕвро=euro\r\nМинус=minus\r\nОблако=cloud\r\nПисьмо=envelope\r\nКарандаш=pencil\r\nСтакан=glass\r\nНота=music\r\nЛупа=search\r\nСердце=heart\r\nЗвезда заполенная=star\r\nЗвезда пустая=star-empty\r\nПользователь=user\r\nФильм=film\r\nЯчейки крупные=th-large\r\nЯчейки мелкие=th\r\nЯчейки со списком=th-list\r\nОк=ok\r\nОтмена=remove\r\nПриблизить=zoom-in\r\nОтдалить=zoom-out\r\nВыключить=off\r\nСигнал WiFi=signal\r\nНастройка=cog\r\nКорзина=trash\r\nДом=home\r\nФайл=file\r\nЧасы=time\r\nДорога=road\r\nСкачать (альтернативная)=download-alt\r\nСкачать=download\r\nЗагрузить на сервер=upload\r\nВходящие=inbox\r\nНачать проигрывать=play-circle\r\nПовтор=repeat\r\nОбновить=refresh\r\nСписок (альтернативный)=list-alt\r\nЗамок=lock\r\nФлаг=flag\r\nНаушники=headphones\r\nЗвук выключен=volume-off\r\nЗвук тише=volume-down\r\nЗвук громче=volume-up\r\nQR код=qrcode\r\nШтрихкод=barcode\r\nТэг=tag\r\nТэги=tags\r\nКнига=book\r\nЗакладка=bookmark\r\nПечать=print\r\nКамера=camera\r\nШрифт=font\r\nЖирный=bold\r\nКурсив=italic\r\nВысота шрифта=text-height\r\nШирина шрифта=text-width\r\nВыровнять текст по левому краю=align-left\r\nВыровнять текст по центру=align-center\r\nВыровнять текст по правому краю=align-right\r\nВыровнять текст по ширине=align-justify\r\nСписок=list\r\nОтступ слева=indent-left\r\nОтступ справа=indent-right\r\nВидео Facetime=facetime-video\r\nИзображение=picture\r\nМаркер на карте=map-marker\r\nКонтрастность=adjust\r\nОттенок=tint\r\nПравить=edit\r\nПоделиться=share\r\nЧекбокс (заполненный)=check\r\nПередвинуть=move\r\nПредыдущий трек=step-backward\r\nПеремотка назад (быстрая)=fast-backward\r\nПеремотка назад=backward\r\nПроиграть трек=play\r\nПауза=pause\r\nСтоп=stop\r\nПеоемотка вперёд=forward\r\nПеремотка вперёд (быстрая)=fast-forward\r\nСледующий трек=step-forward\r\nВынуть диск=eject\r\nВлево (угол)=chevron-left\r\nВправо (угол)=chevron-right\r\nПлюс (в закрашенном кругу)=plus-sign\r\nМинус (в закрашенном кругу)=minus-sign\r\nОтмена (в закрашенном кругу)=remove-sign\r\nОк (в закрашенном кругу)=ok-sign\r\nВопрос (в закрашенном кругу)=question-sign\r\nИнформация (в закрашенном кругу)=info-sign\r\nСделать скриншот=screenshot\r\nОтмена (в пустом кругу)=remove-circle\r\nОк (в пустом кругу)=ok-circle\r\nЗапрещено=ban-circle\r\nВлево (стрелка)=arrow-left\r\nВправо (стрелка)=arrow-right\r\nВверх (стрелка)=arrow-up\r\nВниз (стрелка)=arrow-down\r\nПоделиться (альтернативная)=share-alt\r\nУвеличить размер=resize-full\r\nУменьшить размер=resize-small\r\nВосклицательный знак (в закрашенном кругу)=exclamation-sign\r\nПодарок=gift\r\nЛист дерева=leaf\r\nОгонь=fire\r\nГлаз (открытый)=eye-open\r\nГлаз (закрытый)=eye-close\r\nЗнак предупреждения=warning-sign\r\nСамолёт=plane\r\nКалендарь=calendar\r\nСлучайным образом=random\r\nКомментарий=comment\r\nМагнит=magnet\r\nВверх (угол)=chevron-up\r\nВниз (угол)=chevron-down\r\nRetweet=retweet\r\nКорзина=shopping-cart\r\nПапка закрытая=folder-close\r\nПапка открытая=folder-open\r\nИзменить размер (по вертикали)=resize-vertical\r\nИзменить размер (по горизонтали)=resize-horizontal\r\nЖёсткий диск=hdd\r\nМегафон=bullhorn\r\nКолокольчик=bell\r\nСертификат=certificate\r\nБольшой палец вверх=thumbs-up\r\nБольшой палец вниз=thumbs-down\r\nВправо (палец)=hand-right\r\nВлево (палец)=hand-left\r\nВверх (палец)=hand-up\r\nВниз (палец)=hand-down\r\nВправо (в закрашенном круге)=circle-arrow-right\r\nВлево (в закрашенном круге)=circle-arrow-left\r\nВверх (в закрашенном круге)=circle-arrow-up\r\nВниз (в закрашенном круге)=circle-arrow-down\r\nГлобус=globe\r\nКлюч (гаечный)=wrench\r\nЗадачи=tasks\r\nФильтр=filter\r\nЧемодан/Кейс=briefcase\r\nНа весь экран=fullscreen\r\nDashboard=dashboard\r\nСкрепка=paperclip\r\nСердце (пустое)=heart-empty\r\nСсылка=link\r\nТелефон=phone\r\nБулавка=pushpin\r\nДоллар=usd\r\nФунт=gbp\r\nСортировать=sort\r\nСортировать по алфавиту=sort-by-alphabet\r\nСортировать по алфавиту (в обратном порядке)=sort-by-alphabet-alt\r\nСортировать по числу=sort-by-order\r\nСортировать по числу (в обратном порядке)=sort-by-order-alt\r\nСортировать=sort-by-attributes\r\nСортировать (в обратном порядке)=sort-by-attributes-alt\r\nЧекбокс (пустой)=unchecked\r\nРазвернуть=expand\r\nСвернуть вниз=collapse-down\r\nСвернуть вверх=collapse-up\r\nАвторизоваться (log-in)=log-in\r\nМолния=flash\r\nВыйти (log out)=log-out\r\nВ новом окне=new-window\r\nНачать запись=record\r\nСохранить на диск=save\r\nОткрыть=open\r\nСохранено=saved\r\nИмпортировать=import\r\nЭкспортировать=export\r\nОтправить=send\r\nДискета=floppy-disk\r\nДискета (сохранено)=floppy-saved\r\nДискета (не сохранено)=floppy-remove\r\nДискета (сохраняется)=floppy-save\r\nДискета (открывается)=floppy-open\r\nКредитка=credit-card\r\nПередача данных (трансфер)=transfer\r\nСтоловая (вилка нож)=cutlery\r\nЗаголовок=header\r\nСжатый=compressed\r\nТелефон (старый, трубка)=earphone\r\nТелефон (старый, аппарат)=phone-alt\r\nБашня (ладья)=tower\r\nСтатистика=stats\r\nВидео SD качества=sd-video\r\nВидео HD качества=hd-video\r\nСубтитры=subtitles\r\nЗвук стерео=sound-stereo\r\nЗвук Dolby=sound-dolby\r\nЗвук 5.1=sound-5-1\r\nЗвук 6.1=sound-6-1\r\nЗвук 7.1=sound-7-1\r\nКопирайт=copyright-mark\r\nРегистрационный знак=registration-mark\r\nЗагрузка из облака=cloud-download\r\nЗагрузка в облако=cloud-upload\r\nЁлка=tree-conifer\r\nДерево=tree-deciduous\r\nCD диск=cd\r\nСохранить файл=save-file\r\nОткрыть файл=open-file\r\nВ родительскую папку=level-up\r\nКопировать=copy\r\nВставить=paste\r\nТревога=alert\r\nЭквалайзер=equalizer\r\nКороль (шахматы)=king\r\nКоролева (шахматы)=queen\r\nПешка (шахматы)=pawn\r\nФерзь / королева (шахматы)=bishop\r\nКонь (шахматы)=knight\r\nДетская бутылочка=baby-formula\r\nПалатка=tent\r\nДоска=blackboard\r\nКровать=bed\r\nЯблоко=apple\r\nСтирательная резинка=erase\r\nПесочные часы=hourglass\r\nЛампа=lamp\r\nДублировать=duplicate\r\nКопилка=piggy-bank\r\nНожницы=scissors\r\nБиткойн=bitcoin\r\nЙена=yen\r\nРубль=ruble\r\nВесы=scale\r\nМороженное=ice-lolly\r\nМороженное (откушенное)=ice-lolly-tasted\r\nОбразование (кепка студента)=education\r\nПодробнее (горизонтальные точки)=option-horizontal\r\nПодробнее (вертикальные точки)=option-vertical\r\nМеню=menu-hamburger\r\nМодальное окно=modal-window\r\nНефть=oil\r\nЗерно=grain\r\nОчки=sunglasses\r\nРазмер текста=text-size\r\nЦвет текста=text-color\r\nФон текста=text-background\r\nВыровнять по верху=object-align-top\r\nВыровнять по низу=object-align-bottom\r\nВыровнять по центру (вертикально)=object-align-horizontal\r\nВыровнять по левому краю=object-align-left\r\nВыровнять по центру (горизонтально)=object-align-vertical\r\nВыровнять по правому краю=object-align-right\r\nВправо (треугольник)=triangle-right\r\nВлево (треугольник)=triangle-left\r\nВниз (треугольник)=triangle-bottom\r\nВверх (треугольник)=triangle-top\r\nКонсоль=console\r\nСтепень=superscript\r\nСтепень логарифма=subscript\r\nВлево (угол тонкий)=menu-left\r\nВправо (угол тонкий)=menu-right\r\nВниз (угол тонкий)=menu-down\r\nВверх (угол тонкий)=menu-up',5,0,0,0);

INSERT INTO `part_param` (param_id,param_part,param_name,param_sname,param_uin,param_default,param_array,param_type,param_list,param_link,param_get,param_connect,param_hide) VALUES
(228,67,'Размер','size','aa3b7b46c4764249bc4cee7783a94721','',0,1,'Большая=btn-lg\r\nОбычная= \r\nМаленькая=btn-sm\r\nКрохотная=btn-xs',5,0,0,0),
(229,68,'Текст кнопки','text','7693ccdae7a91f22da5ff5295ae5a8a3','',0,0,'',5,0,0,0),
(230,68,'Элементы','rows','ce8ae7c76582ae5e0e3ea935283580f6','',0,6,'',5,0,0,0),
(231,68,'Поле для заголовка','title','a24ec182b926fedf2fe8046bf9f13c03','',0,7,'',5,0,0,0),
(232,68,'Поле для URL','url','f04b06be88e75db36082196483397502','',0,7,'',5,0,0,0),
(233,68,'URL префикс','url_prefix','54bfa8aa98e36b9e5630e7a7fa87333a','',0,0,'',5,0,0,0),
(234,68,'Вид','class','aaadb2f20952846f8ec0c291c0fc3df6','btn-default',0,1,'по умолчанию=btn-default\r\nглавная=btn-primary\r\nуспех=btn-success\r\nинформация=btn-info\r\nпредупреждение=btn-warning\r\nопасность=btn-danger\r\nссылка=btn-link',5,0,0,0),
(235,68,'Размер','size','54a44e435479806b4ef321255d624778','',0,1,'Большая=btn-lg\r\nОбычная= \r\nМаленькая=btn-sm\r\nКрохотная=btn-xs',5,0,0,0),
(236,68,'Направление выпадания','direction','7d95478ea4239c1da240004398f991d9','dropdown',0,1,'Вниз=dropdown\r\nВверх=dropup',5,0,0,0),
(237,68,'Отделить кнопку с заголовком','separate','4466a049d2118b13a84039541a1feead','',0,4,'',5,0,0,0),
(238,68,'Действие на щелчок по кнопке (если отделена)','on_click','0c1b1ba90b5a564c0b0ad4f59f1313de','',0,0,'',5,0,0,0),
(239,69,'Элементы','rows','ace3a100d6fc38edd6beb624a218826b','',0,6,'',5,0,0,0),
(240,69,'Поле для заголовка','title','7ae8a22cea8a42bc0bb77e933e61d7f0','',0,7,'',5,0,0,0),
(241,69,'Поле для текста','body','694249a8f7a7fe34786e98a52dfa606e','',0,7,'',5,0,0,0),
(242,69,'Исполнять текст как шаблон','shell_body','8831886e08101ac9e352115499062661','',0,4,'',5,0,0,0),
(243,69,'Отображение','theme','201beafa413f887b29ecad07c7e1388c','tabs',0,1,'Табы=tabs\r\nПилюли=pills\r\nВертикальные=pills nav-stacked',5,0,0,0),
(244,69,'Растягивать табы по ширине','justified','123ae883d377cab86b56273e2402fa49','',0,4,'',5,0,0,0),
(245,70,'Количество элементов','count','28f450858518894a160f3400980e309d','',0,0,'',5,0,0,0),
(246,70,'Элементов на странице','num','2ad6f8430251957ac35149ac9c0cbf14','20',0,0,'',5,0,0,0),
(247,70,'Текущая страница','page','b966bb1b1f82690c86b407bfaf05f96b','',0,0,'',5,1,0,1),
(248,70,'Размер','size','2f0365d6f593cd125a83ea951387efc8','',0,1,'Обычный=\r\nБольшой=pagination-lg\r\nМаленький=pagination-sm',5,0,0,0),
(249,70,'Вид','theme','ef99b48a8610ca853edb54ca4c14c704','pagination',0,1,'Страницы=pagination\r\nВперёд/Назад=pager',5,0,0,0),
(250,70,'Растянуть по ширине (для кнопок вперёд/назад)','align','7d483b0f9f3ae93464f2b38858df8a48','',0,4,'',5,0,0,0),
(252,71,'Вид','class','99167d308991e89e1b00ded6786fcb3c','default',0,1,'Обычная=default\r\nГлавная=primary\r\nУспех=success\r\nИнформация=info\r\nПредостережение=warning\r\nОпасность=danger',5,0,0,0),
(253,71,'Заголовок','title','a55f8f3465bb6350b4c52a832e2e3c29','',0,0,'',5,0,0,0),
(254,72,'Число','num','1700c57a4531d97945adb9924d0fa108','',0,0,'',5,0,0,0),
(255,73,'Текст','text','eeacfe3e9bba60bb37318f4f80f379c5','',0,0,'',5,0,0,0),
(256,75,'Заголовок','title','77749ca8755e5ac2d5ecf3e8de55dfa5','',0,0,'',5,0,0,0),
(257,75,'Тип','type','ac1ddb4c0195db2693e82df20637b454','h1',0,1,'h1=h1\r\nh2=h2\r\nh3=h3\r\nh4=h4\r\nh5=h5\r\nh6=h6',5,0,0,0),
(258,24,'Закрепить вверху страницы','fixed_top','88201c7dc3a929bda77c10f93c674a4f','',0,4,'',5,0,0,0),
(259,76,'Текст','text','5fb57b6e99b2c74871879af7d1e6bfab','',0,0,'',5,0,0,0),
(260,76,'Кнопка закрытия','close','64967a40733bafbc26461356340fa5df','',0,4,'',5,0,0,0),
(261,76,'Тип','type','24bb2223b9c71de7fdee19788e559257','info',0,1,'Успешный=success\r\nИнформационный=info\r\nПредупреждающий=warning\r\nОпасный=danger',5,0,0,0),
(262,77,'Минимум','min','b55c78082d404eea21e745c3baa047db','0',0,0,'',5,0,0,0),
(263,77,'Максимум','max','34b52c1022ac5a48094390059cc30f51','100',0,0,'',5,0,0,0),
(264,77,'Значение','value','5511cbf1aa4359d9a8f5f659ae1f51e8','50',0,0,'',5,0,0,0),
(265,77,'Отображать значение','show_value','0dd6ca82b435e4326fa8bc7d265e3db2','1',0,4,'',5,0,0,0),
(266,77,'Вид','theme','7f47ede011907ada72c4e22b2eb2ef4c','',0,1,'Обычный=\r\nУспех=progress-bar-success\r\nИнформация=progress-bar-info\r\nПредупреждение=progress-bar-warning\r\nОпасность=progress-bar-danger',5,0,0,0),
(267,77,'Отображать полоски','show_stripes','8d97089de934892215088fd1fcdd74ec','1',0,4,'',5,0,0,0),
(268,77,'Анимация','animate','9e2a8e36628d20f03fedf368c0602734','1',0,4,'',5,0,0,0),
(269,78,'Элементы','rows','d5ecf360cfa95e8d41c335942292dcaf','',0,6,'',5,0,0,0),
(270,78,'Поле с ссылкой','url','10a9c241dfac76c55e5d1eedcdadc7c0','',0,7,'',5,0,0,0),
(271,78,'URL префикс','url_prefix','eb669ebce8b31a2a22dd4ac068cf79ef','',0,0,'',5,0,0,0),
(272,78,'Поле с заголовком','title','dd00bd53e57ba8f5c9a5f3d30233ac77','',0,7,'',5,0,0,0),
(273,78,'Поле с счётчиком','count','efa5aad03e5e146c4e5ff0853f2c4bb4','',0,7,'',5,0,0,0),
(274,38,'Идентификатор','id','db0e0b3b240275be4385fc54fb1e1e68','',0,0,'',5,0,0,0),
(275,79,'ID элемента-кнопки, при клике на котором открывать окно','clicker_id','d267a51b689d48a96139f3c771dc734f','',0,0,'',5,0,0,0),
(276,79,'Заголовок окна','title','de55ddacadd8a6b58ddd0e5242fce1cc','',0,0,'',5,0,0,0),
(277,79,'Текст окна','body','ee3ea452a1bd1c1f4c6ca2cf85e9786a','',0,0,'',5,0,0,0),
(278,79,'Действие, выполняемое при нажатии кнопки ОК (JS)','action','e96f71f1ec5d14e771dd67e175ab41b8','',0,0,'',5,0,0,0),
(279,79,'Название кнопки ОК','btn_ok','08c193bdc0d24d12c83abaed98f659f2','Ok',0,0,'',5,0,0,0),
(280,79,'Название кнопки Отмена','btn_cancel','92dfe50126cef4f04a6433946be13d89','Отмена',0,0,'',5,0,0,0),
(281,80,'Элементы','rows','d3a75b89dd25f25aefdc281147cb5f78','',0,6,'',5,0,0,0),
(282,80,'Поле для заголовка','title','b81836cd7eac9fdcb1d6ec5d0aa44379','',0,7,'',5,0,0,0),
(283,80,'Поле для текста','body','5c9a1c0ec0dd6a03a7a6a20049145205','',0,7,'',5,0,0,0),
(284,81,'Источник','src','343b3d65694256205e8f610e7bebffac','',0,7,'',5,0,0,0),
(285,81,'Идентификатор','id','30f43422fab4e881e738ca8fdcb68a24','',0,0,'',5,0,0,0),
(286,81,'Заголовок','title','b32e0502db3b71b1da994bfa14694feb','',0,0,'',5,0,0,0),
(287,81,'Значение','value','78294328aacbc79d550e064aa219842a','',0,0,'',5,0,0,0),
(288,81,'Имя','name','1276f46489b5aa9f483ba9bf8290840e','',0,0,'',5,0,0,0),
(289,82,'Источник','src','a102c5cc28a14362debd17b09469e1f3','',0,7,'',5,0,0,0),
(290,82,'Значение','value','d831f917be963d88a0671605bf806888','',0,0,'',5,0,0,0),
(291,82,'Идентификатор','id','96bdeebf6c754f2dfa3a1e686b874b8b','',0,0,'',5,0,0,0),
(292,82,'Имя','name','09da9cfe4e7fa7fafefa5b4e71a2b730','',0,0,'',5,0,0,0),
(293,82,'Высота (в строках)','rows','7f01594f0caa5128a5fdfa463f4c37cf','3',0,0,'',5,0,0,0),
(294,83,'Источник','src','04c2c113ac7b4ff34ea343da7c26adc4','',0,7,'',5,0,0,0),
(295,83,'Опции','rows','cd2d42599a731105752ece7accb2c2c3','',0,6,'',5,0,0,0),
(296,83,'Поле с заголовком','title','80ed016197c04b78554399dd0bf426e8','',0,7,'',5,0,0,0),
(297,29,'Автоматическая генерация','autogen','bf7a2fb5389b026e4258b6f726360c89','',0,4,'',5,0,0,0),
(298,29,'Элементы карты сайта (текст)','sitemap_body','6aaf5081d42e1e59f591bab64e855f11','',0,0,'',5,0,0,0),
(299,85,'Таблица статей','table','dcc15347d9889563e8998f502d9179aa','',0,8,'',5,0,0,0),
(300,89,'Ориентация','direction','765a0ec68b5904b504484b32c840f1cc','vertical',0,1,'Вертикальная=vertical\r\nГоризонтальная=horizontal',5,0,0,0),
(301,21,'Поле сортировки','sort','0847b33c8f7e6c3ac43c00292d4c6c5b','',0,7,'',5,0,0,0),
(302,21,'Обратная сортировка','reverse','4f4496f6de2c0b97793d4ae28dc9ebd9','1',0,4,'',5,0,0,0),
(303,53,'Дополнительные переменные','vars','5b9a46d5d040af4082bc567e46de609e','',1,0,'',5,0,0,0),
(304,63,'Использовать ссылки на элементах','use_url','0c00b121ee73984b8166a3faaa0723b1','1',0,4,'',5,0,0,0),
(308,103,'Адрес ссылки "Домой"','home_link','42d05135cf3f75d4243aa4176e660dcc','',0,0,'',5,0,0,0),
(309,103,'Название ссылки "Домой"','home','7fe0aff8282a06650ac41fabfb38f05b','',0,0,'',5,0,0,0),
(312,95,'Шаблон','block_tpl','1a6a3a0011d0891aa618c407307f0245','',0,2,'',27,0,0,0),
(313,78,'Считать количество из ссылающихся элементв','linked_count','35a90e9f844f9a5a9dad5ffb205188f1','',0,4,'',5,0,0,0),
(314,93,'Шаблон','block_tpl','540bc1ba5a586bd5445586bfca910b0d','',0,2,'',28,0,0,0),
(315,63,'Поле для даты','date','a202a83c1e5639114e2037def092b776','',0,7,'',5,0,0,0),
(316,92,'Шаблон','block_tpl','b9880e4a138c24e4d3455d5db6f97966','',0,2,'',25,0,0,0),
(317,91,'Шаблон','block_tpl','1c276daa58abcebd8b2f77f29573134f','',0,2,'',25,0,0,0),
(318,106,'Тип','type','2b1413aa28367357910269caf0591206','single',0,1,'Допустимо одно значение (radiobutton)=single\r\nМожно отметить несколько (checkbox)=multy',5,0,0,0),
(319,106,'Текст на выбранном элементе','selected_text','b37f9abfcf044518d96a3c9b805dcf13','Отмечено',0,0,'',5,0,0,0),
(321,106,'Текст на не выбранном элементе','normal_text','854bd15a65352f5b3d6692059ac9b877','Не отмечено',0,0,'',5,0,0,0),
(322,108,'Использовать Bootstrap','use_bootstrap','55aa16f27ff58df324c19dbdfa175d6d','',0,4,'',5,0,0,0),
(323,108,'Язык','lng','6940bc986a99b9a9119b8f10b1e9b9bd','ru',0,0,'',5,0,0,0),
(324,108,'Загружать варианты','ajax','cc700dc80afda9c6a6a6e1e92026a325','on',0,1,'Через Ajax (для большого количества элементов)=on\r\nСразу=off',5,0,0,0),
(325,108,'Текущее поле с тегами','col','eec95e871d8b5e2411c94198b7b33f93','',0,7,'',5,0,0,1),
(328,6,'Таблица','table','0ea0540d4421b1f97b5aeafafe526306','',0,8,'',5,0,0,0),
(329,6,'Шаблон','tpl','e55a3052ec5939656f0203c46be4398d','',0,5,'',32,0,0,0),
(330,85,'Шаблон','tpl','d04243a97cbc1a7f237145c39dca70ce','',0,5,'',5,0,0,0),
(331,112,'Шаблон блока','tpl','5003ce69d5bfb77a075460c1dc9a5645','',0,2,'',32,0,0,0),
(332,115,'Язык','lng','8486db68ec7185ce89c083a20e9f7062','xml',0,1,'HTML/XML=Xml\r\nPHP=Php\r\nSQL=Sql\r\nPlain=Plain\r\nJavaScript=JScript\r\nCSS=Css',5,0,0,0),
(333,115,'Спрятать номера строк','hide_gutter','ec5cc691dd368a9e057ed5b842493d0d','',0,4,'',5,0,0,0),
(334,115,'Отображать как HTML-script','html_script','07571e49c772181748a52ac31ba4b8a1','',0,4,'',5,0,0,0),
(335,115,'Код','src','c47676633143e776bb2fc6c2fe34f1d2','',0,0,'',5,0,0,0),
(336,118,'Форма','form','8d179652cd51583f364ba4d8808b3a35','',0,2,'',45,0,0,0),
(337,118,'Шаблон','tpl','03d95c96f0c2731575da488e6cf98042','',0,2,'',49,0,0,0),
(338,118,'Ajax','ajax','335cafce2c6679f4404f8bd9a050f236','',0,4,'',5,0,0,0),
(339,118,'Защищать от повторной отправки','protect','c387c333eaf4ac7abb19bc6d9dda9ef6','',0,4,'',5,0,0,0),
(340,118,'Использовать капчу','capcha','6050b24aeb255966c188b31215504e8a','',0,4,'',5,0,0,0),
(341,122,'Первый объект с пустым URL (для страниц сайта)','first_empty','6d6a8060d5377d5231f71daa74cc65ff','',0,4,'',5,0,0,0),
(342,85,'Страница','page','4bea7e3b1d52cad060d3e6ed5d276dfd','',0,0,'',5,1,0,1),
(343,35,'Действие','action','62cb7eeba105b13d1305328ef5b830ca','',0,0,'',5,1,0,1),
(344,37,'Действие','action','b06704fbc76f7e5da60b213901dd3d53','',0,0,'',5,1,0,1),
(345,36,'Капча 1','capcha1','d2da715bc8a9d9520a9834f33fc778f2','',0,0,'',5,1,0,1),
(346,36,'Капча 2','capcha2','63c7ac98452a5ccd62ea52d51ce90b8f','',0,0,'',5,1,0,1),
(347,6,'Страница','page','fe34ce068ff5ba1819ab07d4784fee9d','',0,0,'',5,1,0,1),
(348,110,'Страница','page','2c4984268636f90c97c1aeb4c6ab3e7f','',0,0,'',5,1,0,1),
(349,98,'Страница','page','e83244cce1c139fdc1235a6e71257490','',0,0,'',5,1,0,1),
(350,118,'Действие','action','0027c74b55cce838373d9251775737ce','',0,0,'',5,1,0,1),
(351,131,'Массив объектов','objects','c24549dc54896d5c7fd5f83d92330702','',0,6,'',5,0,0,0),
(352,131,'Текущая страница','page','7b6cfe404d1f342937f57b85fd2c0e17','0',0,0,'',5,1,0,1),
(353,131,'Элементов на странице','num','d70b60ed5e0880e6484fbbffcd489f8b','10',0,0,'',5,0,0,0),
(354,121,'Класс кнопки отправки','submit_class','a4af65717776e8b78dc5aac1896dfdcc','',0,0,'',5,0,0,0),
(356,134,'Дата время','datetime','5f2a8beefe67cad9681524efd630bf77','',0,0,'',5,0,0,0),
(357,134,'Текст, если даты равны','now','f4b24d3b853ff4ee34c753c397f4b5cf','только что',0,0,'',5,0,0,0),
(358,134,'Для вашего варианта продолжите фразу 21 (минута, минуты)','minute1','82755d3ac6c71ab0c52c069f6ac51f29','минуту',0,1,'минута=минута\r\nминуту=минуту',5,0,0,0),
(359,134,'Постфикс (например, 3 дня "назад")','postfix','752aefdc750dc5e921ded4a5452f73f1','назад',0,0,'',5,0,0,0),
(360,135,'Навигация','navig','12304c73afaa93c154c814401fc67f10','',0,2,'',18,0,0,0),
(362,136,'Таблица-приёмник','table','9d705b429829754eac9fd6011c5693a9','',0,8,'',5,0,0,0),
(363,136,'Значение, по которому осуществляется поиск (или добавление)','value','a81b0140821b9f6743df25182a520a84','',0,0,'',5,0,0,0),
(364,136,'Поле для поиска (если не указано - поиск по главному полю)','field','273cbecf84d29776288626b7f8eeed5a','',0,7,'',5,0,0,0),
(365,140,'Таблица с переменными','table','71a25d6d37022e37a29ecf7a3cb9ade2','',0,8,'',5,0,0,0),
(366,141,'Массив объектов для фильтрации','objs','ae73f487fa8e855cf7f7e6e46b867570','',0,6,'',5,0,0,0),
(367,141,'Таблица с переменными','table','0371ae1a55ac09f0ddcdc4d759a30c65','',0,8,'',5,0,0,0),
(368,142,'Переменная с миниатюрой','mini','36cf791fa21118708f6420296e8d8bfe','',0,7,'',5,0,0,0),
(369,35,'Действие при успешном завершении операции','after','745beacfccb61337820dd7f3f017d616','',0,0,'',5,0,0,0),
(370,134,'Смотреть в будущее','future_look','394c7fe25e17b5fa358a2b5b82d886e6','',0,4,'',5,0,0,0),
(371,134,'Префикс (например, "через" 3 дня, если активна опция "смотреть в будущее")','prefix','52170ddb8fe8df4a1a34b06cd211ec97','',0,0,'',5,0,0,0),
(372,35,'Лимит добавлений','limit','8748697ab549d60d2699c5a232ef8eed','',0,0,'',5,0,0,0),
(373,35,'Время для лимита добавлений (в минутах)','time','714aff64e04ae049aaaa6b21f48f3330','60',0,0,'',5,0,0,0),
(374,35,'Показывать лимит пользователю','show_left','61cb500f465c9ec5804c7418cff9cfbb','',0,4,'',5,0,0,0),
(375,134,'Для вашего варианта продолжите фразу 22 (минут, минуты)','minute2','e9e0a8264112a38ad6bcffb434d0e48d','минуты',0,1,'минут=минут\r\nминуты=минуты',5,0,0,0),
(376,147,'Сборка','form','f2884b4adf227e9193029474a2b1560d','',0,2,'',74,0,0,0),
(383,147,'Группа, в которую вступает пользователь','group','8e44ac03b792e4e1cacdbc6be9f296f6','',0,9,'',5,0,0,0),
(385,147,'Дополнительное условие для отображение формы (даже если пользователь авторизован)','condition','0720061b27563f3a4acf3ff47b49b339','',0,0,'',5,0,0,0),
(386,147,'Текст под предложением пройти регистрацию','reg_text','5bdc564a887f10037ab6b15b36141ac1','',0,0,'',5,0,0,0),
(387,147,'Предлагать выход','show_exit','3b3ec26764e11eba2d0bc5347685a52c','',0,4,'',5,0,0,0),
(388,147,'Добавлять пользователя в таблицу','add_to_table','58809340990727cdc0706ba7dcede70d','',0,8,'',5,0,0,0);

INSERT INTO `row_index` (index_word,index_pos,index_row,index_col,index_tex,index_owner) VALUES
(69,0,89,119,22,0),
(70,0,90,119,22,0),
(71,0,86,93,17,0),
(72,1,86,93,17,0),
(38,2,86,93,17,0),
(38,0,86,95,17,0),
(73,1,86,95,17,0),
(74,2,86,95,17,0),
(75,3,86,95,17,0),
(76,7,86,95,17,0),
(77,8,86,95,17,0),
(124,0,97,114,20,96),
(136,1,97,114,20,96),
(124,0,97,116,20,96),
(27,1,97,116,20,96),
(137,2,97,116,20,96),
(138,3,97,116,20,96),
(124,0,98,114,20,96),
(21,1,98,114,20,96),
(139,2,98,114,20,96),
(133,0,98,116,20,96),
(124,1,98,116,20,96),
(21,2,98,116,20,96),
(140,3,98,116,20,96),
(141,4,98,116,20,96),
(142,0,99,114,20,0),
(143,0,99,116,20,0),
(142,1,99,116,20,0),
(144,2,99,116,20,0),
(165,0,101,93,20,98),
(166,1,101,93,20,98),
(167,2,101,93,20,98),
(168,0,101,95,20,98),
(169,1,101,95,20,98),
(170,2,101,95,20,98),
(171,3,101,95,20,98),
(172,4,101,95,20,98),
(110,5,101,95,20,98),
(173,6,101,95,20,98),
(174,7,101,95,20,98),
(175,8,101,95,20,98),
(176,9,101,95,20,98),
(177,10,101,95,20,98),
(178,14,101,95,20,98),
(179,15,101,95,20,98),
(180,17,101,95,20,98),
(181,18,101,95,20,98),
(182,19,101,95,20,98),
(183,21,101,95,20,98),
(184,22,101,95,20,98),
(185,23,101,95,20,98),
(186,24,101,95,20,98),
(187,26,101,95,20,98),
(188,27,101,95,20,98),
(189,28,101,95,20,98),
(190,29,101,95,20,98),
(113,0,104,93,20,99),
(142,1,104,93,20,99),
(48,0,104,95,20,99),
(149,1,104,95,20,99),
(265,2,104,95,20,99),
(266,3,104,95,20,99),
(267,4,104,95,20,99),
(268,5,104,95,20,99),
(269,6,104,95,20,99),
(113,7,104,95,20,99),
(270,8,104,95,20,99),
(271,9,104,95,20,99),
(272,10,104,95,20,99),
(273,14,104,95,20,99),
(113,15,104,95,20,99),
(274,16,104,95,20,99),
(76,18,104,95,20,99),
(275,19,104,95,20,99),
(276,20,104,95,20,99),
(277,21,104,95,20,99),
(278,22,104,95,20,99),
(279,23,104,95,20,99),
(282,0,66,44,5,19),
(283,1,66,44,5,19),
(27,2,66,44,5,19),
(38,3,66,44,5,19),
(124,0,174,119,22,0),
(139,0,207,165,26,0),
(235,0,208,165,26,0),
(751,0,219,176,28,0),
(752,0,221,176,28,0),
(753,0,223,176,28,0),
(217,0,224,176,28,0),
(754,0,226,176,28,0),
(864,0,769,193,30,0),
(865,0,770,193,30,0),
(866,0,771,193,30,0),
(876,0,411,187,29,808),
(759,1,411,187,29,808),
(878,0,808,187,29,0),
(880,0,809,187,29,808),
(788,0,457,193,30,0),
(893,0,458,193,30,0),
(948,0,1221,44,5,19),
(949,2,1221,44,5,19),
(955,0,58,35,2,0),
(15,1,58,35,2,0),
(917,0,59,35,2,0),
(15,1,59,35,2,0),
(956,0,60,35,2,59),
(21,1,60,35,2,59),
(18,2,60,35,2,59),
(19,3,60,35,2,59),
(957,0,61,35,2,59),
(958,1,61,35,2,59),
(22,2,61,35,2,59),
(23,3,61,35,2,59),
(971,0,78,35,2,59),
(44,1,78,35,2,59),
(972,2,78,35,2,59),
(973,3,78,35,2,59),
(48,7,78,35,2,59),
(974,8,78,35,2,59),
(975,12,78,35,2,59),
(15,0,58,33,2,0),
(917,0,59,33,2,0),
(18,0,60,33,2,59),
(19,1,60,33,2,59),
(22,0,61,33,2,59),
(23,1,61,33,2,59),
(976,0,78,33,2,59),
(44,1,78,33,2,59),
(977,0,88,33,2,0),
(978,0,203,33,2,0),
(984,0,62,33,2,0),
(27,0,62,35,2,0),
(984,1,62,35,2,0),
(985,2,62,35,2,0),
(986,4,62,35,2,0),
(987,8,62,35,2,0),
(988,10,62,35,2,0),
(989,12,62,35,2,0),
(990,14,62,35,2,0),
(991,16,62,35,2,0),
(992,17,62,35,2,0),
(993,18,62,35,2,0),
(994,19,62,35,2,0),
(995,20,62,35,2,0),
(996,22,62,35,2,0),
(997,0,1166,44,5,109),
(998,2,1166,44,5,109),
(1000,0,1229,44,5,19),
(1001,3,1229,44,5,19),
(1002,5,1229,44,5,19),
(1020,0,1648,193,30,0),
(1021,0,1649,193,30,0),
(1026,0,1668,187,29,0),
(1027,1,1668,187,29,0),
(1028,0,1669,187,29,1668),
(1029,0,1670,187,29,1668),
(850,0,424,214,29,411),
(1044,1,424,214,29,411),
(852,0,424,216,29,411),
(850,1,424,216,29,411),
(1044,2,424,216,29,411),
(850,0,708,214,29,411),
(1045,1,708,214,29,411),
(852,0,708,216,29,411),
(850,1,708,216,29,411),
(1045,2,708,216,29,411),
(1046,0,728,214,29,411),
(1047,1,728,214,29,411),
(788,0,728,216,29,411),
(1048,1,728,216,29,411),
(190,2,728,216,29,411),
(1049,3,728,216,29,411),
(759,4,728,216,29,411),
(241,5,728,216,29,411),
(15,6,728,216,29,411),
(1011,7,728,216,29,411),
(864,0,768,214,29,411),
(1050,1,768,214,29,411),
(1051,0,768,216,29,411),
(1052,1,768,216,29,411),
(864,2,768,216,29,411),
(1053,3,768,216,29,411),
(1011,0,1647,214,29,809),
(1054,1,1647,214,29,809),
(1055,0,1661,214,29,809),
(1056,1,1661,214,29,809),
(1057,0,1673,214,29,1669),
(1058,1,1673,214,29,1669),
(1059,0,1674,214,29,1669),
(1060,1,1674,214,29,1669),
(1061,0,1671,214,29,1670),
(1062,1,1671,214,29,1670),
(1063,2,1671,214,29,1670),
(1064,3,1671,214,29,1670),
(1065,0,1672,214,29,1670),
(1066,1,1672,214,29,1670),
(1067,2,1672,214,29,1670),
(1068,3,1672,214,29,1670),
(1069,0,1792,44,5,1790),
(1070,2,1792,44,5,1790),
(1071,0,1228,33,2,0),
(1072,0,1811,353,67,0),
(1073,1,1811,353,67,0),
(1072,0,1812,353,67,0),
(1074,1,1812,353,67,0),
(1075,0,1813,353,67,1811),
(1073,1,1813,353,67,1811),
(1077,0,1816,33,2,0),
(1078,1,1816,33,2,0),
(1079,0,1818,355,67,1812),
(1080,1,1818,355,67,1812),
(1081,0,1819,355,67,1812),
(1082,1,1819,355,67,1812),
(1083,2,1819,355,67,1812),
(1026,0,1820,355,67,1812),
(1084,1,1820,355,67,1812),
(1085,2,1820,355,67,1812),
(1086,0,1821,353,67,1811),
(1087,0,1814,355,67,1813),
(1088,1,1814,355,67,1813),
(1089,0,1815,355,67,1813),
(1090,1,1815,355,67,1813),
(1091,0,1822,355,67,1821),
(1092,1,1822,355,67,1821),
(1093,2,1822,355,67,1821),
(1094,3,1822,355,67,1821),
(1095,0,1823,355,67,1821),
(1086,1,1823,355,67,1821),
(1096,2,1823,355,67,1821),
(1095,0,1824,355,67,1821),
(1086,1,1824,355,67,1821),
(1096,2,1824,355,67,1821),
(1097,3,1824,355,67,1821),
(1086,4,1824,355,67,1821),
(1098,5,1824,355,67,1821),
(1099,6,1824,355,67,1821),
(124,0,96,114,20,0),
(133,0,96,116,20,0),
(124,1,96,116,20,0),
(1102,2,96,116,20,0),
(1103,3,96,116,20,0),
(1123,0,103,93,20,96),
(1124,1,103,93,20,96),
(1125,2,103,93,20,96),
(1126,0,103,95,20,96),
(1127,1,103,95,20,96),
(1128,2,103,95,20,96),
(1129,3,103,95,20,96),
(1130,4,103,95,20,96),
(1131,5,103,95,20,96),
(1132,6,103,95,20,96),
(1133,7,103,95,20,96),
(1134,8,103,95,20,96),
(1135,9,103,95,20,96),
(1136,13,103,95,20,96),
(1137,14,103,95,20,96),
(1138,16,103,95,20,96),
(1139,17,103,95,20,96),
(1140,18,103,95,20,96),
(1141,19,103,95,20,96),
(1142,20,103,95,20,96),
(1143,22,103,95,20,96),
(1144,23,103,95,20,96),
(217,0,102,93,20,97),
(1145,1,102,93,20,97),
(1146,2,102,93,20,97),
(1147,0,102,95,20,97),
(217,1,102,95,20,97),
(1148,2,102,95,20,97),
(1149,3,102,95,20,97),
(1150,4,102,95,20,97),
(1151,8,102,95,20,97),
(136,9,102,95,20,97),
(1152,10,102,95,20,97),
(1153,11,102,95,20,97),
(1154,12,102,95,20,97),
(1155,13,102,95,20,97),
(1156,14,102,95,20,97),
(1157,15,102,95,20,97),
(217,16,102,95,20,97),
(231,20,102,95,20,97),
(1158,21,102,95,20,97),
(1159,22,102,95,20,97),
(1160,23,102,95,20,97),
(217,24,102,95,20,97),
(235,25,102,95,20,97),
(1161,26,102,95,20,97),
(1162,27,102,95,20,97),
(1163,29,102,95,20,97),
(1164,30,102,95,20,97),
(1165,31,102,95,20,97),
(241,32,102,95,20,97),
(1166,33,102,95,20,97),
(1167,0,100,93,20,98),
(1168,1,100,93,20,98),
(1169,2,100,93,20,98),
(1170,3,100,93,20,98),
(149,0,100,95,20,98),
(1171,1,100,95,20,98),
(1172,2,100,95,20,98),
(1167,3,100,95,20,98),
(1173,4,100,95,20,98),
(1174,5,100,95,20,98),
(1175,6,100,95,20,98),
(1169,7,100,95,20,98),
(1170,8,100,95,20,98),
(1176,12,100,95,20,98),
(1177,13,100,95,20,98),
(1178,15,100,95,20,98),
(1179,16,100,95,20,98),
(1180,17,100,95,20,98),
(1181,18,100,95,20,98),
(1182,22,100,95,20,98),
(139,23,100,95,20,98),
(1183,24,100,95,20,98),
(1184,25,100,95,20,98),
(1185,26,100,95,20,98),
(1186,0,129,93,20,98),
(1187,1,129,93,20,98),
(1188,2,129,93,20,98),
(1189,3,129,93,20,98),
(1190,0,129,95,20,98),
(1191,1,129,95,20,98),
(1192,2,129,95,20,98),
(1193,3,129,95,20,98),
(1188,4,129,95,20,98),
(1189,5,129,95,20,98),
(231,6,129,95,20,98),
(1194,7,129,95,20,98),
(1195,8,129,95,20,98),
(1196,12,129,95,20,98),
(1197,13,129,95,20,98),
(1198,14,129,95,20,98),
(1199,15,129,95,20,98),
(1200,16,129,95,20,98),
(1201,17,129,95,20,98),
(1202,19,129,95,20,98),
(1203,20,129,95,20,98),
(183,21,129,95,20,98),
(1186,22,129,95,20,98),
(1187,23,129,95,20,98),
(1104,0,1833,93,17,0),
(1105,1,1833,93,17,0),
(1106,2,1833,93,17,0),
(124,0,1833,95,17,0),
(1107,1,1833,95,17,0),
(110,2,1833,95,17,0),
(1116,3,1833,95,17,0),
(1109,4,1833,95,17,0),
(113,5,1833,95,17,0),
(1110,9,1833,95,17,0),
(1111,10,1833,95,17,0),
(1112,14,1833,95,17,0),
(1113,15,1833,95,17,0),
(1114,16,1833,95,17,0),
(1115,17,1833,95,17,0),
(1105,18,1833,95,17,0),
(27,19,1833,95,17,0),
(1116,20,1833,95,17,0),
(1117,24,1833,95,17,0),
(1118,25,1833,95,17,0),
(1119,26,1833,95,17,0),
(124,27,1833,95,17,0),
(1120,28,1833,95,17,0),
(1121,30,1833,95,17,0),
(1122,31,1833,95,17,0);

INSERT INTO `row_owner` (ro_id,ro_pos,ro_ex,ro_sub,ro_enable,row_id,row_module,row_table,owner_id,owner_table,owner_module,ro_user,ro_users) VALUES
(1,1,4,0,1,1,1,8,0,8,1,-1,0),
(2,2,4,0,1,2,1,8,0,8,1,-1,0),
(3,3,4,0,1,3,1,8,0,8,1,-1,0),
(4,4,4,0,1,4,1,8,0,8,1,-1,0),
(5,5,4,0,1,5,1,8,0,8,1,-1,0),
(6,6,4,0,1,6,1,8,0,8,1,-1,0),
(7,7,4,0,1,7,1,8,0,8,1,-1,0),
(8,8,4,0,1,8,1,8,0,8,1,-1,0),
(9,9,4,0,1,9,1,8,0,8,1,-1,0),
(10,10,4,0,1,10,1,8,0,8,1,-1,0),
(11,1,8,0,1,12,1,12,0,12,1,-1,0),
(12,2,8,0,1,13,1,12,0,12,1,-1,0),
(13,1,3,0,1,14,1,7,0,7,1,-1,0),
(14,1,11,0,1,16,3,15,0,15,3,-1,0),
(15,1,7,0,1,17,1,11,0,11,1,-1,0),
(16,1,5,0,1,19,1,9,0,9,1,-1,0),
(17,1,2,0,1,58,1,5,0,5,1,-1,0),
(18,2,2,0,1,59,1,5,0,5,1,-1,0),
(19,1,2,0,1,60,1,5,59,5,1,-1,0),
(20,2,2,0,1,61,1,5,59,5,1,-1,0),
(21,7,2,0,1,62,1,5,0,0,1,-1,0),
(32,1,5,19,1,66,1,10,19,9,1,-1,0),
(34,2,16,0,1,72,1,20,0,20,1,-1,0),
(35,3,16,0,1,73,1,20,0,20,1,-1,0),
(36,4,16,0,1,74,1,20,0,20,1,-1,0),
(37,5,16,0,1,75,1,20,0,20,1,-1,0),
(38,6,16,0,1,76,1,20,0,20,1,-1,0),
(39,7,16,0,1,77,1,20,0,20,1,-1,0),
(48,3,2,0,1,78,1,5,59,5,1,-1,0),
(49,1,14,0,1,79,1,18,0,18,1,-1,0),
(50,1,14,79,1,80,1,19,79,18,1,-1,0),
(51,2,14,79,1,81,1,19,79,18,1,-1,0),
(52,3,14,79,1,82,1,19,79,18,1,-1,0),
(53,4,14,79,1,83,1,19,79,18,1,-1,0),
(55,1,18,0,1,84,4,22,0,22,4,-1,0),
(56,1,17,0,1,86,4,21,0,21,4,-1,0),
(57,1,19,0,1,87,4,23,0,23,4,-1,0),
(58,3,2,0,1,88,1,5,0,5,1,-1,0),
(59,1,22,0,1,89,4,26,0,26,4,-1,0),
(60,3,22,0,1,90,4,26,0,26,4,-1,0),
(64,1,20,0,1,96,4,24,0,24,4,-1,0),
(65,1,20,0,1,97,4,24,96,24,4,-1,0),
(66,2,20,0,1,98,4,24,96,24,4,-1,0),
(67,2,20,0,1,99,4,24,0,24,4,-1,0),
(68,1,20,98,1,100,4,21,98,24,4,-1,0),
(69,2,20,98,1,101,4,21,98,24,4,-1,0),
(70,1,20,97,1,102,4,21,97,24,4,-1,0),
(71,1,20,96,1,103,4,21,96,24,4,-1,0),
(72,1,20,99,1,104,4,21,99,24,4,-1,0),
(73,2,7,0,1,105,1,11,0,11,1,-1,0),
(74,1,23,0,1,106,4,27,0,27,4,-1,0),
(75,2,23,0,1,107,4,27,0,27,4,-1,0),
(76,2,5,0,1,109,1,9,0,9,1,-1,0),
(77,2,5,109,1,110,1,10,109,9,1,-1,0),
(78,3,7,0,1,111,1,11,0,11,1,-1,0),
(79,3,5,109,1,112,1,10,109,9,1,-1,0),
(80,1,24,0,1,116,4,28,0,28,4,-1,0),
(81,2,24,0,1,119,4,28,0,28,4,-1,0),
(82,1,21,0,1,121,4,25,0,25,4,-1,0),
(83,4,5,109,1,122,1,10,109,9,1,-1,0),
(84,2,11,0,1,126,3,15,0,0,0,-1,0),
(85,3,20,98,1,129,4,21,98,24,4,-1,0),
(107,1,27,0,1,173,2,32,0,32,2,-1,0),
(108,2,22,0,1,174,4,26,0,26,4,-1,0),
(125,2,1,0,1,192,2,1,0,1,2,-1,0),
(126,3,1,0,1,193,2,1,0,1,2,-1,0),
(127,4,1,0,1,194,2,1,0,1,2,-1,0),
(128,5,1,0,1,195,2,1,0,1,2,-1,0),
(129,6,1,0,1,196,2,1,0,1,2,-1,0),
(130,7,1,0,1,197,2,1,0,1,2,-1,0),
(131,8,1,0,1,198,2,1,0,1,2,-1,0),
(132,9,1,0,1,199,2,1,0,1,2,-1,0),
(133,10,1,0,1,200,2,1,0,1,2,-1,0),
(134,11,1,0,1,201,2,1,0,1,2,-1,0),
(135,12,1,0,1,202,2,1,0,1,2,-1,0),
(136,6,2,0,1,203,1,5,0,5,1,-1,0),
(137,2,27,0,1,204,2,32,0,32,2,-1,0),
(138,2,5,19,1,206,1,10,227,9,1,0,0),
(139,1,26,0,1,207,2,31,0,31,2,-1,0),
(140,2,26,0,1,208,2,31,0,31,2,-1,0),
(141,1,26,207,1,209,2,1,207,31,2,-1,0),
(142,2,26,207,1,210,2,1,207,31,2,-1,0),
(143,3,26,207,1,211,2,1,207,31,2,-1,0),
(144,4,26,207,1,212,2,1,207,31,2,-1,0),
(146,1,26,208,1,214,2,1,208,31,2,-1,0),
(147,2,26,208,1,215,2,1,208,31,2,-1,0),
(148,3,26,208,1,216,2,1,208,31,2,-1,0),
(149,4,26,208,1,217,2,1,208,31,2,-1,0),
(150,2,28,0,1,219,2,34,0,34,2,-1,0),
(151,3,28,0,1,221,2,34,0,34,2,-1,0),
(152,4,28,0,1,223,2,34,0,34,2,-1,0),
(153,5,28,0,1,224,2,34,0,34,2,-1,0),
(154,6,28,0,1,226,2,34,0,34,2,-1,0),
(155,3,5,0,1,227,1,9,0,9,1,-1,0),
(311,1,43,0,1,399,6,42,0,42,6,-1,0),
(312,2,43,0,1,400,6,42,0,42,6,-1,0),
(313,3,43,0,1,401,6,42,0,42,6,-1,0),
(314,4,43,0,1,402,6,42,0,42,6,-1,0),
(315,5,43,0,1,403,6,42,0,42,6,-1,0),
(316,6,43,0,1,404,6,42,0,42,6,-1,0),
(317,7,43,0,1,405,6,42,0,42,6,-1,0),
(318,8,43,0,1,406,6,42,0,42,6,-1,0),
(319,9,43,0,1,407,6,42,0,42,6,-1,0),
(320,10,43,0,1,408,6,42,0,42,6,-1,0),
(321,1,29,0,1,411,6,35,808,35,6,-1,0),
(332,1,29,411,1,424,6,43,411,35,6,-1,0),
(333,1,29,424,1,428,2,1,424,43,6,-1,0),
(334,2,29,424,1,429,2,1,424,43,6,-1,0),
(347,1,30,0,1,457,6,36,0,36,6,-1,0),
(348,2,30,0,1,458,6,36,0,36,6,-1,0),
(578,2,29,411,1,708,6,43,411,35,6,-1,0),
(595,1,29,708,1,725,2,1,708,43,6,-1,0),
(596,2,29,708,1,726,2,1,708,43,6,-1,0),
(597,3,29,708,1,727,2,1,708,43,6,-1,0),
(598,3,29,411,1,728,6,43,411,35,6,-1,0),
(616,1,29,728,1,746,2,1,728,43,6,-1,0),
(617,2,29,728,1,747,2,1,728,43,6,-1,0),
(618,3,29,728,1,748,2,1,728,43,6,-1,0),
(619,4,29,728,1,749,2,1,728,43,6,-1,0),
(637,4,29,411,1,768,6,43,411,35,6,-1,0),
(638,3,30,0,1,769,6,36,0,36,6,-1,0),
(639,4,30,0,1,770,6,36,0,36,6,-1,0),
(640,5,30,0,1,771,6,36,0,36,6,-1,0),
(656,1,29,768,1,787,2,1,768,43,6,-1,0),
(657,2,29,768,1,788,2,1,768,43,6,-1,0),
(658,3,29,768,1,789,2,1,768,43,6,-1,0),
(659,4,29,768,1,790,2,1,768,43,6,-1,0),
(660,5,29,768,1,791,2,1,768,43,6,-1,0),
(676,1,29,0,1,808,6,35,0,35,6,-1,0),
(677,2,29,0,1,809,6,35,808,35,6,-1,0),
(984,1,47,0,1,1133,7,46,0,46,7,-1,0),
(985,2,47,0,1,1134,7,46,0,46,7,-1,0),
(986,3,47,0,1,1135,7,46,0,46,7,-1,0),
(988,1,50,0,1,1137,7,49,0,49,7,-1,0),
(989,4,47,0,1,1138,7,46,0,46,7,-1,0),
(990,5,47,0,1,1139,7,46,0,0,0,-1,0),
(993,1,46,0,1,1142,7,45,0,45,7,-1,0),
(994,1,48,0,1,1143,7,47,0,47,7,-1,0),
(995,1,46,1142,1,1144,7,48,1142,45,7,-1,0),
(996,2,46,1142,1,1145,7,48,1142,45,7,-1,0),
(997,3,46,1142,1,1146,7,48,1142,45,7,-1,0),
(998,4,46,1142,1,1147,7,48,1142,45,7,-1,0),
(999,1,46,1146,1,1148,7,50,1146,48,7,-1,0),
(1000,2,46,1146,1,1149,7,50,1146,48,7,-1,0),
(1001,3,46,1146,1,1150,7,50,1146,48,7,-1,0),
(1002,4,46,1146,1,1151,7,50,1146,48,7,-1,0),
(1003,1,46,1147,1,1152,7,50,1147,48,7,-1,0),
(1004,2,46,1147,1,1153,7,50,1147,48,7,-1,0),
(1005,3,46,1147,1,1154,7,50,1147,48,7,-1,0),
(1006,4,46,1147,1,1155,7,50,1147,48,7,-1,0),
(1007,5,46,1142,1,1156,7,48,1142,45,7,-1,0),
(1008,6,47,0,1,1157,7,46,0,0,0,-1,0),
(1009,2,46,0,1,1158,7,45,0,45,7,-1,0),
(1010,2,48,0,1,1159,7,47,0,47,7,-1,0),
(1011,2,50,0,1,1160,7,49,0,49,7,-1,0),
(1012,1,46,1158,1,1161,7,48,1158,45,7,-1,0),
(1013,2,46,1158,1,1162,7,48,1158,45,7,-1,0),
(1016,1,5,109,1,1166,1,10,109,9,1,-1,0),
(1017,3,50,0,1,1167,7,49,0,49,7,-1,0),
(1020,1,52,0,1,1172,5,51,0,51,5,-1,0),
(1021,7,47,0,1,1174,7,46,0,46,7,-1,0),
(1022,6,46,1142,1,1175,7,48,1142,45,7,-1,0),
(1058,3,46,0,1,1211,7,45,0,45,7,-1,0),
(1059,3,48,0,1,1212,7,47,0,47,7,-1,0),
(1060,4,50,0,1,1213,7,49,0,49,7,-1,0),
(1061,4,46,0,1,1214,7,45,0,45,7,-1,0),
(1062,5,50,0,1,1215,7,49,0,49,7,-1,0),
(1063,1,46,1211,1,1216,7,48,1211,45,7,-1,0),
(1064,2,46,1211,1,1217,7,48,1211,45,7,-1,0),
(1065,3,46,1211,1,1218,7,48,1211,45,7,-1,0),
(1066,4,46,1211,1,1219,7,48,1211,45,7,-1,0),
(1067,1,46,1214,1,1220,7,48,1214,45,7,-1,0),
(1068,2,5,19,1,1221,1,10,19,9,1,-1,0),
(1070,8,47,0,1,1223,7,46,0,0,0,-1,0),
(1105,4,2,0,1,1228,1,5,0,5,1,-1,0),
(1106,3,5,19,1,1229,1,10,19,9,1,-1,0),
(1109,1,59,0,1,1232,8,58,0,58,8,-1,0),
(1110,1,56,0,1,1233,8,55,0,55,8,-1,0),
(1114,2,59,0,1,1237,8,58,0,58,8,-1,0),
(1115,3,59,0,1,1238,8,58,0,58,8,-1,0),
(1116,4,59,0,1,1239,8,58,0,58,8,-1,0),
(1117,5,59,0,1,1240,8,58,0,58,8,-1,0),
(1118,6,59,0,1,1241,8,58,0,58,8,-1,0),
(1119,1,56,1233,1,1243,8,54,1233,55,8,-1,0),
(1120,2,56,1233,1,1244,8,54,1233,55,8,-1,0),
(1121,3,56,1233,1,1245,8,54,1233,55,8,-1,0),
(1122,4,56,1233,1,1246,8,54,1233,55,8,-1,0),
(1123,5,56,1233,1,1247,8,54,1233,55,8,-1,0),
(1124,6,56,1233,1,1248,8,54,1233,55,8,-1,0),
(1125,7,56,1233,1,1249,8,54,1233,55,8,-1,0),
(1126,8,56,1233,1,1250,8,54,1233,55,8,-1,0),
(1127,9,56,1233,1,1251,8,54,1233,55,8,-1,0),
(1128,10,56,1233,1,1252,8,54,1233,55,8,-1,0),
(1129,11,56,1233,1,1253,8,54,1233,55,8,-1,0),
(1130,12,56,1233,1,1254,8,54,1233,55,8,-1,0),
(1131,13,56,1233,1,1255,8,54,1233,55,8,-1,0),
(1132,1,29,411,1,1256,6,53,411,35,6,-1,0),
(1133,2,56,0,1,1257,8,55,0,55,8,-1,0),
(1134,1,56,1257,1,1258,8,54,1257,55,8,-1,0),
(1135,2,56,1257,1,1259,8,54,1257,55,8,-1,0),
(1136,3,56,1257,1,1260,8,54,1257,55,8,-1,0),
(1137,4,56,1257,1,1261,8,54,1257,55,8,-1,0),
(1138,5,56,1257,1,1262,8,54,1257,55,8,-1,0),
(1139,6,56,1257,1,1263,8,54,1257,55,8,-1,0),
(1140,7,56,1257,1,1264,8,54,1257,55,8,-1,0),
(1141,2,29,411,1,1265,6,53,411,35,6,-1,0),
(1142,1,29,1265,1,1266,8,54,1265,53,6,-1,0),
(1143,2,29,1265,1,1267,8,54,1265,53,6,-1,0),
(1144,3,29,1265,1,1268,8,54,1265,53,6,-1,0),
(1145,3,29,411,1,1269,6,53,411,35,6,-1,0),
(1146,1,29,1269,1,1270,8,54,1269,53,6,-1,0),
(1147,2,29,1269,1,1271,8,54,1269,53,6,-1,0),
(1148,3,29,1269,1,1272,8,54,1269,53,6,-1,0),
(1149,4,29,1269,1,1273,8,54,1269,53,6,-1,0),
(1150,4,29,411,1,1274,6,53,411,35,6,-1,0),
(1151,5,29,411,1,1275,6,53,411,35,6,-1,0),
(1152,6,29,411,1,1276,6,53,411,35,6,-1,0),
(1153,7,29,411,1,1277,6,53,411,35,6,-1,0),
(1154,8,29,411,1,1278,6,53,411,35,6,-1,0),
(1155,1,29,1278,1,1279,8,54,1278,53,6,-1,0),
(1156,2,29,1278,1,1280,8,54,1278,53,6,-1,0),
(1157,3,29,1278,1,1281,8,54,1278,53,6,-1,0),
(1158,4,29,1278,1,1282,8,54,1278,53,6,-1,0),
(1159,5,29,1278,1,1283,8,54,1278,53,6,-1,0),
(1160,6,29,1278,1,1284,8,54,1278,53,6,-1,0),
(1161,9,29,411,1,1285,6,53,411,35,6,-1,0),
(1162,1,29,1285,1,1286,8,54,1285,53,6,-1,0),
(1163,2,29,1285,1,1287,8,54,1285,53,6,-1,0),
(1164,3,29,1285,1,1288,8,54,1285,53,6,-1,0),
(1165,4,29,1285,1,1289,8,54,1285,53,6,-1,0),
(1166,5,29,1285,1,1290,8,54,1285,53,6,-1,0),
(1167,6,29,1285,1,1291,8,54,1285,53,6,-1,0),
(1168,7,29,1285,1,1292,8,54,1285,53,6,-1,0),
(1169,8,29,1285,1,1293,8,54,1285,53,6,-1,0),
(1170,9,29,1285,1,1294,8,54,1285,53,6,-1,0),
(1171,10,29,1285,1,1295,8,54,1285,53,6,-1,0),
(1172,11,29,1285,1,1296,8,54,1285,53,6,-1,0),
(1173,12,29,1285,1,1297,8,54,1285,53,6,-1,0),
(1174,10,29,411,1,1298,6,53,411,35,6,-1,0),
(1175,11,29,411,1,1299,6,53,411,35,6,-1,0),
(1176,1,29,1299,1,1300,8,54,1299,53,6,-1,0),
(1177,2,29,1299,1,1301,8,54,1299,53,6,-1,0),
(1178,3,29,1299,1,1302,8,54,1299,53,6,-1,0),
(1179,4,29,1299,1,1303,8,54,1299,53,6,-1,0),
(1180,5,29,1299,1,1304,8,54,1299,53,6,-1,0),
(1181,6,29,1299,1,1305,8,54,1299,53,6,-1,0),
(1182,7,29,1299,1,1306,8,54,1299,53,6,-1,0),
(1183,8,29,1299,1,1307,8,54,1299,53,6,-1,0),
(1184,9,29,1299,1,1308,8,54,1299,53,6,-1,0),
(1185,10,29,1299,1,1309,8,54,1299,53,6,-1,0),
(1186,12,29,411,1,1310,6,53,411,35,6,-1,0),
(1187,1,29,1310,1,1311,8,54,1310,53,6,-1,0),
(1188,2,29,1310,1,1312,8,54,1310,53,6,-1,0),
(1189,3,29,1310,1,1313,8,54,1310,53,6,-1,0),
(1190,4,29,1310,1,1314,8,54,1310,53,6,-1,0),
(1191,5,29,1310,1,1315,8,54,1310,53,6,-1,0),
(1192,6,29,1310,1,1316,8,54,1310,53,6,-1,0),
(1193,7,29,1310,1,1317,8,54,1310,53,6,-1,0),
(1194,8,29,1310,1,1318,8,54,1310,53,6,-1,0),
(1195,9,29,1310,1,1319,8,54,1310,53,6,-1,0),
(1196,10,29,1310,1,1320,8,54,1310,53,6,-1,0),
(1197,11,29,1310,1,1321,8,54,1310,53,6,-1,0),
(1198,12,29,1310,1,1322,8,54,1310,53,6,-1,0),
(1199,13,29,1310,1,1323,8,54,1310,53,6,-1,0),
(1200,14,29,1310,1,1324,8,54,1310,53,6,-1,0),
(1201,15,29,1310,1,1325,8,54,1310,53,6,-1,0),
(1202,16,29,1310,1,1326,8,54,1310,53,6,-1,0),
(1203,17,29,1310,1,1327,8,54,1310,53,6,-1,0),
(1204,18,29,1310,1,1328,8,54,1310,53,6,-1,0),
(1205,19,29,1310,1,1329,8,54,1310,53,6,-1,0),
(1206,20,29,1310,1,1330,8,54,1310,53,6,-1,0),
(1207,21,29,1310,1,1331,8,54,1310,53,6,-1,0),
(1208,22,29,1310,1,1332,8,54,1310,53,6,-1,0),
(1209,23,29,1310,1,1333,8,54,1310,53,6,-1,0),
(1210,13,29,411,1,1334,6,53,411,35,6,-1,0),
(1211,1,29,1334,1,1335,8,54,1334,53,6,-1,0),
(1212,2,29,1334,1,1336,8,54,1334,53,6,-1,0),
(1213,3,29,1334,1,1337,8,54,1334,53,6,-1,0),
(1214,4,29,1334,1,1338,8,54,1334,53,6,-1,0),
(1215,5,29,1334,1,1339,8,54,1334,53,6,-1,0),
(1216,6,29,1334,1,1340,8,54,1334,53,6,-1,0),
(1217,7,29,1334,1,1341,8,54,1334,53,6,-1,0),
(1218,8,29,1334,1,1342,8,54,1334,53,6,-1,0),
(1219,9,29,1334,1,1343,8,54,1334,53,6,-1,0),
(1220,10,29,1334,1,1344,8,54,1334,53,6,-1,0),
(1221,11,29,1334,1,1345,8,54,1334,53,6,-1,0),
(1222,12,29,1334,1,1346,8,54,1334,53,6,-1,0),
(1223,13,29,1334,1,1347,8,54,1334,53,6,-1,0),
(1224,14,29,1334,1,1348,8,54,1334,53,6,-1,0),
(1225,14,29,411,1,1349,6,53,411,35,6,-1,0),
(1226,1,29,1349,1,1350,8,54,1349,53,6,-1,0),
(1227,2,29,1349,1,1351,8,54,1349,53,6,-1,0),
(1228,3,29,1349,1,1352,8,54,1349,53,6,-1,0),
(1229,15,29,411,1,1353,6,53,411,35,6,-1,0),
(1230,16,29,411,1,1354,6,53,411,35,6,-1,0),
(1231,17,29,411,1,1355,6,53,411,35,6,-1,0),
(1232,1,29,809,1,1356,6,53,809,35,6,-1,0),
(1233,2,29,809,1,1357,6,53,809,35,6,-1,0),
(1234,3,29,809,1,1358,6,53,809,35,6,-1,0),
(1503,4,29,809,1,1637,6,53,809,35,6,-1,0),
(1504,5,29,809,1,1638,6,53,809,35,6,-1,0),
(1505,1,29,1638,1,1639,8,54,1638,53,6,-1,0),
(1506,2,29,1638,1,1640,8,54,1638,53,6,-1,0),
(1507,3,29,1638,1,1641,8,54,1638,53,6,-1,0),
(1508,4,29,1638,1,1642,8,54,1638,53,6,-1,0),
(1509,5,29,1638,1,1643,8,54,1638,53,6,-1,0),
(1510,6,29,1638,1,1644,8,54,1638,53,6,-1,0),
(1511,7,29,1638,1,1645,8,54,1638,53,6,-1,0),
(1512,6,29,809,1,1646,6,53,809,35,6,-1,0),
(1513,1,29,809,1,1647,6,43,809,35,6,-1,0),
(1514,6,30,0,1,1648,6,36,0,36,6,-1,0),
(1515,7,30,0,1,1649,6,36,0,36,6,-1,0),
(1526,2,29,809,1,1661,6,43,809,35,6,-1,0),
(1533,2,29,0,1,1668,6,35,0,35,6,-1,0),
(1534,1,29,0,1,1669,6,35,1668,35,6,-1,0),
(1535,2,29,0,1,1670,6,35,1668,35,6,-1,0),
(1536,1,29,1670,1,1671,6,43,1670,35,6,-1,0),
(1537,2,29,1670,1,1672,6,43,1670,35,6,-1,0),
(1538,1,29,1669,1,1673,6,43,1669,35,6,-1,0),
(1539,2,29,1669,1,1674,6,43,1669,35,6,-1,0),
(1561,1,29,424,1,1707,8,57,424,43,6,-1,0),
(1562,2,29,424,1,1708,8,57,424,43,6,-1,0),
(1563,3,29,424,1,1709,8,57,424,43,6,-1,0),
(1564,4,29,424,1,1710,8,57,424,43,6,-1,0),
(1565,5,29,424,1,1711,8,57,424,43,6,-1,0),
(1566,6,29,424,1,1712,8,57,424,43,6,-1,0),
(1567,7,29,424,1,1713,8,57,424,43,6,-1,0),
(1568,8,29,424,1,1714,8,57,424,43,6,-1,0),
(1569,9,29,424,1,1715,8,57,424,43,6,-1,0),
(1570,10,29,424,1,1716,8,57,424,43,6,-1,0),
(1571,11,29,424,1,1717,8,57,424,43,6,-1,0),
(1572,12,29,424,1,1718,8,57,424,43,6,-1,0),
(1573,13,29,424,1,1719,8,57,424,43,6,-1,0),
(1574,14,29,424,1,1720,8,57,424,43,6,-1,0),
(1575,15,29,424,1,1721,8,57,424,43,6,-1,0),
(1576,16,29,424,1,1722,8,57,424,43,6,-1,0),
(1577,17,29,424,1,1723,8,57,424,43,6,-1,0),
(1578,1,29,708,1,1725,8,57,708,43,6,-1,0),
(1579,2,29,708,1,1726,8,57,708,43,6,-1,0),
(1580,3,29,708,1,1727,8,57,708,43,6,-1,0),
(1581,4,29,708,1,1728,8,57,708,43,6,-1,0),
(1582,5,29,708,1,1729,8,57,708,43,6,-1,0),
(1583,6,29,708,1,1730,8,57,708,43,6,-1,0),
(1584,7,29,708,1,1731,8,57,708,43,6,-1,0),
(1585,8,29,708,1,1732,8,57,708,43,6,-1,0),
(1586,9,29,708,1,1733,8,57,708,43,6,-1,0),
(1587,10,29,708,1,1734,8,57,708,43,6,-1,0),
(1588,11,29,708,1,1735,8,57,708,43,6,-1,0),
(1589,12,29,708,1,1736,8,57,708,43,6,-1,0),
(1590,13,29,708,1,1737,8,57,708,43,6,-1,0),
(1591,14,29,708,1,1738,8,57,708,43,6,-1,0),
(1592,15,29,708,1,1739,8,57,708,43,6,-1,0),
(1593,16,29,708,1,1740,8,57,708,43,6,-1,0),
(1594,1,29,728,1,1742,8,57,728,43,6,-1,0),
(1595,2,29,728,1,1743,8,57,728,43,6,-1,0),
(1596,3,29,728,1,1744,8,57,728,43,6,-1,0),
(1597,4,29,728,1,1745,8,57,728,43,6,-1,0),
(1598,5,29,728,1,1746,8,57,728,43,6,-1,0),
(1599,6,29,728,1,1747,8,57,728,43,6,-1,0),
(1600,7,29,728,1,1748,8,57,728,43,6,-1,0),
(1601,8,29,728,1,1749,8,57,728,43,6,-1,0),
(1602,9,29,728,1,1750,8,57,728,43,6,-1,0),
(1603,10,29,728,1,1751,8,57,728,43,6,-1,0),
(1604,11,29,728,1,1752,8,57,728,43,6,-1,0),
(1605,12,29,728,1,1753,8,57,728,43,6,-1,0),
(1606,13,29,728,1,1754,8,57,728,43,6,-1,0),
(1607,14,29,728,1,1755,8,57,728,43,6,-1,0),
(1608,15,29,728,1,1756,8,57,728,43,6,-1,0),
(1609,16,29,728,1,1757,8,57,728,43,6,-1,0),
(1610,17,29,728,1,1758,8,57,728,43,6,-1,0),
(1611,18,29,728,1,1759,8,57,728,43,6,-1,0),
(1612,19,29,728,1,1760,8,57,728,43,6,-1,0),
(1613,1,29,768,1,1762,8,57,768,43,6,-1,0),
(1614,2,29,768,1,1763,8,57,768,43,6,-1,0),
(1615,3,29,768,1,1764,8,57,768,43,6,-1,0),
(1616,4,29,768,1,1765,8,57,768,43,6,-1,0),
(1617,5,29,768,1,1766,8,57,768,43,6,-1,0),
(1618,6,29,768,1,1767,8,57,768,43,6,-1,0),
(1619,7,29,768,1,1768,8,57,768,43,6,-1,0),
(1620,8,29,768,1,1769,8,57,768,43,6,-1,0),
(1621,9,29,768,1,1770,8,57,768,43,6,-1,0),
(1622,10,29,768,1,1771,8,57,768,43,6,-1,0),
(1623,11,29,768,1,1772,8,57,768,43,6,-1,0),
(1624,12,29,768,1,1773,8,57,768,43,6,-1,0),
(1625,13,29,768,1,1774,8,57,768,43,6,-1,0),
(1626,14,29,768,1,1775,8,57,768,43,6,-1,0),
(1627,15,29,768,1,1776,8,57,768,43,6,-1,0),
(1628,1,29,1647,1,1778,8,57,1647,43,6,-1,0),
(1629,2,29,1647,1,1779,8,57,1647,43,6,-1,0),
(1630,3,29,1647,1,1780,8,57,1647,43,6,-1,0),
(1631,4,29,1647,1,1781,8,57,1647,43,6,-1,0),
(1632,5,29,1647,1,1782,8,57,1647,43,6,-1,0),
(1633,1,29,1661,1,1784,8,57,1661,43,6,-1,0),
(1634,2,29,1661,1,1785,8,57,1661,43,6,-1,0),
(1635,3,29,1661,1,1786,8,57,1661,43,6,-1,0),
(1636,4,29,1661,1,1787,8,57,1661,43,6,-1,0),
(1637,5,29,1661,1,1788,8,57,1661,43,6,-1,0),
(1638,6,29,1661,1,1789,8,57,1661,43,6,-1,0),
(1639,4,5,0,1,1790,1,9,0,9,1,-1,0),
(1640,1,5,1790,1,1791,1,10,1790,9,1,-1,0),
(1641,2,5,1790,1,1792,1,10,1790,9,1,-1,0),
(1642,1,60,0,1,1793,6,59,0,59,6,-1,0),
(1644,1,61,0,1,1796,6,60,0,60,6,-1,0),
(1645,6,50,0,1,1798,7,49,0,49,7,-1,0),
(1646,1,69,0,1,1799,10,69,0,69,10,-1,0),
(1647,2,69,0,1,1800,10,69,0,69,10,-1,0),
(1648,3,69,0,1,1801,10,69,0,69,10,-1,0),
(1649,4,69,0,1,1802,10,69,0,69,10,-1,0),
(1650,5,69,0,1,1803,10,69,0,69,10,-1,0),
(1651,1,70,0,1,1804,10,70,0,70,10,-1,0),
(1652,2,70,0,1,1805,10,70,0,70,10,-1,0),
(1653,3,70,0,1,1806,10,70,0,70,10,-1,0),
(1654,4,70,0,1,1807,10,70,0,70,10,-1,0),
(1655,5,70,0,1,1808,10,70,0,70,10,-1,0),
(1656,6,70,0,1,1809,10,70,0,70,10,-1,0),
(1657,7,70,0,1,1810,10,70,0,70,10,-1,0),
(1658,1,67,0,1,1811,10,67,0,67,10,-1,0),
(1659,2,67,0,1,1812,10,67,0,67,10,-1,0),
(1660,1,67,0,1,1813,10,67,1811,67,10,-1,0),
(1661,1,67,1813,1,1814,10,68,1813,67,10,-1,0),
(1662,2,67,1813,1,1815,10,68,1813,67,10,-1,0),
(1663,5,2,0,1,1816,1,5,0,5,1,-1,0),
(1664,1,67,1812,1,1818,10,68,1812,67,10,-1,0),
(1665,2,67,1812,1,1819,10,68,1812,67,10,-1,0),
(1666,3,67,1812,1,1820,10,68,1812,67,10,-1,0),
(1667,2,67,0,1,1821,10,67,1811,67,10,-1,0),
(1668,1,67,1821,1,1822,10,68,1821,67,10,-1,0),
(1669,2,67,1821,1,1823,10,68,1821,67,10,-1,0),
(1670,3,67,1821,1,1824,10,68,1821,67,10,-1,0),
(1671,1,71,0,1,1825,10,71,0,0,0,0,0),
(1672,2,17,0,1,1833,4,21,0,0,0,-1,0),
(1673,1,72,0,1,1834,7,72,0,72,7,-1,0),
(1674,1,74,0,1,1835,7,74,0,74,7,-1,0);

INSERT INTO `row_value` (value_id,value_module,value_table,value_row,value_col,value_value) VALUES
(1,1,8,1,40,'Левая колонка'),
(2,1,8,2,40,'Правая колонка'),
(3,1,8,3,40,'Шапка'),
(4,1,8,4,40,'Подвал'),
(5,1,8,5,40,'Над контентом'),
(8,1,8,6,40,'Под контентом'),
(9,1,8,7,40,'Центральная колонка'),
(10,1,8,8,40,'Специальная позиция №1'),
(11,1,8,9,40,'Специальная позиция №2'),
(12,1,8,10,40,'Специальная позиция №3'),
(13,1,8,11,40,'Левая колонка'),
(15,1,12,13,60,'Английский'),
(17,1,12,12,60,'Русский'),
(18,1,12,12,61,'rus'),
(19,1,12,13,61,'eng'),
(22,1,7,15,38,'По умолчанию'),
(23,1,7,15,39,'<html>\r\n<head>\r\n    [* title, css, scripts, meta, favicon *]\r\n    [cm.part.head]\r\n</head>\r\n<body>\r\n\r\n    [cm.part.block_array(align=uin:2154b3bd21f88fc9cb934c76e85e9c05:''Левая колонка'')]\r\n\r\n    [* h1 *]\r\n    [cm.part.title(type=''h1'')]\r\n    \r\n    [* content *]\r\n    [cm.part.body]\r\n    \r\n    [cm.part.block_array(align=uin:fec19dd3bce30a3dad36ea88b8c408ec:''Правая колонка'')]\r\n    \r\n</body>\r\n</html>'),
(134,1,8,18,40,'Левая колонка'),
(137,1,9,19,41,'Главная'),
(148,1,8,20,40,'Левая колонка'),
(163,1,8,21,40,'Левая колонка'),
(179,1,8,22,40,'Левая колонка'),
(196,1,8,23,40,'Левая колонка'),
(212,1,8,24,40,'Левая колонка'),
(227,1,8,25,40,'Левая колонка'),
(242,1,8,26,40,'Левая колонка'),
(257,1,8,27,40,'Левая колонка'),
(272,1,8,28,40,'Левая колонка'),
(287,1,8,29,40,'Левая колонка'),
(302,1,8,30,40,'Левая колонка'),
(317,1,8,31,40,'Левая колонка'),
(332,1,8,32,40,'Левая колонка'),
(347,1,8,33,40,'Левая колонка'),
(362,1,8,34,40,'Левая колонка'),
(377,1,8,35,40,'Левая колонка'),
(392,1,8,36,40,'Левая колонка'),
(407,1,8,37,40,'Левая колонка'),
(422,1,8,38,40,'Левая колонка'),
(437,1,8,39,40,'Левая колонка'),
(452,1,8,40,40,'Левая колонка'),
(465,1,8,41,40,'Левая колонка'),
(480,1,8,42,40,'Левая колонка'),
(493,1,8,43,40,'Левая колонка'),
(498,1,8,44,40,'Левая колонка'),
(511,1,8,45,40,'Левая колонка'),
(526,1,8,46,40,'Левая колонка'),
(541,1,8,47,40,'Левая колонка'),
(554,1,8,48,40,'Левая колонка'),
(569,1,8,49,40,'Левая колонка'),
(582,1,8,50,40,'Левая колонка'),
(595,1,8,51,40,'Левая колонка'),
(608,1,8,52,40,'Левая колонка'),
(621,1,8,53,40,'Левая колонка'),
(634,1,8,54,40,'Левая колонка'),
(647,1,8,55,40,'Левая колонка'),
(659,1,8,56,40,'Левая колонка'),
(664,1,0,1,70,'/files/uploads/favicon/fav1.png'),
(672,1,8,57,40,'Левая колонка'),
(737,1,5,60,33,'Чистка ковров'),
(739,1,5,60,35,'<p>\r\n	Лучшая в мире чистка ковров</p>\r\n'),
(740,1,5,60,56,'0'),
(741,1,5,60,57,'0'),
(742,1,5,60,59,'0'),
(743,1,5,60,63,'0'),
(744,1,5,60,68,''),
(745,1,5,60,69,''),
(746,1,5,60,90,'1'),
(747,1,5,60,34,'chistka-kovrov'),
(748,1,5,61,33,'Ремонт ПК'),
(750,1,5,61,35,'<p>\r\n	Самый качественный ремонт ПК</p>\r\n'),
(751,1,5,61,56,'0'),
(752,1,5,61,57,'0'),
(753,1,5,61,59,'0'),
(754,1,5,61,63,'0'),
(755,1,5,61,68,''),
(756,1,5,61,69,''),
(757,1,5,61,90,'1'),
(758,1,5,61,34,'remont-pk'),
(770,1,8,63,40,'Левая колонка'),
(790,1,8,64,40,'Левая колонка'),
(1088,1,8,65,40,'Левая колонка'),
(1215,1,11,17,48,'Блок Bootstrap'),
(1216,1,11,17,49,'[component.bootstrap_panel(title=current.title, body=current.body.shell++current.block.url_run, theme=''default'')]'),
(1217,1,11,17,0,'a:1:{s:36:"val_2b34f4b7fc78df8c8691458174adca8b";a:1:{i:2;a:1:{s:15:"bootstrap_panel";s:15:"bootstrap_panel";}}}'),
(1226,1,8,67,40,'Левая колонка'),
(1262,1,8,68,40,'Левая колонка'),
(1267,1,0,1,71,'/files/uploads/sites/logo839e3449c7924fd162e8b2db1b1401fe.png'),
(1306,1,8,69,40,'Левая колонка'),
(1317,1,8,70,40,'Левая колонка'),
(1331,1,20,72,91,''),
(1332,1,20,72,87,'/files/uploads/content/sliderfb3eb8fa0804ee56a28ae30510857dab.jpg'),
(1333,1,20,73,91,''),
(1334,1,20,73,87,'/files/uploads/content/slider5e9f076c5545f762965a338d8d8bc74d.jpg'),
(1335,1,20,74,91,''),
(1336,1,20,74,87,'/files/uploads/content/sliderb795f6afc534e4cb6d5dddfca271fe72.jpg'),
(1337,1,20,75,91,''),
(1338,1,20,75,87,'/files/uploads/content/slider7f59a1e659955d32528c2b8329fc2564.jpg'),
(1339,1,20,76,91,''),
(1340,1,20,76,87,'/files/uploads/content/sliderf0147ac1535bf27c30c0187721f23a93.jpg'),
(1341,1,20,77,91,''),
(1342,1,20,77,87,'/files/uploads/content/slidercfd87707e81f16a034847425ba8b6f02.jpg'),
(1575,1,5,78,33,'Продажа тракторов'),
(1577,1,5,78,35,'<p>\r\n	Хорошие трактора по доступным ценам. Только у нас! Спешите!</p>\r\n<p>\r\n	<img alt="" src="/files/pub/bycicle.jpg" style="width: 401px; height: 524px;" /></p>\r\n'),
(1578,1,5,78,56,'0'),
(1579,1,5,78,57,'0'),
(1580,1,5,78,59,'0'),
(1581,1,5,78,63,'0'),
(1582,1,5,78,68,''),
(1583,1,5,78,69,''),
(1584,1,5,78,90,'0'),
(1585,1,5,78,34,'prodaja-traktorov'),
(1586,1,18,79,83,'Для блока'),
(1587,1,19,80,84,'78'),
(1588,1,19,80,85,''),
(1589,1,19,81,84,'59'),
(1590,1,19,81,85,''),
(1591,1,19,82,84,'60'),
(1592,1,19,82,85,''),
(1593,1,19,83,84,'58'),
(1594,1,19,83,85,''),
(1882,1,8,85,40,'Подвал'),
(1888,4,0,4,134,'/files/uploads/articles/6a1b65faa54206d3353e111a3faf0f8a.png'),
(1908,4,21,86,107,'/files/uploads/photo/big66d29841eff8fef6dc2c0514fe7cc17d.jpg'),
(1933,4,26,89,119,'Интересное'),
(1934,4,26,89,120,'interesnoe'),
(1935,4,26,90,119,'Котики'),
(1936,4,26,90,120,'kotiki'),
(2003,1,8,91,40,'Подвал'),
(2027,1,8,93,40,'Подвал'),
(2063,4,21,86,93,'Открытие нашего сайта'),
(2064,4,21,86,94,'site_is_open'),
(2065,4,21,86,95,'<p>\r\n	Сайт наконец-таки открылся. Вы рады?</p>\r\n'),
(2066,4,21,86,140,''),
(2067,4,21,86,122,'90'),
(2068,4,21,86,125,'2015-10-26'),
(2069,4,21,86,128,'0'),
(2070,4,21,86,149,''),
(2071,4,21,86,150,'Ключевое слово'),
(2072,4,21,86,106,'/files/uploads/photo/big4e2e1550b1ccab257f8ef4de0e32bbfc.jpg'),
(2175,4,24,97,114,'Новости России'),
(2177,4,24,97,116,'<p>\r\n	Новости нашей необъятной страны</p>\r\n'),
(2178,4,24,97,147,'0'),
(2179,4,24,98,114,'Новости в мире животных'),
(2181,4,24,98,116,'<p>\r\n	Свежие новости из мира пушистиков и хвостатиков</p>\r\n'),
(2182,4,24,98,147,'0'),
(2183,4,24,99,114,'Реклама'),
(2185,4,24,99,116,'<p>\r\n	Исключительно рекламные сообщения</p>\r\n'),
(2186,4,24,99,147,'0'),
(2188,4,24,97,154,'russia'),
(2189,4,24,98,154,'animals'),
(2190,4,24,99,154,'advert'),
(2195,4,21,100,107,'/files/uploads/photo/bigf87527edaafbaf35e015238316115467.jpg'),
(2203,4,21,101,93,'Зайцы вновь размножаются'),
(2205,4,21,101,95,'<p>\r\n	За текущее полугодие популяция зайцев превысила все возможные ожидания со стороны специалистов. Так, год назад, за тот же отчётный период, популяция выросла всего на 30%, против 64% в этом году.</p>\r\n'),
(2206,4,21,101,140,''),
(2207,4,21,101,107,'/files/uploads/photo/bigaceea868a3dccf27193397d5fb7b8c95.jpeg'),
(2208,4,21,101,125,'2015-10-29'),
(2209,4,21,101,128,'0'),
(2210,4,21,101,149,''),
(2211,4,21,101,150,''),
(2212,4,21,101,94,'zaici-vnov-razmnojaytsya'),
(2213,4,21,101,106,'/files/uploads/photo/bigb8bf8ce1e7699ca4b0da42433a7613cd.jpeg'),
(2242,4,21,102,107,'/files/uploads/photo/biged21ffbb280a1cb8e139eb51c7f4eed2.png'),
(2253,4,21,103,107,'/files/uploads/photo/big3520076fa2a3bf33dc325a4a34208d1d.jpeg'),
(2262,4,21,104,93,'Час рекламы'),
(2264,4,21,104,95,'<p>\r\n	Только сегодня у вас есть эксклюзивная возможность приобрести часы Ferrari по сниженной цене. Заказав часы сейчас, вы экономите до 4 тысяч долларов.</p>\r\n'),
(2265,4,21,104,140,''),
(2266,4,21,104,107,'/files/uploads/photo/biga8be6c770944cba28905af8df136948a.jpg'),
(2267,4,21,104,125,'2015-10-29'),
(2268,4,21,104,128,'0'),
(2269,4,21,104,149,''),
(2270,4,21,104,150,''),
(2271,4,21,104,94,'chas-reklami'),
(2272,4,21,104,106,'/files/uploads/photo/big59ce06ab057f225fbfaff6dbe119a0b7.jpg'),
(2291,1,11,105,48,'Обычный блок'),
(2292,1,11,105,49,'<div class="block_title">\n    [current.title]\n</div>\n<div class="block_body">\n    [current.body]\n</div>\n<div class="block_dynamic">\n    [current.block.url_run]\n</div>'),
(2293,1,11,105,0,'a:0:{}'),
(2312,1,10,66,43,'Информация'),
(2313,1,10,66,44,'<p>\r\n	Добро пожаловать на наш сайт</p>\r\n'),
(2314,1,10,66,0,'a:0:{}'),
(2315,1,10,66,45,'0'),
(2316,1,10,66,46,'1'),
(2317,1,10,66,58,'17'),
(2348,1,8,108,40,'Подвал'),
(2369,1,9,109,41,'Для статей'),
(2387,1,5,88,33,'Статьи'),
(2388,1,5,88,34,'stati'),
(2389,1,5,88,35,''),
(2390,1,5,88,0,'a:0:{}'),
(2391,1,5,88,56,'0'),
(2392,1,5,88,57,'109'),
(2393,1,5,88,59,'4:4'),
(2394,1,5,88,63,'0'),
(2395,1,5,88,68,''),
(2396,1,5,88,69,''),
(2397,1,5,88,90,'1'),
(2413,4,27,107,123,'Вертикальный'),
(2414,4,27,107,124,'[component.b_link_block(rows=cex.tags.rows.sel(cur.linked_same_ex>0), url=''url'', url_prefix=host+modurl.uclose+''tag'', linked_count=1, title=''name'')]'),
(2415,4,27,107,0,'a:1:{s:36:"val_c0eedebfd4dbfcccaee35c94c6a3566c";a:1:{i:2;a:1:{s:12:"b_link_block";s:12:"b_link_block";}}}'),
(2416,1,11,111,48,'Пустой блок'),
(2417,1,11,111,49,'[current.body]\n[current.block.url_run]'),
(2418,1,11,111,0,'a:0:{}'),
(2425,1,10,110,43,'Метки'),
(2426,1,10,110,44,''),
(2427,1,10,110,0,'a:0:{}'),
(2428,1,10,110,45,'4:4:95'),
(2429,1,10,110,46,'1'),
(2430,1,10,110,58,'111'),
(2473,1,7,14,38,'По умолчанию'),
(2474,1,7,14,39,'<!DOCTYPE html>\n<html>\n<head>\n[* title, css, scripts, meta, favicon *]\n[cm.part.head]\n[component.bootstrap]\n</head>\n<body>\n\n<div class="container">\n\n    [* logo *]\n    <h1>\n        [show.image(image=cex.param.logo, width='''', align="middle")]\n        &nbsp; \n        <a href="/">\n            [cex.param.title]\n        </a>\n    </h1>\n    \n    [* navigation *]\n    [component.b_navigation(rows=cex.pages.rows.sel(cur.in_menu), theme=''light'', title_href=''/'', url_prefix=''/'', name=''title'', url=''url'')]\n    \n    [* slider *]\n    [if cex.images.count>0]\n        <div class="hero-unit">\n            [component.bootstrap_slider(rows=cex.images.rows, img=''big_img'', title=''title'')]\n        </div>\n        <br>\n    [/if]\n    \n    [* main content *]\n    <div class="row">\n    	<div class="col-sm-3">\n            [cm.part.block_array(align=uin:2154b3bd21f88fc9cb934c76e85e9c05:''Левая колонка'')]\n        </div>\n        <div class="col-sm-9">\n            [* breadcrumbs *]\n            [component.b_breadcrumbs(home=''Домой'', home_link=''/'')]\n            \n            [* page content *]\n            <h3>[cm.part.title]</h3>\n            [cm.part.body]\n            \n        </div>\n    </div>\n    \n    [* bottom *]\n    <hr>\n    <div class="footer">\n        [cex.param.counters]\n        <div>[stat.online] [stat.online.strnum(''пользователь находится'',''пользователя находятся'',''пользователей находятся'')] на сайте</div>\n        <div>&nbsp;</div>\n    </div>\n    \n</div>\n    \n</body>\n</html>'),
(2475,1,7,14,0,'a:1:{s:36:"val_ab421491b6fc81f552f918d535b9b33a";a:3:{i:1;a:1:{s:5:"image";s:5:"image";}i:2;a:4:{s:9:"bootstrap";s:9:"bootstrap";s:12:"b_navigation";s:12:"b_navigation";s:16:"bootstrap_slider";s:16:"bootstrap_slider";s:13:"b_breadcrumbs";s:13:"b_breadcrumbs";}s:5:"links";a:1:{i:1;s:1:"1";}}}'),
(2476,1,7,14,82,'/files/design/default/'),
(2477,1,8,113,40,'Подвал'),
(2499,1,8,114,40,'Подвал'),
(2521,1,8,115,40,'Подвал'),
(2545,4,28,116,126,'Горизонтальный'),
(2546,4,28,116,127,'[rows=cex.category.sel.if(cex.category.sel.sub,cex.category.rows)]\n[tree linear $rows]\n    [if first?]<div>[if cur.up]Подкатегории[else]Категории[/if]: [/if]\n    [component.bootstrap_button(type=''button'', title=cur.title+'' ''+cex.articles.eifastgetc(''owner''==cur|''owner''^^cur.allsub)._show.b_counter, size='' '', class=''btn-default'', onclick="document.location.href=''"+host++modurl.uclose+cur.wayback_url+"''")]\n    [if last?]</div><br>[/if]\n[/tree]'),
(2547,4,28,116,0,'a:1:{s:36:"val_25e5a7c774cefe0c9ac1fa5507c38fca";a:2:{i:1;a:1:{s:9:"b_counter";s:9:"b_counter";}i:2;a:1:{s:16:"bootstrap_button";s:16:"bootstrap_button";}}}'),
(2554,1,8,117,40,'Подвал'),
(2578,1,8,118,40,'Подвал'),
(2602,4,28,119,126,'Вертикальное дерево'),
(2603,4,28,119,127,'[tree cex.category.rows]\n    <div>\n        [''&nbsp;&nbsp;''.dbl(step)]\n        -\n        [if !cur.selected?]<a href="[host][modurl.uclose][cur.wayback_url]">[/if]\n        [cur.title]\n        [if !cur.selected?]</a>[/if]\n    </div>\n[/tree]'),
(2604,4,28,119,0,'a:0:{}'),
(2605,1,8,120,40,'Подвал'),
(2635,1,10,112,43,'Категории'),
(2636,1,10,112,44,''),
(2637,1,10,112,0,'a:0:{}'),
(2638,1,10,112,45,'4:4:93'),
(2639,1,10,112,46,'1'),
(2640,1,10,112,58,'17'),
(2641,4,25,121,117,'Обычный'),
(2642,4,25,121,118,'[widget.templates.base.list(tpl=uin:63ff7ca0e551e04caf2ece0cb5485876:''Статьи в блоке'', rows=$rows, url_prefix=host+modurl.uclose, body=''body'', use_url=true, date=''date'', link='''', img=''mini'')]'),
(2643,4,25,121,0,'a:1:{s:36:"val_cfa4ddcfd4e56491b5f4cb0860fec339";a:1:{s:5:"links";a:2:{i:126;s:3:"126";i:127;s:65:"eff66dc8d2d774b48d9954a50f2c9b64:384fec5ef6821de7ddad02431d5d99e8";}}}'),
(2650,1,8,123,40,'Подвал'),
(2674,1,8,124,40,'Подвал'),
(2698,1,8,125,40,'Подвал'),
(2728,3,15,126,76,'Статьи в блоке'),
(2729,3,15,126,77,'[compile css u]\n        .list-row{\n            padding: 15px;\n            background-color: #F6F6F6;\n        }\n        .list-row-odd{\n            background-color: #FFFFFF;\n            border-left: 1px solid #E2E2E2;\n            border-right: 1px solid #E2E2E2;\n        }\n        .list-spacer{\n            color: #AAAAAA; font-size: 12px;\n        }\n[/compile]\n[tree $rows]\n<div class="list-row [if index%2==1]list-row-odd[/if]">\n    [if $use_url]\n        [u=$url_prefix.uclose++cur.allway_url]\n    [else]\n        [u='''']\n    [/if]\n    [if $img && cur.col($img)]\n        <div align="center" style="margin-bottom: 5px;">\n        [if $u]<a href="[$u]" class="lnk">[/if]\n        <img src="[cur.col($img)]" border="0" width="100%">\n        [if $u]</a>[/if]\n        </div>\n    [/if]\n    <div style="font-size: 16px;">\n        [if $u]<a href="[$u]" class="lnk">[/if]\n        [cur.title]\n        [if $u]</a>[/if]\n    </div>\n    [if $body]\n        <div align="left">[b=cur.col($body)][if $b.length>64] [$b.clear.ds.scopy(64)]... [else] [$b] [/if]</div>\n    [/if]\n    [if $date]<div align="center" style="margin-top: 10px;" class="list-spacer">[cur.col($date).ndate]</div>[/if]\n</div>\n[/tree]'),
(2730,3,15,126,0,'a:0:{}'),
(2731,1,8,127,40,'Подвал'),
(2755,1,8,128,40,'Подвал'),
(2850,1,10,122,43,'Популярные'),
(2851,1,10,122,44,''),
(2852,1,10,122,0,'a:0:{}'),
(2853,1,10,122,45,'4:4:91'),
(2854,1,10,122,46,'1'),
(2855,1,10,122,58,'17'),
(2860,4,23,87,112,'Обычный'),
(2861,4,23,87,113,'[if cow.up]\n    <p><a href="[host][modurl.uclose][cow.up.wayback_url]">Назад к статьям из категории "[cow.up.title]"</a></p>\n[else]\n    <p><a href="[host][modurl.uclose][if cow.up.table==cex.category][cow.up.wayback_url][/if]">Назад к другим статьям</a></p>\n[/if]\n<p>\n    [if cow.mini!=""]<img src="[cow.mini]" align="left" hspace="5">[/if]\n    [cow.body.shell]\n</p>\n[cow.photo.md.auto]\n[if !cow.user.super? && cex.param.show_author]\n    <p>Автор: [cow.user.name]</p>\n[/if]\n\n<p align="right">Дата: [cow.date.ndate]</p>\n[if cow.hint]<p align="right">Просмотров: [cow.hint]</p>[/if]\n[if cow.tags]\n    <p align="right">Метки:\n    [tree cow.tags]\n        <a href="[host][modurl.uclose]tag/[cur.url]">[cur.name]</a>[if !last?], [/if]\n    [/tree]\n    </p>\n[/if]\n[cm.part.next_prev]\n<br>\n[cow.comments.md.auto]'),
(2862,4,23,87,0,'a:0:{}'),
(2870,4,21,129,107,'/files/uploads/photo/big063b17cfa4a39d0036e1083f584c1b41.jpg'),
(2885,1,8,131,40,'Левая колонка'),
(2983,1,8,133,40,'Левая колонка'),
(2984,1,0,1,53,'Demo Site'),
(2985,1,0,1,54,'14'),
(2986,1,0,1,55,'19'),
(2987,1,0,1,62,'12'),
(2988,1,0,1,72,'Demo Inc'),
(2989,1,0,1,73,'this is demo site'),
(2990,1,0,1,74,'8 800 000 00 00'),
(2991,1,0,1,75,''),
(2992,1,0,1,88,'1140'),
(2993,1,0,1,89,'200'),
(2994,1,0,1,92,'2'),
(3404,4,26,142,119,'котофаны'),
(3405,4,26,142,120,'Array'),
(3406,4,26,144,119,'котофаны'),
(3407,4,26,144,120,'Array'),
(3408,4,26,146,119,'котофаны'),
(3409,4,26,146,120,'kotofani'),
(3410,4,26,148,119,'котофаны'),
(3411,4,26,148,120,'kotofani2'),
(3528,4,26,150,119,'котофаны'),
(3529,4,26,150,120,'kotofani'),
(3530,4,26,152,119,'котофаны'),
(3531,4,26,152,120,'kotofani2'),
(3532,4,26,154,119,'котофаны'),
(3533,4,26,154,120,'kotofani3'),
(3534,4,26,156,119,'котофаны'),
(3535,4,26,156,120,'kotofani4'),
(3536,4,26,158,119,'котофаны'),
(3537,4,26,158,120,'kotofani5'),
(3568,4,26,160,119,'котофаны'),
(3569,4,26,160,120,'kotofani'),
(3570,4,26,162,119,'котофаны'),
(3571,4,26,162,120,'kotofani2'),
(3572,4,26,164,119,'котофаны'),
(3573,4,26,164,120,'kotofani3'),
(3574,4,26,166,119,'котофаны'),
(3575,4,26,166,120,'kotofani4'),
(3607,4,21,171,0,'a:0:{}'),
(3608,4,21,171,93,'Метеорит приближается к земле'),
(3609,4,21,171,94,'meteorit-priblijaetsya-k-zemle'),
(3610,4,21,171,95,'<p>\r\n	Новость облетела всю планету за считанные часы. Учёные в недоумении. Скала весом в 25 тонн приближается к нашей планете. Нам предстоит встретиться с новой опасностью, но готовы ли мы?</p>\r\n'),
(3611,4,21,171,106,'/files/uploads/photo/big893ed74feba5681d9f8838c6bc2aface.jpg'),
(3612,4,21,171,107,'/files/uploads/photo/biga2be455768821a84d2ac153906f842ab.jpg'),
(3613,4,21,171,122,'0'),
(3614,4,21,171,122,'1'),
(3615,4,21,171,125,'2014-06-12'),
(3616,4,21,171,128,'0'),
(3617,4,21,171,140,''),
(3618,4,21,171,149,''),
(3619,4,21,171,150,''),
(3620,4,21,171,159,'1'),
(3663,4,26,168,119,'котофаны'),
(3664,4,26,168,120,'kotofani'),
(3696,4,26,170,119,'котофаны'),
(3697,4,26,170,120,'kotofani'),
(3755,4,27,106,123,'Горизонтальный'),
(3756,4,27,106,124,'[tree cex.tags.rows.sel(cur.linked_count>0).sort(cur.linked_count).desc]\n    [if first?]<div>Метки: [/if]\n    [component.bootstrap_button(type=''button'', title=cur.name+'' ''+cur.linked_count._show.b_counter, size='' '', class=''btn-default'', onclick="document.location.href=''"+host++modurl.uclose+"tag/"+cur.url+"''")]\n    [if last?]</div>[/if]\n[/tree]'),
(3757,4,27,106,0,'a:1:{s:36:"val_c0eedebfd4dbfcccaee35c94c6a3566c";a:2:{i:1;a:1:{s:9:"b_counter";s:9:"b_counter";}i:2;a:1:{s:16:"bootstrap_button";s:16:"bootstrap_button";}}}'),
(3758,4,26,174,119,'Новое'),
(3759,4,26,174,120,'new'),
(3793,1,8,175,40,'Правая колонка'),
(3861,2,1,192,1,'/files/uploads/photo/bige4d84d128a61c5b3632a9cdb6f6eae87.jpg'),
(3866,2,1,193,1,'/files/uploads/photo/big4090adfc3465fce6d097d0ae02c62f8f.jpeg'),
(3867,2,1,193,3,''),
(3868,2,1,193,4,''),
(3869,2,1,193,5,''),
(3870,2,1,193,2,'/files/uploads/photo/big20b4fc82a1f90eb36d32cee3a444687c.jpeg'),
(3871,2,1,194,1,'/files/uploads/photo/bigdabf28f4e5343b62d6a4aee52027880c.jpg'),
(3872,2,1,194,3,''),
(3873,2,1,194,4,''),
(3874,2,1,194,5,''),
(3875,2,1,194,2,'/files/uploads/photo/bigc3732e5651b827697275b9bcb30996e0.jpg'),
(3876,2,1,195,1,'/files/uploads/photo/big22ea6e4c1f9020db001cb6b95af1ff05.jpg'),
(3881,2,1,196,1,'/files/uploads/photo/big7fc7af4303972608725fc079364e99a4.jpg'),
(3886,2,1,197,1,'/files/uploads/photo/bigf7095c22ce5676f282459c02be42c89b.jpg'),
(3891,2,1,198,1,'/files/uploads/photo/bigf8b15cbc42857be84a3dc1267def5f90.jpg'),
(3892,2,1,198,3,''),
(3893,2,1,198,4,''),
(3894,2,1,198,5,''),
(3895,2,1,198,2,'/files/uploads/photo/big5f2276dc816289198d74f0788fec6410.jpg'),
(3896,2,1,199,1,'/files/uploads/photo/bigdc91be8c21d6c48d7cb5d5c3f5f10312.jpeg'),
(3901,2,1,200,1,'/files/uploads/photo/bigaa8b826c9ccc09496af7e7c9d8385c32.jpg'),
(3902,2,1,200,3,''),
(3903,2,1,200,4,''),
(3904,2,1,200,5,''),
(3905,2,1,200,2,'/files/uploads/photo/biga277e741b0fd051fffe4ee1fda8a1171.jpg'),
(3906,2,1,201,1,'/files/uploads/photo/big92ee4cb5826387c80238fa8e1acde57f.jpg'),
(3911,2,1,202,1,'/files/uploads/photo/big8c0468305f509ec5cad5a6933d42f848.jpg'),
(3931,2,32,173,172,'ShadowBox'),
(3932,2,32,173,173,'[compile css u]\n.thumb{\n    float: left;\n    margin-right: 10px;\n    margin-bottom: 10px;\n}\n.wrapper{\n    overflow: hidden;\n    clear: both;\n}\n[/compile]\n\n[if !$main_page]\n    [if cex.category.sel.up]\n        <div><a href="[host][modurl]/[cow.up.wayback_url]">Вернуться назад в категорию "[cow.up.title]"</a></div><br>\n    [else]\n        <div><a href="[host][modurl]">Вернуться назад</a></div><br>\n    [/if]\n[/if]\n\n[if cex.category.sel || $main_page]\n    [cats=cex.category.sel.if(cex.category.sel.sub,cex.category.rows)]\n    [tree linear $cats]\n        [if first?]<div>[if cur.up]Подкатегории[else]Категории[/if]: [/if]\n        [component.bootstrap_button(type=''button'', title=cur.title+'' ''+cex.photo.eifastgetc(''owner''==cur|''owner''^^cur.allsub)._show.b_counter, size='' '', class=''btn-default'', onclick="document.location.href=''"+host++modurl.uclose+cur.wayback_url+"''")]\n        [if last?]</div><br>[/if]\n    [/tree]\n[/if]\n\n[if $count && $num]\n    [pager=component.paginator(count=$count, num=$num)]\n[/if]\n\n[if $pager]<div align="center">[$pager]</div><br>[/if]\n\n<div class="wrapper"></div>\n[tree $rows]\n    <div class="thumb">[show.shadowbox(big=cur.big_img, small=cur.mini, width=cex.param.min_width, height=cex.param.min_height, name=''images'', title=cur.name)]</div>\n[/tree]\n<div class="wrapper"></div>\n\n[if $pager]<div align="center">[$pager]</div><br>[/if]\n\n[if $main_page && !$page]\n    <br>\n    [tree cex.tags.rows.sel(cur.linked_count>0).sort(cur.linked_count).desc]\n        [if first?]<div>Метки: [/if]\n        [component.bootstrap_button(type=''button'', title=cur.name+'' ''+cur.linked_count._show.b_counter, size='' '', class=''btn-default'', onclick="document.location.href=''"+host++modurl.uclose+"tag/"+cur.url+"''")]\n        [if last?]</div>[/if]\n    [/tree]\n[/if]'),
(3933,2,32,173,0,'a:1:{s:36:"val_784accca7f43cd4e2c5a514e2c88d83f";a:2:{i:1;a:2:{s:9:"shadowbox";s:9:"shadowbox";s:9:"b_counter";s:9:"b_counter";}i:2;a:2:{s:9:"paginator";s:9:"paginator";s:16:"bootstrap_button";s:16:"bootstrap_button";}}}'),
(3937,1,8,205,40,'Правая колонка'),
(3952,1,10,206,43,'Последние фото'),
(3953,1,10,206,44,''),
(3954,1,10,206,0,'a:0:{}'),
(3955,1,10,206,45,'2:2:112'),
(3956,1,10,206,46,'1'),
(3957,1,10,206,58,'17'),
(3967,2,32,204,172,'Space Gallery'),
(3968,2,32,204,173,'[component.spacegallery(photo=''mini'', rows=$rows, title=''name'')]'),
(3969,2,32,204,0,'a:1:{s:36:"val_784accca7f43cd4e2c5a514e2c88d83f";a:1:{i:2;a:1:{s:12:"spacegallery";s:12:"spacegallery";}}}'),
(3970,2,31,207,165,'Животные'),
(3971,2,31,207,166,'givotnie'),
(3972,2,31,207,167,''),
(3973,2,31,207,169,'2015-12-09'),
(3974,2,31,207,183,'0'),
(3975,2,31,208,165,'Люди'),
(3976,2,31,208,166,'ludi'),
(3977,2,31,208,167,''),
(3978,2,31,208,169,'2015-12-09'),
(3979,2,31,208,183,'0'),
(3980,2,1,209,1,'/files/uploads/photo/big31e4deb351a59af268c9447a4a94dad6.jpg'),
(3981,2,1,209,3,''),
(3982,2,1,209,4,''),
(3983,2,1,209,5,''),
(3984,2,1,209,2,'/files/uploads/photo/biga969170845f51ff9e556b9ba13008461.jpg'),
(3985,2,1,210,1,'/files/uploads/photo/big63173d9dcde300926635b879a4fd7c3c.jpg'),
(3990,2,1,211,1,'/files/uploads/photo/big7f7a8735135bc4cc9cdac98505437e03.jpg'),
(3991,2,1,211,3,''),
(3992,2,1,211,4,''),
(3993,2,1,211,5,''),
(3994,2,1,211,2,'/files/uploads/photo/bige651481f450ac6c26fccf719da7f1032.jpg'),
(3995,2,1,212,1,'/files/uploads/photo/big7a34a19225b5768a14a461ea4fd2ba58.jpg'),
(4005,2,1,214,1,'/files/uploads/photo/biga0da964eca2a397b7fc9cc6970184904.jpg'),
(4006,2,1,214,3,''),
(4007,2,1,214,4,''),
(4008,2,1,214,5,''),
(4009,2,1,214,2,'/files/uploads/photo/bigedb9df85a6e8d2517e4f9b3a0166204d.jpg'),
(4010,2,1,215,1,'/files/uploads/photo/big09429857a73f0ba381d4f4a2604a4bac.jpg'),
(4011,2,1,215,3,''),
(4012,2,1,215,4,''),
(4013,2,1,215,5,''),
(4014,2,1,215,2,'/files/uploads/photo/big9932ab28a881fd448021edcffcf53258.jpg'),
(4015,2,1,216,1,'/files/uploads/photo/big24b509b76e4f310d20006602402c7733.jpg'),
(4016,2,1,216,3,''),
(4017,2,1,216,4,''),
(4018,2,1,216,5,''),
(4019,2,1,216,2,'/files/uploads/photo/biga83232d422f34c600f3c9d93a03b3f73.jpg'),
(4020,2,1,217,1,'/files/uploads/photo/big0ea16e9f76ac2a5273ec81dba446f54b.jpeg'),
(4021,2,1,217,3,''),
(4022,2,1,217,4,''),
(4023,2,1,217,5,''),
(4024,2,1,217,2,'/files/uploads/photo/bigb2df3cf5ce7be711a2d23deb0f4f3ff3.jpeg'),
(4031,2,1,192,3,''),
(4032,2,1,192,4,''),
(4033,2,1,192,5,'2015-12-09'),
(4034,2,1,192,2,'/files/uploads/photo/biga270734374ab5bba649c702465ea667d.jpg'),
(4035,2,34,219,176,'Кот'),
(4037,2,34,219,177,'kot'),
(4038,2,1,192,178,'219'),
(4045,2,1,195,3,''),
(4046,2,1,195,4,''),
(4047,2,1,195,5,'2015-12-09'),
(4048,2,1,195,2,'/files/uploads/photo/bige59597c4163d55e6660e33d38702b752.jpg'),
(4049,2,1,195,178,'219'),
(4056,2,1,196,3,''),
(4057,2,1,196,4,''),
(4058,2,1,196,5,'2015-12-09'),
(4059,2,1,196,2,'/files/uploads/photo/bigd5d2a894c211e82e1cda6906aba361db.jpg'),
(4060,2,34,221,176,'Цветы'),
(4062,2,34,221,177,'cveti'),
(4063,2,1,196,178,'221'),
(4070,2,1,201,3,''),
(4071,2,1,201,4,''),
(4072,2,1,201,5,'2015-12-09'),
(4073,2,1,201,2,'/files/uploads/photo/big1170581890444f5d53541bfd527ca1b2.jpg'),
(4074,2,34,223,176,'Белочка'),
(4076,2,34,223,177,'belochka'),
(4077,2,34,224,176,'Зима'),
(4079,2,34,224,177,'zima'),
(4080,2,1,201,178,'223'),
(4081,2,1,201,178,'224'),
(4088,2,1,202,3,''),
(4089,2,1,202,4,''),
(4090,2,1,202,5,'2015-12-09'),
(4091,2,1,202,2,'/files/uploads/photo/big838639ac30a45250a078b8965a774b9b.jpg'),
(4092,2,34,226,176,'Лето'),
(4094,2,34,226,177,'leto'),
(4095,2,1,202,178,'221'),
(4096,2,1,202,178,'226'),
(4103,2,1,199,3,''),
(4104,2,1,199,4,''),
(4105,2,1,199,5,'2015-12-09'),
(4106,2,1,199,2,'/files/uploads/photo/bigea576af340585fd9c2c6956e842f07f1.jpeg'),
(4107,2,1,199,178,'221'),
(4108,2,1,199,178,'226'),
(4115,2,1,197,3,''),
(4116,2,1,197,4,''),
(4117,2,1,197,5,'2015-12-09'),
(4118,2,1,197,2,'/files/uploads/photo/biga0364b757e13a317626915406d2a3bfc.jpg'),
(4119,2,1,197,178,'226'),
(4126,2,1,210,3,''),
(4127,2,1,210,4,''),
(4128,2,1,210,5,'2015-12-09'),
(4129,2,1,210,2,'/files/uploads/photo/big9bcf10e94636cb329e4ece9e63c8d048.jpg'),
(4130,2,1,210,178,'219'),
(4137,2,1,212,3,''),
(4138,2,1,212,4,''),
(4139,2,1,212,5,'2015-12-09'),
(4140,2,1,212,2,'/files/uploads/photo/big96e99ae17584c07fff4fce01a38a503d.jpg'),
(4141,2,1,212,178,'219'),
(4142,2,1,212,178,'226'),
(4143,1,9,227,41,'Для фото'),
(4155,1,5,203,33,'Фото'),
(4156,1,5,203,34,'foto'),
(4157,1,5,203,35,''),
(4158,1,5,203,0,'a:0:{}'),
(4159,1,5,203,56,'0'),
(4160,1,5,203,57,'227'),
(4161,1,5,203,59,'2:2'),
(4162,1,5,203,63,'0'),
(4163,1,5,203,68,''),
(4164,1,5,203,69,''),
(4165,1,5,203,90,'1'),
(4891,6,42,399,212,'шт'),
(4892,6,42,400,212,'м2'),
(4893,6,42,401,212,'м3'),
(4894,6,42,402,212,'м/п'),
(4895,6,42,403,212,'г'),
(4896,6,42,404,212,'кг'),
(4897,6,42,405,212,'см'),
(4898,6,42,406,212,'см2'),
(4899,6,42,407,212,'см3'),
(4900,6,42,408,212,'-'),
(4901,1,8,409,40,'Под контентом'),
(4924,1,8,410,40,'Под контентом'),
(4963,6,35,411,192,''),
(5068,6,36,417,193,''),
(5069,6,36,417,194,''),
(5090,1,8,422,40,'Под контентом'),
(5113,1,8,423,40,'Под контентом'),
(5139,6,43,424,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5154,1,8,425,40,'Под контентом'),
(5177,1,8,426,40,'Под контентом'),
(5200,1,8,427,40,'Под контентом'),
(5255,2,1,428,1,'/files/uploads/photo/big17b9e3b5f67fd7ec899002db0269d812.jpg'),
(5256,2,1,428,3,''),
(5257,2,1,428,4,''),
(5258,2,1,428,5,''),
(5259,2,1,428,2,'/files/uploads/photo/big9e8e4c281528c06ae4f98ecd1661d144.jpg'),
(5265,1,8,430,40,'Под контентом'),
(5293,2,1,429,1,'/files/uploads/photo/bigc7f24f4906bd9517679432395b6b5f5d.jpg'),
(5298,1,8,431,40,'Под контентом'),
(5330,1,8,432,40,'Под контентом'),
(5362,1,8,433,40,'Под контентом'),
(5390,6,1,429,3,''),
(5391,6,1,429,4,''),
(5392,6,1,429,5,'2015-12-14'),
(5393,2,1,429,2,'/files/uploads/photo/bigb087c4b09149c660280a7102d937fdbc.jpg'),
(5424,6,43,434,214,'Lumia 920'),
(5425,6,43,434,215,'lumia-920');

INSERT INTO `row_value` (value_id,value_module,value_table,value_row,value_col,value_value) VALUES
(5426,6,43,434,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5427,6,43,434,217,'/files/uploads/photo/big8d612462aa2b4b0d02e9b3c5aeea026c.jpg'),
(5428,6,43,434,218,'2015-12-14'),
(5429,6,43,434,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5430,6,43,434,228,''),
(5431,6,43,434,229,''),
(5432,6,43,434,231,'l920aab'),
(5433,6,43,434,232,''),
(5434,6,43,434,233,''),
(5435,6,43,434,234,''),
(5436,6,43,434,235,'10000'),
(5437,6,43,434,236,'25000'),
(5438,6,43,434,237,'3'),
(5439,6,43,434,238,''),
(5457,6,43,435,214,'Lumia 920'),
(5458,6,43,435,215,'lumia-920'),
(5459,6,43,435,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5460,6,43,435,217,'/files/uploads/photo/bige35b217a310fc73f23cde01646571cb7.jpg'),
(5461,6,43,435,218,'2015-12-14'),
(5462,6,43,435,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5463,6,43,435,228,''),
(5464,6,43,435,229,''),
(5465,6,43,435,231,'l920aab'),
(5466,6,43,435,232,''),
(5467,6,43,435,233,''),
(5468,6,43,435,234,''),
(5469,6,43,435,235,'10000'),
(5470,6,43,435,236,'25000'),
(5471,6,43,435,237,'3'),
(5472,6,43,435,238,''),
(5561,6,43,436,214,'Lumia 920'),
(5562,6,43,436,215,'lumia-920'),
(5563,6,43,436,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5564,6,43,436,217,'/files/uploads/photo/bigbf9451bafa254f40164ec9e4a3000156.jpg'),
(5565,6,43,436,218,'2015-12-14'),
(5566,6,43,436,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5567,6,43,436,228,''),
(5568,6,43,436,229,''),
(5569,6,43,436,231,'l920aab'),
(5570,6,43,436,232,''),
(5571,6,43,436,233,''),
(5572,6,43,436,234,''),
(5573,6,43,436,235,'10000'),
(5574,6,43,436,236,'25000'),
(5575,6,43,436,237,'3'),
(5576,6,43,436,238,''),
(5595,6,43,437,214,'Lumia 920'),
(5596,6,43,437,215,'lumia-920'),
(5597,6,43,437,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5598,6,43,437,217,'/files/uploads/photo/biga12b55daf0cfcb85f28a6b09b6cad697.jpg'),
(5599,6,43,437,218,'2015-12-14'),
(5600,6,43,437,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5601,6,43,437,228,''),
(5602,6,43,437,229,''),
(5603,6,43,437,231,'l920aab'),
(5604,6,43,437,232,''),
(5605,6,43,437,233,''),
(5606,6,43,437,234,''),
(5607,6,43,437,235,'10000'),
(5608,6,43,437,236,'25000'),
(5609,6,43,437,237,'3'),
(5610,6,43,437,238,''),
(5697,6,43,438,214,'Lumia 920'),
(5698,6,43,438,215,'lumia-920'),
(5699,6,43,438,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5700,6,43,438,217,'/files/uploads/photo/big306dd46a4f8e7dc4a4dc354ab767546a.jpg'),
(5701,6,43,438,218,'2015-12-14'),
(5702,6,43,438,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5703,6,43,438,228,''),
(5704,6,43,438,229,''),
(5705,6,43,438,231,'l920aab'),
(5706,6,43,438,232,''),
(5707,6,43,438,233,''),
(5708,6,43,438,234,''),
(5709,6,43,438,235,'10000'),
(5710,6,43,438,236,'25000'),
(5711,6,43,438,237,'3'),
(5712,6,43,438,238,''),
(5731,6,43,439,214,'Lumia 920'),
(5732,6,43,439,215,'lumia-920'),
(5733,6,43,439,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5734,6,43,439,217,'/files/uploads/photo/big761fa39d986522b7d4edb745f67966c2.jpg'),
(5735,6,43,439,218,'2015-12-14'),
(5736,6,43,439,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5737,6,43,439,228,''),
(5738,6,43,439,229,''),
(5739,6,43,439,231,'l920aab'),
(5740,6,43,439,232,''),
(5741,6,43,439,233,''),
(5742,6,43,439,234,''),
(5743,6,43,439,235,'10000'),
(5744,6,43,439,236,'25000'),
(5745,6,43,439,237,'3'),
(5746,6,43,439,238,''),
(5765,6,43,440,214,'Lumia 920'),
(5766,6,43,440,215,'lumia-920'),
(5767,6,43,440,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5768,6,43,440,217,'/files/uploads/photo/big4dc3252ae6d6394d2b328a505320ebe1.jpg'),
(5769,6,43,440,218,'2015-12-14'),
(5770,6,43,440,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5771,6,43,440,228,''),
(5772,6,43,440,229,''),
(5773,6,43,440,231,'l920aab'),
(5774,6,43,440,232,''),
(5775,6,43,440,233,''),
(5776,6,43,440,234,''),
(5777,6,43,440,235,'10000'),
(5778,6,43,440,236,'25000'),
(5779,6,43,440,237,'3'),
(5780,6,43,440,238,''),
(5799,6,43,441,214,'Lumia 920'),
(5800,6,43,441,215,'lumia-920'),
(5801,6,43,441,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(5802,6,43,441,217,'/files/uploads/photo/big0234ac0563f0d68c9a233debd8a06454.jpg'),
(5803,6,43,441,218,'2015-12-14'),
(5804,6,43,441,219,'/files/uploads/photo/biga3d87195841dbe1bbfed3155e3fff555.jpg'),
(5805,6,43,441,228,''),
(5806,6,43,441,229,''),
(5807,6,43,441,231,'l920aab'),
(5808,6,43,441,232,''),
(5809,6,43,441,233,''),
(5810,6,43,441,234,''),
(5811,6,43,441,235,'10000'),
(5812,6,43,441,236,'25000'),
(5813,6,43,441,237,'3'),
(5814,6,43,441,238,''),
(7485,6,43,708,219,'/files/uploads/photo/big896fbe9438945b91fa85153399a80a9b.jpg'),
(7534,2,1,725,1,'/files/uploads/photo/big563d1024d2f0446825d235e200c54453.jpg'),
(7535,2,1,725,3,''),
(7536,2,1,725,4,''),
(7537,2,1,725,5,''),
(7538,2,1,725,2,'/files/uploads/photo/big680d383e625b959a75378cb4d9137a24.jpg'),
(7539,2,1,726,1,'/files/uploads/photo/bigfbcca11f2eae4c953b3b88c3e63ebc9d.jpg'),
(7540,2,1,726,3,''),
(7541,2,1,726,4,''),
(7542,2,1,726,5,''),
(7543,2,1,726,2,'/files/uploads/photo/big8779e1b80a150394a6c72fba8c4467d5.jpg'),
(7544,2,1,727,1,'/files/uploads/photo/big7dfd520c6b69e45f4d426cb8baeb86b7.jpg'),
(7545,2,1,727,3,''),
(7546,2,1,727,4,''),
(7547,2,1,727,5,''),
(7548,2,1,727,2,'/files/uploads/photo/bige420ae7f19076bb0d4b627a102e80032.jpg'),
(7552,6,43,728,219,'/files/uploads/photo/big3825e8977a70989caf31f279f670bcd2.jpg'),
(7603,2,1,746,1,'/files/uploads/photo/big8b457c1d756e8a065457f62373fe47a4.jpg'),
(7604,2,1,746,3,''),
(7605,2,1,746,4,''),
(7606,2,1,746,5,''),
(7607,2,1,746,2,'/files/uploads/photo/bigfe9554a0f36607f0d3092f8c4f4dc0a1.jpg'),
(7608,2,1,747,1,'/files/uploads/photo/big380b7207e35bd9129dfd6174ac29948e.jpg'),
(7609,2,1,747,3,''),
(7610,2,1,747,4,''),
(7611,2,1,747,5,''),
(7612,2,1,747,2,'/files/uploads/photo/big0d17873f18f8a98f451e6f07f27cadaf.jpg'),
(7613,2,1,748,1,'/files/uploads/photo/big42002f9cc8f1ca7f9c89d14fe4bc61e9.jpg'),
(7614,2,1,748,3,''),
(7615,2,1,748,4,''),
(7616,2,1,748,5,''),
(7617,2,1,748,2,'/files/uploads/photo/big68750d79a75fdf205fe86a51d992a8ad.jpg'),
(7618,2,1,749,1,'/files/uploads/photo/big92ec55fb79bd20e7a359c27befabedcd.jpg'),
(7619,2,1,749,3,''),
(7620,2,1,749,4,''),
(7621,2,1,749,5,''),
(7622,2,1,749,2,'/files/uploads/photo/big5803dfc887b98369a698c06dbe862ab0.jpg'),
(7697,6,43,768,219,'/files/uploads/photo/big60e4c3ae63b81dbb0dc25ea1b8b34175.jpg'),
(7712,6,36,769,193,'iPhone'),
(7714,6,36,769,194,'iphone'),
(7715,6,36,770,193,'Спецпредложение'),
(7717,6,36,770,194,'specpredlojenie'),
(7718,6,36,771,193,'Новинка'),
(7720,6,36,771,194,'novinka'),
(7755,2,1,787,1,'/files/uploads/photo/bigb093cfcfb34305d330bc38fd0ffe6cb4.jpg'),
(7756,2,1,787,3,''),
(7757,2,1,787,4,''),
(7758,2,1,787,5,''),
(7759,2,1,787,2,'/files/uploads/photo/big64c896bebb44c2c4b37e3752a85ddf7a.jpg'),
(7760,2,1,788,1,'/files/uploads/photo/bigb355b9585176c96077484eabda83c65b.jpg'),
(7761,2,1,788,3,''),
(7762,2,1,788,4,''),
(7763,2,1,788,5,''),
(7764,2,1,788,2,'/files/uploads/photo/big468917724a4c822139a74a7dbc863baf.jpg'),
(7765,2,1,789,1,'/files/uploads/photo/big2874a70a6ff6c1c0536424508fa814e6.jpg'),
(7766,2,1,789,3,''),
(7767,2,1,789,4,''),
(7768,2,1,789,5,''),
(7769,2,1,789,2,'/files/uploads/photo/bigf2363d56c2163b3159884ce5736ea46e.jpg'),
(7770,2,1,790,1,'/files/uploads/photo/bigc19be29165b3a1e5fc254dd71890eccb.jpg'),
(7771,2,1,790,3,''),
(7772,2,1,790,4,''),
(7773,2,1,790,5,''),
(7774,2,1,790,2,'/files/uploads/photo/big12e4008d0c38b7b85717964008f6e660.jpg'),
(7775,2,1,791,1,'/files/uploads/photo/big38f27a813b49ebb917d88168eb72e28b.jpg'),
(7776,2,1,791,3,''),
(7777,2,1,791,4,''),
(7778,2,1,791,5,''),
(7779,2,1,791,2,'/files/uploads/photo/biga1078a69f2d31ac065ce8ed081e6d5a2.jpg'),
(7866,6,35,411,187,'Мобильные телефоны'),
(7867,6,35,411,188,'mobile'),
(7868,6,35,411,189,''),
(7870,6,35,411,190,''),
(7880,6,35,808,192,''),
(7889,6,35,808,187,'Электроника'),
(7890,6,35,808,188,'elektro'),
(7891,6,35,808,189,''),
(7894,6,35,808,190,''),
(7985,6,35,809,187,'Телевизоры'),
(7986,6,35,809,188,'tv'),
(7987,6,35,809,189,''),
(8395,6,36,457,193,'Флагман'),
(8396,6,36,457,194,'flagman'),
(8399,6,36,458,193,'Камерофон'),
(8400,6,36,458,194,'kamerofon'),
(9607,4,22,84,108,'Табличный'),
(9608,4,22,84,109,'[if !$main_page]\n    [if cex.category.sel.up]\n        <div><a href="[host][modurl]/[cow.up.wayback_url]">Вернуться назад в категорию "[cow.up.title]"</a></div><br>\n    [else]\n        <div><a href="[host][modurl]">Вернуться назад</a></div><br>\n    [/if]\n[/if]\n\n[if cex.category.sel || $main_page]\n    [cex.part.block_cat(block_tpl=uin:23c8c350cbfa8ab85ec054a35c817027:''Горизонтальный'')]\n[/if]\n\n[pager=component.paginator(count=$count, num=$num)]\n\n[if $pager]<div align="center">[$pager]</div><br>[/if]\n\n[widget.templates.base.list(tpl=uin:0f9120b0a13ed22d2106fdcc1c369c09:''Статьи'', rows=$rows, img=''mini'', use_url=1, url_prefix=host+modurl_slash, body=if(cex.param.use_anons_field,''anons'',''body''), date=''date'')]\n\n[if $pager]<br><div align="center">[$pager]</div><br>[/if]\n\n[if $main_page && !$page]\n    <br>\n    [cex.part.block_tags(block_tpl=uin:f0e6e496a8b5c894fea803570d4dcae1:''Горизонтальный'')]\n    [if cex.param.embed_archive][cm.part.block_archive(direction=''horizontal'')][/if]\n    [if cex.param.rss_icon]\n        <div align="right"><a href="[if cex.param.rss_link][cex.param.rss_link][else][host][modurl]/rss.xml[/if]" target="_blank"><img src="[cex.param.rss_icon]"></a></div>\n    [/if]\n[/if]'),
(9609,4,22,84,0,'a:1:{s:36:"val_353242c4820761c26cdd1d69fab9f168";a:2:{i:2;a:1:{s:9:"paginator";s:9:"paginator";}s:5:"links";a:4:{i:16;s:2:"16";i:106;s:3:"106";i:116;s:3:"116";i:117;s:65:"eff66dc8d2d774b48d9954a50f2c9b64:384fec5ef6821de7ddad02431d5d99e8";}}}'),
(9840,1,5,59,33,'Услуги'),
(9841,1,5,59,34,'uslugi'),
(9842,1,5,59,35,'<p>\r\n	Услуги компании</p>\r\n'),
(9843,1,5,59,0,'a:0:{}'),
(9844,1,5,59,56,''),
(9845,1,5,59,57,''),
(9846,1,5,59,59,''),
(9847,1,5,59,63,''),
(9848,1,5,59,68,''),
(9849,1,5,59,69,''),
(9850,1,5,59,90,'1'),
(9944,1,8,1132,40,'Шапка'),
(9950,3,15,16,76,'Статьи'),
(9951,3,15,16,77,'[compile css u]\n        .list-row{\n            padding: 15px;\n            background-color: #F6F6F6;\n        }\n        .list-row-odd{\n            background-color: #FFFFFF;\n            border-left: 1px solid #E2E2E2;\n            border-right: 1px solid #E2E2E2;\n        }\n        .list-spacer{\n            color: #AAAAAA; font-size: 12px;\n        }\n[/compile]\n[tree $rows]\n<div class="list-row [if index%2==1]list-row-odd[/if]">\n    [if $use_url]\n        [u=$url_prefix.uclose++cur.allway_url]\n    [else]\n        [u='''']\n    [/if]\n    [if $img && cur.col($img)]\n        <table width="100%" cellpadding=0 cellspacing=0 border=0><tr><td valign="top" width=10>\n            [if $u]<a href="[$u]" class="lnk">[/if]\n            <img src="[cur.col($img)]" border=0 width=100>\n            [if $u]</a>[/if]\n        </td><td style="padding-left: 10px;" valign="top">\n    [/if]\n    <div style="font-size: 16px;">\n        [if $u]<a href="[$u]" class="lnk">[/if]\n        [cur.title]\n        [if $u]</a>[/if]\n        [if $date]<span class="list-spacer">&nbsp; / &nbsp;[cur.col($date).ndate]</span>[/if]\n    </div><br>\n    [if $body]\n        <div align="left">[b=cur.col($body)][if $b.length>128] [$b.clear.ds.scopy(128)]... [else] [$b] [/if]</div>\n    [/if]\n    [if $u]<div align="right"><a href="[$u]" class="lnk">[if $link][$link][else]Подробнее...[/if]</a></div>[/if]\n    <br>\n    [if $img]</td></tr></table>[/if]\n</div>\n[/tree]'),
(9952,3,15,16,0,'a:0:{}'),
(10020,7,45,1142,262,'Форма обратной связи'),
(10021,7,47,1143,253,'Обратная связь'),
(10022,7,47,1143,254,'[z='''']\n[tree $v]\n    [if !(var^(''Ваш емайл'',''Текст сообщения'',''Ваше имя''))]\n        [z[var]=value]\n    [/if]\n[/tree]\n[block name="get_body" silent]\n    [tree $z]\n        [if first?]\n            <table cellpadding="5" cellspacing="0" border="0">\n        [/if]\n        <tr>\n            <td valign="top">[var]</td>\n            <td>[value]</td>\n        </tr>\n        [if last?]\n            </table>\n        [/if]\n    [/tree]\n[/block]\n[body=glob.date.ndate+'' в ''+glob.time+'' посетитель "''+$v[''Ваше имя'']+''" со страницы ''+$url_from+'' написал письмо'']\n[body=$body+block.get_body+''<p>Текст письма:<br>''+$v[''Текст сообщения'']]\n[func.email(to=zone_email, from=$v[''Ваш емайл''], subject=''Письмо с сайта ''++zone_name, msg=$body)]\n<h3>Письмо успешно отправлено</h3>'),
(10023,7,47,1143,0,'a:1:{s:36:"val_94ae2f10416c4e376392bb81780a7e86";a:1:{i:0;a:1:{s:5:"email";s:5:"email";}}}'),
(10024,7,45,1142,263,'1143'),
(10025,7,45,1142,264,'Отправить'),
(10026,7,45,1142,267,'1137'),
(10043,7,50,1148,269,'Вопрос о работе сайта'),
(10044,7,50,1149,269,'Вопрос о качестве товара'),
(10045,7,50,1150,269,'Претензия'),
(10046,7,50,1151,269,'Наличие товара'),
(10047,7,50,1152,269,'Строитель'),
(10048,7,50,1153,269,'Менеджер'),
(10049,7,50,1154,269,'Продавец'),
(10050,7,50,1155,269,'Программист'),
(10101,7,46,1133,249,'Текст (одна строка)'),
(10102,7,46,1133,250,'[field=cur]<input type="text" name="[cm.part.f_name]" id="field[$field]_[glob.form_id]" value="[$field.default]"[$class.if('' class="''+$class+''"'')]>'),
(10103,7,46,1133,0,'a:0:{}'),
(10104,7,46,1133,251,''),
(10105,7,46,1133,261,''),
(10111,7,46,1134,249,'Текст (несколько строк)'),
(10112,7,46,1134,250,'[field=cur]<textarea name="[cm.part.f_name]" style="height: 150px;" id="field[$field]_[glob.form_id]">[$field.default]</textarea>'),
(10113,7,46,1134,0,'a:0:{}'),
(10114,7,46,1134,251,''),
(10115,7,46,1134,261,''),
(10121,7,46,1138,249,'Список'),
(10122,7,46,1138,250,'[field=cur]<select name="[cm.part.f_name]" id="field[$field]_[glob.form_id]"[$class.if('' class="''+$class+''"'')]>\n    [tree $field.values.rows]\n        <option value="[cur.value]"[if cur.value==$field.default] selected[/if]>[cur.value]</option>\n    [/tree]\n</select>'),
(10123,7,46,1138,0,'a:0:{}'),
(10124,7,46,1138,251,''),
(10125,7,46,1138,261,''),
(10131,7,46,1139,249,'Множественный выбор'),
(10132,7,46,1139,250,'[field=cur][xdef=$field.default.explode('','')]\n[tree $field.values.rows]\n    <div[$class_row.if('' class="''+$class_row+''"'')]><label style="cursor: pointer;"><input type="checkbox" id="field[$field]_[glob.form_id][[[cur]]]" name="[cm.part.f_name][[[cur.value]]]"[$class.if('' class="''+$class+''"'')][if cur.value^$field.default] checked[/if]> [cur.value]</label></div>\n[/tree]'),
(10133,7,46,1139,0,'a:0:{}'),
(10134,7,46,1139,251,''),
(10135,7,46,1139,261,''),
(10146,7,46,1139,270,'[if !$value || $value.count==0]\n    [return ''Не выбрано'']\n[/if]\n[data='''']\n[tree $value]\n    [data[]=var]\n[/tree]\n[return ''<div>''+$data.implode(''</div><div>'')+''</div>'']'),
(10197,7,48,1147,255,'Ваша профессия'),
(10198,7,48,1147,256,'1138'),
(10199,7,48,1147,259,''),
(10200,7,48,1147,260,'0'),
(10221,7,48,1146,255,'Цель обращения'),
(10222,7,48,1146,256,'1139'),
(10223,7,48,1146,259,''),
(10224,7,48,1146,260,'0'),
(10257,7,46,1157,249,'Пароль'),
(10258,7,46,1157,250,'[field=cur]<input type="password" name="field[$field]_[glob.form_id]" id="[cm.part.f_name]"[$class.if('' class="''+$class+''"'')]>'),
(10259,7,46,1157,0,'a:0:{}'),
(10260,7,46,1157,251,''),
(10261,7,46,1157,261,''),
(10262,7,46,1157,270,''),
(10263,7,45,1158,262,'Форма авторизации'),
(10264,7,47,1159,253,'Авторизация'),
(10265,7,47,1159,254,'[x=user.auth($v[''Логин''],$v[''Пароль''])]\r\n[if $x==1]\r\n    <p>Вход успешно выполнен</p>\r\n[else]\r\n    <p>Ошибка авторизации: [$x]</p>\r\n[/if]'),
(10266,7,47,1159,0,'a:0:{}'),
(10267,7,45,1158,263,'1159'),
(10268,7,45,1158,264,'Войти'),
(10273,7,45,1158,267,'1160'),
(10308,7,48,1144,255,'Ваше имя'),
(10309,7,48,1144,256,'1133'),
(10310,7,48,1144,259,''),
(10311,7,48,1144,260,'1'),
(10312,7,48,1144,271,'1'),
(10317,7,48,1145,255,'Ваш емайл'),
(10318,7,48,1145,256,'1135'),
(10319,7,48,1145,259,''),
(10320,7,48,1145,260,'1'),
(10321,7,48,1145,271,'1'),
(10326,7,48,1156,255,'Текст сообщения'),
(10327,7,48,1156,256,'1134'),
(10328,7,48,1156,259,''),
(10329,7,48,1156,260,'0'),
(10330,7,48,1156,271,'1'),
(10335,7,48,1161,255,'Логин'),
(10336,7,48,1161,256,'1133'),
(10337,7,48,1161,259,''),
(10338,7,48,1161,260,'1'),
(10339,7,48,1161,271,'1'),
(10344,7,48,1162,255,'Пароль'),
(10345,7,48,1162,256,'1157'),
(10346,7,48,1162,259,''),
(10347,7,48,1162,260,'1'),
(10348,7,48,1162,271,'1'),
(10371,1,8,1163,40,'Центральная колонка'),
(10405,7,49,1160,265,'Блок авторизации (синий)'),
(10406,7,49,1160,266,'[remind_form(5,1)]\n[if $action==''logout'']\n    [user.logout]\n    <p>Вы вышли из системы. Возвращайтесь ещё.</p>\n[/if]\n\n[if $action==''forgot'']\n    [if stat.check("Remind Password",5,1)]\n    	[tmp=any_group.search_email($email).remind]\n    [/if]\n    <h2>Пароль был выслан на Ваш email, если он был верно указан</h2>\n[/if]\n\n[if user.type==''guest'']\n    [compile css]\n        .auth_block td{\n            color: #FFFFFF;\n        }\n        .auth_block input[[type=''text''], .auth_block input[[type=''password'']]{\n            margin-left: 5px;\n            margin-bottom: 5px;\n            width: 100px;\n            color: #000000;\n        }\n        .auth_block{\n            width: 185px;\n            border: 1px solid #C1C3B7;\n            background-color: #2B8EC4;\n            padding: 10px;\n            padding-bottom: 15px;\n        }\n    [/compile]\n    <div class="auth_block">\n    \n    [cm.part.top]\n        \n        <table cellpadding="5" cellspacing="0" border="0">\n        [tree $form.fields.rows]\n            <tr>\n                <td valign="top">[cur.title]</td>\n                <td>[cur.type.input.shell]</td>\n            </tr>\n        [/tree]\n        </table>\n        \n        [if $capcha]\n            [component.capcha_question(type=''form'')]\n        [/if]\n        \n        <div align="center"><input type="submit" value="[$form.submit]"></div>\n    </form>\n    \n    <div align="center" style="margin-top: 10px;"><input type="button" value="Я забыл пароль" style="font-size: 12px;" OnClick="$(''#forgot[glob.form_id]'').toggle();"></div>\n    <div align="center" id="forgot[glob.form_id]" style="padding: 5px; margin-top: 5px; background-color: #FFFFFF; border: 1px solid #555555; display: none;">\n    	<form action="[url3 "action"][url]" method="post">\n    	[form_protect]\n    	<input type="hidden" name="action" value="forgot">\n    	<div>Ваш email: <input type="text" name="email" value="" style="width: 140px;"></div><br>\n    	<div><input type="submit" value="Напомнить пароль"></div><br>\n    	<div><i>Если Вы не помните email - обратитесь к администратору портала по адресу <a href="mailto:[zone_email]">[zone_email]</a></i></div>\n        </form>\n    </div>\n    \n    </div>\n[else]\n    <div>Вы вошли как [user.name]</div>\n    <div><a href="[url4 "action" "logout"]">Выйти</a></div>\n[/if]'),
(10407,7,49,1160,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:1:{s:15:"capcha_question";s:15:"capcha_question";}}}'),
(10408,7,49,1160,268,'alert(error);'),
(10447,1,8,1170,40,'Над контентом'),
(10448,1,8,1171,40,'Над контентом'),
(10454,1,8,1173,40,'Подвал'),
(10486,7,46,1174,249,'Файл'),
(10487,7,46,1174,250,'[field=cur]<input type="file" name="[cm.part.f_name]" id="field[$field]_[glob.form_id]"[$class.if('' class="''+$class+''"'')]>'),
(10488,7,46,1174,0,'a:0:{}'),
(10489,7,46,1174,251,''),
(10490,7,46,1174,261,''),
(10491,7,46,1174,270,'[if !$value]\n    [return ''Не выбрано'']\n[/if]\n[cex.files.add(''file''=''field''++cur++''_''++glob.form_id)]\n[f=li]\n[return ''<div><a href="''++host++base_dir++$f.file.copy(1)++''">Загрузить</a> (''++$f.file.filesize.smartsize++'')</div>'']'),
(10492,7,48,1175,255,'Файл'),
(10493,7,48,1175,256,'1174'),
(10494,7,48,1175,259,''),
(10495,7,48,1175,260,'0'),
(10496,7,48,1175,271,'0'),
(10870,4,21,104,159,'15'),
(10871,4,21,86,159,'4'),
(10873,7,45,1211,262,'Форма регистрации'),
(10874,7,47,1212,253,'Регистрация (без группы)'),
(10875,7,47,1212,254,'[reg_status=user.reg($v[''Email / Логин''],$v[''Пароль''],$v[''Имя''],$v[''Email / Логин''],1)]\n[switch $reg_status]\n    [case 0]\n        <p>Ошибка регистрации</p>\n    [case 1]\n        <p>Регистрация прошла успешно</p>\n    [case 2]\n        <p>Попробуйте использовать другой логин</p>\n        <p><a href="[url]">Попробовать ещё раз</a></p>\n[/switch]\n'),
(10876,7,47,1212,0,'a:0:{}'),
(10877,7,45,1211,263,'1212'),
(10878,7,45,1211,264,'Зарегистрироваться'),
(10883,7,45,1211,267,'1213'),
(10897,7,48,1217,255,'Пароль'),
(10898,7,48,1217,256,'1157'),
(10899,7,48,1217,259,''),
(10900,7,48,1217,260,'1'),
(10901,7,48,1217,271,'1'),
(10917,7,48,1219,255,'Имя'),
(10918,7,48,1219,256,'1133'),
(10919,7,48,1219,259,''),
(10920,7,48,1219,260,'1'),
(10921,7,48,1219,271,'1'),
(10922,7,48,1220,255,'Поиск'),
(10923,7,48,1220,256,'1133'),
(10924,7,48,1220,259,''),
(10925,7,48,1220,260,'1'),
(10926,7,48,1220,271,'1'),
(10931,7,45,1214,262,'Форма поиска'),
(10932,7,45,1214,263,'0'),
(10933,7,45,1214,264,'Искать'),
(10934,7,45,1214,267,'1215'),
(10959,1,10,1221,43,'Поиск'),
(10960,1,10,1221,44,'<p>\r\n	[widget.forms.base.echo(form=uin:c7ea703338bbdc8cfc551d5846034b48:''Форма поиска'', tpl=uin:81148d58e789a0c40bea530aa186e886:''Форма поиска'')]</p>\r\n'),
(10961,1,10,1221,0,'a:1:{s:36:"val_d3aff7f97b8312980d87fa582a207af1";a:1:{s:5:"links";a:3:{i:1214;s:4:"1214";i:1222;s:4:"1222";i:1223;s:65:"adba24f02440b291927021addd983811:c7da137c820357446fa55236c853811a";}}}'),
(10962,1,10,1221,45,'0'),
(10963,1,10,1221,46,'1'),
(10964,1,10,1221,58,'17'),
(10985,1,5,58,33,'О компании'),
(10986,1,5,58,34,''),
(10987,1,5,58,35,'<p>\r\n	Информация о компании</p>\r\n'),
(10988,1,5,58,0,'a:0:{}'),
(10989,1,5,58,56,'0'),
(10990,1,5,58,57,'0'),
(10991,1,5,58,59,'0'),
(10992,1,5,58,63,'0'),
(10993,1,5,58,68,''),
(10994,1,5,58,69,''),
(10995,1,5,58,90,'1'),
(11009,1,5,62,33,'Контакты'),
(11010,1,5,62,34,'kontakti'),
(11011,1,5,62,35,'<p>\r\n	Наши контакты</p>\r\n<p>\r\n	[show.google_map(address=''г.Красноярск, ул.Ленина, 12'', width=425, height=350)]</p>\r\n<p>\r\n	Форма обратной связи</p>\r\n<p>\r\n	[component.feedback(email=zone_email, submit=''Отправить письмо'', text=''Поздравление'')]</p>\r\n'),
(11012,1,5,62,0,'a:1:{s:36:"val_ac3fde6953c19e57d666c913880f4eaa";a:2:{i:1;a:1:{s:10:"google_map";s:10:"google_map";}i:2;a:1:{s:8:"feedback";s:8:"feedback";}}}'),
(11013,1,5,62,56,'0'),
(11014,1,5,62,57,'0'),
(11015,1,5,62,59,'0'),
(11016,1,5,62,63,'0'),
(11017,1,5,62,68,''),
(11018,1,5,62,69,''),
(11019,1,5,62,90,'1'),
(11025,7,48,1216,255,'Email / Логин'),
(11026,7,48,1216,256,'1135'),
(11027,7,48,1216,259,''),
(11028,7,48,1216,260,'1'),
(11029,7,48,1216,271,'1'),
(11044,1,10,1166,43,'Вход'),
(11045,1,10,1166,44,'<p>\r\n	[widget.forms.base.echo(form=uin:10c9cb802b02cc3dca281bfddcc8264b:''Форма авторизации'', tpl=uin:f6daf3d74ababfaf47ea602883527b90:''Блок авторизации'')]</p>\r\n'),
(11046,1,10,1166,0,'a:1:{s:36:"val_d3aff7f97b8312980d87fa582a207af1";a:1:{s:5:"links";a:3:{i:1158;s:4:"1158";i:1167;s:4:"1167";i:1168;s:65:"adba24f02440b291927021addd983811:c7da137c820357446fa55236c853811a";}}}'),
(11047,1,10,1166,45,'0'),
(11048,1,10,1166,46,'1'),
(11049,1,10,1166,58,'17'),
(11067,1,8,1222,40,'Шапка'),
(11091,7,48,1218,255,'Подтверждение пароля'),
(11092,7,48,1218,256,'1223'),
(11093,7,48,1218,259,''),
(11094,7,48,1218,260,'1'),
(11095,7,48,1218,271,'1'),
(11102,7,46,1223,249,'Подтверждение пароля'),
(11103,7,46,1223,250,'[field=cur]<input type="password" name="[cm.part.f_name]" id="field[$field]_[glob.form_id]"[$class.if('' class="''+$class+''"'')]>'),
(11104,7,46,1223,0,'a:0:{}'),
(11105,7,46,1223,251,'if(value!=f.parents(''form'').find(''input[type=password][id!=''+f.attr(''id'')+'']:first'').val()) return ''Пароль и подтверждение не совпадают'';'),
(11106,7,46,1223,261,''),
(11107,7,46,1223,270,''),
(11476,5,51,1172,288,'Простой'),
(11477,5,51,1172,289,'[compile css u]\r\n.comment_box{\r\n    margin-bottom: 16px;\r\n}\r\n.comment_body{\r\n    font-size: 14px;\r\n}\r\n.comment_info_pan{\r\n    font-size: 11px;\r\n    margin-bottom: 4px;\r\n    color: #777777;\r\n}\r\n.comment_info_date{\r\n    \r\n}\r\n.comment_info_user{\r\n    font-weight: bold;\r\n}\r\n[/compile]\r\n\r\n[tree cex.comments.rows.order(''date,id'')]\r\n    <div class="comment_box">\r\n        <div class="comment_info_pan">\r\n            <span class="comment_info_user">[if !cur.u][cur.name] (гость)[else][cur.u.super?.if(''<b>Администрация</b>'',cur.u.name)][/if]</span>\r\n            <span class="comment_info_date">добавил [cur.date._show.time_passed]</span>\r\n        </div>\r\n        <div class="comment_body">[cur.body]</div>\r\n    </div>\r\n[/tree]'),
(11478,5,51,1172,0,'a:1:{s:36:"val_20e0c8e352dab49cb0c2524a2e03bc9c";a:1:{i:1;a:1:{s:11:"time_passed";s:11:"time_passed";}}}'),
(11479,1,10,1229,43,'Избранное'),
(11480,1,10,1229,44,'<p>\r\n	[component.b_link_block(rows=cm.part.array_navigation(navig=uin:bcfb52ecf26e3c252c94e7aac3884578:''Для блока''), url=''url'', title=''title'')]</p>\r\n'),
(11481,1,10,1229,0,'a:1:{s:36:"val_d3aff7f97b8312980d87fa582a207af1";a:2:{i:2;a:1:{s:12:"b_link_block";s:12:"b_link_block";}s:5:"links";a:1:{i:79;s:2:"79";}}}'),
(11482,1,10,1229,45,'0'),
(11483,1,10,1229,46,'1'),
(11484,1,10,1229,58,'17'),
(11603,8,58,1238,310,'Число'),
(11604,8,58,1238,311,'<p>[cur.name]:<br>\r\n    <input type="text" name="properties[[[cur]]]" value="[$value.safe_input]">\r\n</p>'),
(11605,8,58,1238,0,'a:0:{}'),
(11606,8,58,1238,312,'[cow.dvalues.add(''param''=cur, ''value''=post.properties[cur])]'),
(11607,8,58,1238,313,''),
(11608,8,58,1238,314,''),
(11609,8,58,1238,315,''),
(11610,8,58,1238,316,''),
(11611,8,58,1238,317,'[objs=$objs.fastget:dvalues(_''value''^$val.lower,''param''==cur).owners]'),
(11630,8,58,1232,310,'Текст'),
(11631,8,58,1232,311,'<p>[cur.name]:<br>\r\n    <input type="text" name="dpar[[[cur]]]" id="[cur]_[glob.form_id]" value="[$value]"[$class.if('' class="''+$class+''"'')]>\r\n</p>'),
(11632,8,58,1232,0,'a:0:{}'),
(11633,8,58,1232,312,'[cow.dvalues.add(''param''=cur, ''value''=post.dpar[cur])]'),
(11634,8,58,1232,313,''),
(11635,8,58,1232,314,''),
(11636,8,58,1232,315,''),
(11637,8,58,1232,316,''),
(11638,8,58,1232,317,'[objs=$objs.fastget:dvalues(_''value''^$val.lower,''param''==cur).owners]'),
(11657,1,8,1242,40,'Специальная позиция №1'),
(11661,8,54,1243,295,'Apple'),
(11663,8,54,1243,319,''),
(11664,8,54,1243,318,'apple'),
(11665,8,54,1244,295,'Bosh'),
(11667,8,54,1244,319,''),
(11668,8,54,1244,318,'bosh'),
(11669,8,54,1245,295,'Electrolux'),
(11671,8,54,1245,319,''),
(11672,8,54,1245,318,'electrolux'),
(11673,8,54,1246,295,'Hitachi'),
(11675,8,54,1246,319,''),
(11676,8,54,1246,318,'hitachi'),
(11677,8,54,1247,295,'HTC'),
(11679,8,54,1247,319,''),
(11680,8,54,1247,318,'htc'),
(11681,8,54,1248,295,'Indesit'),
(11683,8,54,1248,319,''),
(11684,8,54,1248,318,'indesit'),
(11685,8,54,1249,295,'Intel'),
(11687,8,54,1249,319,''),
(11688,8,54,1249,318,'intel'),
(11689,8,54,1250,295,'LG'),
(11691,8,54,1250,319,''),
(11692,8,54,1250,318,'lg'),
(11693,8,54,1251,295,'Microsoft'),
(11695,8,54,1251,319,''),
(11696,8,54,1251,318,'microsoft'),
(11697,8,54,1252,295,'Nokia'),
(11699,8,54,1252,319,''),
(11700,8,54,1252,318,'nokia'),
(11701,8,54,1253,295,'Samsung'),
(11703,8,54,1253,319,''),
(11704,8,54,1253,318,'samsung'),
(11705,8,54,1254,295,'Sony'),
(11707,8,54,1254,319,''),
(11708,8,54,1254,318,'sony'),
(11709,8,54,1255,295,'Toshiba'),
(11711,8,54,1255,319,''),
(11712,8,54,1255,318,'toshiba'),
(11723,8,55,1233,296,'Производители бытовой техники'),
(11724,8,55,1257,296,'Производители цифровой техники'),
(11725,8,54,1258,295,'Alcatel'),
(11727,8,54,1258,319,''),
(11728,8,54,1258,318,'alcatel'),
(11729,8,54,1259,295,'Apple'),
(11731,8,54,1259,319,''),
(11732,8,54,1259,318,'apple'),
(11733,8,54,1260,295,'HTC'),
(11735,8,54,1260,319,''),
(11736,8,54,1260,318,'htc'),
(11737,8,54,1261,295,'LG'),
(11739,8,54,1261,319,''),
(11740,8,54,1261,318,'lg'),
(11741,8,54,1262,295,'Microsoft'),
(11743,8,54,1262,319,''),
(11744,8,54,1262,318,'microsoft'),
(11745,8,54,1263,295,'Samsung'),
(11747,8,54,1263,319,''),
(11748,8,54,1263,318,'samsung'),
(11749,8,54,1264,295,'Sony'),
(11751,8,54,1264,319,''),
(11752,8,54,1264,318,'sony'),
(11769,6,53,1265,302,'Тип экрана'),
(11770,6,53,1265,304,'1240'),
(11771,6,53,1265,305,'0'),
(11772,6,53,1265,306,'1');

INSERT INTO `row_value` (value_id,value_module,value_table,value_row,value_col,value_value) VALUES
(11773,6,53,1265,307,'0'),
(11774,6,53,1265,308,''),
(11775,6,53,1265,309,'0'),
(11777,6,53,1265,320,'tip-ekrana'),
(11778,8,54,1266,295,'TN'),
(11780,8,54,1266,319,''),
(11781,8,54,1266,318,'tn'),
(11782,8,54,1267,295,'IPS'),
(11784,8,54,1267,319,''),
(11785,8,54,1267,318,'ips'),
(11786,8,54,1268,295,'Amoled'),
(11788,8,54,1268,319,''),
(11789,8,54,1268,318,'amoled'),
(11790,6,53,1269,302,'Операционная система'),
(11791,6,53,1269,304,'1240'),
(11792,6,53,1269,305,'0'),
(11793,6,53,1269,306,'1'),
(11794,6,53,1269,307,'0'),
(11795,6,53,1269,308,''),
(11796,6,53,1269,309,'0'),
(11798,6,53,1269,320,'operacionnaya-sistema'),
(11799,8,54,1270,295,'Android'),
(11801,8,54,1270,319,''),
(11802,8,54,1270,318,'android'),
(11803,8,54,1271,295,'Windows'),
(11805,8,54,1271,319,''),
(11806,8,54,1271,318,'windows'),
(11807,8,54,1272,295,'iOS'),
(11809,8,54,1272,319,''),
(11810,8,54,1272,318,'ios'),
(11811,8,54,1273,295,'J2ME'),
(11813,8,54,1273,319,''),
(11814,8,54,1273,318,'j2me'),
(11815,6,53,1274,302,'Ширина (см)'),
(11816,6,53,1274,304,'1238'),
(11817,6,53,1274,305,'0'),
(11818,6,53,1274,306,'0'),
(11819,6,53,1274,307,'0'),
(11820,6,53,1274,308,''),
(11821,6,53,1274,309,'0'),
(11823,6,53,1274,320,'shirina-sm'),
(11824,6,53,1275,302,'Высота (см)'),
(11825,6,53,1275,304,'1238'),
(11826,6,53,1275,305,'0'),
(11827,6,53,1275,306,'0'),
(11828,6,53,1275,307,'0'),
(11829,6,53,1275,308,''),
(11830,6,53,1275,309,'0'),
(11832,6,53,1275,320,'visota-sm'),
(11833,6,53,1276,302,'Вес (г)'),
(11834,6,53,1276,304,'1238'),
(11835,6,53,1276,305,'0'),
(11836,6,53,1276,306,'0'),
(11837,6,53,1276,307,'0'),
(11838,6,53,1276,308,''),
(11839,6,53,1276,309,'0'),
(11841,6,53,1276,320,'ves-g'),
(11851,6,53,1278,302,'Объём оперативной памяти'),
(11852,6,53,1278,304,'1240'),
(11853,6,53,1278,305,'0'),
(11854,6,53,1278,306,'1'),
(11855,6,53,1278,307,'0'),
(11856,6,53,1278,308,''),
(11857,6,53,1278,309,'0'),
(11859,6,53,1278,320,'obyom-operativnoi-pamyati'),
(11860,8,54,1279,295,'256'),
(11862,8,54,1279,319,''),
(11863,8,54,1279,318,'256'),
(11864,8,54,1280,295,'512'),
(11866,8,54,1280,319,''),
(11867,8,54,1280,318,'512'),
(11868,8,54,1281,295,'1024'),
(11870,8,54,1281,319,''),
(11871,8,54,1281,318,'1024'),
(11872,8,54,1282,295,'2048'),
(11874,8,54,1282,319,''),
(11875,8,54,1282,318,'2048'),
(11876,8,54,1283,295,'3072'),
(11878,8,54,1283,319,''),
(11879,8,54,1283,318,'3072'),
(11880,8,54,1284,295,'4096'),
(11882,8,54,1284,319,''),
(11883,8,54,1284,318,'4096'),
(11884,6,53,1285,302,'Объём внутренней памяти'),
(11885,6,53,1285,304,'1240'),
(11886,6,53,1285,305,'0'),
(11887,6,53,1285,306,'0'),
(11888,6,53,1285,307,'0'),
(11889,6,53,1285,308,''),
(11890,6,53,1285,309,'0'),
(11892,6,53,1285,320,'obyom-vnutrennei-pamyati'),
(11893,8,54,1286,295,'1'),
(11895,8,54,1286,319,''),
(11896,8,54,1286,318,'1'),
(11897,8,54,1287,295,'2'),
(11899,8,54,1287,319,''),
(11900,8,54,1287,318,'2'),
(11901,8,54,1288,295,'3'),
(11903,8,54,1288,319,''),
(11904,8,54,1288,318,'3'),
(11905,8,54,1289,295,'4'),
(11907,8,54,1289,319,''),
(11908,8,54,1289,318,'4'),
(11909,8,54,1290,295,'6'),
(11911,8,54,1290,319,''),
(11912,8,54,1290,318,'6'),
(11913,8,54,1291,295,'8'),
(11915,8,54,1291,319,''),
(11916,8,54,1291,318,'8'),
(11917,8,54,1292,295,'12'),
(11919,8,54,1292,319,''),
(11920,8,54,1292,318,'12'),
(11921,8,54,1293,295,'16'),
(11923,8,54,1293,319,''),
(11924,8,54,1293,318,'16'),
(11925,8,54,1294,295,'20'),
(11927,8,54,1294,319,''),
(11928,8,54,1294,318,'20'),
(11929,8,54,1295,295,'32'),
(11931,8,54,1295,319,''),
(11932,8,54,1295,318,'32'),
(11933,8,54,1296,295,'64'),
(11935,8,54,1296,319,''),
(11936,8,54,1296,318,'64'),
(11937,8,54,1297,295,'128'),
(11939,8,54,1297,319,''),
(11940,8,54,1297,318,'128'),
(11941,6,53,1298,302,'Слот для карты памяти'),
(11942,6,53,1298,304,'1239'),
(11943,6,53,1298,305,'1'),
(11944,6,53,1298,306,'1'),
(11945,6,53,1298,307,'0'),
(11946,6,53,1298,308,''),
(11947,6,53,1298,309,'0'),
(11949,6,53,1298,320,'slot-dlya-karti-pamyati'),
(11950,6,53,1299,302,'Количество мегапикселей камеры'),
(11951,6,53,1299,304,'1240'),
(11952,6,53,1299,305,'1'),
(11953,6,53,1299,306,'1'),
(11954,6,53,1299,307,'0'),
(11955,6,53,1299,308,''),
(11956,6,53,1299,309,'0'),
(11958,6,53,1299,320,'kolichestvo-megapikselei-kameri'),
(11959,8,54,1300,295,'1'),
(11961,8,54,1300,319,''),
(11962,8,54,1300,318,'1'),
(11963,8,54,1301,295,'2'),
(11965,8,54,1301,319,''),
(11966,8,54,1301,318,'2'),
(11967,8,54,1302,295,'3'),
(11969,8,54,1302,319,''),
(11970,8,54,1302,318,'3'),
(11971,8,54,1303,295,'5'),
(11973,8,54,1303,319,''),
(11974,8,54,1303,318,'5'),
(11975,8,54,1304,295,'8'),
(11977,8,54,1304,319,''),
(11978,8,54,1304,318,'8'),
(11979,8,54,1305,295,'12'),
(11981,8,54,1305,319,''),
(11982,8,54,1305,318,'12'),
(11983,8,54,1306,295,'16'),
(11985,8,54,1306,319,''),
(11986,8,54,1306,318,'16'),
(11987,8,54,1307,295,'20'),
(11989,8,54,1307,319,''),
(11990,8,54,1307,318,'20'),
(11991,8,54,1308,295,'32'),
(11993,8,54,1308,319,''),
(11994,8,54,1308,318,'32'),
(11995,8,54,1309,295,'42'),
(11997,8,54,1309,319,''),
(11998,8,54,1309,318,'42'),
(11999,6,53,1310,302,'Разрешение экрана'),
(12000,6,53,1310,304,'1240'),
(12001,6,53,1310,305,'1'),
(12002,6,53,1310,306,'1'),
(12003,6,53,1310,307,'0'),
(12004,6,53,1310,308,''),
(12005,6,53,1310,309,'0'),
(12007,6,53,1310,320,'razreshenie-ekrana'),
(12008,8,54,1311,295,'1136x640'),
(12010,8,54,1311,319,''),
(12011,8,54,1311,318,'1136x640'),
(12012,8,54,1312,295,'1280x720 (HD)'),
(12014,8,54,1312,319,''),
(12015,8,54,1312,318,'1280x720-hd'),
(12016,8,54,1313,295,'1280x768'),
(12018,8,54,1313,319,''),
(12019,8,54,1313,318,'1280x768'),
(12020,8,54,1314,295,'1334x750'),
(12022,8,54,1314,319,''),
(12023,8,54,1314,318,'1334x750'),
(12024,8,54,1315,295,'1440x1440'),
(12026,8,54,1315,319,''),
(12027,8,54,1315,318,'1440x1440'),
(12028,8,54,1316,295,'1800x1080'),
(12030,8,54,1316,319,''),
(12031,8,54,1316,318,'1800x1080'),
(12032,8,54,1317,295,'1920x1080 (Full HD)'),
(12034,8,54,1317,319,''),
(12035,8,54,1317,318,'1920x1080-full-hd'),
(12036,8,54,1318,295,'1920x1152'),
(12038,8,54,1318,319,''),
(12039,8,54,1318,318,'1920x1152'),
(12040,8,54,1319,295,'2560x1440 (QHD)'),
(12042,8,54,1319,319,''),
(12043,8,54,1319,318,'2560x1440-qhd'),
(12044,8,54,1320,295,'2560x1536'),
(12046,8,54,1320,319,''),
(12047,8,54,1320,318,'2560x1536'),
(12048,8,54,1321,295,'320x240'),
(12050,8,54,1321,319,''),
(12051,8,54,1321,318,'320x240'),
(12052,8,54,1322,295,'3840x2160 (4K)'),
(12054,8,54,1322,319,''),
(12055,8,54,1322,318,'3840x2160-4k'),
(12056,8,54,1323,295,'400x240'),
(12058,8,54,1323,319,''),
(12059,8,54,1323,318,'400x240'),
(12060,8,54,1324,295,'400x360'),
(12062,8,54,1324,319,''),
(12063,8,54,1324,318,'400x360'),
(12064,8,54,1325,295,'480x320'),
(12066,8,54,1325,319,''),
(12067,8,54,1325,318,'480x320'),
(12068,8,54,1326,295,'480x360'),
(12070,8,54,1326,319,''),
(12071,8,54,1326,318,'480x360'),
(12072,8,54,1327,295,'640x360'),
(12074,8,54,1327,319,''),
(12075,8,54,1327,318,'640x360'),
(12076,8,54,1328,295,'640x480'),
(12078,8,54,1328,319,''),
(12079,8,54,1328,318,'640x480'),
(12080,8,54,1329,295,'720x720'),
(12082,8,54,1329,319,''),
(12083,8,54,1329,318,'720x720'),
(12084,8,54,1330,295,'800x480'),
(12086,8,54,1330,319,''),
(12087,8,54,1330,318,'800x480'),
(12088,8,54,1331,295,'854x480'),
(12090,8,54,1331,319,''),
(12091,8,54,1331,318,'854x480'),
(12092,8,54,1332,295,'960x540'),
(12094,8,54,1332,319,''),
(12095,8,54,1332,318,'960x540'),
(12096,8,54,1333,295,'960x640'),
(12098,8,54,1333,319,''),
(12099,8,54,1333,318,'960x640'),
(12100,6,53,1334,302,'Разрешение видеозаписи'),
(12101,6,53,1334,304,'1241'),
(12102,6,53,1334,305,'0'),
(12103,6,53,1334,306,'0'),
(12104,6,53,1334,307,'0'),
(12105,6,53,1334,308,''),
(12106,6,53,1334,309,'0'),
(12108,6,53,1334,320,'razreshenie-videozapisi'),
(12109,8,54,1335,295,'1280x720'),
(12111,8,54,1335,319,''),
(12112,8,54,1335,318,'1280x720'),
(12113,8,54,1336,295,'128x96'),
(12115,8,54,1336,319,''),
(12116,8,54,1336,318,'128x96'),
(12117,8,54,1337,295,'160x120'),
(12119,8,54,1337,319,''),
(12120,8,54,1337,318,'160x120'),
(12121,8,54,1338,295,'176x144'),
(12123,8,54,1338,319,''),
(12124,8,54,1338,318,'176x144'),
(12125,8,54,1339,295,'1920x1080'),
(12127,8,54,1339,319,''),
(12128,8,54,1339,318,'1920x1080'),
(12129,8,54,1340,295,'220х176'),
(12131,8,54,1340,319,''),
(12132,8,54,1340,318,'220h176'),
(12133,8,54,1341,295,'320x240'),
(12135,8,54,1341,319,''),
(12136,8,54,1341,318,'320x240'),
(12137,8,54,1342,295,'352x288'),
(12139,8,54,1342,319,''),
(12140,8,54,1342,318,'352x288'),
(12141,8,54,1343,295,'3840x2160'),
(12143,8,54,1343,319,''),
(12144,8,54,1343,318,'3840x2160'),
(12145,8,54,1344,295,'480x320'),
(12147,8,54,1344,319,''),
(12148,8,54,1344,318,'480x320'),
(12149,8,54,1345,295,'640x480'),
(12151,8,54,1345,319,''),
(12152,8,54,1345,318,'640x480'),
(12153,8,54,1346,295,'720x480'),
(12155,8,54,1346,319,''),
(12156,8,54,1346,318,'720x480'),
(12157,8,54,1347,295,'800x480'),
(12159,8,54,1347,319,''),
(12160,8,54,1347,318,'800x480'),
(12161,8,54,1348,295,'848x480'),
(12163,8,54,1348,319,''),
(12164,8,54,1348,318,'848x480'),
(12174,8,54,1350,295,'GPS'),
(12176,8,54,1350,319,''),
(12177,8,54,1350,318,'gps'),
(12178,8,54,1351,295,'ГЛОНАСС'),
(12180,8,54,1351,319,''),
(12181,8,54,1351,318,'glonass'),
(12182,8,54,1352,295,'BeiDou'),
(12184,8,54,1352,319,''),
(12185,8,54,1352,318,'beidou'),
(12186,6,53,1353,302,'Ёмкость аккумулятора'),
(12187,6,53,1353,304,'1238'),
(12188,6,53,1353,305,'1'),
(12189,6,53,1353,306,'1'),
(12190,6,53,1353,307,'0'),
(12191,6,53,1353,308,''),
(12192,6,53,1353,309,'0'),
(12194,6,53,1353,320,'yomkost-akkumulyatora'),
(12204,6,53,1355,302,'Диагональ экрана (дюймы)'),
(12205,6,53,1355,304,'1238'),
(12206,6,53,1355,305,'1'),
(12207,6,53,1355,306,'1'),
(12208,6,53,1355,307,'0'),
(12209,6,53,1355,308,''),
(12210,6,53,1355,309,'0'),
(12212,6,53,1355,320,'diagonal-ekrana-dyimi'),
(12213,6,53,1356,302,'Производитель'),
(12214,6,53,1356,304,'1240'),
(12215,6,53,1356,305,'1'),
(12216,6,53,1356,306,'1'),
(12217,6,53,1356,307,'0'),
(12218,6,53,1356,308,''),
(12219,6,53,1356,309,'1233'),
(12221,6,53,1356,320,'proizvoditel'),
(12222,6,53,1357,302,'Вес (г)'),
(12223,6,53,1357,304,'1238'),
(12224,6,53,1357,305,'0'),
(12225,6,53,1357,306,'0'),
(12226,6,53,1357,307,'0'),
(12227,6,53,1357,308,''),
(12228,6,53,1357,309,'0'),
(12230,6,53,1357,320,'ves-g'),
(12231,6,53,1358,302,'Размеры (ШxГxВ)'),
(12232,6,53,1358,304,'1238'),
(12233,6,53,1358,305,'0'),
(12234,6,53,1358,306,'0'),
(12235,6,53,1358,307,'0'),
(12236,6,53,1358,308,''),
(12237,6,53,1358,309,'0'),
(12239,6,53,1358,320,'razmeri-shxgxv'),
(13305,8,58,1237,310,'Большое поле текста'),
(13306,8,58,1237,311,'<p>[cur.name]:<br>\r\n    [form.ckeditor(name="properties["+cur+"]", value=$value)]\r\n</p>'),
(13307,8,58,1237,0,'a:1:{s:36:"val_c0ef0886959923cbdf1283ec0c5a479f";a:1:{i:3;a:1:{s:8:"ckeditor";s:8:"ckeditor";}}}'),
(13308,8,58,1237,312,'[cow.dvalues.add(''param''=cur, ''value''=post.properties[cur])]'),
(13309,8,58,1237,313,''),
(13310,8,58,1237,314,''),
(13311,8,58,1237,315,''),
(13312,8,58,1237,316,'<p>[cur.name]:<br>\r\n    <input type="text" name="dpar[[[cur]]]" id="[cur]_[glob.form_id]" value="[$value]"[$class.if('' class="''+$class+''"'')]>\r\n</p>'),
(13313,8,58,1237,317,'[objs=$objs.fastget:dvalues(_''value''^$val.lower,''param''==cur).owners]'),
(13323,8,58,1239,310,'Логический'),
(13324,8,58,1239,311,'<p>\r\n    <label style="cursor: pointer">\r\n        <input type="checkbox" name="properties[[[cur]]]" id="[cur]_[glob.form_id]" class="button"[if $value] checked[/if]>[cur.name]\r\n    </label>\r\n</p>'),
(13325,8,58,1239,0,'a:0:{}'),
(13326,8,58,1239,312,'[if post.properties[cur]]\r\n    [cow.dvalues.add(''param''=cur, ''value''=1)]\r\n[/if]'),
(13327,8,58,1239,313,''),
(13328,8,58,1239,314,''),
(13329,8,58,1239,315,''),
(13330,8,58,1239,316,''),
(13331,8,58,1239,317,'[objs=$objs.fastget:dvalues(''value'',''param''==cur).owners]'),
(13368,6,53,1637,302,'Диагональ (дюймы)'),
(13369,6,53,1637,304,'1238'),
(13370,6,53,1637,305,'1'),
(13371,6,53,1637,306,'1'),
(13372,6,53,1637,307,'0'),
(13373,6,53,1637,308,''),
(13374,6,53,1637,322,''),
(13375,6,53,1637,309,'0'),
(13377,6,53,1637,320,'diagonal-dyimi'),
(13378,6,53,1638,302,'Тип'),
(13379,6,53,1638,304,'1240'),
(13380,6,53,1638,305,'1'),
(13381,6,53,1638,306,'1'),
(13382,6,53,1638,307,'0'),
(13383,6,53,1638,308,''),
(13384,6,53,1638,322,''),
(13385,6,53,1638,309,'0'),
(13387,6,53,1638,320,'tip'),
(13388,8,54,1639,295,'OLED'),
(13390,8,54,1639,319,''),
(13391,8,54,1639,318,'oled'),
(13392,8,54,1640,295,'ЖК'),
(13394,8,54,1640,319,''),
(13395,8,54,1640,318,'jk'),
(13396,8,54,1641,295,'ЭЛТ'),
(13398,8,54,1641,319,''),
(13399,8,54,1641,318,'elt'),
(13400,8,54,1642,295,'ЭЛТ плоский'),
(13402,8,54,1642,319,''),
(13403,8,54,1642,318,'elt-ploskii'),
(13404,8,54,1643,295,'лазерный'),
(13406,8,54,1643,319,''),
(13407,8,54,1643,318,'lazernii'),
(13408,8,54,1644,295,'плазменная панель'),
(13410,8,54,1644,319,''),
(13411,8,54,1644,318,'plazmennaya-panel'),
(13412,8,54,1645,295,'проекционный'),
(13414,8,54,1645,319,''),
(13415,8,54,1645,318,'proekcionnii'),
(13416,6,53,1646,302,'Поддержка 3D'),
(13417,6,53,1646,304,'1239'),
(13418,6,53,1646,305,'1'),
(13419,6,53,1646,306,'1'),
(13420,6,53,1646,307,'0'),
(13421,6,53,1646,308,''),
(13422,6,53,1646,322,''),
(13423,6,53,1646,309,'0'),
(13425,6,53,1646,320,'podderjka-3d'),
(13443,6,36,1648,193,'ТВ'),
(13445,6,36,1648,194,'tv'),
(13446,6,36,1649,193,'FullHD'),
(13448,6,36,1649,194,'fullhd'),
(13483,6,43,1647,219,'/files/uploads/photo/big9c5f591b9e47ce33e3284df795a76aa5.jpg'),
(13515,6,43,1661,219,'/files/uploads/photo/big2dda621e04183c264f8f6dafac4521e1.jpg'),
(13545,6,35,1668,187,'Бытовая техника'),
(13546,6,35,1668,188,'hometech'),
(13547,6,35,1668,189,''),
(13548,6,35,1669,187,'Электроплиты'),
(13549,6,35,1669,188,'oven'),
(13550,6,35,1669,189,''),
(13551,6,35,1670,187,'Холодильники'),
(13552,6,35,1670,188,'frige'),
(13553,6,35,1670,189,''),
(13557,6,43,1671,219,'/files/uploads/photo/big82609a2a25fdd20a8eaa6dd653dee49d.jpg'),
(13577,6,43,1672,219,'/files/uploads/photo/big980f23a4ede7188688acc5192ffd4517.jpg'),
(13597,6,43,1673,219,'/files/uploads/photo/big1bdfbb7b52b5af8d4b079d0fa7724098.jpg'),
(13656,6,43,1674,219,'/files/uploads/photo/big6d59a7ea70a1e0e4ff6f07bdc3e633d2.jpg'),
(13671,1,8,1675,40,'Правая колонка'),
(13687,1,8,2,40,'Правая колонка'),
(13688,1,8,1676,40,'Правая колонка'),
(13689,1,8,1676,40,'Правая колонка'),
(13705,1,8,2,40,'Правая колонка'),
(13706,1,8,2,40,'Правая колонка'),
(13707,1,8,1677,40,'Правая колонка'),
(13708,1,8,1677,40,'Правая колонка'),
(13709,1,8,1677,40,'Правая колонка'),
(13710,1,8,1677,40,'Правая колонка'),
(13726,1,8,2,40,'Правая колонка'),
(13727,1,8,2,40,'Правая колонка'),
(13728,1,8,2,40,'Правая колонка'),
(13729,1,8,2,40,'Правая колонка'),
(13730,1,8,1678,40,'Правая колонка'),
(13731,1,8,1678,40,'Правая колонка'),
(13732,1,8,1678,40,'Правая колонка'),
(13733,1,8,1678,40,'Правая колонка'),
(13734,1,8,1678,40,'Правая колонка'),
(13735,1,8,1678,40,'Правая колонка'),
(13736,1,8,1678,40,'Правая колонка'),
(13737,1,8,1678,40,'Правая колонка'),
(13753,1,8,2,40,'Правая колонка'),
(13754,1,8,2,40,'Правая колонка'),
(13755,1,8,2,40,'Правая колонка'),
(13756,1,8,2,40,'Правая колонка'),
(13757,1,8,2,40,'Правая колонка'),
(13758,1,8,2,40,'Правая колонка'),
(13759,1,8,2,40,'Правая колонка'),
(13760,1,8,2,40,'Правая колонка'),
(13761,1,8,1679,40,'Правая колонка'),
(13762,1,8,1679,40,'Правая колонка'),
(13763,1,8,1679,40,'Правая колонка'),
(13764,1,8,1679,40,'Правая колонка'),
(13765,1,8,1679,40,'Правая колонка'),
(13766,1,8,1679,40,'Правая колонка'),
(13767,1,8,1679,40,'Правая колонка'),
(13768,1,8,1679,40,'Правая колонка'),
(13769,1,8,1679,40,'Правая колонка'),
(13770,1,8,1679,40,'Правая колонка'),
(13771,1,8,1679,40,'Правая колонка'),
(13772,1,8,1679,40,'Правая колонка'),
(13773,1,8,1679,40,'Правая колонка'),
(13774,1,8,1679,40,'Правая колонка'),
(13775,1,8,1679,40,'Правая колонка'),
(13776,1,8,1679,40,'Правая колонка'),
(13792,1,8,2,40,'Правая колонка'),
(13793,1,8,2,40,'Правая колонка'),
(13794,1,8,2,40,'Правая колонка'),
(13795,1,8,2,40,'Правая колонка'),
(13796,1,8,2,40,'Правая колонка'),
(13797,1,8,2,40,'Правая колонка'),
(13798,1,8,2,40,'Правая колонка'),
(13799,1,8,2,40,'Правая колонка'),
(13800,1,8,2,40,'Правая колонка'),
(13801,1,8,2,40,'Правая колонка'),
(13802,1,8,2,40,'Правая колонка'),
(13803,1,8,2,40,'Правая колонка'),
(13804,1,8,2,40,'Правая колонка'),
(13805,1,8,2,40,'Правая колонка'),
(13806,1,8,2,40,'Правая колонка'),
(13807,1,8,2,40,'Правая колонка'),
(13808,1,8,1680,40,'Правая колонка'),
(13809,1,8,1680,40,'Правая колонка'),
(13810,1,8,1680,40,'Правая колонка'),
(13811,1,8,1680,40,'Правая колонка'),
(13812,1,8,1680,40,'Правая колонка'),
(13813,1,8,1680,40,'Правая колонка'),
(13814,1,8,1680,40,'Правая колонка'),
(13815,1,8,1680,40,'Правая колонка'),
(13816,1,8,1680,40,'Правая колонка'),
(13817,1,8,1680,40,'Правая колонка'),
(13818,1,8,1680,40,'Правая колонка'),
(13819,1,8,1680,40,'Правая колонка'),
(13820,1,8,1680,40,'Правая колонка'),
(13821,1,8,1680,40,'Правая колонка'),
(13822,1,8,1680,40,'Правая колонка'),
(13823,1,8,1680,40,'Правая колонка'),
(13824,1,8,1680,40,'Правая колонка'),
(13825,1,8,1680,40,'Правая колонка'),
(13826,1,8,1680,40,'Правая колонка'),
(13827,1,8,1680,40,'Правая колонка'),
(13828,1,8,1680,40,'Правая колонка'),
(13829,1,8,1680,40,'Правая колонка'),
(13830,1,8,1680,40,'Правая колонка'),
(13831,1,8,1680,40,'Правая колонка'),
(13832,1,8,1680,40,'Правая колонка'),
(13833,1,8,1680,40,'Правая колонка'),
(13834,1,8,1680,40,'Правая колонка'),
(13835,1,8,1680,40,'Правая колонка'),
(13836,1,8,1680,40,'Правая колонка'),
(13837,1,8,1680,40,'Правая колонка'),
(13838,1,8,1680,40,'Правая колонка'),
(13839,1,8,1680,40,'Правая колонка'),
(13886,1,8,1687,40,'Правая колонка'),
(13887,1,8,1687,40,'Правая колонка'),
(13888,1,8,1687,40,'Правая колонка'),
(13889,1,8,1687,40,'Правая колонка'),
(13890,1,8,1687,40,'Правая колонка'),
(13891,1,8,1687,40,'Правая колонка'),
(13892,1,8,1687,40,'Правая колонка'),
(13893,1,8,1687,40,'Правая колонка'),
(13894,1,8,1687,40,'Правая колонка'),
(13895,1,8,1687,40,'Правая колонка'),
(13896,1,8,1687,40,'Правая колонка'),
(13897,1,8,1687,40,'Правая колонка'),
(13898,1,8,1687,40,'Правая колонка'),
(13899,1,8,1687,40,'Правая колонка'),
(13900,1,8,1687,40,'Правая колонка'),
(13901,1,8,1687,40,'Правая колонка'),
(13902,1,8,1687,40,'Правая колонка'),
(13903,1,8,1687,40,'Правая колонка'),
(13904,1,8,1687,40,'Правая колонка'),
(13905,1,8,1687,40,'Правая колонка'),
(13906,1,8,1687,40,'Правая колонка'),
(13907,1,8,1687,40,'Правая колонка'),
(13908,1,8,1687,40,'Правая колонка'),
(13909,1,8,1687,40,'Правая колонка'),
(13910,1,8,1687,40,'Правая колонка'),
(13911,1,8,1687,40,'Правая колонка'),
(13912,1,8,1687,40,'Правая колонка'),
(13913,1,8,1687,40,'Правая колонка'),
(13914,1,8,1687,40,'Правая колонка'),
(13915,1,8,1687,40,'Правая колонка'),
(13916,1,8,1687,40,'Правая колонка'),
(13917,1,8,1687,40,'Правая колонка'),
(13938,1,8,1689,40,'Правая колонка'),
(13939,1,8,1689,40,'Правая колонка'),
(13940,1,8,1689,40,'Правая колонка'),
(13941,1,8,1689,40,'Правая колонка'),
(13942,1,8,1689,40,'Правая колонка'),
(13943,1,8,1689,40,'Правая колонка'),
(13944,1,8,1689,40,'Правая колонка'),
(13945,1,8,1689,40,'Правая колонка'),
(13946,1,8,1689,40,'Правая колонка'),
(13947,1,8,1689,40,'Правая колонка'),
(13948,1,8,1689,40,'Правая колонка'),
(13949,1,8,1689,40,'Правая колонка'),
(13950,1,8,1689,40,'Правая колонка'),
(13951,1,8,1689,40,'Правая колонка'),
(13952,1,8,1689,40,'Правая колонка'),
(13953,1,8,1689,40,'Правая колонка'),
(13954,1,8,1689,40,'Правая колонка'),
(13955,1,8,1689,40,'Правая колонка'),
(13956,1,8,1689,40,'Правая колонка'),
(13957,1,8,1689,40,'Правая колонка'),
(13958,1,8,1689,40,'Правая колонка'),
(13959,1,8,1689,40,'Правая колонка'),
(13960,1,8,1689,40,'Правая колонка'),
(13961,1,8,1689,40,'Правая колонка'),
(13962,1,8,1689,40,'Правая колонка'),
(13963,1,8,1689,40,'Правая колонка'),
(13964,1,8,1689,40,'Правая колонка'),
(13965,1,8,1689,40,'Правая колонка'),
(13966,1,8,1689,40,'Правая колонка'),
(13967,1,8,1689,40,'Правая колонка'),
(13968,1,8,1689,40,'Правая колонка'),
(13969,1,8,1689,40,'Правая колонка'),
(14005,1,8,1694,40,'Правая колонка'),
(14006,1,8,1694,40,'Правая колонка'),
(14007,1,8,1694,40,'Правая колонка'),
(14008,1,8,1694,40,'Правая колонка'),
(14009,1,8,1694,40,'Правая колонка'),
(14010,1,8,1694,40,'Правая колонка'),
(14011,1,8,1694,40,'Правая колонка'),
(14012,1,8,1694,40,'Правая колонка'),
(14013,1,8,1694,40,'Правая колонка'),
(14014,1,8,1694,40,'Правая колонка'),
(14015,1,8,1694,40,'Правая колонка'),
(14016,1,8,1694,40,'Правая колонка'),
(14017,1,8,1694,40,'Правая колонка'),
(14018,1,8,1694,40,'Правая колонка'),
(14019,1,8,1694,40,'Правая колонка'),
(14020,1,8,1694,40,'Правая колонка'),
(14021,1,8,1694,40,'Правая колонка'),
(14022,1,8,1694,40,'Правая колонка'),
(14023,1,8,1694,40,'Правая колонка'),
(14024,1,8,1694,40,'Правая колонка'),
(14025,1,8,1694,40,'Правая колонка'),
(14026,1,8,1694,40,'Правая колонка'),
(14027,1,8,1694,40,'Правая колонка'),
(14028,1,8,1694,40,'Правая колонка'),
(14029,1,8,1694,40,'Правая колонка'),
(14030,1,8,1694,40,'Правая колонка'),
(14031,1,8,1694,40,'Правая колонка'),
(14032,1,8,1694,40,'Правая колонка'),
(14033,1,8,1694,40,'Правая колонка'),
(14034,1,8,1694,40,'Правая колонка'),
(14035,1,8,1694,40,'Правая колонка'),
(14036,1,8,1694,40,'Правая колонка'),
(14068,1,8,1698,40,'Правая колонка'),
(14069,1,8,1698,40,'Правая колонка'),
(14070,1,8,1698,40,'Правая колонка'),
(14071,1,8,1698,40,'Правая колонка'),
(14072,1,8,1698,40,'Правая колонка'),
(14073,1,8,1698,40,'Правая колонка'),
(14074,1,8,1698,40,'Правая колонка'),
(14075,1,8,1698,40,'Правая колонка'),
(14076,1,8,1698,40,'Правая колонка'),
(14077,1,8,1698,40,'Правая колонка'),
(14078,1,8,1698,40,'Правая колонка'),
(14079,1,8,1698,40,'Правая колонка'),
(14080,1,8,1698,40,'Правая колонка'),
(14081,1,8,1698,40,'Правая колонка'),
(14082,1,8,1698,40,'Правая колонка'),
(14083,1,8,1698,40,'Правая колонка'),
(14084,1,8,1698,40,'Правая колонка'),
(14085,1,8,1698,40,'Правая колонка'),
(14086,1,8,1698,40,'Правая колонка'),
(14087,1,8,1698,40,'Правая колонка'),
(14088,1,8,1698,40,'Правая колонка'),
(14089,1,8,1698,40,'Правая колонка'),
(14090,1,8,1698,40,'Правая колонка'),
(14091,1,8,1698,40,'Правая колонка'),
(14092,1,8,1698,40,'Правая колонка'),
(14093,1,8,1698,40,'Правая колонка'),
(14094,1,8,1698,40,'Правая колонка'),
(14095,1,8,1698,40,'Правая колонка'),
(14096,1,8,1698,40,'Правая колонка'),
(14097,1,8,1698,40,'Правая колонка'),
(14098,1,8,1698,40,'Правая колонка'),
(14099,1,8,1698,40,'Правая колонка'),
(14136,1,8,1703,40,'Правая колонка'),
(14137,1,8,1703,40,'Правая колонка'),
(14138,1,8,1703,40,'Правая колонка'),
(14139,1,8,1703,40,'Правая колонка'),
(14140,1,8,1703,40,'Правая колонка'),
(14141,1,8,1703,40,'Правая колонка'),
(14142,1,8,1703,40,'Правая колонка'),
(14143,1,8,1703,40,'Правая колонка'),
(14144,1,8,1703,40,'Правая колонка'),
(14145,1,8,1703,40,'Правая колонка'),
(14146,1,8,1703,40,'Правая колонка'),
(14147,1,8,1703,40,'Правая колонка'),
(14148,1,8,1703,40,'Правая колонка'),
(14149,1,8,1703,40,'Правая колонка'),
(14150,1,8,1703,40,'Правая колонка'),
(14151,1,8,1703,40,'Правая колонка'),
(14152,1,8,1703,40,'Правая колонка'),
(14153,1,8,1703,40,'Правая колонка'),
(14154,1,8,1703,40,'Правая колонка'),
(14155,1,8,1703,40,'Правая колонка'),
(14156,1,8,1703,40,'Правая колонка'),
(14157,1,8,1703,40,'Правая колонка'),
(14158,1,8,1703,40,'Правая колонка'),
(14159,1,8,1703,40,'Правая колонка'),
(14160,1,8,1703,40,'Правая колонка'),
(14161,1,8,1703,40,'Правая колонка'),
(14162,1,8,1703,40,'Правая колонка'),
(14163,1,8,1703,40,'Правая колонка'),
(14164,1,8,1703,40,'Правая колонка'),
(14165,1,8,1703,40,'Правая колонка'),
(14166,1,8,1703,40,'Правая колонка'),
(14167,1,8,1703,40,'Правая колонка'),
(14189,1,8,1705,40,'Правая колонка'),
(14190,1,8,1705,40,'Правая колонка'),
(14191,1,8,1705,40,'Правая колонка'),
(14192,1,8,1705,40,'Правая колонка'),
(14193,1,8,1705,40,'Правая колонка'),
(14194,1,8,1705,40,'Правая колонка'),
(14195,1,8,1705,40,'Правая колонка'),
(14196,1,8,1705,40,'Правая колонка'),
(14197,1,8,1705,40,'Правая колонка'),
(14198,1,8,1705,40,'Правая колонка'),
(14199,1,8,1705,40,'Правая колонка'),
(14200,1,8,1705,40,'Правая колонка'),
(14201,1,8,1705,40,'Правая колонка'),
(14202,1,8,1705,40,'Правая колонка'),
(14203,1,8,1705,40,'Правая колонка'),
(14204,1,8,1705,40,'Правая колонка'),
(14205,1,8,1705,40,'Правая колонка'),
(14206,1,8,1705,40,'Правая колонка'),
(14207,1,8,1705,40,'Правая колонка'),
(14208,1,8,1705,40,'Правая колонка'),
(14209,1,8,1705,40,'Правая колонка'),
(14210,1,8,1705,40,'Правая колонка'),
(14211,1,8,1705,40,'Правая колонка'),
(14212,1,8,1705,40,'Правая колонка'),
(14213,1,8,1705,40,'Правая колонка'),
(14214,1,8,1705,40,'Правая колонка'),
(14215,1,8,1705,40,'Правая колонка'),
(14216,1,8,1705,40,'Правая колонка'),
(14217,1,8,1705,40,'Правая колонка'),
(14218,1,8,1705,40,'Правая колонка'),
(14219,1,8,1705,40,'Правая колонка'),
(14220,1,8,1705,40,'Правая колонка'),
(14221,2,0,2,9,'800'),
(14222,2,0,2,8,'1100'),
(14223,2,0,2,10,'1'),
(14224,2,0,2,12,'1'),
(14225,2,0,2,7,'200'),
(14226,2,0,2,6,'150'),
(14227,2,0,2,11,'6'),
(14228,2,0,2,13,'1'),
(14229,2,0,2,179,'/files/uploads/watermarks/wm60ac37a4d728c067c1a9ed2044b002fb.png'),
(14230,2,0,2,180,'90'),
(14231,2,0,2,181,'bottom center'),
(14232,2,0,2,182,'173'),
(14233,2,0,2,184,''),
(14234,2,0,2,185,'204'),
(14235,2,0,2,186,'6'),
(14236,5,0,2,290,'0'),
(14300,7,49,1137,265,'Простая форма'),
(14301,7,49,1137,266,'[cm.part.top]\r\n\r\n[if component.is_bootstrap]\r\n    \r\n    [tree $form.fields.rows]\r\n        <div class="form-group">\r\n            <label for="field[cur]_[glob.form_id]">[cur.title]</label>\r\n            [cur.type.input.shell(class=''form-control'')]\r\n        </div>\r\n    [/tree]\r\n        \r\n[else]    \r\n    \r\n    <table cellpadding="5" cellspacing="0" border="0">\r\n    [tree $form.fields.rows]\r\n        <tr>\r\n            <td valign="top">[cur.title]</td>\r\n            <td>[cur.type.input.shell]</td>\r\n        </tr>\r\n    [/tree]\r\n    </table>\r\n        \r\n[/if]\r\n    \r\n[if $capcha]\r\n    [component.capcha_question(type=''form'')]\r\n[/if]\r\n\r\n[if component.is_bootstrap]\r\n    [cm.part.bottom(submit_class=''btn btn-primary'')]\r\n[else]\r\n    [cm.part.bottom]\r\n[/if]');

INSERT INTO `row_value` (value_id,value_module,value_table,value_row,value_col,value_value) VALUES
(14302,7,49,1137,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:2:{s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(14303,7,49,1137,268,'alert(error);'),
(14304,7,49,1137,294,''),
(14310,7,49,1167,265,'Блок авторизации'),
(14311,7,49,1167,266,'<a name="auth_block"></a>\r\n[if $action=="logout"]\r\n    [user.logout]\r\n    <div>Вы вышли</div>\r\n[/if]\r\n[if user.type==''guest'']\r\n    [cm.part.top(anchor="auth_block")]\r\n    \r\n    [if component.is_bootstrap]\r\n        [tree $form.fields.rows]\r\n            <div class="form-group">\r\n                <label for="field[cur]_[glob.form_id]">[cur.title]</label>\r\n                [cur.type.input.shell(class=''form-control'')]\r\n            </div>\r\n        [/tree]\r\n        [cm.part.bottom(submit_class=''btn btn-primary'')]\r\n    [else]\r\n        <table cellpadding="5" cellspacing="0" border="0">\r\n        [tree $form.fields.rows]\r\n            <tr>\r\n                <td valign="top">[cur.title]</td>\r\n                <td>[cur.type.input.shell]</td>\r\n            </tr>\r\n        [/tree]\r\n        </table>\r\n        [cm.part.bottom]\r\n    [/if]\r\n\r\n[else]\r\n    <div>Вы авторизованы как <b>[user.name]</b></div>\r\n    <div><a href="[url4 "action" "logout"]#auth_block">Выход</a></div>\r\n[/if]'),
(14312,7,49,1167,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:1:{s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(14313,7,49,1167,268,'alert(error);'),
(14314,7,49,1167,294,''),
(14320,7,49,1213,265,'Блок регистрации'),
(14321,7,49,1213,266,'[*** В настоящий момент содержимое данного блоко в точности напоминает содержимое шаблона "Простая форма" ***]\r\n\r\n[cm.part.top]\r\n    \r\n[if component.is_bootstrap]\r\n    [tree $form.fields.rows]\r\n        <div class="form-group">\r\n            <label for="field[cur]_[glob.form_id]">[cur.title]</label>\r\n            [cur.type.input.shell(class=''form-control'')]\r\n        </div>\r\n    [/tree]\r\n[else]\r\n    <table cellpadding="5" cellspacing="0" border="0">\r\n    [tree $form.fields.rows]\r\n        <tr>\r\n            <td valign="top">[cur.title]</td>\r\n            <td>[cur.type.input.shell]</td>\r\n        </tr>\r\n    [/tree]\r\n    </table>\r\n[/if]\r\n\r\n[if $capcha]\r\n    [component.capcha_question(type=''form'')]\r\n    <br>\r\n[/if]\r\n\r\n[if component.is_bootstrap]\r\n    [cm.part.bottom(submit_class=''btn btn-primary'')]\r\n[else]\r\n    [cm.part.bottom]\r\n[/if]'),
(14322,7,49,1213,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:2:{s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(14323,7,49,1213,268,'alert(error);'),
(14324,7,49,1213,294,''),
(14330,7,49,1215,265,'Форма поиска'),
(14331,7,49,1215,266,'<form action="/search" id="form[glob.form_id]" OnSubmit="return submit_form([glob.form_id],[if($ajax,1,0)]);" method="get" enctype="multipart/form-data">\r\n    [if $protect][form_protect][/if]\r\n    <input type="hidden" name="action" value="search">\r\n    [*<input type="hidden" name="form_id" value="[glob.form_id]">*]\r\n    \r\n[if component.is_bootstrap]\r\n    \r\n    [tree $form.fields.rows]\r\n        [input_name=''field''++cur++''_''++glob.form_id]\r\n        [if cur.fix_field][input_name=''query''][/if]\r\n        <div class="form-group">\r\n            <label for="[$input_name]">[cur.title]</label>\r\n            [cur.type.input.shell(class=''form-control'', name=$input_name)]\r\n        </div>\r\n    [/tree]\r\n    \r\n[else]\r\n\r\n    <table cellpadding="5" cellspacing="0" border="0">\r\n    [tree $form.fields.rows]\r\n        <tr>\r\n            <td valign="top">[cur.title]</td>\r\n            <td>\r\n                [if cur.fix_field]\r\n                    [cur.type.input.shell(input_name=''query'')]\r\n                [else]\r\n                    [cur.type.input.shell]\r\n                [/if]\r\n            </td>\r\n        </tr>\r\n    [/tree]\r\n    </table>\r\n        \r\n[/if]\r\n\r\n[if $capcha]\r\n    [component.capcha_question(type=''form'')]\r\n    <br>\r\n[/if]\r\n\r\n[if component.is_bootstrap]\r\n    [cm.part.bottom(submit_class="btn btn-primary")]\r\n[else]\r\n    [cm.part.bottom]\r\n[/if]'),
(14332,7,49,1215,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:2:{s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(14333,7,49,1215,268,'alert(error);'),
(14334,7,49,1215,294,''),
(14341,7,46,1135,249,'E-mail адрес'),
(14342,7,46,1135,250,'[field=cur]<input type="[if component.is_bootstrap]email[else]text[/if]" name="[cm.part.f_name]" id="field[$field]_[glob.form_id]" value="[$field.default]"[$class.if('' class="''+$class+''"'')]>\n[compile js u]\n    $(document).ready(function() {\n        $(''#field[$field]_[glob.form_id]'').blur(function() {\n        [~\n            if($(this).val() != '''') {\n                var pattern = /^([a-z0-9_\\.-])+@[a-z0-9-]+\\.([a-z]{2,4}\\.)?[a-z]{2,4}$/i;\n                if(pattern.test($(this).val())){\n                    $(this).css({''border'' : ''1px solid #569b44''});\n                } else {\n                    $(this).css({''border'' : ''1px solid #ff0000''});\n                }\n            } else {\n                $(this).css({''border'' : ''1px solid #ff0000''});\n            }\n        ~]\n        });\n    });\n[/compile]'),
(14343,7,46,1135,0,'a:1:{s:36:"val_f9864b40c7a0defbfc155474c3909198";a:1:{i:2;a:1:{s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(14344,7,46,1135,251,'var pattern = new RegExp(/^(("[\\w-\\s]+")|([\\w-]+(?:\\.[\\w-]+)*)|("[\\w-\\s]+")([\\w-]+(?:\\.[\\w-]+)*))(@((?:[\\w-]+\\.)*\\w[\\w-]{0,66})\\.([a-z]{2,6}(?:\\.[a-z]{2})?)$)|(@\\[?((25[0-5]\\.|2[0-4][0-9]\\.|1[0-9]{2}\\.|[0-9]{1,2}\\.))((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\\.){2}(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[0-9]{1,2})\\]?$)/i);\r\nif(!pattern.test(value)) return ''Неправильно указан email адрес'';'),
(14345,7,46,1135,261,'[if !$value.valid_email][return ''Неправильно указан Email адрес''][/if]\r\n[return false]'),
(14346,7,46,1135,270,''),
(14358,8,58,1240,310,'Список'),
(14359,8,58,1240,311,'<p>[cur.name]:<br>\n    <select name="properties[[[cur]]]">\n        <option value="">Выберите значение</option>\n        [tree $items]\n            <option value="[cur]"[if cur==$link OR cur.value==$link] selected[/if]>[cur.value]</option>\n        [/tree]\n    </select>\n</p>'),
(14360,8,58,1240,0,'a:0:{}'),
(14361,8,58,1240,312,'[if post.properties[cur]]\r\n    [cow.dvalues.add(''param''=cur, ''link''=post.properties[cur])]\r\n[/if]'),
(14362,8,58,1240,313,''),
(14363,8,58,1240,314,''),
(14364,8,58,1240,315,''),
(14365,8,58,1240,316,''),
(14366,8,58,1240,317,'[objs=$objs.fastget:dvalues(''value''==$val,''param''==cur).owners]'),
(14376,8,58,1241,310,'Множественный выбор'),
(14377,8,58,1241,311,'<p style="margin-bottom: 5px;">[cur.name]:<br>\n        [tree $items]\n            <div><label style="cursor: pointer"><input type="checkbox" name="properties[[[up]]][[[cur]]]" class="button"[if $links.sel(cur==up.rid)] checked[/if]>[cur.value]</label></div>\n        [/tree]\n</p>'),
(14378,8,58,1241,0,'a:0:{}'),
(14379,8,58,1241,312,'[tree post.properties[cur]]\r\n    [cow.dvalues.add(''param''=up, ''link''=var)]\r\n[/if]'),
(14380,8,58,1241,313,''),
(14381,8,58,1241,314,''),
(14382,8,58,1241,315,''),
(14383,8,58,1241,316,''),
(14384,8,58,1241,317,'[tree $val]\r\n    [objs=$objs.fastget:dvalues(''value''==var,''param''==up).owners]\r\n[/tree]'),
(14406,6,43,424,214,'Lumia 920'),
(14407,6,43,424,231,'l920aab'),
(14408,6,43,424,216,'<p>\r\n	Смартфон Lumia 920</p>\r\n'),
(14409,6,43,424,218,'2015-12-14'),
(14410,6,43,424,228,''),
(14411,6,43,424,229,''),
(14414,6,43,424,232,''),
(14415,6,43,424,215,'lumia-920'),
(14416,6,43,424,233,''),
(14417,6,43,424,234,''),
(14418,6,43,424,235,'10000'),
(14419,6,43,424,236,'25000'),
(14420,6,43,424,237,'3'),
(14421,6,43,424,238,''),
(14422,6,43,424,321,''),
(14423,6,43,424,245,'0'),
(14424,6,43,424,217,'/files/uploads/photo/big5831f46bcba38747b3e450d7b1c8ee25.jpg'),
(14425,6,43,424,230,'457'),
(14426,6,43,424,230,'458'),
(14427,8,57,1707,299,'1256'),
(14428,8,57,1707,300,''),
(14429,8,57,1707,326,'1262'),
(14430,8,57,1708,299,'1265'),
(14431,8,57,1708,300,''),
(14432,8,57,1708,326,'1267'),
(14433,8,57,1709,299,'1269'),
(14434,8,57,1709,300,''),
(14435,8,57,1709,326,'1271'),
(14436,8,57,1710,299,'1274'),
(14437,8,57,1710,300,'8'),
(14438,8,57,1710,326,'0'),
(14439,8,57,1711,299,'1275'),
(14440,8,57,1711,300,'21'),
(14441,8,57,1711,326,'0'),
(14442,8,57,1712,299,'1276'),
(14443,8,57,1712,300,'200'),
(14444,8,57,1712,326,'0'),
(14445,8,57,1713,299,'1277'),
(14446,8,57,1713,300,'Зарядное устройство'),
(14447,8,57,1713,326,'0'),
(14448,8,57,1714,299,'1278'),
(14449,8,57,1714,300,''),
(14450,8,57,1714,326,'1281'),
(14451,8,57,1715,299,'1285'),
(14452,8,57,1715,300,''),
(14453,8,57,1715,326,'1295'),
(14454,8,57,1716,299,'1299'),
(14455,8,57,1716,300,''),
(14456,8,57,1716,326,'1304'),
(14457,8,57,1717,299,'1310'),
(14458,8,57,1717,300,''),
(14459,8,57,1717,326,'1312'),
(14460,8,57,1718,299,'1334'),
(14461,8,57,1718,300,''),
(14462,8,57,1718,326,'1335'),
(14463,8,57,1719,299,'1334'),
(14464,8,57,1719,300,''),
(14465,8,57,1719,326,'1339'),
(14466,8,57,1720,299,'1349'),
(14467,8,57,1720,300,''),
(14468,8,57,1720,326,'1350'),
(14469,8,57,1721,299,'1349'),
(14470,8,57,1721,300,''),
(14471,8,57,1721,326,'1351'),
(14472,8,57,1722,299,'1353'),
(14473,8,57,1722,300,'2000'),
(14474,8,57,1722,326,'0'),
(14475,8,57,1723,299,'1355'),
(14476,8,57,1723,300,'4,5'),
(14477,8,57,1723,326,'0'),
(14498,6,43,708,214,'Lumia 1020'),
(14499,6,43,708,231,'l1020aab'),
(14500,6,43,708,216,'<p>\r\n	Смартфон Lumia 1020</p>\r\n'),
(14501,6,43,708,218,'2015-12-15'),
(14502,6,43,708,228,''),
(14503,6,43,708,229,''),
(14505,6,43,708,232,''),
(14506,6,43,708,215,'lumia-1020'),
(14507,6,43,708,233,''),
(14508,6,43,708,234,''),
(14509,6,43,708,235,'15000'),
(14510,6,43,708,236,'20000'),
(14511,6,43,708,237,'0'),
(14512,6,43,708,238,'2017-01-01'),
(14513,6,43,708,321,''),
(14514,6,43,708,245,'0'),
(14515,6,43,708,217,'/files/uploads/photo/big9a1a39bcecbf5103670682da3ab5e141.jpg'),
(14516,6,43,708,230,'458'),
(14517,8,57,1725,299,'1256'),
(14518,8,57,1725,300,''),
(14519,8,57,1725,326,'1262'),
(14520,8,57,1726,299,'1265'),
(14521,8,57,1726,300,''),
(14522,8,57,1726,326,'1268'),
(14523,8,57,1727,299,'1269'),
(14524,8,57,1727,300,''),
(14525,8,57,1727,326,'1271'),
(14526,8,57,1728,299,'1274'),
(14527,8,57,1728,300,'8'),
(14528,8,57,1728,326,'0'),
(14529,8,57,1729,299,'1275'),
(14530,8,57,1729,300,'21'),
(14531,8,57,1729,326,'0'),
(14532,8,57,1730,299,'1276'),
(14533,8,57,1730,300,'120'),
(14534,8,57,1730,326,'0'),
(14535,8,57,1731,299,'1277'),
(14536,8,57,1731,300,'Зарядное устройство, чехол-зарядное'),
(14537,8,57,1731,326,'0'),
(14538,8,57,1732,299,'1278'),
(14539,8,57,1732,300,''),
(14540,8,57,1732,326,'1282'),
(14541,8,57,1733,299,'1285'),
(14542,8,57,1733,300,''),
(14543,8,57,1733,326,'1295'),
(14544,8,57,1734,299,'1299'),
(14545,8,57,1734,300,''),
(14546,8,57,1734,326,'1309'),
(14547,8,57,1735,299,'1310'),
(14548,8,57,1735,300,''),
(14549,8,57,1735,326,'1312'),
(14550,8,57,1736,299,'1334'),
(14551,8,57,1736,300,''),
(14552,8,57,1736,326,'1339'),
(14553,8,57,1737,299,'1349'),
(14554,8,57,1737,300,''),
(14555,8,57,1737,326,'1350'),
(14556,8,57,1738,299,'1349'),
(14557,8,57,1738,300,''),
(14558,8,57,1738,326,'1351'),
(14559,8,57,1739,299,'1353'),
(14560,8,57,1739,300,'2000'),
(14561,8,57,1739,326,'0'),
(14562,8,57,1740,299,'1355'),
(14563,8,57,1740,300,'4.5'),
(14564,8,57,1740,326,'0'),
(14585,6,43,728,214,'Galaxy S6'),
(14586,6,43,728,231,'gs6aab'),
(14587,6,43,728,216,'<p>\r\n	Флагман 2015 года на рынке телефонов от компании Samsung</p>\r\n'),
(14588,6,43,728,218,'2015-12-15'),
(14589,6,43,728,228,''),
(14590,6,43,728,229,''),
(14592,6,43,728,232,''),
(14593,6,43,728,215,'galaxy-s6'),
(14594,6,43,728,233,''),
(14595,6,43,728,234,''),
(14596,6,43,728,235,'35000'),
(14597,6,43,728,236,'40000'),
(14598,6,43,728,237,'10'),
(14599,6,43,728,238,''),
(14600,6,43,728,321,''),
(14601,6,43,728,245,'0'),
(14602,6,43,728,217,'/files/uploads/photo/big8eb6a24ea4b553475923a6e9e7562242.jpg'),
(14603,6,43,728,230,'457'),
(14604,8,57,1742,299,'1256'),
(14605,8,57,1742,300,''),
(14606,8,57,1742,326,'1263'),
(14607,8,57,1743,299,'1265'),
(14608,8,57,1743,300,''),
(14609,8,57,1743,326,'1268'),
(14610,8,57,1744,299,'1269'),
(14611,8,57,1744,300,''),
(14612,8,57,1744,326,'1270'),
(14613,8,57,1745,299,'1274'),
(14614,8,57,1745,300,'7'),
(14615,8,57,1745,326,'0'),
(14616,8,57,1746,299,'1275'),
(14617,8,57,1746,300,'14'),
(14618,8,57,1746,326,'0'),
(14619,8,57,1747,299,'1276'),
(14620,8,57,1747,300,'138'),
(14621,8,57,1747,326,'0'),
(14622,8,57,1748,299,'1277'),
(14623,8,57,1748,300,'Зарядное устройство, инструкция, кабель для соединения с ПК'),
(14624,8,57,1748,326,'0'),
(14625,8,57,1749,299,'1278'),
(14626,8,57,1749,300,''),
(14627,8,57,1749,326,'1283'),
(14628,8,57,1750,299,'1285'),
(14629,8,57,1750,300,''),
(14630,8,57,1750,326,'1295'),
(14631,8,57,1751,299,'1298'),
(14632,8,57,1751,300,'1'),
(14633,8,57,1751,326,'0'),
(14634,8,57,1752,299,'1299'),
(14635,8,57,1752,300,''),
(14636,8,57,1752,326,'1306'),
(14637,8,57,1753,299,'1310'),
(14638,8,57,1753,300,''),
(14639,8,57,1753,326,'1320'),
(14640,8,57,1754,299,'1334'),
(14641,8,57,1754,300,''),
(14642,8,57,1754,326,'1335'),
(14643,8,57,1755,299,'1334'),
(14644,8,57,1755,300,''),
(14645,8,57,1755,326,'1339'),
(14646,8,57,1756,299,'1334'),
(14647,8,57,1756,300,''),
(14648,8,57,1756,326,'1343'),
(14649,8,57,1757,299,'1349'),
(14650,8,57,1757,300,''),
(14651,8,57,1757,326,'1350'),
(14652,8,57,1758,299,'1349'),
(14653,8,57,1758,300,''),
(14654,8,57,1758,326,'1351'),
(14655,8,57,1759,299,'1353'),
(14656,8,57,1759,300,'2550'),
(14657,8,57,1759,326,'0'),
(14658,8,57,1760,299,'1355'),
(14659,8,57,1760,300,'5.1'),
(14660,8,57,1760,326,'0'),
(14683,6,43,768,214,'iPhone 6S'),
(14684,6,43,768,231,'i6saab'),
(14685,6,43,768,216,'<p>\r\n	Улучшенная версия iPhone 6</p>\r\n'),
(14686,6,43,768,218,'2015-12-15'),
(14687,6,43,768,228,''),
(14688,6,43,768,229,''),
(14692,6,43,768,232,''),
(14693,6,43,768,215,'iphone-6s'),
(14694,6,43,768,233,''),
(14695,6,43,768,234,''),
(14696,6,43,768,235,'62000'),
(14697,6,43,768,236,'65000'),
(14698,6,43,768,237,''),
(14699,6,43,768,238,''),
(14700,6,43,768,321,''),
(14701,6,43,768,245,'0'),
(14702,6,43,768,217,'/files/uploads/photo/big7a3c07b629ff2d75c4eeb625b367e60b.jpg'),
(14703,6,43,768,230,'769'),
(14704,6,43,768,230,'770'),
(14705,6,43,768,230,'771'),
(14706,8,57,1762,299,'1256'),
(14707,8,57,1762,300,''),
(14708,8,57,1762,326,'1259'),
(14709,8,57,1763,299,'1265'),
(14710,8,57,1763,300,''),
(14711,8,57,1763,326,'1267'),
(14712,8,57,1764,299,'1269'),
(14713,8,57,1764,300,''),
(14714,8,57,1764,326,'1272'),
(14715,8,57,1765,299,'1274'),
(14716,8,57,1765,300,'7'),
(14717,8,57,1765,326,'0'),
(14718,8,57,1766,299,'1275'),
(14719,8,57,1766,300,'13'),
(14720,8,57,1766,326,'0'),
(14721,8,57,1767,299,'1276'),
(14722,8,57,1767,300,'143'),
(14723,8,57,1767,326,'0'),
(14724,8,57,1768,299,'1277'),
(14725,8,57,1768,300,'Гарнитура с пультом управления, USB адаптер'),
(14726,8,57,1768,326,'0'),
(14727,8,57,1769,299,'1285'),
(14728,8,57,1769,300,''),
(14729,8,57,1769,326,'1296'),
(14730,8,57,1770,299,'1299'),
(14731,8,57,1770,300,''),
(14732,8,57,1770,326,'1305'),
(14733,8,57,1771,299,'1310'),
(14734,8,57,1771,300,''),
(14735,8,57,1771,326,'1312'),
(14736,8,57,1772,299,'1334'),
(14737,8,57,1772,300,''),
(14738,8,57,1772,326,'1343'),
(14739,8,57,1773,299,'1349'),
(14740,8,57,1773,300,''),
(14741,8,57,1773,326,'1350'),
(14742,8,57,1774,299,'1349'),
(14743,8,57,1774,300,''),
(14744,8,57,1774,326,'1351'),
(14745,8,57,1775,299,'1353'),
(14746,8,57,1775,300,''),
(14747,8,57,1775,326,'0'),
(14748,8,57,1776,299,'1355'),
(14749,8,57,1776,300,'4.7'),
(14750,8,57,1776,326,'0'),
(14772,6,43,1647,214,'Samsung UE32'),
(14773,6,43,1647,231,'J6300AU'),
(14774,6,43,1647,216,''),
(14775,6,43,1647,218,'2016-04-20'),
(14776,6,43,1647,228,''),
(14777,6,43,1647,229,''),
(14780,6,43,1647,232,''),
(14781,6,43,1647,215,'samsung-ue32'),
(14782,6,43,1647,233,''),
(14783,6,43,1647,234,''),
(14784,6,43,1647,235,'31000'),
(14785,6,43,1647,236,''),
(14786,6,43,1647,237,'1'),
(14787,6,43,1647,238,''),
(14788,6,43,1647,321,''),
(14789,6,43,1647,245,'1'),
(14790,6,43,1647,217,'/files/uploads/photo/biged73b4a229dfcc08fbdf9a458cd65639.jpg'),
(14791,6,43,1647,230,'1648'),
(14792,6,43,1647,230,'1649'),
(14793,8,57,1778,299,'1356'),
(14794,8,57,1778,300,''),
(14795,8,57,1778,326,'1253'),
(14796,8,57,1779,299,'1357'),
(14797,8,57,1779,300,''),
(14798,8,57,1779,326,'0'),
(14799,8,57,1780,299,'1358'),
(14800,8,57,1780,300,''),
(14801,8,57,1780,326,'0'),
(14802,8,57,1781,299,'1637'),
(14803,8,57,1781,300,'32'),
(14804,8,57,1781,326,'0'),
(14805,8,57,1782,299,'1638'),
(14806,8,57,1782,300,''),
(14807,8,57,1782,326,'1640'),
(14828,6,43,1661,214,'LG 42LF'),
(14829,6,43,1661,231,'42LF650V'),
(14830,6,43,1661,216,''),
(14831,6,43,1661,218,'2016-04-20'),
(14832,6,43,1661,228,''),
(14833,6,43,1661,229,''),
(14835,6,43,1661,232,''),
(14836,6,43,1661,215,'lg-42lf'),
(14837,6,43,1661,233,''),
(14838,6,43,1661,234,''),
(14839,6,43,1661,235,'39000'),
(14840,6,43,1661,236,''),
(14841,6,43,1661,237,'23'),
(14842,6,43,1661,238,''),
(14843,6,43,1661,321,''),
(14844,6,43,1661,245,'1'),
(14845,6,43,1661,217,'/files/uploads/photo/bigc65158d45c83a9082ebba0a29f5cba58.jpg'),
(14846,6,43,1661,230,'1648'),
(14847,8,57,1784,299,'1356'),
(14848,8,57,1784,300,''),
(14849,8,57,1784,326,'1250'),
(14850,8,57,1785,299,'1357'),
(14851,8,57,1785,300,''),
(14852,8,57,1785,326,'0'),
(14853,8,57,1786,299,'1358'),
(14854,8,57,1786,300,''),
(14855,8,57,1786,326,'0'),
(14856,8,57,1787,299,'1637'),
(14857,8,57,1787,300,'42'),
(14858,8,57,1787,326,'0'),
(14859,8,57,1788,299,'1638'),
(14860,8,57,1788,300,''),
(14861,8,57,1788,326,'1640'),
(14862,8,57,1789,299,'1646'),
(14863,8,57,1789,300,'1'),
(14864,8,57,1789,326,'0'),
(14884,6,43,1673,214,'Мечта 15М'),
(14885,6,43,1673,231,'м15мч'),
(14886,6,43,1673,216,''),
(14887,6,43,1673,218,'2016-04-20'),
(14888,6,43,1673,228,''),
(14889,6,43,1673,229,''),
(14890,6,43,1673,232,''),
(14891,6,43,1673,215,'mechta-15m'),
(14892,6,43,1673,233,''),
(14893,6,43,1673,234,''),
(14894,6,43,1673,235,'12500'),
(14895,6,43,1673,236,''),
(14896,6,43,1673,237,''),
(14897,6,43,1673,238,''),
(14898,6,43,1673,321,''),
(14899,6,43,1673,245,'1'),
(14900,6,43,1673,217,'/files/uploads/photo/big4e64474a60eef9a0966aad440deb6b12.jpg'),
(14920,6,43,1674,214,'Terra 14'),
(14921,6,43,1674,231,'14.120-01 WH'),
(14922,6,43,1674,216,''),
(14923,6,43,1674,218,'2016-04-20'),
(14924,6,43,1674,228,''),
(14925,6,43,1674,229,''),
(14926,6,43,1674,232,''),
(14927,6,43,1674,215,'terra-14'),
(14928,6,43,1674,233,''),
(14929,6,43,1674,234,''),
(14930,6,43,1674,235,'7700'),
(14931,6,43,1674,236,''),
(14932,6,43,1674,237,''),
(14933,6,43,1674,238,''),
(14934,6,43,1674,321,''),
(14935,6,43,1674,245,'1'),
(14936,6,43,1674,217,'/files/uploads/photo/bigb64cb44dc8d27fc62611899f9ca15a4d.jpg'),
(14956,6,43,1671,214,'Indesit DF 5200 W'),
(14957,6,43,1671,231,'DF 5200 W'),
(14958,6,43,1671,216,''),
(14959,6,43,1671,218,'2016-04-20'),
(14960,6,43,1671,228,''),
(14961,6,43,1671,229,''),
(14962,6,43,1671,232,''),
(14963,6,43,1671,215,'indesit-df-5200-w'),
(14964,6,43,1671,233,''),
(14965,6,43,1671,234,''),
(14966,6,43,1671,235,'25000'),
(14967,6,43,1671,236,''),
(14968,6,43,1671,237,''),
(14969,6,43,1671,238,''),
(14970,6,43,1671,321,''),
(14971,6,43,1671,245,'1'),
(14972,6,43,1671,217,'/files/uploads/photo/big1ec8d3ffef6ec951623635abcc1867b5.jpg'),
(14992,6,43,1672,214,'ATLANT М 7184-003'),
(14993,6,43,1672,231,'М 7184-003'),
(14994,6,43,1672,216,''),
(14995,6,43,1672,218,'2016-04-20'),
(14996,6,43,1672,228,''),
(14997,6,43,1672,229,''),
(14998,6,43,1672,232,''),
(14999,6,43,1672,215,'atlant-m-7184-003'),
(15000,6,43,1672,233,''),
(15001,6,43,1672,234,''),
(15002,6,43,1672,235,'19000'),
(15003,6,43,1672,236,''),
(15004,6,43,1672,237,''),
(15005,6,43,1672,238,''),
(15006,6,43,1672,321,''),
(15007,6,43,1672,245,'1'),
(15008,6,43,1672,217,'/files/uploads/photo/big38e29d11c81c59f4793ac71fde2fc4d1.jpg'),
(15052,6,53,1349,302,'Средства навигации'),
(15053,6,53,1349,304,'1241'),
(15054,6,53,1349,305,'1'),
(15055,6,53,1349,306,'1'),
(15056,6,53,1349,307,'0'),
(15057,6,53,1349,308,'GPS,ГЛОНАСС'),
(15058,6,53,1349,322,''),
(15059,6,53,1349,309,'0'),
(15060,6,53,1349,320,'sredstva-navigacii'),
(15070,6,53,1256,302,'Производитель'),
(15071,6,53,1256,304,'1240'),
(15072,6,53,1256,305,'1'),
(15073,6,53,1256,306,'1'),
(15074,6,53,1256,307,'0'),
(15075,6,53,1256,308,'Samsung'),
(15076,6,53,1256,322,''),
(15077,6,53,1256,309,'1257'),
(15078,6,53,1256,320,'proizvoditel'),
(15087,6,53,1277,302,'Комплектация'),
(15088,6,53,1277,304,'1232'),
(15089,6,53,1277,305,'0'),
(15090,6,53,1277,306,'0'),
(15091,6,53,1277,307,'0'),
(15092,6,53,1277,308,'зарядное устройство'),
(15093,6,53,1277,322,''),
(15094,6,53,1277,309,'0'),
(15095,6,53,1277,320,'komplektaciya'),
(15104,6,53,1354,302,'Съёмный аккумулятор'),
(15105,6,53,1354,304,'1239'),
(15106,6,53,1354,305,'0'),
(15107,6,53,1354,306,'0'),
(15108,6,53,1354,307,'0'),
(15109,6,53,1354,308,'1'),
(15110,6,53,1354,322,''),
(15111,6,53,1354,309,'0'),
(15112,6,53,1354,320,'syomnii-akkumulyator'),
(15116,1,9,1790,41,'Для магазина'),
(15117,1,10,1791,43,'Корзина'),
(15118,1,10,1791,44,''),
(15119,1,10,1791,0,'a:0:{}'),
(15120,1,10,1791,45,'6:6:144'),
(15121,1,10,1791,46,'1'),
(15122,1,10,1791,58,'17'),
(15123,1,10,1792,0,'a:1:{s:36:"val_d3aff7f97b8312980d87fa582a207af1";a:1:{s:5:"links";a:3:{i:1158;s:4:"1158";i:1167;s:4:"1167";i:1168;s:65:"adba24f02440b291927021addd983811:c7da137c820357446fa55236c853811a";}}}'),
(15124,1,10,1792,43,'Вход'),
(15125,1,10,1792,44,'<p>\r\n	[widget.forms.base.echo(form=uin:10c9cb802b02cc3dca281bfddcc8264b:''Форма авторизации'', tpl=uin:f6daf3d74ababfaf47ea602883527b90:''Блок авторизации'')]</p>\r\n'),
(15126,1,10,1792,45,'0'),
(15127,1,10,1792,46,'1'),
(15128,1,10,1792,58,'17'),
(15140,1,5,1228,33,'Магазин'),
(15141,1,5,1228,34,'shop'),
(15142,1,5,1228,35,''),
(15143,1,5,1228,0,'a:0:{}'),
(15144,1,5,1228,56,'0'),
(15145,1,5,1228,57,'1790'),
(15146,1,5,1228,59,'6:6'),
(15147,1,5,1228,63,'0'),
(15148,1,5,1228,68,''),
(15149,1,5,1228,69,''),
(15150,1,5,1228,90,'1'),
(15151,6,59,1793,327,'Список категорий'),
(15152,6,59,1793,328,'[cex.part.category]'),
(15153,6,59,1793,0,'a:0:{}'),
(15157,1,8,1795,40,'Под контентом'),
(15187,1,8,1797,40,'Под контентом'),
(15188,6,0,6,220,'1000'),
(15189,6,0,6,221,'700'),
(15190,6,0,6,222,'1'),
(15191,6,0,6,223,'2'),
(15192,6,0,6,224,'200'),
(15193,6,0,6,225,'150'),
(15194,6,0,6,226,'5'),
(15195,6,0,6,227,'1'),
(15196,6,0,6,335,'1793'),
(15197,6,0,6,336,'1796'),
(15198,6,0,6,337,'0'),
(15199,2,0,6,9,'1000'),
(15200,2,0,6,8,'700'),
(15201,2,0,6,10,'1'),
(15202,2,0,6,12,'1'),
(15203,2,0,6,7,'200'),
(15204,2,0,6,6,'150'),
(15205,2,0,6,11,'5'),
(15206,2,0,6,13,'1'),
(15207,2,0,6,180,''),
(15208,2,0,6,181,'0'),
(15209,2,0,6,182,'173'),
(15210,2,0,6,184,''),
(15211,2,0,6,185,'0'),
(15212,2,0,6,186,''),
(15213,5,0,6,290,'0'),
(15217,6,60,1796,329,'Подрубрики и товары'),
(15218,6,60,1796,330,'[tree linear $cats]\n    [cur.title]\n[/tree]'),
(15219,6,60,1796,0,'a:0:{}'),
(15223,7,49,1798,265,'Поля в строчку'),
(15224,7,49,1798,266,'[cm.part.top(anchor="auth_block")]\r\n\r\n[compile css u]\r\n.task-reg-input{\r\n    width: 300px;\r\n    font-size: 16px;\r\n}\r\n.task-reg-submit{\r\n    padding: 10px;\r\n}\r\n[/compile]\r\n    \r\n[if component.is_bootstrap]\r\n    [tree $form.fields.rows]\r\n        <div class="form-group">\r\n            <label for="field[cur]_[glob.form_id]">[cur.title]</label>\r\n            [cur.type.input.shell(class=''form-control'')]\r\n        </div>\r\n    [/tree]\r\n[else]\r\n    [tree $form.fields.rows]\r\n        <p>[cur.title]<br>\r\n        [cur.type.input.shell(class="task-reg-input")]</p>\r\n    [/tree]\r\n[/if]\r\n\r\n[if $capcha]\r\n    [component.capcha_question(type=''form'')]\r\n    <br>\r\n[/if]\r\n\r\n[if component.is_bootstrap]\r\n    [cm.part.bottom(submit_class=''btn btn-primary'')]\r\n[else]\r\n    [cm.part.bottom(submit_class="task-reg-submit")]\r\n[/if]'),
(15225,7,49,1798,0,'a:1:{s:36:"val_9e2ab1d6d29b67dd0e06b59525633a2e";a:1:{i:2;a:2:{s:15:"capcha_question";s:15:"capcha_question";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(15226,7,49,1798,268,'alert(error);'),
(15227,7,49,1798,294,''),
(15230,10,69,1799,357,'Точная цена'),
(15231,10,69,1800,357,'От цены'),
(15232,10,69,1801,357,'По договору'),
(15233,10,69,1802,357,'Бесплатно'),
(15234,10,69,1803,357,'% от цены'),
(15235,10,70,1804,358,'ед'),
(15236,10,70,1805,358,'шт'),
(15237,10,70,1806,358,'г'),
(15238,10,70,1807,358,'кг'),
(15239,10,70,1808,358,'м2'),
(15240,10,70,1809,358,'м3'),
(15241,10,70,1810,358,'мп'),
(15242,10,67,1811,353,'Уборка помещений'),
(15243,10,67,1811,354,'kategoria_1'),
(15244,10,67,1812,353,'Уборка улиц'),
(15245,10,67,1812,354,'kategoria_2'),
(15246,10,67,1813,353,'Жилые помещения'),
(15247,10,67,1813,354,'podkategoria_1'),
(15258,1,5,1816,33,'Прайс-лист'),
(15260,1,5,1816,35,''),
(15261,1,5,1816,0,'a:0:{}'),
(15262,1,5,1816,56,'0'),
(15263,1,5,1816,57,'0'),
(15264,1,5,1816,59,'10:10'),
(15265,1,5,1816,63,'0'),
(15266,1,5,1816,68,''),
(15267,1,5,1816,69,''),
(15268,1,5,1816,90,'1'),
(15269,1,5,1816,34,'prais-list'),
(15270,1,8,1817,40,'Специальная позиция №3'),
(15274,10,68,1818,355,'Долбить лёд'),
(15275,10,68,1818,356,'dolbit_led'),
(15276,10,68,1818,359,'100'),
(15277,10,68,1818,360,'1800'),
(15278,10,68,1818,361,'1808'),
(15279,10,68,1819,355,'Посыпать дорожки солью'),
(15280,10,68,1819,356,'posipat_dorogki_solu'),
(15281,10,68,1819,359,'100'),
(15282,10,68,1819,360,'1799'),
(15283,10,68,1819,361,'1810'),
(15284,10,68,1820,355,'Быть вежливым с прохожими'),
(15285,10,68,1820,356,'bit_veglivim_s_prohogimi'),
(15286,10,68,1820,359,'10'),
(15287,10,68,1820,360,'1803'),
(15288,10,68,1820,361,'0'),
(15289,10,67,1821,353,'Офисы'),
(15291,10,67,1821,354,'ofisi'),
(15297,10,68,1814,355,'Мойка окон'),
(15298,10,68,1814,356,'tovar_1'),
(15299,10,68,1814,359,'500'),
(15300,10,68,1814,360,'1799'),
(15301,10,68,1814,361,'1805'),
(15307,10,68,1815,355,'Мытьё полов'),
(15308,10,68,1815,356,'tovar_2'),
(15309,10,68,1815,359,'300'),
(15310,10,68,1815,360,'1800'),
(15311,10,68,1815,361,'1808'),
(15312,10,68,1822,355,'Уборка после буйных клиентов'),
(15313,10,68,1822,356,'uborka_posle_buinih_klientov'),
(15314,10,68,1822,359,''),
(15315,10,68,1822,360,'1801'),
(15316,10,68,1822,361,'0'),
(15317,10,68,1823,355,'Вынос офисной оргтехники'),
(15319,10,68,1823,359,'400'),
(15320,10,68,1823,360,'1799'),
(15321,10,68,1823,361,'1804'),
(15322,10,68,1823,356,'vinos-ofisnoi-orgtehniki'),
(15323,10,68,1824,355,'Вынос офисной оргтехники из чужого офиса в отсутствие владельца'),
(15324,10,68,1824,356,'vinos_ofisnoi_orgtehniki_iz_cugogo_ofisa_v_otsutstvie_vladelca'),
(15325,10,68,1824,359,'200'),
(15326,10,68,1824,360,'1803'),
(15327,10,68,1824,361,'0'),
(15328,10,71,1825,365,'Базовый'),
(15329,10,71,1825,366,'[compile css]\n.cart-div{\n	color: #697A95;\n	height: 41px;\n	z-index: 310;\n	position:absolute;\n	display:none;\n	width: 150px;\n	text-align:right;\n	background-color: #FFFFFF;\n	padding: 5px;\n	border:1px solid #444444;\n}\n.cart-block{\n	font-size: 14px;\n	padding-top: 5px;\n	padding-bottom: 5px;\n}\n.head2{\n	font-weight: bold;\n	text-align: center;\n	font-size: 14px;\n	border-bottom: 1px solid #444444;\n	height: 30px;\n	background-color: #F4F4F4;\n}\n.head1{\n	font-size: 16px;\n	font-weight: bold;\n	text-align: center;\n	color: #000000;\n}\n.price_table th{\n	background-color: #[cex.param.bg1];\n	font-weight: bold;\n	color: #FFFFFF;\n	font-size: 12px;\n	padding: 5px;\n	height: 30px;\n	text-align: center;\n}\n.price_table .td_item{\n	height: 30px;\n	font-size: 12px;\n	padding: 5px;\n	background-color: #[cex.param.bg2];\n}\n.price_table .td_span{\n	height: 30px;\n	padding: 10px;\n}\n.price{\n	font-size: 18px;\n}\n.price_count_input{\n	width: 30px;\n	text-align: center;\n}\n.price_count_label{\n	font-size: 14px;\n}\n[/compile]\n\n[compile js]\n[~\nfunction numbers_only(myfield, e, dec){\n	var key;\n	var keychar;\n	if (window.event) key = window.event.keyCode;\n	else if (e) key = e.which;\n	else return true;\n	keychar = String.fromCharCode(key);\n	if ((key==null) || (key==0) || (key==8) || (key==9) || (key==13) || (key==27) ) return true;\n	else if ((("0123456789").indexOf(keychar) > -1)) return true;\n	else return false;\n}\nvar ap={};\nfunction process(edit,id,price){\n	var lbl=document.getElementById(''l''+id);\n	lbl.innerHTML=(price*edit.value)+''р.'';\n	ap[id]=price*edit.value;\n	tot=0;\n	for(var i in ap) tot=tot+ap[i];\n	var lbl2=document.getElementById(''cart-block'');\n	var div=document.getElementById(''cart-div'');\n	if(lbl2){\n		if(tot>0) div.style.display=''''; else div.style.display=''none'';\n		lbl2.innerHTML=tot+''р.'';\n	}\n}\n~]\n[/compile]\n\n[tree cex.cat.rows]\n\n    [if first?]\n        <table class="price_table" width="100%" cellpadding="5" cellspacing="3" style="border-spacing: 3px; border-collapse: separate;">\n    [/if]\n\n    [if step==0]\n        <tr><td colspan="[if cex.param.calc]4[else]3[/if]" class="td_span"><h2 class="head1">[cur.title]<a name="[cur.title.latinica]"></a></h2>\n    [else]\n        <tr><td colspan="[if cex.param.calc]4[else]3[/if]" class="head2">[cur.title]<a name="[cur.title.latinica]"></a></td></tr>\n    [/if]\n    \n    [if first?]\n        <tr>\n        	<th class="th1">Перечень работ</th>\n        	<th class="th1">Ед.изм.</th>\n        	<th class="th1">Цена</th>\n        	[if cex.param.calc]\n        	    <th class="th1">Количество / Сумма</th>\n        	[/if]\n        </tr>\n    [/if]\n    \n    [tree cur.item.rows]\n        <tr>\n        	<td class="td_item">[cur.title]</td>\n        	[if cur.ptype.title==''Точная цена'' || cur.ptype.title==''От цены'']\n            	<td class="td_item" width="50" align="center">[cur.units.title]</td>\n            	<td class="td_item" width="100" align="center">\n        	        [if cur.ptype.title==''От цены'']от[/if]\n        	        <span class="price">[cur.price]</span>р.\n    	        </td>\n    	        \n    	        [if cex.param.calc]\n                	<td class="td_item" width="100" valign="middle">\n                		<input type="text" class="price_count_input" value="0" align="left" onKeyPress="if(numbers_only(this, event)){ return true; }else return false;"\n                			OnKeyUp="process(this, [cur], [cur.price.numeric]);\n                		">&nbsp;&nbsp;&nbsp;<a href="#total"><span id="l[cur]" class="price_count_label"></span></a>\n                	</td>    	        \n                [/if]\n            	\n            [else]\n                <td class="td_item" width="150" align="center" colspan="[if cex.param.calc]3[else]2[/if]">\n            	    [if cur.ptype.title==''По договору'']Договорная[/if]\n            	    [if cur.ptype.title==''Бесплатно'']Бесплатно[/if]\n            	    [if cur.ptype.title==''% от цены''][cur.price]% от стоимости[/if]\n        	    </td>\n            [/if]\n        </tr>\n    [/tree]\n    \n    [if last?]\n        </table>\n    [/if]\n\n[/tree]\n\n[if cex.param.calc]\n    <a name="total"></a>\n    <div id="cart-div" style="display:none;" align="center">\n    	<b>Итого:</b>\n    	<br>\n    	<div id="cart-block">0р.</div>\n    	[if cex.param.doc_href]<a href="[cex.param.doc_href]">оформить договор</a>[/if]\n    </div>\n[/if]');

INSERT INTO `row_value` (value_id,value_module,value_table,value_row,value_col,value_value) VALUES
(15331,10,71,1825,0,'a:0:{}'),
(15332,1,8,1826,40,'Специальная позиция №3'),
(15337,1,8,1827,40,'Специальная позиция №3'),
(15343,1,8,1828,40,'Специальная позиция №3'),
(15344,10,0,10,362,'696f82'),
(15345,10,0,10,363,'f7f7f7'),
(15346,10,0,10,364,'1'),
(15347,10,0,10,367,'1825'),
(15348,10,0,10,368,'/kontakti'),
(15350,1,8,1829,40,'Над контентом'),
(15351,5,0,5,290,'1172'),
(15352,5,0,5,342,'5'),
(15353,5,0,5,343,'10'),
(15354,1,8,1830,40,'Подвал'),
(15404,4,24,96,114,'Новости'),
(15405,4,24,96,154,'news'),
(15406,4,24,96,116,'<p>\r\n	Свежие новости на каждый день</p>\r\n'),
(15407,4,24,96,147,'0'),
(15408,4,21,101,159,'14'),
(15410,1,8,1831,40,'Подвал'),
(15444,1,8,1832,40,'Подвал'),
(15445,4,0,4,129,'87'),
(15446,4,0,4,130,'84'),
(15447,4,0,4,131,'121'),
(15448,4,0,4,132,'119'),
(15449,4,0,4,133,'107'),
(15450,4,0,4,135,'500'),
(15451,4,0,4,136,''),
(15452,4,0,4,137,'1'),
(15453,4,0,4,138,'3'),
(15454,4,0,4,139,'0'),
(15455,4,0,4,141,'1'),
(15456,4,0,4,148,'5'),
(15457,4,0,4,155,'1'),
(15458,4,0,4,156,'0'),
(15459,4,0,4,157,'1'),
(15460,4,0,4,158,'1'),
(15461,2,0,4,9,'1100'),
(15462,2,0,4,8,'800'),
(15463,2,0,4,10,'1'),
(15464,2,0,4,12,'1'),
(15465,2,0,4,7,'150'),
(15466,2,0,4,6,'100'),
(15467,2,0,4,11,'6'),
(15468,2,0,4,13,'2'),
(15469,2,0,4,180,''),
(15470,2,0,4,181,'0'),
(15471,2,0,4,182,'0'),
(15472,2,0,4,184,''),
(15473,2,0,4,185,'0'),
(15474,2,0,4,186,''),
(15475,5,0,4,290,'1172'),
(15476,5,0,4,342,'5'),
(15477,5,0,4,343,'10'),
(15526,4,21,103,93,'Застой в пищевой промышленности'),
(15527,4,21,103,94,'zastoi-v-pishevoi-promishlennosti'),
(15528,4,21,103,95,'<p>\r\n	Трудовики Сибири остановили конвейеры по производству и заготовке мяса крупного рогатого скота. Эксперты утверждают, что производства не могут конкурировать с дешёвой кегурятиной, поставляемой из Австралии.</p>\r\n'),
(15529,4,21,103,0,'a:0:{}'),
(15530,4,21,103,140,''),
(15533,4,21,103,125,'2015-10-29'),
(15534,4,21,103,128,'0'),
(15535,4,21,103,149,''),
(15536,4,21,103,150,''),
(15537,4,21,103,159,'6'),
(15538,4,21,103,106,'/files/uploads/photo/big32b6d2fc052c0e9f1c41a80b6a5024e7.jpeg'),
(15539,4,21,103,122,'89'),
(15540,4,21,103,122,'90'),
(15554,4,21,102,93,'Зима подобралась близко'),
(15555,4,21,102,94,'zima-podobralas-blizko'),
(15556,4,21,102,95,'<p>\r\n	У многих зима ассоциируется с холодами и заморозками. Однако в России принято отмечать сразу несколько праздников в середине зимы. Благодаря этому первую половину зимы люди ждут праздника, а вторую половину - отходят от него.</p>\r\n'),
(15557,4,21,102,0,'a:0:{}'),
(15558,4,21,102,140,''),
(15560,4,21,102,125,'2015-10-29'),
(15561,4,21,102,128,'0'),
(15562,4,21,102,149,''),
(15563,4,21,102,150,''),
(15564,4,21,102,159,'6'),
(15565,4,21,102,106,'/files/uploads/photo/bige7d920507fd2bf29abd6ac32e18fa29a.png'),
(15566,4,21,102,122,'89'),
(15580,4,21,100,93,'Медведь сбежал из зоопарка в Кении'),
(15581,4,21,100,94,'medved-sbejal-iz-zooparka-v-kenii'),
(15582,4,21,100,95,'<p>\r\n	Сегодня утром бурый медведь совершил дерзкий побег из зоопарка Кении. Сотрудники сообщают, что зверь агрессивен и очень опасен. Ловить животное своими силами не безопасно.</p>\r\n'),
(15583,4,21,100,0,'a:0:{}'),
(15584,4,21,100,140,''),
(15586,4,21,100,125,'2015-10-29'),
(15587,4,21,100,128,'0'),
(15588,4,21,100,149,''),
(15589,4,21,100,150,''),
(15590,4,21,100,159,'7'),
(15591,4,21,100,106,'/files/uploads/photo/big476cbbe0d60c9296b4dee1346599b1b9.jpg'),
(15592,4,21,100,122,'89'),
(15607,4,21,129,93,'Пёстрый тушканчик на грани исчезновения'),
(15608,4,21,129,94,'pyostrii-tushkanchik-na-grani-ische'),
(15609,4,21,129,95,'<p>\r\n	Обитатели северных пустынь оказались на грани исчезновения благодаря изменившемуся климату. Южный ветер высушил остатки питательных растений, способствующих размножению популяции пёстрого тушканчика.</p>\r\n'),
(15610,4,21,129,0,'a:0:{}'),
(15611,4,21,129,140,''),
(15614,4,21,129,125,'2015-11-03'),
(15615,4,21,129,128,'0'),
(15616,4,21,129,149,''),
(15617,4,21,129,150,''),
(15619,4,21,129,106,'/files/uploads/photo/bige0d302303a562a59f175d23691e269f8.jpg'),
(15620,4,21,129,122,'89'),
(15621,4,21,129,122,'90'),
(15622,4,21,1833,0,'a:0:{}'),
(15623,4,21,1833,93,'Метеорит приближается к земле'),
(15624,4,21,1833,94,'meteorit-priblijaetsya-k-zemle'),
(15625,4,21,1833,95,'<p>\r\n	Новость облетела всю планету за считанные часы. Учёные в недоумении. Скала весом в 25 тонн приближается к нашей планете. Нам предстоит встретиться с новой опасностью, но готовы ли мы?</p>\r\n'),
(15626,4,21,1833,106,'/files/uploads/photo/big8154a5e42e7dd5f1ed72f75df23abef8.jpg'),
(15627,4,21,1833,107,'/files/uploads/photo/biga2be455768821a84d2ac153906f842ab.jpg'),
(15628,4,21,1833,122,'89'),
(15629,4,21,1833,122,'174'),
(15630,4,21,1833,122,'90'),
(15631,4,21,1833,125,'2014-06-12'),
(15632,4,21,1833,128,'0'),
(15633,4,21,1833,140,''),
(15634,4,21,1833,149,''),
(15635,4,21,1833,150,''),
(15636,4,21,1833,159,'2'),
(15643,7,72,1834,369,'Обычный'),
(15644,7,72,1834,370,'[if user.group($group) && $show_exit]\n    \n    [if get.action==''logout'']\n        [user.logout]\n        <div>Вы вышли из системы</div>\n        [xbreak]\n    [/if]\n    <div>Вы вошли как <b>[user.name]</b>. <a href="[url2 "action" "logout"]">Выйти</a></div><br>\n[/if]\n[if user.guest? || $condition.parse]\n    <div id="auth_block" style="[if post.form_name!=$form.auth_form.name]display: none;[/if]">\n        [f=cm.part.echo(form=$form.auth_form, tpl=$form.auth_tpl)]\n        [if component.is_bootstrap]\n            [$f._component.bootstrap_panel(title=''Вход'', theme=''default'')]\n        [else]\n            [$f]\n        [/if]\n    </div>\n    <div id="reg_block" style="[if post.form_name!=$form.reg_form.name]display: none;[/if]">\n        [f=cm.part.echo(form=$form.reg_form, tpl=$form.reg_tpl)]\n        [if component.is_bootstrap]\n            [$f._component.bootstrap_panel(title=''Регистрация'', theme=''default'')]\n        [else]\n            [$f]\n        [/if]\n    </div>\n[/if]\n[if !user.guest? && !user.group($group)]\n    [user.invite($group)]\n    [if $add_to_table && user.group($group)]\n        [$add_to_table.add(''user''=user)]\n    [/if]\n[/if]\n[if user.guest? || $condition.parse]\n    [component.jquery(version=''1.3.2'')]\n    <a href="#" OnClick="$(''#reg_block'').hide(); $(''#auth_block'').toggle(); return false;">Войдите</a>\n    или пройдите <a href="#" OnClick="$(''#auth_block'').hide(); $(''#reg_block'').toggle(); return false;">регистрацию</a>\n    [$reg_text]\n    <br><br>\n[/if]'),
(15645,7,72,1834,0,'a:1:{s:36:"val_00440c2682b9df93d6b2e583cd00dc2d";a:1:{i:2;a:3:{s:6:"jquery";s:6:"jquery";s:15:"bootstrap_panel";s:15:"bootstrap_panel";s:12:"is_bootstrap";s:12:"is_bootstrap";}}}'),
(15646,7,74,1835,375,'Обычная'),
(15647,7,74,1835,376,'1211'),
(15648,7,74,1835,377,'1213'),
(15649,7,74,1835,379,'1158'),
(15650,7,74,1835,380,'1167'),
(15651,7,74,1835,382,'1834'),
(15652,4,21,129,159,'26');

INSERT INTO `table_sub` (sub_id,sub_table1,sub_table2) VALUES
(1,9,10),
(2,7,13),
(3,7,14),
(4,18,19),
(5,24,21),
(6,21,1),
(7,21,29),
(8,31,1),
(13,43,1),
(14,35,43),
(16,45,48),
(17,48,50),
(18,1,29),
(19,53,54),
(20,55,54),
(21,43,57),
(22,35,53),
(24,67,68);